// Targeted by JavaCPP version 1.2: DO NOT EDIT THIS FILE

package org.bytedeco.javacpp;

import java.nio.*;
import org.bytedeco.javacpp.*;
import org.bytedeco.javacpp.annotation.*;

import static org.bytedeco.javacpp.cuda.*;
import static org.bytedeco.javacpp.nppc.*;

public class nppi extends org.bytedeco.javacpp.presets.nppi {
    static { Loader.load(); }

// Parsed from <nppi.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_H
// #define NV_NPPI_H
 
/**
 * \file nppi.h
 * NPP Image Processing Functionality.
 */
 
// #ifdef __cplusplus
// #endif

// #include "nppdefs.h"

/** \defgroup nppi NPP Image Processing
 *
 * \{
 */

// #include "nppi_support_functions.h"
// #include "nppi_data_exchange_and_initialization.h"
// #include "nppi_arithmetic_and_logical_operations.h"
// #include "nppi_color_conversion.h"
// #include "nppi_threshold_and_compare_operations.h"
// #include "nppi_morphological_operations.h"
// #include "nppi_filtering_functions.h"
// #include "nppi_statistics_functions.h"
// #include "nppi_linear_transforms.h"
// #include "nppi_geometry_transforms.h"
// #include "nppi_compression_functions.h"
// #include "nppi_computer_vision.h"

/** \} end of Image Processing module */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_H */


// Parsed from <nppi_support_functions.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_SUPPORT_FUNCTIONS_H
// #define NV_NPPI_SUPPORT_FUNCTIONS_H
 
/**
 * \file nppi_support_functions.h
 * NPP Image Processing Functionality.
 * Image memory management
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_memory_management Memory Management
 *  \ingroup nppi
 *
 * Routines for allocating and deallocating pitched image storage. These methods
 * are provided for convenience. They allocate memory that may contain additional
 * padding bytes at the end of each line of pixels. Though padding is not necessary
 * for any of the NPP image-processing primitives to work correctly, its absense may
 * cause sever performance degradation compared to properly padded images.
 *
 * \{
 *
 */

/** \name Image Memory Allocation
 * ImageAllocator methods for 2D arrays of data. The allocators have width and height parameters
 * to specify the size of the image data being allocated. They return a pointer to the
 * newly created memory and return the numbers of bytes between successive lines. 
 *
 * If the memory allocation failed due to lack of free device memory or device memory fragmentation
 * the routine returns 0.
 *
 * All allocators return memory with line strides that are 
 * beneficial for performance. It is not mandatory to use these allocators. Any valid CUDA device-memory
 * pointers can be used by the NPP primitives and there are no restrictions on line strides.
 *
 * \{
 *
 */

/**
 * 8-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp8u*") BytePointer nppiMalloc_8u_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp8u*") ByteBuffer nppiMalloc_8u_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp8u*") byte[] nppiMalloc_8u_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 2 channel 8-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp8u*") BytePointer nppiMalloc_8u_C2(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp8u*") ByteBuffer nppiMalloc_8u_C2(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp8u*") byte[] nppiMalloc_8u_C2(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 3 channel 8-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp8u*") BytePointer nppiMalloc_8u_C3(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp8u*") ByteBuffer nppiMalloc_8u_C3(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp8u*") byte[] nppiMalloc_8u_C3(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 8-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp8u*") BytePointer nppiMalloc_8u_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp8u*") ByteBuffer nppiMalloc_8u_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp8u*") byte[] nppiMalloc_8u_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 16-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp16u*") ShortPointer nppiMalloc_16u_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp16u*") ShortBuffer nppiMalloc_16u_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp16u*") short[] nppiMalloc_16u_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 2 channel 16-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp16u*") ShortPointer nppiMalloc_16u_C2(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp16u*") ShortBuffer nppiMalloc_16u_C2(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp16u*") short[] nppiMalloc_16u_C2(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 3 channel 16-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp16u*") ShortPointer nppiMalloc_16u_C3(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp16u*") ShortBuffer nppiMalloc_16u_C3(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp16u*") short[] nppiMalloc_16u_C3(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 16-bit unsigned image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp16u*") ShortPointer nppiMalloc_16u_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp16u*") ShortBuffer nppiMalloc_16u_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp16u*") short[] nppiMalloc_16u_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 16-bit signed image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp16s*") ShortPointer nppiMalloc_16s_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp16s*") ShortBuffer nppiMalloc_16s_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp16s*") short[] nppiMalloc_16s_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 2 channel 16-bit signed image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp16s*") ShortPointer nppiMalloc_16s_C2(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp16s*") ShortBuffer nppiMalloc_16s_C2(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp16s*") short[] nppiMalloc_16s_C2(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 16-bit signed image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp16s*") ShortPointer nppiMalloc_16s_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp16s*") ShortBuffer nppiMalloc_16s_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp16s*") short[] nppiMalloc_16s_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 1 channel 16-bit signed complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp16sc nppiMalloc_16sc_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 2 channel 16-bit signed complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp16sc nppiMalloc_16sc_C2(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C2(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C2(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 3 channel 16-bit signed complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp16sc nppiMalloc_16sc_C3(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C3(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C3(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 16-bit signed complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp16sc nppiMalloc_16sc_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp16sc nppiMalloc_16sc_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 32-bit signed image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp32s*") IntPointer nppiMalloc_32s_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp32s*") IntBuffer nppiMalloc_32s_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp32s*") int[] nppiMalloc_32s_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 3 channel 32-bit signed image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp32s*") IntPointer nppiMalloc_32s_C3(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp32s*") IntBuffer nppiMalloc_32s_C3(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp32s*") int[] nppiMalloc_32s_C3(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 32-bit signed image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp32s*") IntPointer nppiMalloc_32s_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp32s*") IntBuffer nppiMalloc_32s_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp32s*") int[] nppiMalloc_32s_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 32-bit integer complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32sc nppiMalloc_32sc_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 2 channel 32-bit integer complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32sc nppiMalloc_32sc_C2(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C2(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C2(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 3 channel 32-bit integer complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32sc nppiMalloc_32sc_C3(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C3(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C3(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 32-bit integer complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32sc nppiMalloc_32sc_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32sc nppiMalloc_32sc_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);


/**
 * 32-bit floating point image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp32f*") FloatPointer nppiMalloc_32f_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp32f*") FloatBuffer nppiMalloc_32f_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp32f*") float[] nppiMalloc_32f_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 2 channel 32-bit floating point image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp32f*") FloatPointer nppiMalloc_32f_C2(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp32f*") FloatBuffer nppiMalloc_32f_C2(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp32f*") float[] nppiMalloc_32f_C2(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 3 channel 32-bit floating point image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp32f*") FloatPointer nppiMalloc_32f_C3(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp32f*") FloatBuffer nppiMalloc_32f_C3(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp32f*") float[] nppiMalloc_32f_C3(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 32-bit floating point image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native @Cast("Npp32f*") FloatPointer nppiMalloc_32f_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native @Cast("Npp32f*") FloatBuffer nppiMalloc_32f_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native @Cast("Npp32f*") float[] nppiMalloc_32f_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 32-bit float complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32fc nppiMalloc_32fc_C1(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C1(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C1(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 2 channel 32-bit float complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32fc nppiMalloc_32fc_C2(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C2(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C2(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 3 channel 32-bit float complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32fc nppiMalloc_32fc_C3(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C3(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C3(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/**
 * 4 channel 32-bit float complex image memory allocator.
 * @param nWidthPixels Image width.
 * @param nHeightPixels Image height.
 * @param pStepBytes \ref line_step.
 * @return Pointer to new image data.
 */
public static native Npp32fc nppiMalloc_32fc_C4(int nWidthPixels, int nHeightPixels, IntPointer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C4(int nWidthPixels, int nHeightPixels, IntBuffer pStepBytes);
public static native Npp32fc nppiMalloc_32fc_C4(int nWidthPixels, int nHeightPixels, int[] pStepBytes);

/** \} Malloc */


/**
 * Free method for any 2D allocated memory.
 * This method should be used to free memory allocated with any of the nppiMalloc_<modifier> methods.
 * @param pData A pointer to memory allocated using nppiMalloc_<modifier>.
 */
public static native void nppiFree(Pointer pData);

/** \} Image-Memory Management */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_SUPPORT_FUNCTIONS_H */


// Parsed from <nppi_data_exchange_and_initialization.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_DATA_EXCHANGE_AND_INITIALIZATION_H
// #define NV_NPPI_DATA_EXCHANGE_AND_INITIALIZATION_H
 
/**
 * \file nppi_data_exchange_and_initialization.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_data_exchange_and_initialization Data Exchange and Initialization
 *  \ingroup nppi
 *
 * Primitives for initializting, copying and converting image data.
 *
 * \{
 *
 */

/** 
 * \defgroup image_set Set
 *
 * Primitives for setting pixels to a specific value.
 *
 * \{
 *
 */


/** \name Set 
 *
 * Set all pixels within the ROI to a specific value.
 *
 * \{
 *
 */

/** 
 * 8-bit image set.
 * @param nValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8s_C1R(@Cast("const Npp8s") byte nValue, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C1R(@Cast("const Npp8s") byte nValue, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C1R(@Cast("const Npp8s") byte nValue, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 8-bit two-channel image set.
 * @param aValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8s_C2R(@Cast("const Npp8s*") BytePointer aValue, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C2R(@Cast("const Npp8s*") ByteBuffer aValue, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C2R(@Cast("const Npp8s*") byte[] aValue, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 8-bit three-channel image set.
 * @param aValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8s_C3R(@Cast("const Npp8s*") BytePointer aValue, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C3R(@Cast("const Npp8s*") ByteBuffer aValue, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C3R(@Cast("const Npp8s*") byte[] aValue, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 8-bit four-channel image set.
 * @param aValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8s_C4R(@Cast("const Npp8s*") BytePointer aValue, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C4R(@Cast("const Npp8s*") ByteBuffer aValue, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_C4R(@Cast("const Npp8s*") byte[] aValue, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 8-bit four-channel image set ignoring alpha channel.
 * @param aValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8s_AC4R(@Cast("const Npp8s*") BytePointer aValue, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_AC4R(@Cast("const Npp8s*") ByteBuffer aValue, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8s_AC4R(@Cast("const Npp8s*") byte[] aValue, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 8-bit unsigned image set.
 * @param nValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C1R(@Cast("const Npp8u") byte nValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C1R(@Cast("const Npp8u") byte nValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C1R(@Cast("const Npp8u") byte nValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 2 channel 8-bit unsigned image set.
 * @param aValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C2R(@Cast("const Npp8u*") BytePointer aValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C2R(@Cast("const Npp8u*") ByteBuffer aValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C2R(@Cast("const Npp8u*") byte[] aValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 8-bit unsigned image set.
 * @param aValue The pixel value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C3R(@Cast("const Npp8u*") BytePointer aValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C3R(@Cast("const Npp8u*") ByteBuffer aValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C3R(@Cast("const Npp8u*") byte[] aValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 8-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C4R(@Cast("const Npp8u*") BytePointer aValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C4R(@Cast("const Npp8u*") ByteBuffer aValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C4R(@Cast("const Npp8u*") byte[] aValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 8-bit unsigned image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_AC4R(@Cast("const Npp8u*") BytePointer aValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_AC4R(@Cast("const Npp8u*") ByteBuffer aValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_AC4R(@Cast("const Npp8u*") byte[] aValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit unsigned image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C1R(@Cast("const Npp16u") short nValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C1R(@Cast("const Npp16u") short nValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C1R(@Cast("const Npp16u") short nValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 2 channel 16-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C2R(@Cast("const Npp16u*") ShortPointer aValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C2R(@Cast("const Npp16u*") ShortBuffer aValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C2R(@Cast("const Npp16u*") short[] aValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 16-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C3R(@Cast("const Npp16u*") ShortPointer aValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C3R(@Cast("const Npp16u*") ShortBuffer aValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C3R(@Cast("const Npp16u*") short[] aValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C4R(@Cast("const Npp16u*") ShortPointer aValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C4R(@Cast("const Npp16u*") ShortBuffer aValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C4R(@Cast("const Npp16u*") short[] aValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit unsigned image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_AC4R(@Cast("const Npp16u*") ShortPointer aValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_AC4R(@Cast("const Npp16u*") ShortBuffer aValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_AC4R(@Cast("const Npp16u*") short[] aValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C1R(@Cast("const Npp16s") short nValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C1R(@Cast("const Npp16s") short nValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C1R(@Cast("const Npp16s") short nValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 2 channel 16-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C2R(@Cast("const Npp16s*") ShortPointer aValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C2R(@Cast("const Npp16s*") ShortBuffer aValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C2R(@Cast("const Npp16s*") short[] aValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 16-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C3R(@Cast("const Npp16s*") ShortPointer aValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C3R(@Cast("const Npp16s*") ShortBuffer aValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C3R(@Cast("const Npp16s*") short[] aValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C4R(@Cast("const Npp16s*") ShortPointer aValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C4R(@Cast("const Npp16s*") ShortBuffer aValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C4R(@Cast("const Npp16s*") short[] aValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_AC4R(@Cast("const Npp16s*") ShortPointer aValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_AC4R(@Cast("const Npp16s*") ShortBuffer aValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_AC4R(@Cast("const Npp16s*") short[] aValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit complex integer image set.
 * @param oValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16sc_C1R(@Const @ByVal Npp16sc oValue, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit complex integer two-channel image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16sc_C2R(@Const Npp16sc aValue, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit complex integer three-channel image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16sc_C3R(@Const Npp16sc aValue, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit complex integer four-channel image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16sc_C4R(@Const Npp16sc aValue, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit complex integer four-channel image set ignoring alpha.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16sc_AC4R(@Const Npp16sc aValue, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 32-bit image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C1R(@Cast("const Npp32s") int nValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C1R(@Cast("const Npp32s") int nValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C1R(@Cast("const Npp32s") int nValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 2 channel 32-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C2R(@Cast("const Npp32s*") IntPointer aValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C2R(@Cast("const Npp32s*") IntBuffer aValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C2R(@Cast("const Npp32s*") int[] aValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 32-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C3R(@Cast("const Npp32s*") IntPointer aValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C3R(@Cast("const Npp32s*") IntBuffer aValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C3R(@Cast("const Npp32s*") int[] aValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C4R(@Cast("const Npp32s*") IntPointer aValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C4R(@Cast("const Npp32s*") IntBuffer aValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C4R(@Cast("const Npp32s*") int[] aValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_AC4R(@Cast("const Npp32s*") IntPointer aValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_AC4R(@Cast("const Npp32s*") IntBuffer aValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_AC4R(@Cast("const Npp32s*") int[] aValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 32-bit unsigned image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32u_C1R(@Cast("const Npp32u") int nValue, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C1R(@Cast("const Npp32u") int nValue, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C1R(@Cast("const Npp32u") int nValue, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 2 channel 32-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32u_C2R(@Cast("const Npp32u*") IntPointer aValue, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C2R(@Cast("const Npp32u*") IntBuffer aValue, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C2R(@Cast("const Npp32u*") int[] aValue, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 32-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32u_C3R(@Cast("const Npp32u*") IntPointer aValue, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C3R(@Cast("const Npp32u*") IntBuffer aValue, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C3R(@Cast("const Npp32u*") int[] aValue, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32u_C4R(@Cast("const Npp32u*") IntPointer aValue, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C4R(@Cast("const Npp32u*") IntBuffer aValue, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_C4R(@Cast("const Npp32u*") int[] aValue, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit unsigned image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32u_AC4R(@Cast("const Npp32u*") IntPointer aValue, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_AC4R(@Cast("const Npp32u*") IntBuffer aValue, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32u_AC4R(@Cast("const Npp32u*") int[] aValue, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 32-bit complex integer image set.
 * @param oValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32sc_C1R(@Const @ByVal Npp32sc oValue, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Two channel 32-bit complex integer image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32sc_C2R(@Const Npp32sc aValue, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 32-bit complex integer image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32sc_C3R(@Const Npp32sc aValue, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 32-bit complex integer image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32sc_C4R(@Const Npp32sc aValue, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 32-bit complex integer four-channel image set ignoring alpha.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32sc_AC4R(@Const Npp32sc aValue, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/** 
 * 32-bit floating point image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C1R(@Cast("const Npp32f") float nValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C1R(@Cast("const Npp32f") float nValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C1R(@Cast("const Npp32f") float nValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 2 channel 32-bit floating point image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C2R(@Cast("const Npp32f*") FloatPointer aValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C2R(@Cast("const Npp32f*") FloatBuffer aValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C2R(@Cast("const Npp32f*") float[] aValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 32-bit floating point image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C3R(@Cast("const Npp32f*") FloatPointer aValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C3R(@Cast("const Npp32f*") FloatBuffer aValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C3R(@Cast("const Npp32f*") float[] aValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit floating point image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C4R(@Cast("const Npp32f*") FloatPointer aValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C4R(@Cast("const Npp32f*") FloatBuffer aValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C4R(@Cast("const Npp32f*") float[] aValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit floating point image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_AC4R(@Cast("const Npp32f*") FloatPointer aValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_AC4R(@Cast("const Npp32f*") FloatBuffer aValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_AC4R(@Cast("const Npp32f*") float[] aValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/** 
 * Single channel 32-bit complex image set.
 * @param oValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32fc_C1R(@Const @ByVal Npp32fc oValue, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Two channel 32-bit complex image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32fc_C2R(@Const Npp32fc aValue, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 32-bit complex image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32fc_C3R(@Const Npp32fc aValue, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 32-bit complex image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32fc_C4R(@Const Npp32fc aValue, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 32-bit complex four-channel image set ignoring alpha.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32fc_AC4R(@Const Npp32fc aValue, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Set */

/** \name Masked Set
 * 
 * The masked set primitives have an additional "mask image" input. The mask  
 * controls which pixels within the ROI are set. For details see \ref masked_operation.
 *
 * \{
 *
 */

/** 
 * Masked 8-bit unsigned image set. 
 * @param nValue The pixel value to be set.
 * @param pDst Pointer \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C1MR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_C1MR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_C1MR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 3 channel 8-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C3MR(@Cast("const Npp8u*") BytePointer aValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_C3MR(@Cast("const Npp8u*") ByteBuffer aValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_C3MR(@Cast("const Npp8u*") byte[] aValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 4 channel 8-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C4MR(@Cast("const Npp8u*") BytePointer aValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_C4MR(@Cast("const Npp8u*") ByteBuffer aValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_C4MR(@Cast("const Npp8u*") byte[] aValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 4 channel 8-bit unsigned image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_AC4MR(@Cast("const Npp8u*") BytePointer aValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_AC4MR(@Cast("const Npp8u*") ByteBuffer aValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_8u_AC4MR(@Cast("const Npp8u*") byte[] aValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 16-bit unsigned image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C1MR( @Cast("Npp16u") short nValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_C1MR( @Cast("Npp16u") short nValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_C1MR( @Cast("Npp16u") short nValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 3 channel 16-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C3MR(@Cast("const Npp16u*") ShortPointer aValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_C3MR(@Cast("const Npp16u*") ShortBuffer aValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_C3MR(@Cast("const Npp16u*") short[] aValue, @Cast("Npp16u*") short[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 4 channel 16-bit unsigned image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C4MR(@Cast("const Npp16u*") ShortPointer aValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_C4MR(@Cast("const Npp16u*") ShortBuffer aValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_C4MR(@Cast("const Npp16u*") short[] aValue, @Cast("Npp16u*") short[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 4 channel 16-bit unsigned image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_AC4MR(@Cast("const Npp16u*") ShortPointer aValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_AC4MR(@Cast("const Npp16u*") ShortBuffer aValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16u_AC4MR(@Cast("const Npp16u*") short[] aValue, @Cast("Npp16u*") short[] pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 16-bit image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C1MR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_C1MR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_C1MR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 3 channel 16-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C3MR(@Cast("const Npp16s*") ShortPointer aValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_C3MR(@Cast("const Npp16s*") ShortBuffer aValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_C3MR(@Cast("const Npp16s*") short[] aValue, @Cast("Npp16s*") short[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);
                          
/** 
 * Masked 4 channel 16-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C4MR(@Cast("const Npp16s*") ShortPointer aValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_C4MR(@Cast("const Npp16s*") ShortBuffer aValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_C4MR(@Cast("const Npp16s*") short[] aValue, @Cast("Npp16s*") short[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);
                          
/** 
 * Masked 4 channel 16-bit image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_AC4MR(@Cast("const Npp16s*") ShortPointer aValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_AC4MR(@Cast("const Npp16s*") ShortBuffer aValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_16s_AC4MR(@Cast("const Npp16s*") short[] aValue, @Cast("Npp16s*") short[] pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 32-bit image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C1MR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_C1MR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_C1MR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 3 channel 32-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C3MR(@Cast("const Npp32s*") IntPointer aValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_C3MR(@Cast("const Npp32s*") IntBuffer aValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_C3MR(@Cast("const Npp32s*") int[] aValue, @Cast("Npp32s*") int[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);
                          
/** 
 * Masked 4 channel 32-bit image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C4MR(@Cast("const Npp32s*") IntPointer aValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_C4MR(@Cast("const Npp32s*") IntBuffer aValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_C4MR(@Cast("const Npp32s*") int[] aValue, @Cast("Npp32s*") int[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);
                          
/** 
 * Masked 4 channel 16-bit image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_AC4MR(@Cast("const Npp32s*") IntPointer aValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_AC4MR(@Cast("const Npp32s*") IntBuffer aValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32s_AC4MR(@Cast("const Npp32s*") int[] aValue, @Cast("Npp32s*") int[] pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 32-bit floating point image set.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C1MR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_C1MR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_C1MR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 3 channel 32-bit floating point image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C3MR(@Cast("const Npp32f*") FloatPointer aValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_C3MR(@Cast("const Npp32f*") FloatBuffer aValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_C3MR(@Cast("const Npp32f*") float[] aValue, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * Masked 4 channel 32-bit floating point image set.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C4MR(@Cast("const Npp32f*") FloatPointer aValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_C4MR(@Cast("const Npp32f*") FloatBuffer aValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_C4MR(@Cast("const Npp32f*") float[] aValue, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                 @ByVal NppiSize oSizeROI,
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);
                          
/** 
 * Masked 4 channel 32-bit floating point image set method, not affecting Alpha channel.
 * @param aValue The pixel-value to be set.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_AC4MR(@Cast("const Npp32f*") FloatPointer aValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_AC4MR(@Cast("const Npp32f*") FloatBuffer aValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiSet_32f_AC4MR(@Cast("const Npp32f*") float[] aValue, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                  @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);


/** \} Masked Set */

/** \name Channel Set
 * 
 * The select-channel set primitives set a single color channel in multi-channel images
 * to a given value. The channel is selected by adjusting the pDst pointer to point to 
 * the desired color channel (see \ref channel_of_interest).
 *
 * \{
 *
 */

/** 
 * 3 channel 8-bit unsigned image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C3CR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C3CR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C3CR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 8-bit unsigned image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_8u_C4CR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C4CR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_8u_C4CR(@Cast("Npp8u") byte nValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 16-bit unsigned image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C3CR(@Cast("Npp16u") short nValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C3CR(@Cast("Npp16u") short nValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C3CR(@Cast("Npp16u") short nValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit unsigned image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16u_C4CR(@Cast("Npp16u") short nValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C4CR(@Cast("Npp16u") short nValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16u_C4CR(@Cast("Npp16u") short nValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 16-bit signed image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C3CR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C3CR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C3CR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit signed image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_16s_C4CR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C4CR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_16s_C4CR(@Cast("Npp16s") short nValue, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 32-bit unsigned image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C3CR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C3CR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C3CR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit unsigned image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32s_C4CR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C4CR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32s_C4CR(@Cast("Npp32s") int nValue, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 3 channel 32-bit floating point image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C3CR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C3CR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C3CR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit floating point image set affecting only single channel.
 * @param nValue The pixel-value to be set.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSet_32f_C4CR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C4CR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSet_32f_C4CR(@Cast("Npp32f") float nValue, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/** \} Channel Set */

/** \} image_set */


/** 
 * \defgroup image_copy Copy
 *
 * \{
 *
 */

/** \name Copy
 *
 * Copy pixels from one image to another.
 * 
 * \{
 *
 */

/** 
 * 8-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Two-channel 8-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C2R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 8-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 8-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 8-bit image copy, ignoring alpha channel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8s_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8s_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 8-bit unsigned image copy, not affecting Alpha channel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit unsigned image copy, not affecting Alpha channel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 16-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 16-bit image copy, not affecting Alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 16-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16sc_C1R(@Const Npp16sc pSrc, int nSrcStep, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Two-channel 16-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16sc_C2R(@Const Npp16sc pSrc, int nSrcStep, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 16-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16sc_C3R(@Const Npp16sc pSrc, int nSrcStep, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 16-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16sc_C4R(@Const Npp16sc pSrc, int nSrcStep, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 16-bit complex image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16sc_AC4R(@Const Npp16sc pSrc, int nSrcStep, Npp16sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/** 
 * 32-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 32-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit image copy, not affecting Alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 32-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32sc_C1R(@Const Npp32sc pSrc, int nSrcStep, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Two-channel 32-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32sc_C2R(@Const Npp32sc pSrc, int nSrcStep, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 32-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32sc_C3R(@Const Npp32sc pSrc, int nSrcStep, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32sc_C4R(@Const Npp32sc pSrc, int nSrcStep, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit complex image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32sc_AC4R(@Const Npp32sc pSrc, int nSrcStep, Npp32sc pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/** 
 * 32-bit floating point image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 32-bit floating point image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit floating point image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * 4 channel 32-bit floating point image copy, not affecting Alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/** 
 * 32-bit floating-point complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32fc_C1R(@Const Npp32fc pSrc, int nSrcStep, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Two-channel 32-bit floating-point complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32fc_C2R(@Const Npp32fc pSrc, int nSrcStep, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 32-bit floating-point complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32fc_C3R(@Const Npp32fc pSrc, int nSrcStep, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit floating-point complex image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32fc_C4R(@Const Npp32fc pSrc, int nSrcStep, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit floating-point complex image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32fc_AC4R(@Const Npp32fc pSrc, int nSrcStep, Npp32fc pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Copy */

/** \name Masked Copy
 * 
 * The masked copy primitives have an additional "mask image" input. The mask  
 * controls which pixels within the ROI are copied. For details see \ref masked_operation.
 *
 * \{
 *
 */

/** 
 * \ref masked_operation 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation three channel 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C3MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_C3MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_C3MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C4MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_C4MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_C4MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 8-bit unsigned image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_AC4MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_AC4MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_8u_AC4MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_C1MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation three channel 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C3MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_C3MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_C3MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C4MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_C4MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_C4MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 16-bit unsigned image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_AC4MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_AC4MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16u_AC4MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation 16-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C1MR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_C1MR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_C1MR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation three channel 16-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C3MR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_C3MR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_C3MR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 16-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C4MR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_C4MR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_C4MR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 16-bit signed image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_AC4MR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_AC4MR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_16s_AC4MR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation 32-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C1MR(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_C1MR(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_C1MR(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation three channel 32-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C3MR(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_C3MR(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_C3MR(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 32-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C4MR(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_C4MR(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_C4MR(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 32-bit signed image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_AC4MR(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_AC4MR(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32s_AC4MR(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation 32-bit float image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_C1MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation three channel 32-bit float image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C3MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_C3MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_C3MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 32-bit float image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C4MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_C4MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_C4MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** 
 * \ref masked_operation four channel 32-bit float image copy, ignoring alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_AC4MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_AC4MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep);
public static native @Cast("NppStatus") int nppiCopy_32f_AC4MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep);

/** \} Masked Copy */


/** \name Channel Copy
 * 
 * The channel copy primitives copy a single color channel from a multi-channel source image
 * to any other color channel in a multi-channel destination image. The channel is selected 
 * by adjusting the respective image  pointers to point to the desired color channel 
 * (see \ref channel_of_interest).
 *
 * \{
 *
 */

/** 
 * Select-channel 8-bit unsigned image copy for three-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C3CR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3CR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3CR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 8-bit unsigned image copy for four-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C4CR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4CR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4CR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 16-bit signed image copy for three-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C3CR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3CR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3CR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 16-bit signed image copy for four-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C4CR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4CR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4CR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 16-bit unsigned image copy for three-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C3CR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3CR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3CR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 16-bit unsigned image copy for four-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C4CR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4CR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4CR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 32-bit signed image copy for three-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C3CR(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3CR(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3CR(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 32-bit signed image copy for four-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C4CR(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4CR(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4CR(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 32-bit float image copy for three-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C3CR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3CR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3CR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Select-channel 32-bit float image copy for four-channel images.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C4CR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4CR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4CR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Channel Copy */


/** \name Extract Channel Copy
 * 
 * The channel extract primitives copy a single color channel from a multi-channel source image
 * to singl-channel destination image. The channel is selected by adjusting the source image pointer
 * to point to the desired color channel (see \ref channel_of_interest).
 *
 * \{
 *
 */


/** 
 * Three-channel to single-channel 8-bit unsigned image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C3C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel to single-channel 8-bit unsigned image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C4C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel to single-channel 16-bit signed image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C3C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel to single-channel 16-bit signed image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C4C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel to single-channel 16-bit unsigned image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C3C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel to single-channel 16-bit unsigned image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C4C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel to single-channel 32-bit signed image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C3C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel to single-channel 32-bit signed image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C4C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel to single-channel 32-bit float image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C3C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel to single-channel 32-bit float image copy.
 * @param pSrc \ref select_source_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C4C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Extract Channel Copy */

/** \name Insert Channel Copy
 * 
 * The channel insert primitives copy a single-channel source image into one of the color channels
 * in a multi-channel destination image. The channel is selected by adjusting the destination image pointer
 * to point to the desired color channel (see \ref channel_of_interest).
 *
 * \{
 *
 */

/** 
 * Single-channel to three-channel 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C1C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C1C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C1C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to four-channel 8-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C1C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C1C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C1C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to three-channel 16-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C1C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C1C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C1C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to four-channel 16-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C1C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C1C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C1C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to three-channel 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C1C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C1C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C1C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to four-channel 16-bit unsigned image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C1C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C1C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C1C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to three-channel 32-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C1C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C1C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C1C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to four-channel 32-bit signed image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C1C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C1C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C1C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to three-channel 32-bit float image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C1C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C1C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C1C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single-channel to four-channel 32-bit float image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref select_destination_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C1C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C1C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C1C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Insert Channel Copy */


/** \name Packed-to-Planar Copy
 * 
 * Split a packed multi-channel image into a planar image.
 *
 * E.g. copy the three channels of an RGB image into three separate single-channel
 * images.
 *
 * \{
 *
 */

/** 
 * Three-channel 8-bit unsigned packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr BytePointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr ByteBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr byte[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 8-bit unsigned packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_C4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr BytePointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4P4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr ByteBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_C4P4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr byte[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 16-bit signed packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C3P3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3P3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr ShortPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3P3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr ShortBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C3P3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr short[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 16-bit signed packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_C4P4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4P4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr ShortPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4P4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr ShortBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_C4P4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr short[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 16-bit unsigned packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C3P3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3P3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr ShortPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3P3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr ShortBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C3P3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr short[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 16-bit unsigned packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_C4P4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4P4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr ShortPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4P4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr ShortBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_C4P4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr short[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 32-bit signed packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C3P3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3P3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*const*") @ByPtrPtr IntPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3P3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*const*") @ByPtrPtr IntBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C3P3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*const*") @ByPtrPtr int[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit signed packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_C4P4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4P4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*const*") @ByPtrPtr IntPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4P4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*const*") @ByPtrPtr IntBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_C4P4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*const*") @ByPtrPtr int[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 32-bit float packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C3P3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3P3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr FloatPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3P3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr FloatBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C3P3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr float[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit float packed to planar image copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param aDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_C4P4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*const*") PointerPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4P4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr FloatPointer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4P4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr FloatBuffer aDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_C4P4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr float[] aDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Packed-to-Planar Copy */


/** \name Planar-to-Packed Copy
 * 
 * Combine multiple image planes into a packed multi-channel image.
 *
 * E.g. copy three single-channel images into a single 3-channel image.
 *
 * \{
 *
 */

/** 
 * Three-channel 8-bit unsigned planar to packed image copy.
 * @param aSrc Planar \ref source_image_pointer.
 * @param nSrcStep \ref source_planar_image_pointer_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer aSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer aSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] aSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 8-bit unsigned planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_8u_P4C4R(@Cast("const Npp8u*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_P4C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer aSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_P4C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer aSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_8u_P4C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] aSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 16-bit unsigned planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_P3C3R(@Cast("const Npp16u*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_P3C3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer aSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_P3C3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer aSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_P3C3R(@Cast("const Npp16u*const*") @ByPtrPtr short[] aSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 16-bit unsigned planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16u_P4C4R(@Cast("const Npp16u*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_P4C4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer aSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_P4C4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer aSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16u_P4C4R(@Cast("const Npp16u*const*") @ByPtrPtr short[] aSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 16-bit signed planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_P3C3R(@Cast("const Npp16s*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_P3C3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortPointer aSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_P3C3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortBuffer aSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_P3C3R(@Cast("const Npp16s*const*") @ByPtrPtr short[] aSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 16-bit signed planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_16s_P4C4R(@Cast("const Npp16s*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_P4C4R(@Cast("const Npp16s*const*") @ByPtrPtr ShortPointer aSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_P4C4R(@Cast("const Npp16s*const*") @ByPtrPtr ShortBuffer aSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_16s_P4C4R(@Cast("const Npp16s*const*") @ByPtrPtr short[] aSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 32-bit signed planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_P3C3R(@Cast("const Npp32s*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_P3C3R(@Cast("const Npp32s*const*") @ByPtrPtr IntPointer aSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_P3C3R(@Cast("const Npp32s*const*") @ByPtrPtr IntBuffer aSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_P3C3R(@Cast("const Npp32s*const*") @ByPtrPtr int[] aSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit signed planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32s_P4C4R(@Cast("const Npp32s*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_P4C4R(@Cast("const Npp32s*const*") @ByPtrPtr IntPointer aSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_P4C4R(@Cast("const Npp32s*const*") @ByPtrPtr IntBuffer aSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32s_P4C4R(@Cast("const Npp32s*const*") @ByPtrPtr int[] aSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three-channel 32-bit float planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_P3C3R(@Cast("const Npp32f*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_P3C3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer aSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_P3C3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer aSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_P3C3R(@Cast("const Npp32f*const*") @ByPtrPtr float[] aSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four-channel 32-bit float planar to packed image copy.
 * @param aSrc Planar \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopy_32f_P4C4R(@Cast("const Npp32f*const*") PointerPointer aSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_P4C4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer aSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_P4C4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer aSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCopy_32f_P4C4R(@Cast("const Npp32f*const*") @ByPtrPtr float[] aSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Planar-to-Packed Copy */

/** \} image_copy */

/** 
 * \defgroup image_convert Convert
 *
 * \{
 *
 */

/** 
 * \name Convert to Increase Bit-Depth
 *
 * The integer conversion methods do not involve any scaling. Also, even when increasing the bit-depth
 * loss of information may occur:
 * - When converting integers (e.g. Npp32u) to float (e.g. Npp32f) integervalue not accurately representable 
 *   by the float are rounded to the closest floating-point value.
 * - When converting signed integers to unsigned integers all negative values are lost (saturated to 0).
 *
 * \{
 *
 */

/** 
 * Single channel 8-bit unsigned to 16-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned to 16-bit unsigned  conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit unsigned  conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16s_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16s_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u16s_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u16s_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32s_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32s_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 32-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32s_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32s_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 32-bit floating-point conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit signed to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit signed to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32s_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit signed to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32s_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit signed to 32-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32s_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32s_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit signed to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit signed to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit signed to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit signed to 32-bit floating-point conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 16-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32s_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 16-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32s_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32s_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit unsigned to 32-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32s_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32s_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 16-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 16-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit unsigned to 32-bit floating-point conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 16-bit signed to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 16-bit signed to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit signed to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit signed to 32-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 16-bit signed to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32f_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 16-bit signed to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32f_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit signed to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32f_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit signed to 32-bit floating-point conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32f_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32f_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit signed to 8-bit unsigned conversion with saturation.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s8u_C1Rs(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s8u_C1Rs(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s8u_C1Rs(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit signed to 16-bit unsigned conversion with saturation.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s16u_C1Rs(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s16u_C1Rs(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s16u_C1Rs(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit signed to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit signed to 32-bit unsigned conversion with saturation.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8s32u_C1Rs(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32u_C1Rs(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_8s32u_C1Rs(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 16-bit signed to 16-bit unsigned conversion with saturation.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s16u_C1Rs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s16u_C1Rs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s16u_C1Rs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 16-bit signed to 32-bit unsigned conversion with saturation.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s32u_C1Rs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32u_C1Rs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s32u_C1Rs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 16-bit unsigned to 32-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u32u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u32u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/** 
 * Single channel 32-bit signed to 32-bit unsigned conversion with saturation.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s32u_C1Rs(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s32u_C1Rs(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s32u_C1Rs(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 32-bit signed to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s32f_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s32f_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s32f_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 32-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32u32f_C1R(@Cast("const Npp32u*") IntPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32u32f_C1R(@Cast("const Npp32u*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32u32f_C1R(@Cast("const Npp32u*") int[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} Convert to Increase Bit-Depth */


/** 
 * \name Convert to Decrease Bit-Depth
 *
 * The integer conversion methods do not involve any scaling. When converting floating-point values
 * to integers the user may choose the most appropriate rounding-mode. Typically information is lost when
 * converting to lower bit depth:
 * - All converted values are saturated to the destination type's range. E.g. any values larger than
 *   the largest value of the destination type are clamped to the destination's maximum.
 * - Converting floating-point values to integer also involves rounding, effectively loosing all
 *   fractional value information in the process. 
 *
 * \{
 *
 */

/** 
 * Single channel 16-bit unsigned to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u8u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 16-bit unsigned to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u8u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit unsigned to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u8u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit unsigned to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u8u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16u8u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);
          

/** 
 * Single channel 16-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s8u_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);
          
/** 
 * Three channel 16-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s8u_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s8u_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 16-bit signed to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s8u_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_16s8u_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);
          
          
/** 
 * Single channel 32-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8u_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);
          
/** 
 * Three channel 32-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8u_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 32-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8u_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 32-bit signed to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8u_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8u_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);
          
      
/** 
 * Single channel 32-bit signed to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);
          
/** 
 * Three channel 32-bit signed to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 32-bit signed to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 32-bit signed to 8-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s8s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiConvert_32s8s_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);
          
/** 
 * Single channel 8-bit unsigned to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_8u8s_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_8u8s_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_8u8s_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 16-bit unsigned to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u8s_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_16u8s_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_16u8s_C1RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 16-bit signed to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16s8s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_16s8s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_16s8s_C1RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 16-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_16u16s_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_16u16s_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_16u16s_C1RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit unsigned to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32u8u_C1RSfs(@Cast("const Npp32u*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u8u_C1RSfs(@Cast("const Npp32u*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u8u_C1RSfs(@Cast("const Npp32u*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit unsigned to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32u8s_C1RSfs(@Cast("const Npp32u*") IntPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u8s_C1RSfs(@Cast("const Npp32u*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u8s_C1RSfs(@Cast("const Npp32u*") int[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit unsigned to 16-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32u16u_C1RSfs(@Cast("const Npp32u*") IntPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u16u_C1RSfs(@Cast("const Npp32u*") IntBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u16u_C1RSfs(@Cast("const Npp32u*") int[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32u16s_C1RSfs(@Cast("const Npp32u*") IntPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u16s_C1RSfs(@Cast("const Npp32u*") IntBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u16s_C1RSfs(@Cast("const Npp32u*") int[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32u32s_C1RSfs(@Cast("const Npp32u*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u32s_C1RSfs(@Cast("const Npp32u*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32u32s_C1RSfs(@Cast("const Npp32u*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit unsigned to 16-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s16u_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32s16u_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32s16u_C1RSfs(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode \ref rounding_mode_parameter.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32s16s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32s16s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32s16s_C1RSfs(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit floating point to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8u_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Three channel 32-bit floating point to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8u_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8u_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8u_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8u_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Single channel 32-bit floating point to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8s_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Three channel 32-bit floating point to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8s_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 8-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8s_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 8-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8s_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f8s_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Single channel 32-bit floating point to 16-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16u_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Three channel 32-bit floating point to 16-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16u_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 16-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16u_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 16-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16u_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16u_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Single channel 32-bit floating point to 16-bit signed conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16s_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Three channel 32-bit floating point to 16-bit signed conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16s_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 16-bit signed conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16s_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);

/** 
 * Four channel 32-bit floating point to 16-bit signed conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16s_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);
public static native @Cast("NppStatus") int nppiConvert_32f16s_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode);


/** 
 * Single channel 32-bit floating point to 8-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8u_C1RSfs(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C1RSfs(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f8u_C1RSfs(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit floating point to 8-bit signed conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f8s_C1RSfs(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C1RSfs(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f8s_C1RSfs(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit floating point to 16-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16u_C1RSfs(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C1RSfs(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f16u_C1RSfs(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit floating point to 16-bit signed conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f16s_C1RSfs(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C1RSfs(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f16s_C1RSfs(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit floating point to 32-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f32u_C1RSfs(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f32u_C1RSfs(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f32u_C1RSfs(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** 
 * Single channel 32-bit floating point to 32-bit signed conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eRoundMode Flag specifying how fractional float values are rounded to integer values.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiConvert_32f32s_C1RSfs(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f32s_C1RSfs(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiConvert_32f32s_C1RSfs(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int eRoundMode, int nScaleFactor);

/** \} Convert to Decrease Bit-Depth */

/** \} image_convert */


/** 
 * \defgroup image_scale Scale
 *
 * \{
 *
 */

/**
 * \name Scaled Bit-Depth Conversion
 * Scale bit-depth up and down.
 *
 * To map source pixel srcPixelValue to destination pixel dstPixelValue the following equation is used:
 * 
 *      dstPixelValue = dstMinRangeValue + scaleFactor * (srcPixelValue - srcMinRangeValue)
 *
 * where scaleFactor = (dstMaxRangeValue - dstMinRangeValue) / (srcMaxRangeValue - srcMinRangeValue).
 *
 * For conversions between integer data types, the entire integer numeric range of the input data type is mapped onto 
 * the entire integer numeric range of the output data type.
 *
 * For conversions to floating point data types the floating point data range is defined by the user supplied floating point values
 * of nMax and nMin which are used as the dstMaxRangeValue and dstMinRangeValue respectively in the scaleFactor and dstPixelValue 
 * calculations and also as the saturation values to which output data is clamped.
 *
 * When converting from floating-point values to integer values, nMax and nMin are used as the srcMaxRangeValue and srcMinRangeValue
 * respectively in the scaleFactor and dstPixelValue calculations. Output values are saturated and clamped to the full output integer
 * pixel value range.
 *
 * \{
 *
 */

/** 
 * Single channel 8-bit unsigned to 16-bit unsigned conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned to 16-bit unsigned  conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit unsigned  conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16s_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16s_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 16-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u16s_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u16s_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u32s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three channel 8-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u32s_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 32-bit signed conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u32s_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four channel 8-bit unsigned to 32-bit signed conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_8u32s_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiScale_8u32s_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Single channel 8-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** 
 * Three channel 8-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** 
 * Four channel 8-bit unsigned to 32-bit floating-point conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** 
 * Four channel 8-bit unsigned to 32-bit floating-point conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** 
 * Single channel 16-bit unsigned to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16u8u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);

/** 
 * Three channel 16-bit unsigned to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16u8u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);

/** 
 * Four channel 16-bit unsigned to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16u8u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);

/** 
 * Four channel 16-bit unsigned to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16u8u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16u8u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
          

/** 
 * Single channel 16-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16s8u_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
          
/** 
 * Three channel 16-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16s8u_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);

/** 
 * Four channel 16-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16s8u_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);

/** 
 * Four channel 16-bit signed to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_16s8u_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_16s8u_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
          
          
/** 
 * Single channel 32-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_32s8u_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
          
/** 
 * Three channel 32-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_32s8u_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);

/** 
 * Four channel 32-bit signed to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_32s8u_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);

/** 
 * Four channel 32-bit signed to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param hint algorithm performance or accuracy selector, currently ignored
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiScale_32s8u_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
public static native @Cast("NppStatus") int nppiScale_32s8u_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppHintAlgorithm") int hint);
          
/** 
 * Single channel 32-bit floating point to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_32f8u_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** 
 * Three channel 32-bit floating point to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_32f8u_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** 
 * Four channel 32-bit floating point to 8-bit unsigned conversion.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_32f8u_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** 
 * Four channel 32-bit floating point to 8-bit unsigned conversion, not affecting Alpha.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nMin specifies the minimum saturation value to which every output value will be clamped.
 * @param nMax specifies the maximum saturation value to which every output value will be clamped.
 * @return \ref image_data_error_codes, \ref roi_error_codes, ::NPP_SCALE_RANGE_ERROR indicates an error condition if nMax <= nMin.
 */
public static native @Cast("NppStatus") int nppiScale_32f8u_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);
public static native @Cast("NppStatus") int nppiScale_32f8u_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nMin, @Cast("Npp32f") float nMax);

/** \} Scaled Bit-Depth Conversion */

/** \} image_scale */

/** 
 * \defgroup image_copy_constant_border Copy Constant Border
 * 
 * \{
 *
 */

/** \name CopyConstBorder
 * 
 * Methods for copying images and padding borders with a constant, user-specifiable color.
 *
 * \{
 *
 */

/** 
 * 1 channel 8-bit unsigned integer image copy with constant border color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and constant border color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the constant border color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @param nValue The pixel value to be set for border pixels.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("Npp8u") byte nValue);

/**
 * 3 channel 8-bit unsigned integer image copy with constant border color.
 * See nppiCopyConstBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("const Npp8u*") BytePointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("const Npp8u*") ByteBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("const Npp8u*") byte[] aValue);

/**
 * 4 channel 8-bit unsigned integer image copy with constant border color.
 * See nppiCopyConstBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("const Npp8u*") BytePointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("const Npp8u*") ByteBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth,
                                     @Cast("const Npp8u*") byte[] aValue);
                                       
/**
 * 4 channel 8-bit unsigned integer image copy with constant border color with alpha channel unaffected.
 * See nppiCopyConstBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGB values of the border pixels. Because this method does not
 *      affect the destination image's alpha channel, only three components of the border color
 *      are needed.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp8u*") BytePointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp8u*") BytePointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp8u*") ByteBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp8u*") byte[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp8u*") byte[] aValue);

/** 
 * 1 channel 16-bit unsigned integer image copy with constant border color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and constant border color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the constant border color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @param nValue The pixel value to be set for border pixels.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp16u") short nValue);

/**
 * 3 channel 16-bit unsigned integer image copy with constant border color.
 * See nppiCopyConstBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16u*") ShortPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16u*") ShortBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16u*") short[] aValue);

/**
 * 4 channel 16-bit unsigned integer image copy with constant border color.
 * See nppiCopyConstBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16u*") ShortPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16u*") ShortBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16u*") short[] aValue);
                                       
/**
 * 4 channel 16-bit unsigned integer image copy with constant border color with alpha channel unaffected.
 * See nppiCopyConstBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGB values of the border pixels. Because this method does not
 *      affect the destination image's alpha channel, only three components of the border color
 *      are needed.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp16u*") ShortPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp16u*") ShortBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp16u*") short[] aValue);

/** 
 * 1 channel 16-bit signed integer image copy with constant border color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and constant border color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the constant border color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @param nValue The pixel value to be set for border pixels.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp16s") short nValue);

/**
 * 3 channel 16-bit signed integer image copy with constant border color.
 * See nppiCopyConstBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16s*") ShortPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16s*") ShortBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16s*") short[] aValue);

/**
 * 4 channel 16-bit signed integer image copy with constant border color.
 * See nppiCopyConstBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16s*") ShortPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16s*") ShortBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp16s*") short[] aValue);
                                       
/**
 * 4 channel 16-bit signed integer image copy with constant border color with alpha channel unaffected.
 * See nppiCopyConstBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGB values of the border pixels. Because this method does not
 *      affect the destination image's alpha channel, only three components of the border color
 *      are needed.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp16s*") ShortPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp16s*") ShortBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp16s*") short[] aValue);

/** 
 * 1 channel 32-bit signed integer image copy with constant border color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and constant border color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the constant border color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @param nValue The pixel value to be set for border pixels.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp32s") int nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp32s") int nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C1R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp32s") int nValue);

/**
 * 3 channel 32-bit signed integer image copy with constant border color.
 * See nppiCopyConstBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32s*") IntPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32s*") IntBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C3R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32s*") int[] aValue);

/**
 * 4 channel 32-bit signed integer image copy with constant border color.
 * See nppiCopyConstBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32s*") IntPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32s*") IntBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32s*") int[] aValue);
                                       
/**
 * 4 channel 32-bit signed integer image copy with constant border color with alpha channel unaffected.
 * See nppiCopyConstBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGB values of the border pixels. Because this method does not
 *      affect the destination image's alpha channel, only three components of the border color
 *      are needed.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp32s*") IntPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp32s*") IntBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32s_AC4R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp32s*") int[] aValue);

/** 
 * 1 channel 32-bit floating point image copy with constant border color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and constant border color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the constant border color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @param nValue The pixel value to be set for border pixels.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("Npp32f") float nValue);

/**
 * 3 channel 32-bit floating point image copy with constant border color.
 * See nppiCopyConstBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32f*") FloatPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32f*") FloatBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32f*") float[] aValue);

/**
 * 4 channel 32-bit floating point image copy with constant border color.
 * See nppiCopyConstBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGBA values of the border pixels to be set.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32f*") FloatPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32f*") FloatBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth,
                                      @Cast("const Npp32f*") float[] aValue);
                                       
/**
 * 4 channel 32-bit floating point image copy with constant border color with alpha channel unaffected.
 * See nppiCopyConstBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @param aValue Vector of the RGB values of the border pixels. Because this method does not
 *      affect the destination image's alpha channel, only three components of the border color
 *      are needed.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp32f*") FloatPointer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp32f*") FloatBuffer aValue);
public static native @Cast("NppStatus") int nppiCopyConstBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                             @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                       int nTopBorderHeight, int nLeftBorderWidth,
                                       @Cast("const Npp32f*") float[] aValue);

/** \} CopyConstBorder*/

/** \} image_copy_constant_border */

/** 
 * \defgroup image_copy_replicate_border Copy Replicate Border
 *
 * \{
 *
 */

/** \name CopyReplicateBorder
 * Methods for copying images and padding borders with a replicates of the nearest source image pixel color.
 *
 * \{
 *
 */

/** 
 * 1 channel 8-bit unsigned integer image copy with nearest source image pixel color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and nearest source image pixel color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the nearest source image pixel color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 8-bit unsigned integer image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 8-bit unsigned integer image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                               @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                         int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 8-bit unsigned integer image copy with nearest source image pixel color with alpha channel unaffected.
 * See nppiCopyReplicateBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 16-bit unsigned integer image copy with nearest source image pixel color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and nearest source image pixel color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the nearest source image pixel color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 16-bit unsigned integer image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 16-bit unsigned integer image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 16-bit unsigned image copy with nearest source image pixel color with alpha channel unaffected.
 * See nppiCopyReplicateBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 16-bit signed integer image copy with nearest source image pixel color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and nearest source image pixel color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the nearest source image pixel color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 16-bit signed integer image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 16-bit signed integer image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 16-bit signed integer image copy with nearest source image pixel color with alpha channel unaffected.
 * See nppiCopyReplicateBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 32-bit signed integer image copy with nearest source image pixel color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and nearest source image pixel color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the nearest source image pixel color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C1R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 32-bit signed image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C3R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 32-bit signed integer image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_C4R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 32-bit signed integer image copy with nearest source image pixel color with alpha channel unaffected.
 * See nppiCopyReplicateBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32s_AC4R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 32-bit floating point image copy with nearest source image pixel color.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and nearest source image pixel color (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the nearest source image pixel color.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 32-bit floating point image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 32-bit floating point image copy with nearest source image pixel color.
 * See nppiCopyReplicateBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                          int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 32-bit floating point image copy with nearest source image pixel color with alpha channel unaffected.
 * See nppiCopyReplicateBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyReplicateBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                                 @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                           int nTopBorderHeight, int nLeftBorderWidth);

/** \} CopyReplicateBorder */

/** \} image_copy_replicate_border */

/** 
 * \defgroup image_copy_wrap_border Copy Wrap Border
 *
 * \{
 *
 */

/** \name CopyWrapBorder
 * 
 * Methods for copying images and padding borders with wrapped replications of the source image pixel colors.
 *
 * \{
 *
 */

/** 
 * 1 channel 8-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and a border consisting of wrapped replication of the source image pixel colors (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the wrapped replication of the corresponding column of source image pixels colors.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 8-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 8-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                          @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                    int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 8-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors with alpha channel unaffected.
 * See nppiCopyWrapBorder_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") BytePointer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc,   int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp8u*") byte[] pDst,   int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 16-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and a border consisting of wrapped replication of the source image pixel colors (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the wrapped replication of the corresponding column of source image pixels colors.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 16-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 16-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 16-bit unsigned integer image copy with the borders wrapped by replication of source image pixel colors with alpha channel unaffected.
 * See nppiCopyWrapBorder_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16u*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 16-bit signed integer image copy with the borders wrapped by replication of source image pixel colors.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and a border consisting of wrapped replication of the source image pixel colors (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the wrapped replication of the corresponding column of source image pixels colors.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 16-bit signed integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 16-bit signed integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 16-bit signed integer image copy with the borders wrapped by replication of source image pixel colors with alpha channel unaffected.
 * See nppiCopyWrapBorder_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp16s*") short[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 32-bit signed integer image copy with the borders wrapped by replication of source image pixel colors.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and a border consisting of wrapped replication of the source image pixel colors (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the wrapped replication of the corresponding column of source image pixels colors.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C1R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 32-bit signed integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C3R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 32-bit signed integer image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_C4R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 4 channel 32-bit signed integer image copy with the borders wrapped by replication of source image pixel colors with alpha channel unaffected.
 * See nppiCopyWrapBorder_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32s_AC4R(@Cast("const Npp32s*") int[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32s*") int[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);

/** 
 * 1 channel 32-bit floating point image copy with the borders wrapped by replication of source image pixel colors.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region of pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image (inner part) and a border consisting of wrapped replication of the source image pixel colors (outer part).
 * @param nTopBorderHeight Height (in pixels) of the top border. The number of pixel rows at the top of the
 *      destination ROI that will be filled with the wrapped replication of the corresponding column of source image pixels colors.
 *      nBottomBorderHeight = oDstSizeROI.height - nTopBorderHeight - oSrcSizeROI.height.
 * @param nLeftBorderWidth Width (in pixels) of the left border. The width of the border at the right side of the
 *      destination ROI is implicitly defined by the size of the source ROI:
 *      nRightBorderWidth = oDstSizeROI.width - nLeftBorderWidth - oSrcSizeROI.width.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 3 channel 32-bit floating point image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);

/**
 * 4 channel 32-bit floating point image copy with the borders wrapped by replication of source image pixel colors.
 * See nppiCopyWrapBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                           @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                     int nTopBorderHeight, int nLeftBorderWidth);
                                       
/**
 * 1 channel 32-bit floating point image copy with the borders wrapped by replication of source image pixel colors with alpha channel unaffected.
 * See nppiCopyWrapBorder_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSizeROI Size of the source region-of-interest.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nTopBorderHeight Height of top border.
 * @param nLeftBorderWidth Width of left border.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatPointer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);
public static native @Cast("NppStatus") int nppiCopyWrapBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc,  int nSrcStep, @ByVal NppiSize oSrcSizeROI,
                                            @Cast("Npp32f*") float[] pDst,  int nDstStep, @ByVal NppiSize oDstSizeROI,
                                      int nTopBorderHeight, int nLeftBorderWidth);

/** \} CopyWrapBorder */

/** \} image_copy_wrap_border */

/** 
 * \defgroup image_copy_sub_pixel Copy Sub-Pixel
 *
 * \{
 *
 */

/** \name CopySubpix
 *
 * Functions for copying linearly interpolated images using source image subpixel coordinates
 *
 * \{
 *
 */

/** 
 * 1 channel 8-bit unsigned integer linearly interpolated source image subpixel coordinate color copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 3 channel 8-bit unsigned integer linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 4 channel 8-bit unsigned integer linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                      @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
                                       
/**
 * 4 channel 8-bit unsigned integer linearly interpolated source image subpixel coordinate color copy with alpha channel unaffected.
 * See nppiCopySubpix_8u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                       @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                       @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                       @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/** 
 * 1 channel 16-bit unsigned integer linearly interpolated source image subpixel coordinate color copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 3 channel 16-bit unsigned integer linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 4 channel 16-bit unsigned integer linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                       @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
                                       
/**
 * 4 channel 16-bit unsigned linearly interpolated source image subpixel coordinate color copy with alpha channel unaffected.
 * See nppiCopySubpix_16u_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                        @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                        @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                        @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/** 
 * 1 channel 16-bit signed integer linearly interpolated source image subpixel coordinate color copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 3 channel 16-bit signed integer linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 4 channel 16-bit signed integer linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                       @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, 
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
                                       
/**
 * 4 channel 16-bit signed integer linearly interpolated source image subpixel coordinate color copy with alpha channel unaffected.
 * See nppiCopySubpix_16s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                        @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                        @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                        @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/** 
 * 1 channel 32-bit signed integer linearly interpolated source image subpixel coordinate color copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                       @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                       @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                       @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 3 channel 32-bit signed linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                       @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                       @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                       @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 4 channel 32-bit signed integer linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                       @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                       @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                       @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
                                       
/**
 * 4 channel 32-bit signed integer linearly interpolated source image subpixel coordinate color copy with alpha channel unaffected.
 * See nppiCopySubpix_32s_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                        @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                        @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                        @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/** 
 * 1 channel 32-bit floating point linearly interpolated source image subpixel coordinate color copy.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                       @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 3 channel 32-bit floating point linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                       @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/**
 * 4 channel 32-bit floating point linearly interpolated source image subpixel coordinate color copy.
 * See nppiCopySubpix_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                       @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                 @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
                                       
/**
 * 4 channel 32-bit floating point linearly interpolated source image subpixel coordinate color copy with alpha channel unaffected.
 * See nppiCopySubpix_32f_C1R() for detailed documentation.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @param nDx Fractional part of source image X coordinate.
 * @param nDy Fractional part of source image Y coordinate.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCopySubpix_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);
public static native @Cast("NppStatus") int nppiCopySubpix_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                        @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI,
                                  @Cast("Npp32f") float nDx, @Cast("Npp32f") float nDy);

/** \} CopySubpix */

/** \} image_copy_subpix */

/** 
 * \defgroup image_duplicate_channel Duplicate Channel
 *
 * \{
 *
 */

/** \name Dup
 * 
 * Functions for duplicating a single channel image in a multiple channel image.
 *
 * \{
 *
 */

/** 
 * 1 channel 8-bit unsigned integer source image duplicated in all 3 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_8u_C1C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_8u_C1C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_8u_C1C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);

/**
 * 1 channel 8-bit unsigned integer source image duplicated in all 4 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_8u_C1C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_8u_C1C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_8u_C1C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI); 
                                       
/**
 * 1 channel 8-bit unsigned integer source image duplicated in 3 channels of 4 channel destination image with alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_8u_C1AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                  @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_8u_C1AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                  @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_8u_C1AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                  @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI); 

/** 
 * 1 channel 16-bit unsigned integer source image duplicated in all 3 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_16u_C1C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16u_C1C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16u_C1C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI); 

/**
 * 1 channel 16-bit unsigned integer source image duplicated in all 4 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiDup_16u_C1C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16u_C1C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16u_C1C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI); 
                                       
/**
 * 1 channel 16-bit unsigned integer source image duplicated in 3 channels of 4 channel destination image with alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_16u_C1AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                   @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16u_C1AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                   @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16u_C1AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                   @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI); 

/** 
 * 1 channel 16-bit signed integer source image duplicated in all 3 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_16s_C1C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                  @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16s_C1C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                  @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16s_C1C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                  @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI); 

/**
 * 1 channel 16-bit signed integer source image duplicated in all 4 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiDup_16s_C1C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                  @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16s_C1C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                  @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16s_C1C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                  @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI); 
                                       
/**
 * 1 channel 16-bit signed integer source image duplicated in 3 channels of 4 channel destination image with alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_16s_C1AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                   @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16s_C1AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                   @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_16s_C1AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                   @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);

/** 
 * 1 channel 32-bit signed integer source image duplicated in all 3 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_32s_C1C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                  @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32s_C1C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                  @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32s_C1C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                  @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);

/**
 * 1 channel 32-bit signed integer source image duplicated in all 4 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiDup_32s_C1C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                  @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32s_C1C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                  @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32s_C1C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                  @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
                                       
/**
 * 1 channel 32-bit signed integer source image duplicated in 3 channels of 4 channel destination image with alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_32s_C1AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                   @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32s_C1AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                   @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32s_C1AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                   @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);

/** 
 * 1 channel 32-bit floating point source image duplicated in all 3 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size (width, height) of the destination region, i.e. the region that gets filled with
 *      data from the source image, source image ROI is assumed to be same as destination image ROI.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_32f_C1C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32f_C1C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32f_C1C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);

/**
 * 1 channel 32-bit floating point source image duplicated in all 4 channels of destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
  * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiDup_32f_C1C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32f_C1C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32f_C1C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
                                       
/**
 * 1 channel 32-bit floating point source image duplicated in 3 channels of 4 channel destination image with alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Size of the destination region-of-interest.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDup_32f_C1AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                   @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32f_C1AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                   @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);
public static native @Cast("NppStatus") int nppiDup_32f_C1AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                   @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI);

/** \} Dup */

/** \} image_duplicate_channel */


/** 
 * \defgroup image_transpose Transpose 
 * 
 * \{
 *
 */

/** \name Transpose
 * Methods for transposing images of various types. Like matrix transpose, image transpose is a mirror along the image's
 * diagonal (upper-left to lower-right corner).
 *
 * \{
 *
 */

/**
 * 1 channel 8-bit unsigned int image transpose.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 3 channel 8-bit unsigned int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 4 channel 8-bit unsigned int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 1 channel 16-bit unsigned int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 3 channel 16-bit unsigned int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 4 channel 16-bit unsigned int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 1 channel 16-bit signed int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 3 channel 16-bit signed int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 4 channel 16-bit signed int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 1 channel 32-bit signed int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 3 channel 32-bit signed int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 4 channel 32-bit signed int image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 1 channel 32-bit floating point image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 3 channel 32-bit floating point image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/**
 * 4 channel 32-bit floating point image transpose.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst Pointer to the destination ROI.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 *
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiTranspose_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSrcROI);
public static native @Cast("NppStatus") int nppiTranspose_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSrcROI);

/** \} Transpose */

/** \} image_transpose */


/** 
 * \defgroup image_swap_channels Swap Channels
 *
 * \{
 *
 */

/** \name SwapChannels
 * 
 * Functions for swapping and duplicating channels in multiple channel images. 
 * The methods support arbitrary permutations of the original channels, including replication and
 * setting one or more channels to a constant value.
 *
 * \{
 *
 */

/** 
 * 3 channel 8-bit unsigned integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 8-bit unsigned integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 4 channel 8-bit unsigned integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to a 3 channel BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/**
 * 4 channel 8-bit unsigned integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder); 
                                       
/** 
 * 4 channel 8-bit unsigned integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 8-bit unsigned integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [3,2,1,0] converts this to VBGR
 *      channel order.
 * @param nValue (V) Single channel constant value that can be replicated in one or more of the 4 destination channels.
 *      nValue is either written or not written to a particular channel depending on the aDstOrder entry for that destination
 *      channel. An aDstOrder value of 3 will output nValue to that channel, an aDstOrder value greater than 3 will leave that
 *      particular destination channel value unmodified.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_C3C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder, @Cast("const Npp8u") byte nValue);

/**
 * 4 channel 8-bit unsigned integer source image to 4 channel destination image with destination alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [3,2,1,0] converts this to VBGR
 *      channel order.
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to BGRA
 *      channel order. In the AC4R case, the alpha channel is always assumed to be channel 3.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder); 

/** 
 * 3 channel 16-bit unsigned integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder); 

/** 
 * 3 channel 16-bit unsigned integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 4 channel 16-bit unsigned integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to a 3 channel BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                           @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                           @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/**
 * 4 channel 16-bit unsigned integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder); 
                                       
/** 
 * 4 channel 16-bit unsigned integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 16-bit unsigned integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [3,2,1,0] converts this to VBGR
 *      channel order.
 * @param nValue (V) Single channel constant value that can be replicated in one or more of the 4 destination channels.
 *      nValue is either written or not written to a particular channel depending on the aDstOrder entry for that destination
 *      channel. An aDstOrder value of 3 will output nValue to that channel, an aDstOrder value greater than 3 will leave that
 *      particular destination channel value unmodified.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                           @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_C3C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                           @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder, @Cast("const Npp16u") short nValue);

/**
 * 4 channel 16-bit unsigned integer source image to 4 channel destination image with destination alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to BGRA
 *      channel order. In the AC4R case, the alpha channel is always assumed to be channel 3.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                                          @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder); 

/** 
 * 3 channel 16-bit signed integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                         @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder); 

/** 
 * 3 channel 16-bit signed integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 4 channel 16-bit signed integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to a 3 channel BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                           @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                           @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/**
 * 4 channel 16-bit signed integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                         @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder); 
                                       
/** 
 * 4 channel 16-bit signed integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 16-bit signed integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [3,2,1,0] converts this to VBGR
 *      channel order.
 * @param nValue (V) Single channel constant value that can be replicated in one or more of the 4 destination channels.
 *      nValue is either written or not written to a particular channel depending on the aDstOrder entry for that destination
 *      channel. An aDstOrder value of 3 will output nValue to that channel, an aDstOrder value greater than 3 will leave that
 *      particular destination channel value unmodified.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                           @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_C3C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                           @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder, @Cast("const Npp16s") short nValue);

/**
 * 4 channel 16-bit signed integer source image to 4 channel destination image with destination alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to BGRA
 *      channel order. In the AC4R case, the alpha channel is always assumed to be channel 3.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 32-bit signed integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                         @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                         @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 32-bit signed integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3IR(@Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3IR(@Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3IR(@Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 4 channel 32-bit signed integer source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to a 3 channel BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, 
                                           @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, 
                                           @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/**
 * 4 channel 32-bit signed integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                         @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                         @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);
                                       
/** 
 * 4 channel 32-bit signed integer in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4IR(@Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4IR(@Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C4IR(@Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 32-bit signed integer source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [3,2,1,0] converts this to VBGR
 *      channel order.
 * @param nValue (V) Single channel constant value that can be replicated in one or more of the 4 destination channels.
 *      nValue is either written or not written to a particular channel depending on the aDstOrder entry for that destination
 *      channel. An aDstOrder value of 3 will output nValue to that channel, an aDstOrder value greater than 3 will leave that
 *      particular destination channel value unmodified.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, 
                                           @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder, @Cast("const Npp32s") int nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder, @Cast("const Npp32s") int nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_C3C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, 
                                           @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder, @Cast("const Npp32s") int nValue);

/**
 * 4 channel 32-bit signed integer source image to 4 channel destination image with destination alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to BGRA
 *      channel order. In the AC4R case, the alpha channel is always assumed to be channel 3.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep,
                                          @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep,
                                          @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep,
                                          @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 32-bit floating point source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 32-bit floating point in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [2,1,0] converts this to BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 4 channel 32-bit floating point source image to 3 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to a 3 channel BGR
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/**
 * 4 channel 32-bit floating point source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);
                                       
/** 
 * 4 channel 32-bit floating point in place image.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an ARGB image, aDstOrder = [3,2,1,0] converts this to BGRA
 *      channel order.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** 
 * 3 channel 32-bit floating point source image to 4 channel destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGB image, aDstOrder = [3,2,1,0] converts this to VBGR
 *      channel order.
 * @param nValue (V) Single channel constant value that can be replicated in one or more of the 4 destination channels.
 *      nValue is either written or not written to a particular channel depending on the aDstOrder entry for that destination
 *      channel. An aDstOrder value of 3 will output nValue to that channel, an aDstOrder value greater than 3 will leave that
 *      particular destination channel value unmodified.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_C3C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder, @Cast("const Npp32f") float nValue);

/**
 * 4 channel 32-bit floating point source image to 4 channel destination image with destination alpha channel unaffected.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDstOrder Host memory integer array describing how channel values are permutated. The n-th entry
 *      of the array contains the number of the channel that is stored in the n-th channel of
 *      the output image. E.g. Given an RGBA image, aDstOrder = [2,1,0] converts this to BGRA
 *      channel order. In the AC4R case, the alpha channel is always assumed to be channel 3.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSwapChannels_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntPointer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const IntBuffer aDstOrder);
public static native @Cast("NppStatus") int nppiSwapChannels_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Const int[] aDstOrder);

/** \} SwapChannels */

/** \} image_swap_channels */

/** \} image_data_exchange_and_initialization */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_DATA_EXCHANGE_AND_INITIALIZATION_H */


// Parsed from <nppi_arithmetic_and_logical_operations.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_ARITHMETIC_AND_LOGICAL_OPERATIONS_H
// #define NV_NPPI_ARITHMETIC_AND_LOGICAL_OPERATIONS_H
 
/**
 * \file nppi_arithmetic_and_logical_operations.h
 * Image Arithmetic and Logical Operations.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif


/** 
 * \defgroup image_arithmetic_and_logical_operations Arithmetic and Logical Operations
 * \ingroup nppi
 * \{
 */

/** 
 * \defgroup image_arithmetic_operations Arithmetic Operations
 * \{
 */

/** 
 * \defgroup image_addc AddC
 *
 * Adds a constant value to each pixel of an image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image add constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel..
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel 8-bit unsigned char in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel..
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C3IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel..
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel..
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel..
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_8u_C4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image add constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C3IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_AC4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16u_C4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image add constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C3IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                           @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_AC4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_16s_C4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const @ByVal Npp16sc nConstant, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image add constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16sc_C1IRSfs(@Const @ByVal Npp16sc nConstant, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16sc_C3IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_16sc_AC4IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image add constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAddC_32s_C3IRSfs(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const @ByVal Npp32sc nConstant, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image add constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32sc_C1IRSfs(@Const @ByVal Npp32sc nConstant, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32sc_C3IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha image add constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                            Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image add constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32sc_AC4IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image add constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image add constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_C3IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C3IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C3IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                        @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                        @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                        @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image add constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_AC4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_AC4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image add constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32f_C4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddC_32f_C4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const @ByVal Npp32fc nConstant, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image add constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_C1IR(@Const @ByVal Npp32fc nConstant, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image add constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_C3IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                         Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha in place image add constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_AC4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image add constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image add constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddC_32fc_C4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_addc */ 


/** 
 * \defgroup image_mulc MulC
 *
 * Multiplies each pixel of an image by a constant value.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel 8-bit unsigned char in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C3IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_8u_C4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C3IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_AC4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16u_C4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C3IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                           @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_AC4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_16s_C4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const @ByVal Npp16sc nConstant, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16sc_C1IRSfs(@Const @ByVal Npp16sc nConstant, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16sc_C3IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_16sc_AC4IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMulC_32s_C3IRSfs(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const @ByVal Npp32sc nConstant, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32sc_C1IRSfs(@Const @ByVal Npp32sc nConstant, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32sc_C3IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha image multiply by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                            Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image multiply by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32sc_AC4IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image multiply by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image multiply by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_C3IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C3IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C3IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                        @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                        @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                        @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image multiply by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_AC4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_AC4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image multiply by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32f_C4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulC_32f_C4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const @ByVal Npp32fc nConstant, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image multiply by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_C1IR(@Const @ByVal Npp32fc nConstant, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image multiply by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_C3IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                         Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha in place image multiply by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_AC4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image multiply by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image multiply by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulC_32fc_C4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_mulc */ 

/** 
 * \defgroup image_mulcscale MulCScale
 *
 * Multiplies each pixel of an image by a constant value then scales the result
 * by the maximum value for the data bit width.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                           @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                           @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                           @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image multiply by constant and scale by max bit width value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                           @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                           @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                           @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel 8-bit unsigned char in place image multiply by constant and scale by max bit width value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_C3IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C3IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C3IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                            @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                            @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                            @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image multiply by constant, scale and scale by max bit width value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_AC4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_AC4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                           @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                           @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                           @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image multiply by constant and scale by max bit width value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_8u_C4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_8u_C4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                            @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                            @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                            @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image multiply by constant and scale by max bit width value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                            @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                            @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                            @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel in place image multiply by constant and scale by max bit width value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_C3IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C3IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C3IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                             @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                             @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                             @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image multiply by constant and scale by max bit width value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_AC4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_AC4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image multiply by constant and scale by max bit width value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                            @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                            @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                            @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image multiply by constant and scale by max bit width value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulCScale_16u_C4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulCScale_16u_C4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_mulcscale */ 

/** \defgroup image_subc SubC
 * Subtracts a constant value from each pixel of an image.
 * \{
 */

/** 
 * One 8-bit unsigned char channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image subtract constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel 8-bit unsigned char in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C3IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_8u_C4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image subtract constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C3IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_AC4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16u_C4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image subtract constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C3IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                           @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_AC4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_16s_C4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const @ByVal Npp16sc nConstant, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image subtract constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16sc_C1IRSfs(@Const @ByVal Npp16sc nConstant, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16sc_C3IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_16sc_AC4IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image subtract constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSubC_32s_C3IRSfs(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const @ByVal Npp32sc nConstant, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image subtract constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32sc_C1IRSfs(@Const @ByVal Npp32sc nConstant, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32sc_C3IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha image subtract constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                            Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image subtract constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32sc_AC4IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image subtract constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image subtract constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_C3IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C3IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C3IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                        @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                        @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                        @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image subtract constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_AC4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_AC4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image subtract constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32f_C4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSubC_32f_C4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const @ByVal Npp32fc nConstant, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image subtract constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_C1IR(@Const @ByVal Npp32fc nConstant, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image subtract constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_C3IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                         Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha in place image subtract constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_AC4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image subtract constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image subtract constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSubC_32fc_C4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_subc */ 

/** 
 * \defgroup image_divc DivC
 *
 * Divides each pixel of an image by a constant value.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image divided by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C1IRSfs(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel 8-bit unsigned char in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C3IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_8u_C4IRSfs(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image divided by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C1IRSfs(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C3IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_AC4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16u_C4IRSfs(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s") short nConstant, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image divided by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C1IRSfs(@Cast("const Npp16s") short nConstant, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C3IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                           @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_AC4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_16s_C4IRSfs(@Cast("const Npp16s*") short[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const @ByVal Npp16sc nConstant, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image divided by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16sc_C1IRSfs(@Const @ByVal Npp16sc nConstant, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16sc_C3IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc aConstants, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_16sc_AC4IRSfs(@Const Npp16sc aConstants, Npp16sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image divided by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C1IRSfs(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDivC_32s_C3IRSfs(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const @ByVal Npp32sc nConstant, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image divided by constant, scale, then clamp to saturated value.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32sc_C1IRSfs(@Const @ByVal Npp32sc nConstant, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32sc_C3IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha image divided by constant, scale, then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc aConstants, 
                            Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed complex integer (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image divided by constant, scale, then clamp to saturated value.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32sc_AC4IRSfs(@Const Npp32sc aConstants, Npp32sc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f") float nConstant, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image divided by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C1IR(@Cast("const Npp32f") float nConstant, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image divided by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_C3IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C3IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C3IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                        @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                        @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                        @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image divided by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_AC4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_AC4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer aConstants, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer aConstants, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] aConstants, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image divided by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32f_C4IR(@Cast("const Npp32f*") FloatPointer aConstants, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C4IR(@Cast("const Npp32f*") FloatBuffer aConstants, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDivC_32f_C4IR(@Cast("const Npp32f*") float[] aConstants, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const @ByVal Npp32fc nConstant, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image divided by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_C1IR(@Const @ByVal Npp32fc nConstant, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image divided by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_C3IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                         Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel with unmodified alpha in place image divided by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_AC4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel image divided by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc aConstants, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit complex floating point (32-bit floating point real, 32-bit floating point imaginary) channel in place image divided by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDivC_32fc_C4IR(@Const Npp32fc aConstants, Npp32fc pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_divc */ 

/** 
 * \defgroup image_absdiffc AbsDiffC
 *
 * Determines absolute difference between each pixel of an image and a constant value.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image absolute difference with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiffC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nConstant);
public static native @Cast("NppStatus") int nppiAbsDiffC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nConstant);
public static native @Cast("NppStatus") int nppiAbsDiffC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nConstant);

/** 
 * One 16-bit unsigned short channel image absolute difference with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiffC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp16u") short nConstant);
public static native @Cast("NppStatus") int nppiAbsDiffC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp16u") short nConstant);
public static native @Cast("NppStatus") int nppiAbsDiffC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp16u") short nConstant);

/** 
 * One 32-bit floating point channel image absolute difference with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiffC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nConstant);
public static native @Cast("NppStatus") int nppiAbsDiffC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nConstant);
public static native @Cast("NppStatus") int nppiAbsDiffC_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nConstant);

/** \} image_absdiffc */ 

/** 
 * \defgroup image_add Add
 *
 * Pixel by pixel addition of two images.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_C1IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C1IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C1IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C3IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_8u_C4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_C1IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C1IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C1IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C3IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_AC4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16u_C4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_C1IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C1IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C1IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C3IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_AC4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_16s_C4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16sc_C1IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16sc_C3IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_16sc_AC4IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                            Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/**
 * Note: This function is to be deprecated in future NPP releases, use the function above with a scale factor of 0 instead. 
 * 32-bit image add.
 * Add the pixel values of corresponding pixels in the ROI and write them to the output image.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntPointer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") int[] pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);                        

/** 
 * One 32-bit signed integer channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32s_C1IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C1IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C1IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiAdd_32s_C3IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32sc_C1IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32sc_C3IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image addition, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32sc_AC4IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                            Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C1IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_C3IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C3IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C3IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_AC4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_AC4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32f_C4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAdd_32f_C4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_C1IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_C3IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_AC4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                         Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image addition.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image addition.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAdd_32fc_C4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_add */ 

/** 
 * \defgroup image_addsquare AddSquare
 *
 * Pixel by pixel addition of squared pixels from source image to floating point
 * pixel values of destination image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image squared then added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddSquare_8u32f_C1IMR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep,     @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, 
                                @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_8u32f_C1IMR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep,     @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, 
                                @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_8u32f_C1IMR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep,     @Cast("const Npp8u*") byte[] pMask, int nMaskStep, 
                                @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel image squared then added to in place floating point destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddSquare_8u32f_C1IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                               @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_8u32f_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                               @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_8u32f_C1IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                               @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image squared then added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddSquare_16u32f_C1IMR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, 
                                 @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_16u32f_C1IMR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, 
                                 @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_16u32f_C1IMR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, 
                                 @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image squared then added to in place floating point destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddSquare_16u32f_C1IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                                @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_16u32f_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_16u32f_C1IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                                @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel image squared then added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddSquare_32f_C1IMR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, 
                              @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_32f_C1IMR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, 
                              @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_32f_C1IMR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, 
                              @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel image squared then added to in place floating point destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddSquare_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                             @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                             @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddSquare_32f_C1IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                             @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_addsquare */ 

/** 
 * \defgroup image_addproduct AddProduct
 * Pixel by pixel addition of product of pixels from two source images to
 * floating point pixel values of destination image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image product added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddProduct_8u32f_C1IMR(@Cast("const Npp8u*") BytePointer pSrc1,  int nSrc1Step,    @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step,
                           @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,    @Cast("Npp32f*") FloatPointer pSrcDst,    int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_8u32f_C1IMR(@Cast("const Npp8u*") ByteBuffer pSrc1,  int nSrc1Step,    @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step,
                           @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,    @Cast("Npp32f*") FloatBuffer pSrcDst,    int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_8u32f_C1IMR(@Cast("const Npp8u*") byte[] pSrc1,  int nSrc1Step,    @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step,
                           @Cast("const Npp8u*") byte[] pMask, int nMaskStep,    @Cast("Npp32f*") float[] pSrcDst,    int nSrcDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel image product added to in place floating point destination image.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddProduct_8u32f_C1IR(@Cast("const Npp8u*") BytePointer pSrc1,    int nSrc1Step,   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step,
                                @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_8u32f_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc1,    int nSrc1Step,   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step,
                                @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_8u32f_C1IR(@Cast("const Npp8u*") byte[] pSrc1,    int nSrc1Step,   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step,
                                @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image product added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddProduct_16u32f_C1IMR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step,    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step,
                            @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,    @Cast("Npp32f*") FloatPointer pSrcDst,     int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_16u32f_C1IMR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step,    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step,
                            @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,    @Cast("Npp32f*") FloatBuffer pSrcDst,     int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_16u32f_C1IMR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step,    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step,
                            @Cast("const Npp8u*") byte[] pMask, int nMaskStep,    @Cast("Npp32f*") float[] pSrcDst,     int nSrcDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image product added to in place floating point destination image.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddProduct_16u32f_C1IR(@Cast("const Npp16u*") ShortPointer pSrc1,    int nSrc1Step,   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step,
                                 @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_16u32f_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc1,    int nSrc1Step,   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step,
                                 @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_16u32f_C1IR(@Cast("const Npp16u*") short[] pSrc1,    int nSrc1Step,   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step,
                                 @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel image product added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddProduct_32f_C1IMR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,    @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                         @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,    @Cast("Npp32f*") FloatPointer pSrcDst,     int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_32f_C1IMR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,    @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                         @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,    @Cast("Npp32f*") FloatBuffer pSrcDst,     int nSrcDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_32f_C1IMR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,    @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                         @Cast("const Npp8u*") byte[] pMask, int nMaskStep,    @Cast("Npp32f*") float[] pSrcDst,     int nSrcDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel image product added to in place floating point destination image.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddProduct_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc1,    int nSrc1Step,   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                              @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc1,    int nSrc1Step,   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                              @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAddProduct_32f_C1IR(@Cast("const Npp32f*") float[] pSrc1,    int nSrc1Step,   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                              @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_addproduct */ 

/** 
 * \defgroup image_addweighted AddWeighted
 * Pixel by pixel addition of alpha weighted pixel values from a source image to
 * floating point pixel values of destination image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel alpha weighted image added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAlpha Alpha weight to be applied to source image pixels (0.0F to 1.0F)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddWeighted_8u32f_C1IMR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep,     @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, 
                                  @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep,  @ByVal NppiSize oSizeROI,   @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_8u32f_C1IMR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep,     @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, 
                                  @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep,  @ByVal NppiSize oSizeROI,   @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_8u32f_C1IMR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep,     @Cast("const Npp8u*") byte[] pMask, int nMaskStep, 
                                  @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep,  @ByVal NppiSize oSizeROI,   @Cast("Npp32f") float nAlpha);

/** 
 * One 8-bit unsigned char channel alpha weighted image added to in place floating point destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAlpha Alpha weight to be applied to source image pixels (0.0F to 1.0F)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddWeighted_8u32f_C1IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                                 @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_8u32f_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                                 @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_8u32f_C1IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                                 @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);

/** 
 * One 16-bit unsigned short channel alpha weighted image added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAlpha Alpha weight to be applied to source image pixels (0.0F to 1.0F)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddWeighted_16u32f_C1IMR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep,     @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, 
                                   @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI,   @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_16u32f_C1IMR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep,     @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, 
                                   @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI,   @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_16u32f_C1IMR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep,     @Cast("const Npp8u*") byte[] pMask, int nMaskStep, 
                                   @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep,  @ByVal NppiSize oSizeROI,   @Cast("Npp32f") float nAlpha);

/** 
 * One 16-bit unsigned short channel alpha weighted image added to in place floating point destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAlpha Alpha weight to be applied to source image pixels (0.0F to 1.0F)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddWeighted_16u32f_C1IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                                  @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_16u32f_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                                  @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_16u32f_C1IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                                  @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);

/** 
 * One 32-bit floating point channel alpha weighted image added to in place floating point destination image using filter mask (updates destination when mask is non-zero).
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAlpha Alpha weight to be applied to source image pixels (0.0F to 1.0F)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddWeighted_32f_C1IMR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, 
                                @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_32f_C1IMR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, 
                                @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_32f_C1IMR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, 
                                @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);

/** 
 * One 32-bit floating point channel alpha weighted image added to in place floating point destination image.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAlpha Alpha weight to be applied to source image pixels (0.0F to 1.0F)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAddWeighted_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                               @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                               @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);
public static native @Cast("NppStatus") int nppiAddWeighted_32f_C1IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                               @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nAlpha);

/** \} image_addweighted */ 

/** 
 * \defgroup image_mul Mul
 *
 * Pixel by pixel multiply of two images.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_C1IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C1IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C1IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C3IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_8u_C4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_C1IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C1IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C1IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C3IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_AC4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16u_C4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_C1IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C1IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C1IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C3IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_AC4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_16s_C4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16sc_C1IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16sc_C3IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_16sc_AC4IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                            Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Note: This function is to be deprecated in future NPP releases, use the function above with a scale factor of 0 instead.
 * 1 channel 32-bit image multiplication.
 * Multiply corresponding pixels in ROI. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntPointer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") int[] pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI); 

/** 
 * One 32-bit signed integer channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32s_C1IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C1IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C1IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiMul_32s_C3IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32sc_C1IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32sc_C3IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image multiplication, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32sc_AC4IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                            Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C1IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_C3IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C3IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C3IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_AC4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_AC4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32f_C4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMul_32f_C4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_C1IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_C3IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_AC4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                         Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image multiplication.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image multiplication.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMul_32fc_C4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_mul */ 

/** 
 * \defgroup image_mulscale MulScale
 *
 * Pixel by pixel multiplies each pixel of two images then scales the result by
 * the maximum value for the data bit width.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_C1IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C1IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_C3IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C3IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C3IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                           @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                           @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                           @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_AC4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                            @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                            @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_AC4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                            @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_8u_C4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_8u_C4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                           @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_C1IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C1IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_C3IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C3IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C3IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                            @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                            @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                            @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_AC4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                             @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                             @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_AC4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                             @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image multiplication then scale by maximum value for pixel bit width.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMulScale_16u_C4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMulScale_16u_C4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                            @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_mulscale */ 

/** 
 * \defgroup image_sub Sub
 *
 * Pixel by pixel subtraction of two images.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_C1IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C1IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C1IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C3IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_8u_C4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_C1IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C1IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C1IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C3IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_AC4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16u_C4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_C1IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C1IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C1IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C3IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_AC4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_16s_C4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16sc_C1IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16sc_C3IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_16sc_AC4IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                            Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/**
 * Note: This function is to be deprecated in future NPP releases, use the function above with a scale factor of 0 instead. 
 * 32-bit image subtraction.
 * Subtract pSrc1's pixels from corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntPointer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") int[] pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32s_C1IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C1IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C1IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSub_32s_C3IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed integer channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */


/** 
 * Four 32-bit signed integer channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */


/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32sc_C1IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32sc_C3IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image subtraction, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32sc_AC4IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                            Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C1IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_C3IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C3IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C3IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_AC4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_AC4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32f_C4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSub_32f_C4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_C1IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_C3IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_AC4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                         Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image subtraction.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image subtraction.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSub_32fc_C4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_sub */ 

/** 
 * \defgroup image_div Div
 *
 * Pixel by pixel division of two images.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_C1IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C1IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C1IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C3IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel with unmodified alpha in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                          @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                        @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_8u_C4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                         @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_C1IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C1IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C1IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C3IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel with unmodified alpha in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_AC4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16u_C4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_C1IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C1IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C1IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C3IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel with unmodified alpha in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_AC4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                           @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                         @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_16s_C4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                          @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16sc_C1RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16sc_C1IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16sc_C3RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                          Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16sc_C3IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                           Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16sc_AC4RSfs(@Const Npp16sc pSrc1, int nSrc1Step, @Const Npp16sc pSrc2, int nSrc2Step, 
                           Npp16sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 16-bit signed short complex number (16-bit real, 16-bit imaginary) channel with unmodified alpha in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_16sc_AC4IRSfs(@Const Npp16sc pSrc,     int nSrcStep, 
                            Npp16sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/**
 * Note: This function is to be deprecated in future NPP releases, use the function above with a scale factor of 0 instead. 
 * 32-bit image division.
 * Divide pixels in pSrc2 by pSrc1's pixels. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntPointer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") IntBuffer pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                          @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                @Cast("Npp32s*") int[] pDst,  int nDstStep, 
                                @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32s_C1IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C1IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C1IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32s_C3RSfs(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C3RSfs(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C3RSfs(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                         @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32s_C3IRSfs(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C3IRSfs(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_32s_C3IRSfs(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                          @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32sc_C1RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32sc_C1IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32sc_C3RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                          Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * One 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32sc_C3IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                           Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32sc_AC4RSfs(@Const Npp32sc pSrc1, int nSrc1Step, @Const Npp32sc pSrc2, int nSrc2Step, 
                           Npp32sc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   int nScaleFactor);

/** 
 * Four 32-bit signed integer complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32sc_AC4IRSfs(@Const Npp32sc pSrc,     int nSrcStep, 
                            Npp32sc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C1IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_C3IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C3IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C3IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                       @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel with unmodified alpha in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_AC4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_AC4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                        @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32f_C4IR(@Cast("const Npp32f*") FloatPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C4IR(@Cast("const Npp32f*") FloatBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDiv_32f_C4IR(@Cast("const Npp32f*") float[] pSrc,     int nSrcStep, 
                       @Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_C1IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_C3IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_AC4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                        Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel with unmodified alpha in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_AC4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                         Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel image division.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, @Const Npp32fc pSrc2, int nSrc2Step, 
                       Npp32fc pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point complex number (32-bit real, 32-bit imaginary) channel in place image division.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_32fc_C4IR(@Const Npp32fc pSrc,     int nSrcStep, 
                        Npp32fc pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_div */ 

/** 
 * \defgroup image_divround Div_Round
 *
 * Pixel by pixel division of two images using result rounding modes.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C1IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C1IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C1IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C3IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C3IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C3IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
                               
/** 
 * Four 8-bit unsigned char channel image division with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                               @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                               @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                               @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image division with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_AC4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                                @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_AC4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_AC4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                                @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                              @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C4IRSfs(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C4IRSfs(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_8u_C4IRSfs(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                               @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C1IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C1IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C1IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C3IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C3IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C3IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
                               
/** 
 * Four 16-bit unsigned short channel image division with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image division with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_AC4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                                 @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_AC4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                                 @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_AC4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                                 @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                               @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C4IRSfs(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C4IRSfs(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16u_C4IRSfs(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                                @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * One 16-bit signed short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C1IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C1IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C1IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C3IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C3IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C3IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
                               
/** 
 * Four 16-bit signed short channel image division with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image division with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_AC4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                                 @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_AC4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                                 @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_AC4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                                 @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                               @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,    @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image division, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rndMode Result Rounding mode to be used (NPP_RND_ZERO, NPP_RND_NEAR, or NP_RND_FINANCIAL)
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C4IRSfs(@Cast("const Npp16s*") ShortPointer pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C4IRSfs(@Cast("const Npp16s*") ShortBuffer pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);
public static native @Cast("NppStatus") int nppiDiv_Round_16s_C4IRSfs(@Cast("const Npp16s*") short[] pSrc,     int nSrcStep, 
                                @Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, @Cast("NppRoundMode") int rndMode, int nScaleFactor);

/** \} image_divround */ 

/** 
 * \defgroup image_abs Abs
 *
 * Absolute value of each pixel value in an image.
 *
 * \{
 */

/** 
 * One 16-bit signed short channel image absolute value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit signed short channel in place image absolute value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit signed short channel image absolute value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit signed short channel in place image absolute value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel image absolute value with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel in place image absolute value with unmodified alpha.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel image absolute value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel in place image absolute value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_16s_C4IR(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C4IR(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_16s_C4IR(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel image absolute value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image absolute value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image absolute value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image absolute value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image absolute value with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image absolute value with unmodified alpha.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image absolute value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image absolute value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbs_32f_C4IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C4IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbs_32f_C4IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_abs */ 

/** 
 * \defgroup image_absdiff AbsDiff
 *
 * Pixel by pixel absolute difference between two images.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel absolute difference of image1 minus image2.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channels absolute difference of image1 minus image2.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channels absolute difference of image1 minus image2.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel absolute difference of image1 minus image2.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiff_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel absolute difference of image1 minus image2.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAbsDiff_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAbsDiff_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** \} image_absdiff */ 

/** 
 * \defgroup image_sqr Sqr
 *
 * Square each pixel in an image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_C1IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C1IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C1IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_C3IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C3IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C3IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image squared with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image squared with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_AC4IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_AC4IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_AC4IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_8u_C4IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C4IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_8u_C4IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_C1IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C1IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C1IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_C3IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C3IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C3IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image squared with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image squared with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_AC4IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_AC4IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_AC4IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_C4RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C4RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16u_C4IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C4IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16u_C4IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_C1IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C1IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C1IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_C3IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C3IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C3IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image squared with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image squared with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_AC4IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_AC4IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_AC4IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_C4RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C4RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image squared, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_16s_C4IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C4IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqr_16s_C4IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image squared.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image squared.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image squared.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image squared.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image squared with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image squared with unmodified alpha.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image squared.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image squared.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqr_32f_C4IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C4IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqr_32f_C4IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_sqr */ 

/** \defgroup image_sqrt Sqrt
 *
 * Pixel by pixel square root of each pixel in an image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_8u_C1IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C1IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C1IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel in place image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_8u_C3IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C3IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_C3IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel image square root with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 8-bit unsigned char channel in place image square root with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_8u_AC4IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_AC4IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_8u_AC4IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16u_C1IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C1IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C1IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16u_C3IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C3IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_C3IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel image square root with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16u_AC4RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_AC4RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_AC4RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit unsigned short channel in place image square root with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16u_AC4IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_AC4IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16u_AC4IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16s_C1IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C1IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C1IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image square root, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16s_C3IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C3IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_C3IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel image square root with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16s_AC4RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_AC4RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_AC4RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Four 16-bit signed short channel in place image square root with unmodified alpha, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_16s_AC4IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_AC4IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrt_16s_AC4IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image square root.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image square root.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image square root.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image square root.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image square root with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image square root with unmodified alpha.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel image square root.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit floating point channel in place image square root.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrt_32f_C4IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C4IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiSqrt_32f_C4IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_sqrt */ 

/** \defgroup image_ln Ln
 *
 * Pixel by pixel natural logarithm of each pixel in an image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_8u_C1IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C1IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C1IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel in place image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_8u_C3IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C3IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_8u_C3IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16u_C1IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C1IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C1IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16u_C3IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C3IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16u_C3IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16s_C1IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C1IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C1IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image natural logarithm, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_16s_C3IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C3IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiLn_16s_C3IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image natural logarithm.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image natural logarithm.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image natural logarithm.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image natural logarithm.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLn_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLn_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_ln */ 

/** 
 * \defgroup image_exp Exp
 *
 * Exponential value of each pixel in an image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 8-bit unsigned char channel in place image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_8u_C1IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C1IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C1IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 8-bit unsigned char channel in place image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_8u_C3IRSfs(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C3IRSfs(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_8u_C3IRSfs(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16u_C1RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C1RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C1RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit unsigned short channel in place image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16u_C1IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C1IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C1IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16u_C3RSfs(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C3RSfs(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C3RSfs(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit unsigned short channel in place image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16u_C3IRSfs(@Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C3IRSfs(@Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16u_C3IRSfs(@Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16s_C1RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C1RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C1RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 16-bit signed short channel in place image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16s_C1IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C1IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C1IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16s_C3RSfs(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C3RSfs(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C3RSfs(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * Three 16-bit signed short channel in place image exponential, scale by 2^(-nScaleFactor), then clamp to saturated value.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_16s_C3IRSfs(@Cast("Npp16s*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C3IRSfs(@Cast("Npp16s*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);
public static native @Cast("NppStatus") int nppiExp_16s_C3IRSfs(@Cast("Npp16s*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI, int nScaleFactor);

/** 
 * One 32-bit floating point channel image exponential.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit floating point channel in place image exponential.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel image exponential.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit floating point channel in place image exponential.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiExp_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiExp_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_exp */ 

/** \} image_arithmetic_operations */ 

/** 
 * \defgroup image_logical_operations Logical Operations
 *
 * \{
 */

/** \defgroup image_andc AndC
 *
 * Pixel by pixel logical and of an image with a constant.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image logical and with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel in place image logical and with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_C3IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C3IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C3IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical and with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                       @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                       @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                       @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical and with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_AC4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_AC4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical and with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_8u_C4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_8u_C4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image logical and with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel in place image logical and with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_C3IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C3IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C3IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical and with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                        @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                        @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                        @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image logical and with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_AC4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_AC4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image logical and with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_16u_C4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_16u_C4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel in place image logical and with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel in place image logical and with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_C3IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C3IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C3IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical and with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                        @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                        @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                        @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image logical and with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_AC4IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_AC4IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_AC4IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical and with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image logical and with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAndC_32s_C4IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C4IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAndC_32s_C4IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_andc */ 


/** 
 * \defgroup image_orc OrC
 *
 * Pixel by pixel logical or of an image with a constant.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image logical or with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel in place image logical or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_C3IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C3IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C3IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical or with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical or with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_AC4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_AC4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_8u_C4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_8u_C4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image logical or with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel in place image logical or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_C3IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C3IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C3IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical or with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image logical or with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_AC4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_AC4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image logical or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_16u_C4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_16u_C4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel in place image logical or with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel in place image logical or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_C3IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C3IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C3IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical or with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image logical or with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_AC4IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_AC4IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_AC4IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image logical or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOrC_32s_C4IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C4IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOrC_32s_C4IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_orc */ 

/** 
 * \defgroup image_xorc XorC
 *
 * Pixel by pixel logical exclusive or of an image with a constant.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u") byte nConstant, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image logical exclusive or with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C1IR(@Cast("const Npp8u") byte nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel in place image logical exclusive or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_C3IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C3IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C3IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical exclusive or with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                       @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                       @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                       @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical exclusive or with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_AC4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_AC4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer aConstants, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer aConstants, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] aConstants, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical exclusive or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_8u_C4IR(@Cast("const Npp8u*") BytePointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C4IR(@Cast("const Npp8u*") ByteBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_8u_C4IR(@Cast("const Npp8u*") byte[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u") short nConstant, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image logical exclusive or with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C1IR(@Cast("const Npp16u") short nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel in place image logical exclusive or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_C3IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C3IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C3IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical exclusive or with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                        @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                        @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                        @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image logical exclusive or with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_AC4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_AC4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer aConstants, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer aConstants, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] aConstants, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image logical exclusive or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_16u_C4IR(@Cast("const Npp16u*") ShortPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C4IR(@Cast("const Npp16u*") ShortBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_16u_C4IR(@Cast("const Npp16u*") short[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s") int nConstant, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel in place image logical exclusive or with constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C1IR(@Cast("const Npp32s") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel in place image logical exclusive or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_C3IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C3IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C3IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical exclusive or with constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                        @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                        @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                        @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image logical exclusive or with constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_AC4IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_AC4IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_AC4IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical exclusive or with constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer aConstants, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer aConstants, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] aConstants, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image logical exclusive or with constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXorC_32s_C4IR(@Cast("const Npp32s*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C4IR(@Cast("const Npp32s*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXorC_32s_C4IR(@Cast("const Npp32s*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_xorc */ 

/** 
 * \defgroup image_rshiftc RShiftC
 *
 * Pixel by pixel right shift of an image by a constant value.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image right shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image right shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image right shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8u_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8u_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit signed char channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8s*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8s*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8s*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit signed char channel in place image right shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit signed char channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                         @Cast("Npp8s*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                         @Cast("Npp8s*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C3R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                         @Cast("Npp8s*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit signed char channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit signed char channel image right shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_AC4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp8s*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp8s*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_AC4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp8s*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit signed char channel in place image right shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit signed char channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                         @Cast("Npp8s*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                         @Cast("Npp8s*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                         @Cast("Npp8s*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit signed char channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_8s_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_8s_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image right shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image right shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image right shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16u_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16u_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit signed short channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit signed short channel in place image right shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit signed short channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit signed short channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel image right shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                           @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                           @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                           @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel in place image right shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit signed short channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_16s_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_16s_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel in place image right shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image right shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                           @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                           @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                           @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image right shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image right shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image right shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRShiftC_32s_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRShiftC_32s_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_rshiftc */ 

/** 
 * \defgroup image_lshiftc LShiftC
 *
 * Pixel by pixel left shift of an image by a constant value.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image left shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel in place image left shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image left shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image left shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                         @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                         @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                         @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image left shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_8u_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_8u_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image left shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel in place image left shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image left shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                           @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                           @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                           @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image left shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image left shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_16u_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_16u_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nConstant Constant.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u") int nConstant, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel in place image left shift by constant.
 * @param nConstant Constant.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C1IR(@Cast("const Npp32u") int nConstant, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel in place image left shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_C3IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C3IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C3IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image left shift by constant with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                           @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                           @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                           @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image left shift by constant with unmodified alpha.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_AC4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_AC4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_AC4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image left shift by constant.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer aConstants, 
                          @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer aConstants, 
                          @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] aConstants, 
                          @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel in place image left shift by constant.
 * @param aConstants fixed size array of constant values, one per channel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLShiftC_32s_C4IR(@Cast("const Npp32u*") IntPointer aConstants, @Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C4IR(@Cast("const Npp32u*") IntBuffer aConstants, @Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLShiftC_32s_C4IR(@Cast("const Npp32u*") int[] aConstants, @Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_lshiftc */ 

/** 
 * \defgroup image_and And
 *
 * Pixel by pixel logical and of images.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 8-bit unsigned char channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_C1IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C1IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 8-bit unsigned char channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_C3IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C3IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C3IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical and with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 8-bit unsigned char channel in place image logical and with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_AC4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                       @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_AC4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                       @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 8-bit unsigned char channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_8u_C4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_8u_C4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 16-bit unsigned short channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_C1IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C1IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 16-bit unsigned short channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_C3IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C3IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C3IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical and with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 16-bit unsigned short channel in place image logical and with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_AC4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                        @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_AC4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                        @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 16-bit unsigned short channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_16u_C4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_16u_C4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 32-bit signed integer channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_C1IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C1IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C1IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 32-bit signed integer channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_C3IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C3IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C3IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical and with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 32-bit signed integer channel in place image logical and with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_AC4IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                        @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_AC4IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_AC4IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                        @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical and.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 32-bit signed integer channel in place image logical and.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAnd_32s_C4IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C4IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAnd_32s_C4IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_and */ 

/** 
 * \defgroup image_or Or
 *
 * Pixel by pixel logical or of images.
 *
 * \{
 */
 
/** 
 * One 8-bit unsigned char channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 8-bit unsigned char channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_C1IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C1IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 8-bit unsigned char channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_C3IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C3IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C3IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical or with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 8-bit unsigned char channel in place image logical or with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_AC4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_AC4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 8-bit unsigned char channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_8u_C4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_8u_C4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                     @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 16-bit unsigned short channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_C1IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C1IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 16-bit unsigned short channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_C3IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C3IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C3IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical or with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 16-bit unsigned short channel in place image logical or with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_AC4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_AC4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                     @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 16-bit unsigned short channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_16u_C4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_16u_C4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                      @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 32-bit signed integer channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_C1IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C1IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C1IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 32-bit signed integer channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_C3IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C3IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C3IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical or with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 32-bit signed integer channel in place image logical or with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_AC4IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_AC4IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_AC4IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                     @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 32-bit signed integer channel in place image logical or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiOr_32s_C4IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C4IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiOr_32s_C4IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                      @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_or */ 

/** 
 * \defgroup image_xor Xor
 *
 * Pixel by pixel logical exclusive or of images.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 8-bit unsigned char channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_C1IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C1IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 8-bit unsigned char channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_C3IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C3IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C3IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical exclusive or with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 8-bit unsigned char channel in place image logical exclusive or with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_AC4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                       @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_AC4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                       @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 8-bit unsigned char channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_8u_C4IR(@Cast("const Npp8u*") BytePointer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C4IR(@Cast("const Npp8u*") ByteBuffer pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_8u_C4IR(@Cast("const Npp8u*") byte[] pSrc,     int nSrcStep, 
                      @Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 16-bit unsigned short channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_C1IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C1IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 16-bit unsigned short channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_C3IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C3IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C3IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical exclusive or with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                       @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 16-bit unsigned short channel in place image logical exclusive or with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_AC4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                        @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_AC4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                        @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                      @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 16-bit unsigned short channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_16u_C4IR(@Cast("const Npp16u*") ShortPointer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C4IR(@Cast("const Npp16u*") ShortBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") ShortBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_16u_C4IR(@Cast("const Npp16u*") short[] pSrc,     int nSrcStep, 
                       @Cast("Npp16u*") short[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 32-bit signed integer channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * One 32-bit signed integer channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_C1IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C1IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C1IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 32-bit signed integer channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Three 32-bit signed integer channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_C3IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C3IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C3IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical exclusive or with unmodified alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                       @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                       @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                       @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 32-bit signed integer channel in place image logical exclusive or with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_AC4IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                        @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_AC4IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                        @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_AC4IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                        @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 32-bit signed integer channel image logical exclusive or.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                      @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
/** 
 * Four 32-bit signed integer channel in place image logical exclusive or.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXor_32s_C4IR(@Cast("const Npp32s*") IntPointer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntPointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C4IR(@Cast("const Npp32s*") IntBuffer pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") IntBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXor_32s_C4IR(@Cast("const Npp32s*") int[] pSrc,     int nSrcStep, 
                       @Cast("Npp32s*") int[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_xor */ 

/** 
 * \defgroup image_not Not
 *
 * Pixel by pixel logical not of image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image logical not.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image logical not.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image logical not.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel in place image logical not.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical not with unmodified alpha.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical not with unmodified alpha.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image logical not.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image logical not.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNot_8u_C4IR(@Cast("Npp8u*") BytePointer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C4IR(@Cast("Npp8u*") ByteBuffer pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNot_8u_C4IR(@Cast("Npp8u*") byte[] pSrcDst,  int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_not */ 

/** \} image_logical_operations */ 

/** 
 * \defgroup image_alpha_composition_operations Alpha Composition
 * \{
 */

/** 
 * \defgroup image_alphacompc AlphaCompC
 *
 * Composite two images using constant alpha values.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2,
                            @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2,
                            @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2,
                            @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Three 8-bit unsigned char channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                            @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                            @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                            @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 8-bit unsigned char channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                            @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                            @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                            @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 8-bit unsigned char channel image composition with alpha using constant source alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                             @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                             @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, 
                             @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 8-bit signed char channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8s") byte nAlpha1, @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8s") byte nAlpha2,
                            @Cast("Npp8s*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8s") byte nAlpha1, @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8s") byte nAlpha2,
                            @Cast("Npp8s*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_8s_C1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8s") byte nAlpha1, @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8s") byte nAlpha2,
                            @Cast("Npp8s*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 16-bit unsigned short channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2,
                             @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2,
                             @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2,
                             @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Three 16-bit unsigned short channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                             @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                             @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                             @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 16-bit unsigned short channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                             @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                             @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                             @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 16-bit unsigned short channel image composition with alpha using constant source alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                              @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                              @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, @Cast("Npp16u") short nAlpha2, 
                              @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 16-bit signed short channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16s") short nAlpha1, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, @Cast("Npp16s") short nAlpha2,
                             @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16s") short nAlpha1, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, @Cast("Npp16s") short nAlpha2,
                             @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("Npp16s") short nAlpha1, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, @Cast("Npp16s") short nAlpha2,
                             @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 32-bit unsigned integer channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_32u_C1R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, @Cast("Npp32u") int nAlpha1, @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, @Cast("Npp32u") int nAlpha2,
                             @Cast("Npp32u*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_32u_C1R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, @Cast("Npp32u") int nAlpha1, @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, @Cast("Npp32u") int nAlpha2,
                             @Cast("Npp32u*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_32u_C1R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, @Cast("Npp32u") int nAlpha1, @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, @Cast("Npp32u") int nAlpha2,
                             @Cast("Npp32u*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 32-bit signed integer channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("Npp32s") int nAlpha1, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, @Cast("Npp32s") int nAlpha2,
                             @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("Npp32s") int nAlpha1, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, @Cast("Npp32s") int nAlpha2,
                             @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("Npp32s") int nAlpha1, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, @Cast("Npp32s") int nAlpha2,
                             @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 32-bit floating point channel image composition using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0.0 - 1.0).
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param nAlpha2 Image alpha opacity (0.0 - 1.0).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("Npp32f") float nAlpha1, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, @Cast("Npp32f") float nAlpha2,
                             @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("Npp32f") float nAlpha1, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, @Cast("Npp32f") float nAlpha2,
                             @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompC_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("Npp32f") float nAlpha1, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, @Cast("Npp32f") float nAlpha2,
                             @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI,   @Cast("NppiAlphaOp") int eAlphaOp);

/** \} image_alphacompc */ 

/** 
 * \defgroup image_alphapremulc AlphaPremulC
 * 
 * Premultiplies pixels of an image using a constant alpha value.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image premultiplication using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 8-bit unsigned char channel in place image premultiplication using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C1IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C1IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C1IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel image premultiplication using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 8-bit unsigned char channel in place image premultiplication using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C3IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C3IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C3IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image premultiplication using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image premultiplication using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C4IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C4IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_C4IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel image premultiplication with alpha using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image premultiplication with alpha using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_AC4IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_AC4IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_8u_AC4IR(@Cast("Npp8u") byte nAlpha1, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel image premultiplication using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * One 16-bit unsigned short channel in place image premultiplication using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C1IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C1IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C1IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel image premultiplication using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Three 16-bit unsigned short channel in place image premultiplication using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C3IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C3IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C3IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image premultiplication using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image premultiplication using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C4IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C4IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_C4IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image premultiplication with alpha using constant alpha.
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image premultiplication with alpha using constant alpha.
 * @param nAlpha1 Image alpha opacity (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_AC4IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_AC4IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremulC_16u_AC4IR(@Cast("Npp16u") short nAlpha1, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_alphapremulc */ 

/** 
 * \defgroup image_alphacomp AlphaComp
 *
 * Composite two images using alpha opacity values contained in each image.
 *
 * \{
 */

/** 
 * One 8-bit unsigned char channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_8u_AC1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                            @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_8u_AC1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                            @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_8u_AC1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                            @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 8-bit unsigned char channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                            @Cast("Npp8u*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                            @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                            @Cast("Npp8u*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 8-bit signed char channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_8s_AC1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                            @Cast("Npp8s*") BytePointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_8s_AC1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                            @Cast("Npp8s*") ByteBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_8s_AC1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                            @Cast("Npp8s*") byte[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 16-bit unsigned short channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_16u_AC1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_16u_AC1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_16u_AC1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                             @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 16-bit unsigned short channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp16u*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp16u*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                             @Cast("Npp16u*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 16-bit signed short channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_16s_AC1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp16s*") ShortPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_16s_AC1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp16s*") ShortBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_16s_AC1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                             @Cast("Npp16s*") short[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 32-bit unsigned integer channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_32u_AC1R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp32u*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32u_AC1R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp32u*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32u_AC1R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                             @Cast("Npp32u*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 32-bit unsigned integer channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_32u_AC4R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp32u*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32u_AC4R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp32u*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32u_AC4R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                             @Cast("Npp32u*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 32-bit signed integer channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_32s_AC1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32s_AC1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32s_AC1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                             @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 32-bit signed integer channel image composition using image alpha values (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp32s*") IntPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp32s*") IntBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32s_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                             @Cast("Npp32s*") int[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * One 32-bit floating point channel image composition using image alpha values (0.0 - 1.0).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_32f_AC1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32f_AC1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32f_AC1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                             @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** 
 * Four 32-bit floating point channel image composition using image alpha values (0.0 - 1.0).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eAlphaOp alpha-blending operation..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaComp_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                             @Cast("Npp32f*") FloatPointer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                             @Cast("Npp32f*") FloatBuffer pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaComp_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                             @Cast("Npp32f*") float[] pDst,  int nDstStep,  @ByVal NppiSize oSizeROI, @Cast("NppiAlphaOp") int eAlphaOp);

/** \} image_alphacomp */ 

/** 
 * \defgroup image_alphapremul AlphaPremul
 * 
 * Premultiplies image pixels by image alpha opacity values.
 *
 * \{
 */

/** 
 * Four 8-bit unsigned char channel image premultiplication with pixel alpha (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremul_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 8-bit unsigned char channel in place image premultiplication with pixel alpha (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremul_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel image premultiplication with pixel alpha (0 - max channel pixel value).
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremul_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** 
 * Four 16-bit unsigned short channel in place image premultiplication with pixel alpha (0 - max channel pixel value).
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaPremul_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiAlphaPremul_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} image_alphapremul */ 

/** \} image_alpha_composition*/ 

/** \} image_arithmetic_and_logical_operations */ 

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_ARITHMETIC_AND_LOGICAL_OPERATIONS_H */


// Parsed from <nppi_color_conversion.h>

 /* Copyright 2009-2015 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY                                                  
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_COLOR_CONVERSION_H
// #define NV_NPPI_COLOR_CONVERSION_H
 
/**
 * \file nppi_color_conversion.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif


/** \defgroup image_color_conversion Color and Sampling Conversion
 *  \ingroup nppi
 *
 * Routines manipulating an image's color model and sampling format.
 *
 * \{
 *
 */

/** \defgroup image_color_model_conversion Color Model Conversion
 *
 * Routines for converting between various image color models.
 *
 * \{ 
 *
 */

/** \name RGBToYUV 
 *  RGB to YUV color conversion.
 *
 *  Here is how NPP converts gamma corrected RGB or BGR to YUV. For digital RGB values in the range [0..255], 
 *  Y has the range [0..255], U varies in the range [-112..+112], 
 *  and V in the range [-157..+157]. To fit in the range of [0..255], a constant value
 *  of 128 is added to computed U and V values, and V is then saturated.
 *
 *  <pre>{@code   
 *  Npp32f nY =  0.299F * R + 0.587F * G + 0.114F * B; 
 *  Npp32f nU = (0.492F * ((Npp32f)nB - nY)) + 128.0F;
 *  Npp32f nV = (0.877F * ((Npp32f)nR - nY)) + 128.0F;
 *  if (nV > 255.0F) 
 *      nV = 255.0F;
 *  }</pre>
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned packed YUV color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel 8-bit unsigned packed YUV color conversion with alpha, not affecting alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar RGB to 3 channel 8-bit unsigned planar YUV color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned planar YUV color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel 8-bit unsigned planar YUV color conversion with alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_AC4P4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV_8u_AC4P4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYUV 
 *  BGR to YUV color conversion.
 *
 *  Here is how NPP converts gamma corrected RGB or BGR to YUV. For digital RGB values in the range [0..255], 
 *  Y has the range [0..255], U varies in the range [-112..+112], 
 *  and V in the range [-157..+157]. To fit in the range of [0..255], a constant value
 *  of 128 is added to computed U and V values, and V is then saturated.
 *
 *  <pre>{@code   
 *  Npp32f nY =  0.299F * R + 0.587F * G + 0.114F * B; 
 *  Npp32f nU = (0.492F * ((Npp32f)nB - nY)) + 128.0F;
 *  Npp32f nV = (0.877F * ((Npp32f)nR - nY)) + 128.0F;
 *  if (nV > 255.0F) 
 *      nV = 255.0F;
 *  }</pre>
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned packed YUV color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 4 channel 8-bit unsigned packed YUV color conversion with alpha, not affecting alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar BGR to 3 channel 8-bit unsigned planar YUV color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YUV color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 4 channel 8-bit unsigned planar YUV color conversion with alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_AC4P4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV_8u_AC4P4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YUVToRGB 
 *  YUV to RGB color conversion.
 *
 *  Here is how NPP converts YUV to gamma corrected RGB or BGR.
 *
 *  <pre>{@code
 *  Npp32f nY = (Npp32f)Y;
 *  Npp32f nU = (Npp32f)U - 128.0F;
 *  Npp32f nV = (Npp32f)V - 128.0F;
 *  Npp32f nR = nY + 1.140F * nV; 
 *  if (nR < 0.0F)
 *      nR = 0.0F;
 *  if (nR > 255.0F)
 *      nR = 255.0F;    
 *  Npp32f nG = nY - 0.394F * nU - 0.581F * nV;
 *  if (nG < 0.0F)
 *      nG = 0.0F;
 *  if (nG > 255.0F)
 *      nG = 255.0F;    
 *  Npp32f nB = nY + 2.032F * nU;
 *  if (nB < 0.0F)
 *      nB = 0.0F;
 *  if (nB > 255.0F)
 *      nB = 255.0F;    
 *  }</pre>
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed YUV to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit packed YUV with alpha to 4 channel 8-bit unsigned packed RGB color conversion with alpha, not affecting alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV to 3 channel 8-bit unsigned planar RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YUVToBGR 
 *  YUV to BGR color conversion.
 *
 *  Here is how NPP converts YUV to gamma corrected RGB or BGR.
 *
 *  <pre>{@code
 *  Npp32f nY = (Npp32f)Y;
 *  Npp32f nU = (Npp32f)U - 128.0F;
 *  Npp32f nV = (Npp32f)V - 128.0F;
 *  Npp32f nR = nY + 1.140F * nV; 
 *  if (nR < 0.0F)
 *      nR = 0.0F;
 *  if (nR > 255.0F)
 *      nR = 255.0F;    
 *  Npp32f nG = nY - 0.394F * nU - 0.581F * nV;
 *  if (nG < 0.0F)
 *      nG = 0.0F;
 *  if (nG > 255.0F)
 *      nG = 255.0F;    
 *  Npp32f nB = nY + 2.032F * nU;
 *  if (nB < 0.0F)
 *      nB = 0.0F;
 *  if (nB > 255.0F)
 *      nB = 255.0F;    
 *  }</pre>
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed YUV to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit packed YUV with alpha to 4 channel 8-bit unsigned packed BGR color conversion with alpha, not affecting alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV to 3 channel 8-bit unsigned planar BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUVToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToYUV422 
 *  RGB to YUV422 color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 2 channel 8-bit unsigned packed YUV422 color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_C3C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_C3C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_C3C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar RGB to 3 channel 8-bit unsigned planar YUV422 color conversion.
 * images.
 *                         
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned planar YUV422 color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV422_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YUV422ToRGB 
 *  YUV422 to RGB color conversion.
 *
 * \{
 *
 */

/**
 * 2 channel 8-bit unsigned packed YUV422 to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_C2C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_C2C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_C2C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV422 to 3 channel 8-bit unsigned planar RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV422 to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV422 to 4 channel 8-bit unsigned packed RGB color conversion with alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV422ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToYUV420 
 *  RGB to YUV420 color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned planar RGB to 3 channel 8-bit unsigned planar YUV420 color conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned planar YUV420 color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYUV420_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YUV420ToRGB 
 *  YUV420 to RGB color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned planar YUV420 to 3 channel 8-bit unsigned planar RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV420 to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV420 to 4 channel 8-bit unsigned packed RGB color conversion with constant alpha (0xFF).
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV420 to 4 channel 8-bit unsigned packed RGB color conversion with alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToRGB_8u_P3AC4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name NV21ToRGB 
 *  NV21 to RGB color conversion.
 *
 * \{
 *
 */

/**
 *  2 channel 8-bit unsigned planar NV21 to 4 channel 8-bit unsigned packed ARGB color conversion with constant alpha (0xFF).
 *
 * @param pSrc \ref source_planar_image_pointer_array (one for Y plane, one for VU plane).
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNV21ToRGB_8u_P2C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNV21ToRGB_8u_P2C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNV21ToRGB_8u_P2C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNV21ToRGB_8u_P2C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYUV420 
 *  BGR to YUV420 color conversion.
 *
 * \{
 *
 */

/**
 * 4 channel 8-bit unsigned pacmed BGR with alpha to 3 channel 8-bit unsigned planar YUV420 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYUV420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV420_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYUV420_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);
 
/** \} */

/** \name YUV420ToBGR 
 *  YUV420 to BGR color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned planar YUV420 to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YUV420 to 4 channel 8-bit unsigned packed BGR color conversion with constant alpha (0xFF).
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYUV420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name NV21ToBGR 
 *  NV21 to BGR color conversion.
 *
 * \{
 *
 */

/**
 *  2 channel 8-bit unsigned planar NV21 to 4 channel 8-bit unsigned packed BGRA color conversion with constant alpha (0xFF).
 *
 * @param pSrc \ref source_planar_image_pointer_array (one for Y plane, one for VU plane).
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiNV21ToBGR_8u_P2C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNV21ToBGR_8u_P2C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNV21ToBGR_8u_P2C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiNV21ToBGR_8u_P2C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToYCbCr 
 *  RGB to YCbCr color conversion.
 *
 *  Here is how NPP converts gamma corrected RGB or BGR to YCbCr.  In the YCbCr model, 
 *  Y is defined to have a nominal range [16..235], while Cb and Cr are defined
 *  to have a range [16..240], with the value of 128 as corresponding to zero.
 *
 *  <pre>{@code
 *  Npp32f nY  =  0.257F * R + 0.504F * G + 0.098F * B + 16.0F; 
 *  Npp32f nCb = -0.148F * R - 0.291F * G + 0.439F * B + 128.0F;
 *  Npp32f nCr =  0.439F * R - 0.368F * G - 0.071F * B + 128.0F;
 *  }</pre>
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel unsigned 8-bit packed YCbCr color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel unsigned 8-bit packed YCbCr with alpha color conversion, not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel planar 8-bit unsigned RGB to 3 channel planar 8-bit YCbCr color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel unsigned 8-bit planar YCbCr color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 3 channel 8-bit unsigned planar YCbCr color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCrToRGB 
 *  YCbCr to RGB color conversion.
 *
 *  Here is how NPP converts YCbCr to gamma corrected RGB or BGR.  The output RGB values are saturated to the range [0..255].
 *
 *  <pre>{@code
 *  Npp32f nY = 1.164F * ((Npp32f)Y - 16.0F);
 *  Npp32f nR = ((Npp32f)Cr - 128.0F);
 *  Npp32f nB = ((Npp32f)Cb - 128.0F);
 *  Npp32f nG = nY - 0.813F * nR - 0.392F * nB;
 *  if (nG > 255.0F)
 *      nG = 255.0F;
 *  nR = nY + 1.596F * nR; 
 *  if (nR > 255.0F)
 *      nR = 255.0F;
 *  nB = nY + 2.017F * nB;
 *  if (nB > 255.0F)
 *      nB = 255.0F;
 *  }</pre>
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed YCbCr to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed YCbCr with alpha to 4 channel 8-bit unsigned packed RGB with alpha color conversion, not affecting alpha.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr to 3 channel 8-bit unsigned planar RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr to 4 channel 8-bit unsigned packed RGB color conversion with constant alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.                                         
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name YCbCrToBGR 
 *  YCbCr to BGR color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned planar YCbCr to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr to 4 channel 8-bit unsigned packed BGR color conversion with constant alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name YCbCrToBGR_709CSC 
 *  YCbCr to BGR_709CSC color conversion.
 *
 * \{
 *
 */
 
/**
 * 3 channel 8-bit unsigned planar YCbCr to 3 channel 8-bit unsigned packed BGR_709CSC color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr to 4 channel 8-bit unsigned packed BGR_709CSC color conversion with constant alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCrToBGR_709CSC_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name RGBToYCbCr422 
 *  RGB to YCbCr422 color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 2 channel 8-bit unsigned packed YCbCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_C3C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_C3C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_C3C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned planar YCbCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar RGB to 2 channel 8-bit unsigned packed YCbCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToRGB 
 *  YCbCr422 to RGB color conversion.
 *
 * \{
 *
 */
 
/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 3 channel 8-bit unsigned packed RGB color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_C2C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_C2C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_C2C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI); 

/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 3 channel 8-bit unsigned planar RGB color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 3 channel 8-bit unsigned packed RGB color conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToYCrCb422 
 *  RGB to YCrCb422 color conversion.
 *
 * \{
 *
 */
 
/**
 * 3 channel 8-bit unsigned packed RGB to 2 channel 8-bit unsigned packed YCrCb422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCrCb422_8u_C3C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb422_8u_C3C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb422_8u_C3C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar RGB to 2 channel 8-bit unsigned packed YCrCb422 color conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb422ToRGB 
 *  YCrCb422 to RGB color conversion.
 *
 * \{
 *
 */

/**
 * 2 channel 8-bit unsigned packed YCrCb422 to 3 channel 8-bit unsigned packed RGB color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb422ToRGB_8u_C2C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToRGB_8u_C2C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToRGB_8u_C2C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI); 

/**
 * 2 channel 8-bit unsigned packed YCrCb422 to 3 channel 8-bit unsigned planar RGB color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb422ToRGB_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToRGB_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToRGB_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToRGB_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYCbCr422 
 *  BGR to YCbCr422 color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed BGR to 2 channel 8-bit unsigned packed YCrCb422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_C3C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_C3C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_C3C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 2 channel 8-bit unsigned packed YCrCb422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_AC4C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_AC4C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_AC4C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YCbCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCbCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr422_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToBGR 
 *  YCbCr422 to BGR color conversion.
 *
 * \{
 *
 */

/**
 * 2 channel 8-bit unsigned packed YCrCb422 to 3 channel 8-bit unsigned packed BGR color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_C2C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_C2C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_C2C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed YCrCb422 to 4 channel 8-bit unsigned packed BGR color conversion with constant alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_C2C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_C2C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_C2C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 3 channel 8-bit unsigned packed BGR color conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToCbYCr422 
 *  RGB to CbYCr422 color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 2 channel 8-bit unsigned packed CbYCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToCbYCr422_8u_C3C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToCbYCr422_8u_C3C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToCbYCr422_8u_C3C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed RGB first gets forward gamma corrected then converted to 2 channel 8-bit unsigned packed CbYCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToCbYCr422Gamma_8u_C3C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToCbYCr422Gamma_8u_C3C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToCbYCr422Gamma_8u_C3C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name CbYCr422ToRGB 
 *  CbYCr422 to RGB color conversion.
 *
 * \{
 *
 */

/**
 * 2 channel 8-bit unsigned packed CbYCrC22 to 3 channel 8-bit unsigned packed RGB color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToRGB_8u_C2C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToRGB_8u_C2C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToRGB_8u_C2C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToCbYCr422 
 *  BGR to CbYCr422 color conversion.
 *
 * \{
 *
 */

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 2 channel 8-bit unsigned packed CbYCr422 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_8u_AC4C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_8u_AC4C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_8u_AC4C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToCbYCr422_709HDTV 
 *  BGR to CbYCr422_709HDTV color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed BGR to 2 channel 8-bit unsigned packed CbYCr422_709HDTV color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_709HDTV_8u_C3C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_709HDTV_8u_C3C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_709HDTV_8u_C3C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 2 channel 8-bit unsigned packed CbYCr422_709HDTV color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_709HDTV_8u_AC4C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_709HDTV_8u_AC4C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToCbYCr422_709HDTV_8u_AC4C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name CbYCr422ToBGR 
 *  CbYCr422 to BGR color conversion.
 *
 * \{
 *
 */

/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 4 channel 8-bit unsigned packed BGR color conversion with alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_8u_C2C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_8u_C2C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_8u_C2C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name CbYCr422ToBGR_709HDTV 
 *  CbYCr422 to BGR_709HDTV color conversion.
 *
 * \{
 *
 */

/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 3 channel 8-bit unsigned packed BGR_709HDTV color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_709HDTV_8u_C2C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_709HDTV_8u_C2C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_709HDTV_8u_C2C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 4 channel 8-bit unsigned packed BGR_709HDTV color conversion with constant alpha.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_709HDTV_8u_C2C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_709HDTV_8u_C2C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiCbYCr422ToBGR_709HDTV_8u_C2C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name RGBToYCbCr420 
 *  RGB to YCbCr420 color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned planar YCbCr420 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr420ToRGB 
 *  YCbCr420 to RGB color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToRGB_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToYCrCb420 
 *  RGB to YCrCb420 color conversion.
 *
 * \{
 *
 */

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 3 channel 8-bit unsigned planar YCrCb420 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb420ToRGB 
 *  YCrCb420 to RGB color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned planar YCrCb420 to 4 channel 8-bit unsigned packed RGB color conversion with constant alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc,IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCrCb420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc,IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCrCb420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc,IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCrCb420ToRGB_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc,int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name BGRToYCbCr420 
 *  BGR to YCbCr420 color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YCbCr420 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCbCr420 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYCbCr420_709CSC 
 *  BGR to YCbCr420_709CSC color conversion.
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YCbCr420_709CSC color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCbCr420_709CSC color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYCbCr420_709HDTV 
 *  BGR to YCbCr420_709HDTV color conversion.
 *
 * \{
 *
 */

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCbCr420_709HDTV color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709HDTV_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709HDTV_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709HDTV_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr420_709HDTV_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYCrCb420_709CSC 
 *  BGR to YCrCb420_709CSC color conversion.
 * \{
 */

/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YCrCb420_709CSC color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCrCb420_709CSC color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_709CSC_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr420ToBGR 
 *  YCbCr420 to BGR color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 4 channel 8-bit unsigned packed BGR color conversion with constant alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep,@Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep,@Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep,@Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep,@Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name YCbCr420ToBGR_709CSC 
 *  YCbCr420_709CSC to BGR color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned packed BGR_709CSC color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709CSC_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr420ToBGR_709HDTV 
 *  YCbCr420_709HDTV to BGR color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 4 channel 8-bit unsigned packed BGR_709HDTV color conversion with constant alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709HDTV_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709HDTV_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709HDTV_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr420ToBGR_709HDTV_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name BGRToYCrCb420 
 *  BGR to YCrCb420 color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YCrCb420 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCrCb420 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCrCb420_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYCbCr411 
 *  BGR to YCbCr411 color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YCbCr411 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCbCr411 color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr411_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToYCbCr 
 *  BGR to YCbCr color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar YCbCr color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 3 channel 8-bit unsigned planar YCbCr color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 4 channel 8-bit unsigned planar YCbCr color conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToYCbCr_8u_AC4P4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr411ToBGR 
 *  YCbCr411 to BGR color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 4 channel 8-bit unsigned packed BGR color conversion with constant alpha.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nAval 8-bit unsigned alpha constant.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);
public static native @Cast("NppStatus") int nppiYCbCr411ToBGR_8u_P3C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nAval);

/** \} */

/** \name RGBToXYZ 
 *  RGB to XYZ color conversion.
 *
 *  Here is how NPP converts gamma corrected RGB or BGR to XYZ.
 *
 *  <pre>{@code
 *  Npp32f nNormalizedR = (Npp32f)R * 0.003921569F; // / 255.0F
 *  Npp32f nNormalizedG = (Npp32f)G * 0.003921569F;
 *  Npp32f nNormalizedB = (Npp32f)B * 0.003921569F;
 *  Npp32f nX = 0.412453F * nNormalizedR + 0.35758F  * nNormalizedG + 0.180423F * nNormalizedB; 
 *  if (nX > 1.0F)
 *      nX = 1.0F;
 *  Npp32f nY = 0.212671F * nNormalizedR + 0.71516F  * nNormalizedG + 0.072169F * nNormalizedB;
 *  if (nY > 1.0F)
 *      nY = 1.0F;
 *  Npp32f nZ = 0.019334F * nNormalizedR + 0.119193F * nNormalizedG + 0.950227F * nNormalizedB;
 *  if (nZ > 1.0F)
 *      nZ = 1.0F;
 *  X = (Npp8u)(nX * 255.0F);
 *  Y = (Npp8u)(nY * 255.0F);
 *  Z = (Npp8u)(nZ * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned packed XYZ color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToXYZ_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToXYZ_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToXYZ_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel 8-bit unsigned packed XYZ with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToXYZ_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToXYZ_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToXYZ_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name XYZToRGB 
 *  XYZ to RGB color conversion.
 *
 *  Here is how NPP converts XYZ to gamma corrected RGB or BGR.  The code assumes that X,Y, and Z values are in the range [0..1].
 *
 *  <pre>{@code
 *  Npp32f nNormalizedX = (Npp32f)X * 0.003921569F; // / 255.0F
 *  Npp32f nNormalizedY = (Npp32f)Y * 0.003921569F;
 *  Npp32f nNormalizedZ = (Npp32f)Z * 0.003921569F;
 *  Npp32f nR = 3.240479F * nNormalizedX - 1.53715F  * nNormalizedY - 0.498535F * nNormalizedZ; 
 *  if (nR > 1.0F)
 *      nR = 1.0F;
 *  Npp32f nG = -0.969256F * nNormalizedX + 1.875991F  * nNormalizedY + 0.041556F * nNormalizedZ;
 *  if (nG > 1.0F)
 *      nG = 1.0F;
 *  Npp32f nB = 0.055648F * nNormalizedX - 0.204043F * nNormalizedY + 1.057311F * nNormalizedZ;
 *  if (nB > 1.0F)
 *      nB = 1.0F;
 *  R = (Npp8u)(nR * 255.0F);
 *  G = (Npp8u)(nG * 255.0F);
 *  B = (Npp8u)(nB * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed XYZ to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXYZToRGB_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXYZToRGB_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXYZToRGB_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed XYZ with alpha to 4 channel 8-bit unsigned packed RGB with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiXYZToRGB_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXYZToRGB_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiXYZToRGB_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToLUV 
 *  RGB to LUV color conversion.
 *
 *  Here is how NPP converts gamma corrected RGB or BGR to CIE LUV using the CIE XYZ D65 white point with a Y luminance of 1.0.
 *  The computed values of the L component are in the range [0..100], U component in the range [-134..220], 
 *  and V component in the range [-140..122]. The code uses cbrtf() the 32 bit floating point cube root math function.
 *
 *  <pre>{@code
 *  // use CIE D65 chromaticity coordinates
 *  #define nCIE_XYZ_D65_xn 0.312713F
 *  #define nCIE_XYZ_D65_yn 0.329016F
 *  #define nn_DIVISOR (-2.0F * nCIE_XYZ_D65_xn + 12.0F * nCIE_XYZ_D65_yn + 3.0F)
 *  #define nun (4.0F * nCIE_XYZ_D65_xn / nn_DIVISOR)
 *  #define nvn (9.0F * nCIE_XYZ_D65_yn / nn_DIVISOR)
 *    
 *  // First convert to XYZ
 *  Npp32f nNormalizedR = (Npp32f)R * 0.003921569F; // / 255.0F
 *  Npp32f nNormalizedG = (Npp32f)G * 0.003921569F;
 *  Npp32f nNormalizedB = (Npp32f)B * 0.003921569F;
 *  Npp32f nX = 0.412453F * nNormalizedR + 0.35758F  * nNormalizedG + 0.180423F * nNormalizedB; 
 *  Npp32f nY = 0.212671F * nNormalizedR + 0.71516F  * nNormalizedG + 0.072169F * nNormalizedB;
 *  Npp32f nZ = 0.019334F * nNormalizedR + 0.119193F * nNormalizedG + 0.950227F * nNormalizedB;
 *  // Now calculate LUV from the XYZ value
 *  Npp32f nTemp = nX + 15.0F * nY + 3.0F * nZ;
 *  Npp32f nu = 4.0F * nX / nTemp;
 *  Npp32f nv = 9.0F * nY / nTemp;
 *  Npp32f nL = 116.0F * cbrtf(nY) - 16.0F;
 *  if (nL < 0.0F)
 *      nL = 0.0F;
 *  if (nL > 100.0F)
 *      nL = 100.0F;
 *  nTemp = 13.0F * nL;
 *  Npp32f nU = nTemp * (nu - nun);
 *  if (nU < -134.0F)
 *      nU = -134.0F;
 *  if (nU > 220.0F)
 *      nU = 220.0F;
 *  Npp32f nV = nTemp * (nv - nvn);
 *  if (nV < -140.0F)
 *      nV = -140.0F;
 *  if (nV > 122.0F)
 *      nV = 122.0F;
 *  L = (Npp8u)(nL * 255.0F * 0.01F); // / 100.0F
 *  U = (Npp8u)((nU + 134.0F) * 255.0F * 0.0028249F); // / 354.0F
 *  V = (Npp8u)((nV + 140.0F) * 255.0F * 0.0038168F); // / 262.0F
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned packed LUV color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToLUV_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToLUV_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToLUV_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel 8-bit unsigned packed LUV with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToLUV_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToLUV_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToLUV_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name LUVToRGB 
 *  LUV to RGB color conversion.
 *
 *  Here is how NPP converts CIE LUV to gamma corrected RGB or BGR using the CIE XYZ D65 white point with a Y luminance of 1.0.
 *  The code uses powf() the 32 bit floating point power math function. 
 *
 *  <pre>{@code
 *  // use CIE D65 chromaticity coordinates
 *  #define nCIE_XYZ_D65_xn 0.312713F
 *  #define nCIE_XYZ_D65_yn 0.329016F
 *  #define nn_DIVISOR (-2.0F * nCIE_XYZ_D65_xn + 12.0F * nCIE_XYZ_D65_yn + 3.0F)
 *  #define nun (4.0F * nCIE_XYZ_D65_xn / nn_DIVISOR)
 *  #define nvn (9.0F * nCIE_XYZ_D65_yn / nn_DIVISOR)
 *    
 *  // First convert normalized LUV back to original CIE LUV range
 *  Npp32f nL = (Npp32f)L * 100.0F * 0.003921569F;  // / 255.0F
 *  Npp32f nU = ((Npp32f)U * 354.0F * 0.003921569F) - 134.0F;
 *  Npp32f nV = ((Npp32f)V * 262.0F * 0.003921569F) - 140.0F;
 *  // Now convert LUV to CIE XYZ
 *  Npp32f nTemp = 13.0F * nL;
 *  Npp32f nu = nU / nTemp + nun;
 *  Npp32f nv = nV / nTemp + nvn;
 *  Npp32f nNormalizedY;
 *  if (nL > 7.9996248F)
 *  {
 *      nNormalizedY = (nL + 16.0F) * 0.008621F; // / 116.0F
 *      nNormalizedY = powf(nNormalizedY, 3.0F);
 *  }
 *  else
 *  {    
 *      nNormalizedY = nL * 0.001107F; // / 903.3F
 *  }    
 *  Npp32f nNormalizedX = (-9.0F * nNormalizedY * nu) / ((nu - 4.0F) * nv - nu * nv);
 *  Npp32f nNormalizedZ = (9.0F * nNormalizedY - 15.0F * nv * nNormalizedY - nv * nNormalizedX) / (3.0F * nv);
 *  Npp32f nR = 3.240479F * nNormalizedX - 1.53715F  * nNormalizedY - 0.498535F * nNormalizedZ; 
 *  if (nR > 1.0F)
 *      nR = 1.0F;
 *  if (nR < 0.0F)
 *      nR = 0.0F;
 *  Npp32f nG = -0.969256F * nNormalizedX + 1.875991F  * nNormalizedY + 0.041556F * nNormalizedZ;
 *  if (nG > 1.0F)
 *      nG = 1.0F;
 *  if (nG < 0.0F)
 *      nG = 0.0F;
 *  Npp32f nB = 0.055648F * nNormalizedX - 0.204043F * nNormalizedY + 1.057311F * nNormalizedZ;
 *  if (nB > 1.0F)
 *      nB = 1.0F;
 *  if (nB < 0.0F)
 *      nB = 0.0F;
 *  R = (Npp8u)(nR * 255.0F);
 *  G = (Npp8u)(nG * 255.0F);
 *  B = (Npp8u)(nB * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed LUV to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLUVToRGB_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLUVToRGB_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLUVToRGB_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed LUV with alpha to 4 channel 8-bit unsigned packed RGB with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLUVToRGB_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLUVToRGB_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLUVToRGB_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToLab 
 *  BGR to Lab color conversion.
 *
 *  This is how NPP converts gamma corrected BGR or RGB to Lab using the CIE Lab D65 white point with a Y luminance of 1.0.
 *  The computed values of the L component are in the range [0..100], a and b component values are in the range [-128..127].
 *  The code uses cbrtf() the 32 bit floating point cube root math function.
 *
 *  <pre>{@code
 *  // use CIE Lab chromaticity coordinates
 *  #define nCIE_LAB_D65_xn 0.950455F
 *  #define nCIE_LAB_D65_yn 1.0F
 *  #define nCIE_LAB_D65_zn 1.088753F
 *  // First convert to XYZ
 *  Npp32f nNormalizedR = (Npp32f)R * 0.003921569F; // / 255.0F
 *  Npp32f nNormalizedG = (Npp32f)G * 0.003921569F;
 *  Npp32f nNormalizedB = (Npp32f)B * 0.003921569F;
 *  Npp32f nX = 0.412453F * nNormalizedR + 0.35758F  * nNormalizedG + 0.180423F * nNormalizedB; 
 *  Npp32f nY = 0.212671F * nNormalizedR + 0.71516F  * nNormalizedG + 0.072169F * nNormalizedB;
 *  Npp32f nZ = 0.019334F * nNormalizedR + 0.119193F * nNormalizedG + 0.950227F * nNormalizedB;
 *  Npp32f nL = cbrtf(nY);
 *  Npp32f nA;
 *  Npp32f nB;
 *  Npp32f nfX = nX * 1.052128F; // / nCIE_LAB_D65_xn; 
 *  Npp32f nfY = nY;
 *  Npp32f nfZ = nZ * 0.918482F; // / nCIE_LAB_D65_zn;
 *  nfY = nL - 16.0F;
 *  nL = 116.0F * nL - 16.0F;
 *  nA = cbrtf(nfX) - 16.0F;
 *  nA = 500.0F * (nA - nfY);
 *  nB = cbrtf(nfZ) - 16.0F;
 *  nB = 200.0F * (nfY - nB);
 *  // Now scale Lab range
 *  nL = nL * 255.0F * 0.01F; // / 100.0F
 *  nA = nA + 128.0F;
 *  nB = nB + 128.0F;
 *  L = (Npp8u)nL;
 *  a = (Npp8u)nA;
 *  b = (Npp8u)nB;
 *  }</pre>
 * 
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned packed Lab color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToLab_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToLab_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToLab_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name LabToBGR 
 *  Lab to BGR color conversion.
 *
 *  This is how NPP converts Lab to gamma corrected BGR or RGB using the CIE Lab D65 white point with a Y luminance of 1.0.
 *  The code uses powf() the 32 bit floating point power math function. 
 *
 *  <pre>{@code
 *  // use CIE Lab chromaticity coordinates
 *  #define nCIE_LAB_D65_xn 0.950455F
 *  #define nCIE_LAB_D65_yn 1.0F
 *  #define nCIE_LAB_D65_zn 1.088753F
 *  // First convert Lab back to original range then to CIE XYZ
 *  Npp32f nL = (Npp32f)L * 100.0F * 0.003921569F;  // / 255.0F
 *  Npp32f nA = (Npp32f)a - 128.0F;
 *  Npp32f nB = (Npp32f)b - 128.0F;
 *  Npp32f nP = (nL + 16.0F) * 0.008621F; // / 116.0F
 *  Npp32f nNormalizedY = nP * nP * nP; // powf(nP, 3.0F);
 *  Npp32f nNormalizedX = nCIE_LAB_D65_xn * powf((nP + nA * 0.002F), 3.0F); // / 500.0F
 *  Npp32f nNormalizedZ = nCIE_LAB_D65_zn * powf((nP - nB * 0.005F), 3.0F); // / 200.0F
 *  Npp32f nR = 3.240479F * nNormalizedX - 1.53715F  * nNormalizedY - 0.498535F * nNormalizedZ; 
 *  if (nR > 1.0F)
 *      nR = 1.0F;
 *  Npp32f nG = -0.969256F * nNormalizedX + 1.875991F  * nNormalizedY + 0.041556F * nNormalizedZ;
 *  if (nG > 1.0F)
 *      nG = 1.0F;
 *  nB = 0.055648F * nNormalizedX - 0.204043F * nNormalizedY + 1.057311F * nNormalizedZ;
 *  if (nB > 1.0F)
 *      nB = 1.0F;
 *  R = (Npp8u)(nR * 255.0F);
 *  G = (Npp8u)(nG * 255.0F);
 *  B = (Npp8u)(nB * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed Lab to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiLabToBGR_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLabToBGR_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiLabToBGR_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToYCC 
 *  RGB to PhotoYCC color conversion.
 *
 *  This is how NPP converts gamma corrected BGR or RGB to PhotoYCC.
 *  The computed Y, C1, C2 values are then quantized and converted to fit in the range [0..1] before expanding to 8 bits.
 *
 *  <pre>{@code
 *  Npp32f nNormalizedR = (Npp32f)R * 0.003921569F; // / 255.0F
 *  Npp32f nNormalizedG = (Npp32f)G * 0.003921569F;
 *  Npp32f nNormalizedB = (Npp32f)B * 0.003921569F;
 *  Npp32f nY = 0.299F * nNormalizedR + 0.587F  * nNormalizedG + 0.114F * nNormalizedB; 
 *  Npp32f nC1 = nNormalizedB - nY;
 *  nC1 = 111.4F * 0.003921569F * nC1 + 156.0F * 0.003921569F;
 *  Npp32f nC2 = nNormalizedR - nY;
 *  nC2 = 135.64F * 0.003921569F * nC2 + 137.0F * 0.003921569F;
 *  nY = 1.0F * 0.713267F * nY; // / 1.402F
 *  Y = (Npp8u)(nY  * 255.0F);
 *  C1 = (Npp8u)(nC1 * 255.0F);
 *  C2 = (Npp8u)(nC2 * 255.0F);
 *  }</pre>
 * 
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned packed YCC color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel 8-bit unsigned packed YCC with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToYCC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToYCC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCCToRGB 
 *  PhotoYCC to RGB color conversion.
 *
 *  This is how NPP converts PhotoYCC to gamma corrected RGB or BGR.
 *
 *  <pre>{@code
 *  Npp32f nNormalizedY  = ((Npp32f)Y * 0.003921569F) * 1.3584F;  // / 255.0F
 *  Npp32f nNormalizedC1 = (((Npp32f)C1 * 0.003921569F) - 156.0F * 0.003921569F) * 2.2179F;
 *  Npp32f nNormalizedC2 = (((Npp32f)C2 * 0.003921569F) - 137.0F * 0.003921569F) * 1.8215F;
 *  Npp32f nR = nNormalizedY + nNormalizedC2;
 *  if (nR > 1.0F)
 *      nR = 1.0F;
 *  Npp32f nG = nNormalizedY - 0.194F  * nNormalizedC1 - 0.509F * nNormalizedC2;
 *  if (nG > 1.0F)
 *      nG = 1.0F;
 *  Npp32f nB = nNormalizedY + nNormalizedC1;
 *  if (nB > 1.0F)
 *      nB = 1.0F;
 *  R = (Npp8u)(nR * 255.0F);
 *  G = (Npp8u)(nG * 255.0F);
 *  B = (Npp8u)(nB * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed YCC to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCCToRGB_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCCToRGB_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCCToRGB_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed YCC with alpha to 4 channel 8-bit unsigned packed RGB with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCCToRGB_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCCToRGB_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCCToRGB_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToHLS 
 *  RGB to HLS color conversion.
 *
 *  This is how NPP converts gamma corrected RGB or BGR to HLS.
 *  This code uses the fmaxf() and fminf() 32 bit floating point math functions.
 *
 *  <pre>{@code
 *  Npp32f nNormalizedR = (Npp32f)R * 0.003921569F;  // / 255.0F
 *  Npp32f nNormalizedG = (Npp32f)G * 0.003921569F;
 *  Npp32f nNormalizedB = (Npp32f)B * 0.003921569F;
 *  Npp32f nS;
 *  Npp32f nH;
 *  // Lightness
 *  Npp32f nMax = fmaxf(nNormalizedR, nNormalizedG);
 *         nMax = fmaxf(nMax, nNormalizedB);
 *  Npp32f nMin = fminf(nNormalizedR, nNormalizedG);
 *         nMin = fminf(nMin, nNormalizedB);
 *  Npp32f nL = (nMax + nMin) * 0.5F;
 *  Npp32f nDivisor = nMax - nMin;
 *  // Saturation
 *  if (nDivisor == 0.0F) // achromatics case
 *  {
 *      nS = 0.0F;
 *      nH = 0.0F;
 *  }
 *  else // chromatics case
 *  {
 *      if (nL > 0.5F)
 *          nS = nDivisor / (1.0F - (nMax + nMin - 1.0F));
 *      else
 *          nS = nDivisor / (nMax + nMin);
 *  }
 *  // Hue
 *  Npp32f nCr = (nMax - nNormalizedR) / nDivisor;
 *  Npp32f nCg = (nMax - nNormalizedG) / nDivisor;
 *  Npp32f nCb = (nMax - nNormalizedB) / nDivisor;
 *  if (nNormalizedR == nMax)
 *      nH = nCb - nCg;
 *  else if (nNormalizedG == nMax)
 *      nH = 2.0F + nCr - nCb;
 *  else if (nNormalizedB == nMax)
 *      nH = 4.0F + nCg - nCr;
 *  nH = nH * 0.166667F; // / 6.0F       
 *  if (nH < 0.0F)
 *      nH = nH + 1.0F;
 *  H = (Npp8u)(nH * 255.0F);
 *  L = (Npp8u)(nL * 255.0F);
 *  S = (Npp8u)(nS * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned packed HLS color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToHLS_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHLS_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHLS_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel 8-bit unsigned packed HLS with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToHLS_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHLS_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHLS_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name HLSToRGB 
 *  HLS to RGB color conversion.
 *
 *  This is how NPP converts HLS to gamma corrected RGB or BGR.
 *
 *  <pre>{@code
 *  Npp32f nNormalizedH = (Npp32f)H * 0.003921569F;  // / 255.0F
 *  Npp32f nNormalizedL = (Npp32f)L * 0.003921569F;
 *  Npp32f nNormalizedS = (Npp32f)S * 0.003921569F;
 *  Npp32f nM1;
 *  Npp32f nM2;
 *  Npp32f nR;
 *  Npp32f nG;
 *  Npp32f nB;
 *  Npp32f nh = 0.0F;
 *  if (nNormalizedL <= 0.5F)
 *      nM2 = nNormalizedL * (1.0F + nNormalizedS);
 *  else
 *      nM2 = nNormalizedL + nNormalizedS - nNormalizedL * nNormalizedS;
 *  nM1 = 2.0F * nNormalizedL - nM2;
 *  if (nNormalizedS == 0.0F)
 *      nR = nG = nB = nNormalizedL;
 *  else
 *  {
 *      nh = nNormalizedH + 0.3333F;
 *      if (nh > 1.0F)
 *          nh -= 1.0F;
 *  }
 *  Npp32f nMDiff = nM2 - nM1;
 *  if (0.6667F < nh)
 *      nR = nM1;
 *  else
 *  {    
 *      if (nh < 0.1667F)
 *          nR = (nM1 + nMDiff * nh * 6.0F); // / 0.1667F
 *      else if (nh < 0.5F)
 *          nR = nM2;
 *      else
 *          nR = nM1 + nMDiff * ( 0.6667F - nh ) * 6.0F; // / 0.1667F
 *  }
 *  if (nR > 1.0F)
 *      nR = 1.0F;     
 *  nh = nNormalizedH;
 *  if (0.6667F < nh)
 *      nG = nM1;
 *  else
 *  {
 *      if (nh < 0.1667F)
 *          nG = (nM1 + nMDiff * nh * 6.0F); // / 0.1667F
 *      else if (nh < 0.5F)
 *          nG = nM2;
 *      else
 *          nG = nM1 + nMDiff * (0.6667F - nh ) * 6.0F; // / 0.1667F
 *  }
 *  if (nG > 1.0F)
 *      nG = 1.0F;     
 *  nh = nNormalizedH - 0.3333F;
 *  if (nh < 0.0F)
 *      nh += 1.0F;
 *  if (0.6667F < nh)
 *      nB = nM1;
 *  else
 *  {
 *      if (nh < 0.1667F)
 *          nB = (nM1 + nMDiff * nh * 6.0F); // / 0.1667F
 *      else if (nh < 0.5F)
 *          nB = nM2;
 *      else
 *          nB = nM1 + nMDiff * (0.6667F - nh ) * 6.0F; // / 0.1667F
 *  }        
 *  if (nB > 1.0F)
 *      nB = 1.0F;     
 *  R = (Npp8u)(nR * 255.0F);
 *  G = (Npp8u)(nG * 255.0F);
 *  B = (Npp8u)(nB * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed HLS to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToRGB_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToRGB_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToRGB_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed HLS with alpha to 4 channel 8-bit unsigned packed RGB with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToRGB_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToRGB_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToRGB_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name BGRToHLS 
 *  BGR to HLS color conversion.
 * \{
 */
/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 4 channel 8-bit unsigned packed HLS with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed BGR to 3 channel 8-bit unsigned planar HLS color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed BGR with alpha to 4 channel 8-bit unsigned planar HLS with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AC4P4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AC4P4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar BGR to 3 channel 8-bit unsigned packed HLS color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned planar BGR with alpha to 4 channel 8-bit unsigned packed HLS with alpha color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar BGR to 3 channel 8-bit unsigned planar HLS color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned planar BGR with alpha to 4 channel 8-bit unsigned planar HLS with alpha color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiBGRToHLS_8u_AP4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name HLSToBGR 
 *  HLS to BGR color conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed HLS to 3 channel 8-bit unsigned planar BGR color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_C3P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_C3P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_C3P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed HLS with alpha to 4 channel 8-bit unsigned planar BGR with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AC4P4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AC4P4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AC4P4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar HLS to 3 channel 8-bit unsigned planar BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned planar HLS with alpha to 4 channel 8-bit unsigned planar BGR with alpha color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed HLS with alpha to 4 channel 8-bit unsigned packed BGR with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */


/**
 * 3 channel 8-bit unsigned planar HLS to 3 channel 8-bit unsigned packed BGR color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3C3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_P3C3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned planar HLS with alpha to 4 channel 8-bit unsigned packed BGR with alpha color conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4C4R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4C4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4C4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHLSToBGR_8u_AP4C4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToHSV 
 *  RGB to HSV color conversion.
 *
 *  This is how NPP converts gamma corrected RGB or BGR to HSV.
 *  This code uses the fmaxf() and fminf() 32 bit floating point math functions.
 *
 * <pre>{@code
 *  Npp32f nNormalizedR = (Npp32f)R * 0.003921569F; // / 255.0F
 *  Npp32f nNormalizedG = (Npp32f)G * 0.003921569F;
 *  Npp32f nNormalizedB = (Npp32f)B * 0.003921569F;
 *  Npp32f nS;
 *  Npp32f nH;
 *  // Value
 *  Npp32f nV = fmaxf(nNormalizedR, nNormalizedG);
 *         nV = fmaxf(nV, nNormalizedB);
 *  // Saturation
 *  Npp32f nTemp = fminf(nNormalizedR, nNormalizedG);
 *         nTemp = fminf(nTemp, nNormalizedB);
 *  Npp32f nDivisor = nV - nTemp;
 *  if (nV == 0.0F) // achromatics case
 *  {
 *      nS = 0.0F;
 *      nH = 0.0F;
 *  }    
 *  else // chromatics case
 *      nS = nDivisor / nV;
 *  // Hue:
 *  Npp32f nCr = (nV - nNormalizedR) / nDivisor;
 *  Npp32f nCg = (nV - nNormalizedG) / nDivisor;
 *  Npp32f nCb = (nV - nNormalizedB) / nDivisor;
 *  if (nNormalizedR == nV)
 *      nH = nCb - nCg;
 *  else if (nNormalizedG == nV)
 *      nH = 2.0F + nCr - nCb;
 *  else if (nNormalizedB == nV)
 *      nH = 4.0F + nCg - nCr;
 *  nH = nH * 0.166667F; // / 6.0F       
 *  if (nH < 0.0F)
 *      nH = nH + 1.0F;
 *  H = (Npp8u)(nH * 255.0F);
 *  S = (Npp8u)(nS * 255.0F);
 *  V = (Npp8u)(nV * 255.0F);
 * }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed RGB to 3 channel 8-bit unsigned packed HSV color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToHSV_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHSV_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHSV_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 4 channel 8-bit unsigned packed HSV with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToHSV_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHSV_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToHSV_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name HSVToRGB 
 *  HSV to RGB color conversion.
 *
 *  This is how NPP converts HSV to gamma corrected RGB or BGR.
 *  This code uses the floorf() 32 bit floating point math function.
 *
 *  <pre>{@code
 *  Npp32f nNormalizedH = (Npp32f)H * 0.003921569F; // / 255.0F
 *  Npp32f nNormalizedS = (Npp32f)S * 0.003921569F;
 *  Npp32f nNormalizedV = (Npp32f)V * 0.003921569F;
 *  Npp32f nR;
 *  Npp32f nG;
 *  Npp32f nB;
 *  if (nNormalizedS == 0.0F)
 *  {
 *      nR = nG = nB = nNormalizedV;
 *  }
 *  else
 *  {
 *      if (nNormalizedH == 1.0F)
 *          nNormalizedH = 0.0F;
 *      else
 *          nNormalizedH = nNormalizedH * 6.0F; // / 0.1667F
 *  }
 *  Npp32f nI = floorf(nNormalizedH);
 *  Npp32f nF = nNormalizedH - nI;
 *  Npp32f nM = nNormalizedV * (1.0F - nNormalizedS);
 *  Npp32f nN = nNormalizedV * (1.0F - nNormalizedS * nF);
 *  Npp32f nK = nNormalizedV * (1.0F - nNormalizedS * (1.0F - nF));
 *  if (nI == 0.0F)
 *      { nR = nNormalizedV; nG = nK; nB = nM; }
 *  else if (nI == 1.0F)
 *      { nR = nN; nG = nNormalizedV; nB = nM; }
 *  else if (nI == 2.0F)
 *      { nR = nM; nG = nNormalizedV; nB = nK; }
 *  else if (nI == 3.0F)
 *      { nR = nM; nG = nN; nB = nNormalizedV; }
 *  else if (nI == 4.0F)
 *      { nR = nK; nG = nM; nB = nNormalizedV; }
 *  else if (nI == 5.0F)
 *      { nR = nNormalizedV; nG = nM; nB = nN; }
 *  R = (Npp8u)(nR * 255.0F);
 *  G = (Npp8u)(nG * 255.0F);
 *  B = (Npp8u)(nB * 255.0F);
 *  }</pre>
 *
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed HSV to 3 channel 8-bit unsigned packed RGB color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHSVToRGB_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHSVToRGB_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHSVToRGB_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed HSV with alpha to 4 channel 8-bit unsigned packed RGB with alpha color conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHSVToRGB_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHSVToRGB_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiHSVToRGB_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name RGBToGray 
 *  RGB to CCIR601 Gray conversion.
 *
 *  Here is how NPP converts gamma corrected RGB to CCIR601 Gray.
 *
 *  <pre>{@code   
 *   nGray =  0.299F * R + 0.587F * G + 0.114F * B; 
 *  }</pre>
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 1 channel 8-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_8u_C3C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_8u_C3C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_8u_C3C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 1 channel 8-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_8u_AC4C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_8u_AC4C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_8u_AC4C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 16-bit unsigned packed RGB to 1 channel 16-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_16u_C3C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16u_C3C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16u_C3C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 16-bit unsigned packed RGB with alpha to 1 channel 16-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_16u_AC4C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16u_AC4C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16u_AC4C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 16-bit signed packed RGB to 1 channel 16-bit signed packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_16s_C3C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16s_C3C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16s_C3C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 16-bit signed packed RGB with alpha to 1 channel 16-bit signed packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_16s_AC4C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16s_AC4C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_16s_AC4C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 32-bit floating point packed RGB to 1 channel 32-bit floating point packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_32f_C3C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_32f_C3C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_32f_C3C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 32-bit floating point packed RGB with alpha to 1 channel 32-bit floating point packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRGBToGray_32f_AC4C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_32f_AC4C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiRGBToGray_32f_AC4C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name ColorToGray 
 *  RGB Color to Gray conversion using user supplied conversion coefficients.
 *
 *  Here is how NPP converts gamma corrected RGB Color to Gray using user supplied conversion coefficients.
 *
 *  <pre>{@code   
 *   nGray =  aCoeffs[0] * R + aCoeffs[1] * G + aCoeffs[2] * B;
 *  }</pre>
 *
 *  For the C4C1R versions of the functions the calculations are as follows.  
 *  For BGRA or other formats with alpha just rearrange the coefficients accordingly.
 *
 *  <pre>{@code   
 *   nGray =  aCoeffs[0] * R + aCoeffs[1] * G + aCoeffs[2] * B + aCoeffs[3] * A;
 *  }</pre>
 *
 *
 * \{
 *
 */

/**
 * 3 channel 8-bit unsigned packed RGB to 1 channel 8-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_8u_C3C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_8u_C3C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_8u_C3C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 8-bit unsigned packed RGB with alpha to 1 channel 8-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_8u_AC4C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_8u_AC4C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_8u_AC4C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 8-bit unsigned packed RGBA to 1 channel 8-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_8u_C4C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_8u_C4C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_8u_C4C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 3 channel 16-bit unsigned packed RGB to 1 channel 16-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_16u_C3C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16u_C3C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16u_C3C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 16-bit unsigned packed RGB with alpha to 1 channel 16-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_16u_AC4C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16u_AC4C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16u_AC4C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 16-bit unsigned packed RGBA to 1 channel 16-bit unsigned packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_16u_C4C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16u_C4C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16u_C4C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 3 channel 16-bit signed packed RGB to 1 channel 16-bit signed packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_16s_C3C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16s_C3C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16s_C3C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 16-bit signed packed RGB with alpha to 1 channel 16-bit signed packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_16s_AC4C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16s_AC4C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16s_AC4C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 16-bit signed packed RGBA to 1 channel 16-bit signed packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_16s_C4C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16s_C4C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_16s_C4C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 3 channel 32-bit floating point packed RGB to 1 channel 32-bit floating point packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_32f_C3C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_32f_C3C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_32f_C3C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 32-bit floating point packed RGB with alpha to 1 channel 32-bit floating point packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_32f_AC4C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_32f_AC4C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_32f_AC4C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/**
 * 4 channel 32-bit floating point packed RGBA to 1 channel 32-bit floating point packed Gray conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCoeffs fixed size array of constant floating point conversion coefficient values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorToGray_32f_C4C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatPointer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_32f_C4C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") FloatBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiColorToGray_32f_C4C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("const Npp32f*") float[] aCoeffs);

/** \} */

/** \name ColorDebayer 
 *  Grayscale Color Filter Array to RGB Color Debayer conversion. Generates one RGB color pixel for every grayscale source pixel.
 *  Source and destination images must have even width and height.  Missing pixel colors are generated using bilinear interpolation
 *  with chroma correlation of generated green values (eInterpolation MUST be set to 0). eGrid allows the user to specify the Bayer grid 
 *  registration position at source image location oSrcROI.x, oSrcROI.y relative to pSrc. Possible registration positions are:
 *
 *  <pre>{@code
 *  NPPI_BAYER_BGGR  NPPI_BAYER_RGGB  NPPI_BAYER_GBRG  NPPI_BAYER_GRBG
 *
 *        B G              R G              G B              G R
 *        G R              G B              R G              B G
 *
 *  }</pre>
 *
 *  If it becomes necessary to access source pixels outside source image then the source image borders are mirrored.
 *
 *  Here is how the algorithm works.  R, G, and B base pixels from the source image are used unmodified.  To generate R values for those
 *  G pixels, the average of R(x - 1, y) and R(x + 1, y) or R(x, y - 1) and R(x, y + 1) is used depending on whether the left and right
 *  or top and bottom pixels are R base pixels.  To generate B values for those G pixels, the same algorithm is used using nearest B values.
 *  For an R base pixel, if there are no B values in the upper, lower, left, or right adjacent pixels then B is the average of B values
 *  in the 4 diagonal (G base) pixels.  The same algorithm is used using R values to generate the R value of a B base pixel. 
 *  Chroma correlation is applied to generated G values only, for a B base pixel G(x - 1, y) and G(x + 1, y) are averaged or G(x, y - 1)
 *  and G(x, y + 1) are averaged depending on whether the absolute difference between B(x, y) and the average of B(x - 2, y) and B(x + 2, y)
 *  is smaller than the absolute difference between B(x, y) and the average of B(x, y - 2) and B(x, y + 2). For an R base pixel the same
 *  algorithm is used testing against the surrounding R values at those offsets.  If the horizontal and vertical differences are the same
 *  at one of those pixels then the average of the four left, right, upper and lower G values is used instead.
 *  
 *
 * \{
 *
 */

/**
 * 1 channel 8-bit unsigned packed CFA grayscale Bayer pattern to 3 channel 8-bit unsigned packed RGB conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize \ref full source image width and height relative to pSrc.
 * @param oSrcROI \ref rectangle specifying starting source image pixel x and y location relative to pSrc and ROI width and height. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param eGrid enumeration value specifying bayer grid registration position at location oSrcROI.x, oSrcROI.y relative to pSrc.
 * @param eInterpolation MUST be NPPI_INTER_UNDEFINED
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCFAToRGB_8u_C1C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation);
public static native @Cast("NppStatus") int nppiCFAToRGB_8u_C1C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation);
public static native @Cast("NppStatus") int nppiCFAToRGB_8u_C1C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") byte[] pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation);

/**
 * 1 channel 8-bit unsigned packed CFA grayscale Bayer pattern to 4 channel 8-bit unsigned packed RGB conversion with alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize \ref full source image width and height relative to pSrc.
 * @param oSrcROI \ref rectangle specifying starting source image pixel x and y location relative to pSrc and ROI width and height. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param eGrid enumeration value specifying bayer grid registration position at location oSrcROI.x, oSrcROI.y relative to pSrc.
 * @param eInterpolation MUST be NPPI_INTER_UNDEFINED
 * @param nAlpha constant alpha value to be written to each destination pixel
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCFAToRGBA_8u_C1AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp8u*") BytePointer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation, @Cast("Npp8u") byte nAlpha);
public static native @Cast("NppStatus") int nppiCFAToRGBA_8u_C1AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation, @Cast("Npp8u") byte nAlpha);
public static native @Cast("NppStatus") int nppiCFAToRGBA_8u_C1AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp8u*") byte[] pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation, @Cast("Npp8u") byte nAlpha);

/**
 * 1 channel 16-bit unsigned packed CFA grayscale Bayer pattern to 3 channel 16-bit unsigned packed RGB conversion.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize \ref full source image width and height relative to pSrc.
 * @param oSrcROI \ref rectangle specifying starting source image pixel x and y location relative to pSrc and ROI width and height. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param eGrid enumeration value specifying bayer grid registration position at location oSrcROI.x, oSrcROI.y relative to pSrc.
 * @param eInterpolation MUST be NPPI_INTER_UNDEFINED
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCFAToRGB_16u_C1C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation);
public static native @Cast("NppStatus") int nppiCFAToRGB_16u_C1C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation);
public static native @Cast("NppStatus") int nppiCFAToRGB_16u_C1C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") short[] pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation);

/**
 * 1 channel 16-bit unsigned packed CFA grayscale Bayer pattern to 4 channel 16-bit unsigned packed RGB conversion with alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize \ref full source image width and height relative to pSrc.
 * @param oSrcROI \ref rectangle specifying starting source image pixel x and y location relative to pSrc and ROI width and height. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param eGrid enumeration value specifying bayer grid registration position at location oSrcROI.x, oSrcROI.y relative to pSrc.
 * @param eInterpolation MUST be NPPI_INTER_UNDEFINED
 * @param nAlpha constant alpha value to be written to each destination pixel
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCFAToRGBA_16u_C1AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                               @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation, @Cast("Npp16u") short nAlpha);
public static native @Cast("NppStatus") int nppiCFAToRGBA_16u_C1AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                               @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation, @Cast("Npp16u") short nAlpha);
public static native @Cast("NppStatus") int nppiCFAToRGBA_16u_C1AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiRect oSrcROI, 
                               @Cast("Npp16u*") short[] pDst, int nDstStep, @Cast("NppiBayerGridPosition") int eGrid, @Cast("NppiInterpolationMode") int eInterpolation, @Cast("Npp16u") short nAlpha);

/** \} */

/** \} image_color_model_conversion */ 

/** \defgroup image_color_sampling_format_conversion Color Sampling Format Conversion
 *
 * Routines for converting between various image color sampling formats.
 *
 *
 * \{                                         
 */

/** \name YCbCr420ToYCbCr411 
 *  YCbCr420 to YCbCr411 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 2 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P2P3R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr411_8u_P2P3R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToYCbCr422 
 *  YCbCr422 to YCbCr422 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 2 channel 8-bit unsigned packed YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToYCrCb422 
 *  YCbCr422 to YCrCb422 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 2 channel 8-bit unsigned packed YCrCb422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb422_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb422_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb422_8u_C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 2 channel 8-bit unsigned packed YCrCb422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToCbYCr422 
 *  YCbCr422 to CbYCr422 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 2 channel 8-bit unsigned packed CbYCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToCbYCr422_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToCbYCr422_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToCbYCr422_8u_C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name CbYCr422ToYCbCr411 
 *  CbYCr422 to YCbCr411 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 3 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToYCbCr420 
 *  YCbCr422 to YCbCr420 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 3 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 2 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 3 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 2 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_C2P2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_C2P2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr420_8u_C2P2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb420ToYCbCr422 
 *  YCrCb420 to YCbCr422 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCrCb420 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCrCb420 to 2 channel 8-bit unsigned packed YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToYCrCb420 
 *  YCbCr422 to YCrCb420 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 3 channel 8-bit unsigned planar YCrCb420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr422ToYCbCr411 
 *  YCbCr422 to YCbCr411 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 3 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr422 to 2 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 3 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed YCbCr422 to 2 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_C2P2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_C2P2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr422ToYCbCr411_8u_C2P2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb422ToYCbCr422 
 *  YCrCb422 to YCbCr422 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed YCrCb422 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb422ToYCbCr420 
 *  YCrCb422 to YCbCr420 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed YCrCb422 to 3 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb422ToYCbCr411 
 *  YCrCb422 to YCbCr411 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed YCrCb422 to 3 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb422ToYCbCr411_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name CbYCr422ToYCbCr422 
 *  CbYCr422 to YCbCr422 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 2 channel 8-bit unsigned packed YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr422_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr422_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr422_8u_C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr422_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name CbYCr422ToYCbCr420 
 *  CbYCr422 to YCbCr420 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 3 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr420_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 2 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr420_8u_C2P2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr420_8u_C2P2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCbCr420_8u_C2P2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name CbYCr422ToYCrCb420 
 *  CbYCr422 to YCrCb420 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned packed CbYCr422 to 3 channel 8-bit unsigned planar YCrCb420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCbYCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiCbYCr422ToYCrCb420_8u_C2P3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr420ToYCbCr420 
 *  YCbCr420 to YCbCr420 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 2 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P2P3R(@Cast("const Npp8u*const") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P2P3R(@Cast("const Npp8u*const") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P2P3R(@Cast("const Npp8u*const") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420_8u_P2P3R(@Cast("const Npp8u*const") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);
 
/** \} */

/** \name YCbCr420ToYCbCr422 
 *  YCbCr420 to YCbCr422 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr420 to 2 channel 8-bit unsigned packed YCbCr422 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P2C2R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P2C2R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCbCr422_8u_P2C2R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr420ToCbYCr422 
 *  YCbCr420 to CbYCr422 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned planar YCbCr420 to 2 channel 8-bit unsigned packed CbYCr422 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToCbYCr422_8u_P2C2R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToCbYCr422_8u_P2C2R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToCbYCr422_8u_P2C2R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr420ToYCrCb420 
 *  YCbCr420 to YCrCb420 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned planar YCbCr420 to 3 channel 8-bit unsigned planar YCrCb420 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr420ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr420ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb420ToCbYCr422 
 *  YCrCb420 to CbYCr422 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCrCb420 to 2 channel 8-bit unsigned packed CbYCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb420ToCbYCr422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToCbYCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToCbYCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToCbYCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb420ToYCbCr420 
 *  YCrCb420 to YCbCr420 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCrCb420 to 2 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCrCb420ToYCbCr411 
 *  YCrCb420 to YCbCr411 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCrCb420 to 2 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCrCb420ToYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr411ToYCbCr411 
 *  YCbCr411 to YCbCr411 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 2 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned planar YCbCr411 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P2P3R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411_8u_P2P3R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr411ToYCbCr422 
 *  YCbCr411 to YCbCr422 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 2 channel 8-bit unsigned packed YCbCr422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned planar YCbCr422 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*const") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*const") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*const") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P2P3R(@Cast("const Npp8u*const") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr411 to 2 channel 8-bit unsigned packed YCbCr422 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P2C2R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P2C2R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr422_8u_P2C2R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr411ToYCrCb422 
 *  YCbCr411 to YCrCb422 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned planar YCrCb422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 2 channel 8-bit unsigned packed YCrCb422 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb422_8u_P3C2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr411ToYCbCr420 
 *  YCbCr411 to YCbCr420 sampling format conversion.
 * \{
 */
/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar YCbCr411 to 2 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 * images.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param rSrcStep \ref source_planar_image_line_step_array.
 * @param pDstY \ref destination_planar_image_pointer.
 * @param nDstYStep \ref destination_planar_image_line_step.
 * @param pDstCbCr \ref destination_planar_image_pointer.
 * @param nDstCbCrStep \ref destination_planar_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") PointerPointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, IntPointer rSrcStep, @Cast("Npp8u*") BytePointer pDstY, int nDstYStep, @Cast("Npp8u*") BytePointer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, IntBuffer rSrcStep, @Cast("Npp8u*") ByteBuffer pDstY, int nDstYStep, @Cast("Npp8u*") ByteBuffer pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P3P2R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int[] rSrcStep, @Cast("Npp8u*") byte[] pDstY, int nDstYStep, @Cast("Npp8u*") byte[] pDstCbCr, int nDstCbCrStep, @ByVal NppiSize oSizeROI);

/**
 * 2 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned planar YCbCr420 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P2P3R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCbCr420_8u_P2P3R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name YCbCr411ToYCrCb420 
 *  YCbCr411 to YCrCb420 sampling format conversion.
 * \{
 */
/**
 * 2 channel 8-bit unsigned planar YCbCr411 to 3 channel 8-bit unsigned planar YCrCb420 sampling format conversion.
 *
 * @param pSrcY \ref source_planar_image_pointer.
 * @param nSrcYStep \ref source_planar_image_line_step.
 * @param pSrcCbCr \ref source_planar_image_pointer.
 * @param nSrcCbCrStep \ref source_planar_image_line_step.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param rDstStep \ref destination_planar_image_line_step_array.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") PointerPointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") BytePointer pSrcY, int nSrcYStep, @Cast("const Npp8u*") BytePointer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, IntPointer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") ByteBuffer pSrcY, int nSrcYStep, @Cast("const Npp8u*") ByteBuffer pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, IntBuffer rDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiYCbCr411ToYCrCb420_8u_P2P3R(@Cast("const Npp8u*") byte[] pSrcY, int nSrcYStep, @Cast("const Npp8u*") byte[] pSrcCbCr, int nSrcCbCrStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int[] rDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \} image_color_sampling_format_conversion */ 

/** \defgroup image_color_gamma_correction Color Gamma Correction
 *
 * Routines for correcting image color gamma.
 *
 * \{                                         
 *
 */

/** \name GammaFwd 
 *  Forward gamma correction.
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed color not in place forward gamma correction.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaFwd_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed color in place forward gamma correction.
 *
 * @param pSrcDst in place packed pixel image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaFwd_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed color with alpha not in place forward gamma correction.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaFwd_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed color with alpha in place forward gamma correction.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaFwd_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar color not in place forward gamma correction.
 *
 * @param pSrc source planar pixel format image pointer array.
 * @param nSrcStep source planar pixel format image line step.
 * @param pDst destination planar pixel format image pointer array.
 * @param nDstStep destination planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaFwd_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar color in place forward gamma correction.
 *
 * @param pSrcDst in place planar pixel format image pointer array.
 * @param nSrcDstStep in place planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaFwd_8u_IP3R(@Cast("Npp8u*const*") PointerPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaFwd_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \name GammaInv 
 *  Inverse gamma correction.
 * \{
 */
/**
 * 3 channel 8-bit unsigned packed color not in place inverse gamma correction.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaInv_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned packed color in place inverse gamma correction.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaInv_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed color with alpha not in place inverse gamma correction.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaInv_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 4 channel 8-bit unsigned packed color with alpha in place inverse gamma correction.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaInv_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar color not in place inverse gamma correction.
 *
 * @param pSrc source planar pixel format image pointer array.
 * @param nSrcStep source planar pixel format image line step.
 * @param pDst destination planar pixel format image pointer array.
 * @param nDstStep destination planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaInv_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * 3 channel 8-bit unsigned planar color in place inverse gamma correction.
 *
 * @param pSrcDst in place planar pixel format image pointer array.
 * @param nSrcDstStep in place planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGammaInv_8u_IP3R(@Cast("Npp8u*const*") PointerPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiGammaInv_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/** \} */

/** \} image_color_gamma_correction */ 

/** \defgroup image_complement_color_key Complement Color Key
 *
 * Routines for performing complement color key replacement.
 *
 * \{                                         
 *
 */

/** \name CompColorKey 
 *  Complement color key replacement.
 * \{
 */
/**
 * 1 channel 8-bit unsigned packed color complement color key replacement of source image 1 by source image 2.
 *
 * @param pSrc1 source1 packed pixel format image pointer.
 * @param nSrc1Step source1 packed pixel format image line step.
 * @param pSrc2 source2 packed pixel format image pointer.
 * @param nSrc2Step source2 packed pixel format image line step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nColorKeyConst color key constant
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nColorKeyConst);
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nColorKeyConst);
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u") byte nColorKeyConst);

/**
 * 3 channel 8-bit unsigned packed color complement color key replacement of source image 1 by source image 2.
 *
 * @param pSrc1 source1 packed pixel format image pointer.
 * @param nSrc1Step source1 packed pixel format image line step.
 * @param pSrc2 source2 packed pixel format image pointer.
 * @param nSrc2Step source2 packed pixel format image line step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nColorKeyConst color key constant array
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer nColorKeyConst);
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer nColorKeyConst);
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] nColorKeyConst);

/**
 * 4 channel 8-bit unsigned packed color complement color key replacement of source image 1 by source image 2.
 *
 * @param pSrc1 source1 packed pixel format image pointer.
 * @param nSrc1Step source1 packed pixel format image line step.
 * @param pSrc2 source2 packed pixel format image pointer.
 * @param nSrc2Step source2 packed pixel format image line step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nColorKeyConst color key constant array
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer nColorKeyConst);
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer nColorKeyConst);
public static native @Cast("NppStatus") int nppiCompColorKey_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] nColorKeyConst);

/**
 * 4 channel 8-bit unsigned packed color complement color key replacement of source image 1 by source image 2 with alpha blending.
 *
 * @param pSrc1 source1 packed pixel format image pointer.
 * @param nSrc1Step source1 packed pixel format image line step.
 * @param nAlpha1 source1 image alpha opacity (0 - max channel pixel value).
 * @param pSrc2 source2 packed pixel format image pointer.
 * @param nSrc2Step source2 packed pixel format image line step.
 * @param nAlpha2 source2 image alpha opacity (0 - max channel pixel value).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nColorKeyConst color key constant array
 * @param nppAlphaOp NppiAlphaOp alpha compositing operation selector  (excluding premul ops).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiAlphaCompColorKey_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer nColorKeyConst, @Cast("NppiAlphaOp") int nppAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompColorKey_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer nColorKeyConst, @Cast("NppiAlphaOp") int nppAlphaOp);
public static native @Cast("NppStatus") int nppiAlphaCompColorKey_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, @Cast("Npp8u") byte nAlpha1, @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, @Cast("Npp8u") byte nAlpha2, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] nColorKeyConst, @Cast("NppiAlphaOp") int nppAlphaOp);

/** \} */

/** \} image_complement_color_key */ 

/** \defgroup image_color_processing Color Processing
 *
 * Routines for performing image color manipulation.
 *
 * \{                                         
 *
 */

/** \name ColorTwist
 * 
 *  Perform color twist pixel processing.  Color twist consists of applying the following formula to each
 *  image pixel using coefficients from the user supplied color twist host matrix array as follows where 
 *  dst[x] and src[x] represent destination pixel and source pixel channel or plane x. The full sized
 *  coefficient matrix should be sent for all pixel channel sizes, the function will process the appropriate
 *  coefficients and channels for the corresponding pixel size.
 *
 *  <pre>{@code
 *      dst[0] = aTwist[0][0] * src[0] + aTwist[0][1] * src[1] + aTwist[0][2] * src[2] + aTwist[0][3]
 *      dst[1] = aTwist[1][0] * src[0] + aTwist[1][1] * src[1] + aTwist[1][2] * src[2] + aTwist[1][3]
 *      dst[2] = aTwist[2][0] * src[0] + aTwist[2][1] * src[1] + aTwist[2][2] * src[2] + aTwist[2][3]
 *  }</pre>
 *
 * \{
 */

/**
 * 1 channel 8-bit unsigned color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 8-bit unsigned in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 8-bit unsigned color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 8-bit unsigned in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C2IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C2IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C2IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 8-bit unsigned color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 8-bit unsigned in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit unsigned color twist, with alpha copy.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is copied unmodified from the source pixel to the destination pixel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit unsigned in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is unmodified.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_C4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit unsigned color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit unsigned in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit unsigned color twist with 4x4 matrix and constant vector addition.
 *
 * An input 4x4 color twist matrix with floating-point coefficient values with an additional constant vector addition
 * is applied within ROI.  For this particular version of the function the result is generated as shown below.
 *
 *  <pre>{@code
 *      dst[0] = aTwist[0][0] * src[0] + aTwist[0][1] * src[1] + aTwist[0][2] * src[2] + aTwist[0][3] * src[3] + aConstants[0]
 *      dst[1] = aTwist[1][0] * src[0] + aTwist[1][1] * src[1] + aTwist[1][2] * src[2] + aTwist[1][3] * src[3] + aConstants[1]
 *      dst[2] = aTwist[2][0] * src[0] + aTwist[2][1] * src[1] + aTwist[2][2] * src[2] + aTwist[2][3] * src[3] + aConstants[2]
 *      dst[3] = aTwist[3][0] * src[0] + aTwist[3][1] * src[1] + aTwist[3][2] * src[2] + aTwist[3][3] * src[3] + aConstants[3]
 *  }</pre>
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @param aConstants fixed size array of constant values, one per channel..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32fC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatPointer aTwist, @Cast("const Npp32f*") FloatPointer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist32fC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatBuffer aTwist, @Cast("const Npp32f*") FloatBuffer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist32fC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") float[] aTwist, @Cast("const Npp32f*") float[] aConstants);

/**
 * 4 channel 8-bit unsigned in place color twist with 4x4 matrix and an additional constant vector addition.
 *
 * An input 4x4 color twist matrix with floating-point coefficient values with an additional constant vector addition
 * is applied within ROI.  For this particular version of the function the result is generated as shown below.
 *
 *  <pre>{@code
 *      dst[0] = aTwist[0][0] * src[0] + aTwist[0][1] * src[1] + aTwist[0][2] * src[2] + aTwist[0][3] * src[3] + aConstants[0]
 *      dst[1] = aTwist[1][0] * src[0] + aTwist[1][1] * src[1] + aTwist[1][2] * src[2] + aTwist[1][3] * src[3] + aConstants[1]
 *      dst[2] = aTwist[2][0] * src[0] + aTwist[2][1] * src[1] + aTwist[2][2] * src[2] + aTwist[2][3] * src[3] + aConstants[2]
 *      dst[3] = aTwist[3][0] * src[0] + aTwist[3][1] * src[1] + aTwist[3][2] * src[2] + aTwist[3][3] * src[3] + aConstants[3]
 *  }</pre>
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @param aConstants fixed size array of constant values, one per channel..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32fC_8u_C4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatPointer aTwist, @Cast("const Npp32f*") FloatPointer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist32fC_8u_C4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatBuffer aTwist, @Cast("const Npp32f*") FloatBuffer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist32fC_8u_C4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") float[] aTwist, @Cast("const Npp32f*") float[] aConstants);

/**
 * 3 channel 8-bit unsigned planar color twist.
 *
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8u*const*") PointerPointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8u*const*") @ByPtrPtr byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 8-bit unsigned planar in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place planar pixel format image pointer array, one pointer per plane.
 * @param nSrcDstStep in place planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_IP3R(@Cast("Npp8u*const*") PointerPointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8u_IP3R(@Cast("Npp8u*const*") @ByPtrPtr byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 8-bit signed color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 8-bit signed in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C1IR(@Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C1IR(@Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C1IR(@Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 8-bit signed color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C2R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 8-bit signed in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C2IR(@Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C2IR(@Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C2IR(@Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 8-bit signed color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 8-bit signed in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C3IR(@Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C3IR(@Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C3IR(@Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit signed color twist, with alpha copy.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is copied unmodified from the source pixel to the destination pixel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit signed in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is unmodified.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C4IR(@Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C4IR(@Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_C4IR(@Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit signed color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 8-bit signed in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_AC4IR(@Cast("Npp8s*") BytePointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_AC4IR(@Cast("Npp8s*") ByteBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_AC4IR(@Cast("Npp8s*") byte[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 8-bit signed planar color twist.
 *
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_P3R(@Cast("const Npp8s*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp8s*const*") PointerPointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_P3R(@Cast("const Npp8s*const*") @ByPtrPtr BytePointer pSrc, int nSrcStep, @Cast("Npp8s*const*") @ByPtrPtr BytePointer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_P3R(@Cast("const Npp8s*const*") @ByPtrPtr ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*const*") @ByPtrPtr ByteBuffer pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_P3R(@Cast("const Npp8s*const*") @ByPtrPtr byte[] pSrc, int nSrcStep, @Cast("Npp8s*const*") @ByPtrPtr byte[] pDst, int nDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 8-bit signed planar in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place planar pixel format image pointer array, one pointer per plane.
 * @param nSrcDstStep in place planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_IP3R(@Cast("Npp8s*const*") PointerPointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_IP3R(@Cast("Npp8s*const*") @ByPtrPtr BytePointer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_IP3R(@Cast("Npp8s*const*") @ByPtrPtr ByteBuffer pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_8s_IP3R(@Cast("Npp8s*const*") @ByPtrPtr byte[] pSrcDst, int nSrcDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);


/**
 * 1 channel 16-bit unsigned color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 16-bit unsigned in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 16-bit unsigned color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C2R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C2R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C2R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 16-bit unsigned in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C2IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C2IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C2IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit unsigned color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit unsigned in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 16-bit unsigned color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 16-bit unsigned in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                            @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                            @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                            @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit unsigned planar color twist.
 *
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_P3R(@Cast("const Npp16u*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp16u*const*") PointerPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr short[] pSrc, int nSrcStep, @Cast("Npp16u*const*") @ByPtrPtr short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit unsigned planar in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place planar pixel format image pointer array, one pointer per plane.
 * @param nSrcDstStep in place planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_IP3R(@Cast("Npp16u*const*") PointerPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_IP3R(@Cast("Npp16u*const*") @ByPtrPtr ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_IP3R(@Cast("Npp16u*const*") @ByPtrPtr ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16u_IP3R(@Cast("Npp16u*const*") @ByPtrPtr short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 16-bit signed color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 16-bit signed in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 16-bit signed color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C2R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C2R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C2R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 16-bit signed in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C2IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C2IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C2IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit signed color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit signed in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 16-bit signed color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 16-bit signed in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                            @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                            @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                            @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit signed planar color twist.
 *
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_P3R(@Cast("const Npp16s*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp16s*const*") PointerPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr ShortPointer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr ShortBuffer pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr short[] pSrc, int nSrcStep, @Cast("Npp16s*const*") @ByPtrPtr short[] pDst, int nDstStep, 
                          @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 16-bit signed planar in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place planar pixel format image pointer array, one pointer per plane.
 * @param nSrcDstStep in place planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_IP3R(@Cast("Npp16s*const*") PointerPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_IP3R(@Cast("Npp16s*const*") @ByPtrPtr ShortPointer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_IP3R(@Cast("Npp16s*const*") @ByPtrPtr ShortBuffer pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist32f_16s_IP3R(@Cast("Npp16s*const*") @ByPtrPtr short[] pSrcDst, int nSrcDstStep, 
                           @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 32-bit floating point color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 1 channel 32-bit floating point in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 32-bit floating point color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C2R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C2R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C2R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 2 channel 32-bit floating point in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C2IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C2IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C2IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 32-bit floating point color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 32-bit floating point in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 32-bit floating point color twist, with alpha copy.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is copied unmodified from the source pixel to the destination pixel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 32-bit floating point in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not modified.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_C4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_C4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 32-bit floating point color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 32-bit floating point in place color twist, not affecting Alpha.
 *
 * An input color twist matrix with floating-point coefficient values is applied with
 * in ROI.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 4 channel 32-bit floating point color twist with 4x4 matrix and constant vector addition.
 *
 * An input 4x4 color twist matrix with floating-point coefficient values with an additional constant vector addition
 * is applied within ROI.  For this particular version of the function the result is generated as shown below.
 *
 *  <pre>{@code
 *      dst[0] = aTwist[0][0] * src[0] + aTwist[0][1] * src[1] + aTwist[0][2] * src[2] + aTwist[0][3] * src[3] + aConstants[0]
 *      dst[1] = aTwist[1][0] * src[0] + aTwist[1][1] * src[1] + aTwist[1][2] * src[2] + aTwist[1][3] * src[3] + aConstants[1]
 *      dst[2] = aTwist[2][0] * src[0] + aTwist[2][1] * src[1] + aTwist[2][2] * src[2] + aTwist[2][3] * src[3] + aConstants[2]
 *      dst[3] = aTwist[3][0] * src[0] + aTwist[3][1] * src[1] + aTwist[3][2] * src[2] + aTwist[3][3] * src[3] + aConstants[3]
 *  }</pre>
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @param aConstants fixed size array of constant values, one per channel..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32fC_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatPointer aTwist, @Cast("const Npp32f*") FloatPointer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist_32fC_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatBuffer aTwist, @Cast("const Npp32f*") FloatBuffer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist_32fC_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") float[] aTwist, @Cast("const Npp32f*") float[] aConstants);

/**
 * 4 channel 32-bit floating point in place color twist with 4x4 matrix and an additional constant vector addition.
 *
 * An input 4x4 color twist matrix with floating-point coefficient values with an additional constant vector addition
 * is applied within ROI.  For this particular version of the function the result is generated as shown below.
 *
 *  <pre>{@code
 *      dst[0] = aTwist[0][0] * src[0] + aTwist[0][1] * src[1] + aTwist[0][2] * src[2] + aTwist[0][3] * src[3] + aConstants[0]
 *      dst[1] = aTwist[1][0] * src[0] + aTwist[1][1] * src[1] + aTwist[1][2] * src[2] + aTwist[1][3] * src[3] + aConstants[1]
 *      dst[2] = aTwist[2][0] * src[0] + aTwist[2][1] * src[1] + aTwist[2][2] * src[2] + aTwist[2][3] * src[3] + aConstants[2]
 *      dst[3] = aTwist[3][0] * src[0] + aTwist[3][1] * src[1] + aTwist[3][2] * src[2] + aTwist[3][3] * src[3] + aConstants[3]
 *  }</pre>
 *
 * @param pSrcDst in place packed pixel format image pointer.
 * @param nSrcDstStep in place packed pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @param aConstants fixed size array of constant values, one per channel..
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32fC_C4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatPointer aTwist, @Cast("const Npp32f*") FloatPointer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist_32fC_C4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") FloatBuffer aTwist, @Cast("const Npp32f*") FloatBuffer aConstants);
public static native @Cast("NppStatus") int nppiColorTwist_32fC_C4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                         @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[4]*/ )[4]") float[] aTwist, @Cast("const Npp32f*") float[] aConstants);

/**
 * 3 channel 32-bit floating point planar color twist.
 *
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_P3R(@Cast("const Npp32f*const*") PointerPointer pSrc, int nSrcStep, @Cast("Npp32f*const*") PointerPointer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr FloatPointer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr FloatBuffer pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr float[] pSrc, int nSrcStep, @Cast("Npp32f*const*") @ByPtrPtr float[] pDst, int nDstStep, 
                       @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/**
 * 3 channel 32-bit floating point planar in place color twist.
 * 
 * An input color twist matrix with floating-point coefficient values is applied
 * within ROI.
 *
 * @param pSrcDst in place planar pixel format image pointer array, one pointer per plane.
 * @param nSrcDstStep in place planar pixel format image line step.
 * @param oSizeROI \ref roi_specification.
 * @param aTwist The color twist matrix with floating-point coefficient values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiColorTwist_32f_IP3R(@Cast("Npp32f*const*") PointerPointer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_IP3R(@Cast("Npp32f*const*") @ByPtrPtr FloatPointer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatPointer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_IP3R(@Cast("Npp32f*const*") @ByPtrPtr FloatBuffer pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") FloatBuffer aTwist);
public static native @Cast("NppStatus") int nppiColorTwist_32f_IP3R(@Cast("Npp32f*const*") @ByPtrPtr float[] pSrcDst, int nSrcDstStep, 
                        @ByVal NppiSize oSizeROI, @Cast("const Npp32f(* /*[3]*/ )[4]") float[] aTwist);

/** \} */

/** \name ColorLUT
 * 
 *  Perform image color processing using members of various types of color look up tables.
 * \{
 */

/**
 * 8-bit unsigned look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 8-bit unsigned look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_C1IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C1IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C1IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 8-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 8-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_C3IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C3IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C3IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C3IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
               @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_C4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C4IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_C4IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_AC4IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_8u_AC4IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);


/**
 * 16-bit unsigned look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 16-bit unsigned look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_C1IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C1IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C1IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 16-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 16-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_C3IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C3IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C3IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C3IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_C4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C4IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_C4IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16u_AC4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_AC4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_AC4IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16u_AC4IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);


/**
 * 16-bit signed look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 16-bit signed look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_C1IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C1IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C1IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 16-bit signed look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 16-bit signed look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_C3IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C3IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C3IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C3IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_C4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C4IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_C4IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_16s_AC4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_AC4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_AC4IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_16s_AC4IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);


/**
 * 32-bit floating point look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f*") FloatPointer pValues, @Cast("const Npp32f*") FloatPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f*") FloatBuffer pValues, @Cast("const Npp32f*") FloatBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f*") float[] pValues, @Cast("const Npp32f*") float[] pLevels, int nLevels);

/**
 * 32-bit floating point look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_C1IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f*") FloatPointer pValues, @Cast("const Npp32f*") FloatPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C1IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f*") FloatBuffer pValues, @Cast("const Npp32f*") FloatBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C1IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f*") float[] pValues, @Cast("const Npp32f*") float[] pLevels, int nLevels);

/**
 * 3 channel 32-bit floating point look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 3 channel 32-bit floating point look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_C3IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C3IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C3IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C3IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points with no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_C4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C4IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_C4IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                 @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_32f_AC4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_AC4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_AC4IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_32f_AC4IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/** \} */

/** \name ColorLUT_Linear
 * 
 * Perform image color processing using linear interpolation between members of various types of color look up tables.
 * \{
 */
/**
 * 8-bit unsigned linear interpolated look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 *
 * >>>>>>> ATTENTION ATTENTION <<<<<<<
 *
 * NOTE: As of the 5.0 release of NPP, the pValues and pLevels pointers need to be device memory pointers.
 *
 * >>>>>>>                     <<<<<<<
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is now a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is now a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 8-bit unsigned linear interpolated look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C1IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C1IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C1IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 8-bit unsigned linear interpolated look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 *
 * >>>>>>> ATTENTION ATTENTION <<<<<<<
 *
 * NOTE: As of the 5.0 release of NPP, the pValues and pLevels pointers need to be host memory pointers to arrays of device memory pointers.
 *
 * >>>>>>>                     <<<<<<<
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 8-bit unsigned linear interpolated look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C3IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned linear interpolated look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 *
 * >>>>>>> ATTENTION ATTENTION <<<<<<<
 *
 * NOTE: As of the 5.0 release of NPP, the pValues and pLevels pointers need to be host memory pointers to arrays of device memory pointers.
 *
 * >>>>>>>                     <<<<<<<
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned linear interpolated look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_C4IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned linear interpolated look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * >>>>>>> ATTENTION ATTENTION <<<<<<<
 *
 * NOTE: As of the 5.0 release of NPP, the pValues and pLevels pointers need to be host memory pointers to arrays of device memory pointers.
 *
 * >>>>>>>                     <<<<<<<
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned linear interpolated look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points through linear interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_8u_AC4IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);
       
/**
 * 16-bit unsigned look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 16-bit unsigned look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C1IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C1IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C1IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 16-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 16-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C3IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_C4IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16u_AC4IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);


/**
 * 16-bit signed look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 16-bit signed look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C1IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C1IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C1IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 16-bit signed look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 16-bit signed look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C3IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_C4IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_16s_AC4IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);


/**
 * 32-bit floating point look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatPointer pValues, @Cast("const Npp32f*") FloatPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatBuffer pValues, @Cast("const Npp32f*") FloatBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") float[] pValues, @Cast("const Npp32f*") float[] pLevels, int nLevels);

/**
 * 32-bit floating point look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C1IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatPointer pValues, @Cast("const Npp32f*") FloatPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C1IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatBuffer pValues, @Cast("const Npp32f*") FloatBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C1IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") float[] pValues, @Cast("const Npp32f*") float[] pLevels, int nLevels);

/**
 * 3 channel 32-bit floating point look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 3 channel 32-bit floating point look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C3IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using linear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_C4IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Linear_32f_AC4IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/** \} */

/** \name ColorLUT_Cubic
 * 
 *  Perform image color processing using linear interpolation between members of various types of color look up tables.
 * \{
 */
/**
 * 8-bit unsigned cubic interpolated look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 8-bit unsigned cubic interpolated look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C1IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C1IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C1IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 8-bit unsigned cubic interpolated look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 8-bit unsigned cubic interpolated look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C3IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned cubic interpolated look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned cubic interpolated look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_C4IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned cubic interpolated look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 8-bit unsigned cubic interpolated look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_8u_AC4IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 16-bit unsigned look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 16-bit unsigned look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C1IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C1IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C1IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 16-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 16-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C3IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_C4IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit unsigned look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4IR(      @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4IR(      @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16u_AC4IR(      @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);


/**
 * 16-bit signed look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 16-bit signed look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C1IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntPointer pValues, @Cast("const Npp32s*") IntPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C1IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") IntBuffer pValues, @Cast("const Npp32s*") IntBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C1IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s*") int[] pValues, @Cast("const Npp32s*") int[] pLevels, int nLevels);

/**
 * 3 channel 16-bit signed look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 3 channel 16-bit signed look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C3IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_C4IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);

/**
 * 4 channel 16-bit signed look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") PointerPointer pValues, @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4IR(      @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntPointer pValues, @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4IR(      @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr IntBuffer pValues, @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_16s_AC4IR(      @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s**") @ByPtrPtr int[] pValues, @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels);


/**
 * 32-bit floating point look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pValues, @Cast("const Npp32f*") FloatPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pValues, @Cast("const Npp32f*") FloatBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pValues, @Cast("const Npp32f*") float[] pLevels, int nLevels);

/**
 * 32-bit floating point look-up-table in place color conversion.
 *
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Pointer to an array of user defined OUTPUT values (this is a device memory pointer)
 * @param pLevels Pointer to an array of user defined INPUT values  (this is a device memory pointer)
 * @param nLevels Number of user defined number of input/output mapping points (levels)
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C1IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatPointer pValues, @Cast("const Npp32f*") FloatPointer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C1IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatBuffer pValues, @Cast("const Npp32f*") FloatBuffer pLevels, int nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C1IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") float[] pValues, @Cast("const Npp32f*") float[] pLevels, int nLevels);

/**
 * 3 channel 32-bit floating point look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 3 channel 32-bit floating point look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C3IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points through cubic interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table in place color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 4 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_C4IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/**
 * 4 channel 32-bit floating point look-up-table in place color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points using no interpolation. 
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT values.
 * @param pLevels Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined INPUT values.
 * @param nLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per color CHANNEL.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 1024 (the current size limit).
 */
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") PointerPointer pValues, @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4IR(      @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatPointer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4IR(      @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pValues, @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels);
public static native @Cast("NppStatus") int nppiLUT_Cubic_32f_AC4IR(      @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f**") @ByPtrPtr float[] pValues, @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels);

/** \} */

/** \name ColorLUT_Trilinear
 * 
 *  Perform image color processing using 3D trilinear interpolation between members of various types of color look up tables.
 * \{
 */

/**
 * Four channel 8-bit unsigned 3D trilinear interpolated look-up-table color conversion, with alpha copy.
 * Alpha channel is the last channel and is copied to the destination unmodified.
 *
 * The LUT is derived from a set of user defined mapping points through trilinear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Device pointer to aLevels[2] number of contiguous 2D x,y planes of 4-byte packed RGBX values
 *        containing the user defined base OUTPUT values at that x,y, and z (R,G,B) level location. Each level must contain x * y 4-byte
 *        packed pixel values (4th byte is used for alignement only and is ignored) in row (x) order.
 * @param pLevels Host pointer to an array of 3 host pointers, one per cube edge, pointing to user defined INPUT level values.
 * @param aLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per 3D cube edge.
 *        aLevels[0] represents the number of x axis levels (Red), aLevels[1] represents the number of y axis levels (Green), 
 *        and aLevels[2] represets the number of z axis levels (Blue).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("Npp32u*") IntPointer pValues, @Cast("Npp8u**") PointerPointer pLevels, IntPointer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("Npp32u*") IntPointer pValues, @Cast("Npp8u**") @ByPtrPtr BytePointer pLevels, IntPointer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("Npp32u*") IntBuffer pValues, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pLevels, IntBuffer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("Npp32u*") int[] pValues, @Cast("Npp8u**") @ByPtrPtr byte[] pLevels, int[] aLevels);

/**
 * Four channel 8-bit unsigned 3D trilinear interpolated look-up-table color conversion, not affecting alpha.
 * Alpha channel is the last channel and is not processed.
 *
 * The LUT is derived from a set of user defined mapping points through trilinear interpolation. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Device pointer to aLevels[2] number of contiguous 2D x,y planes of 4-byte packed RGBX values
 *        containing the user defined base OUTPUT values at that x,y, and z (R,G,B) level location. Each level must contain x * y 4-byte
 *        packed pixel values (4th byte is used for alignement only and is ignored) in row (x) order.
 * @param pLevels Host pointer to an array of 3 host pointers, one per cube edge, pointing to user defined INPUT level values.
 * @param aLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per 3D cube edge.
 *        aLevels[0] represents the number of x axis levels (Red), aLevels[1] represents the number of y axis levels (Green), 
 *        and aLevels[2] represets the number of z axis levels (Blue).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("Npp32u*") IntPointer pValues, @Cast("Npp8u**") PointerPointer pLevels, IntPointer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("Npp32u*") IntPointer pValues, @Cast("Npp8u**") @ByPtrPtr BytePointer pLevels, IntPointer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("Npp32u*") IntBuffer pValues, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pLevels, IntBuffer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("Npp32u*") int[] pValues, @Cast("Npp8u**") @ByPtrPtr byte[] pLevels, int[] aLevels);

/**
 * Four channel 8-bit unsigned 3D trilinear interpolated look-up-table in place color conversion, not affecting alpha.
 * Alpha channel is the last channel and is not processed.
 *
 * The LUT is derived from a set of user defined mapping points through trilinear interpolation. 
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pValues Device pointer aLevels[2] number of contiguous 2D x,y planes of 4-byte packed RGBX values
 *        containing the user defined base OUTPUT values at that x,y, and z (R,G,B) level location. Each level must contain x * y 4-byte
 *        packed pixel values (4th byte is used for alignement only and is ignored) in row (x) order.
 * @param pLevels Host pointer to an array of 3 host pointers, one per cube edge, pointing to user defined INPUT level values.
 * @param aLevels Host pointer to an array of 3 user defined number of input/output mapping points, one per 3D cube edge.
 *        aLevels[0] represents the number of x axis levels (Red), aLevels[1] represents the number of y axis levels (Green), 
 *        and aLevels[2] represets the number of z axis levels (Blue).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_NUMBER_OF_LEVELS_ERROR if the number of levels is less than 2 or greater than 256.
 */
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("Npp32u*") IntPointer pValues, @Cast("Npp8u**") PointerPointer pLevels, IntPointer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4IR(      @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("Npp32u*") IntPointer pValues, @Cast("Npp8u**") @ByPtrPtr BytePointer pLevels, IntPointer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4IR(      @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("Npp32u*") IntBuffer pValues, @Cast("Npp8u**") @ByPtrPtr ByteBuffer pLevels, IntBuffer aLevels);
public static native @Cast("NppStatus") int nppiLUT_Trilinear_8u_AC4IR(      @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("Npp32u*") int[] pValues, @Cast("Npp8u**") @ByPtrPtr byte[] pLevels, int[] aLevels);

/** \} */

/** \name ColorLUTPalette
 * 
 *  Perform image color processing using various types of bit range restricted palette color look up tables.
 * \{
 */

/**
 * One channel 8-bit unsigned bit range restricted palette look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTable Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
 * @param nBitSize Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u*") BytePointer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u*") ByteBuffer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u*") byte[] pTable, int nBitSize);

/**
 * One channel 8-bit unsigned bit range restricted 24-bit palette look-up-table color conversion with 24-bit destination output per pixel.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step (3 bytes per pixel).
 * @param oSizeROI \ref roi_specification.
 * @param pTable Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
 * @param nBitSize Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_8u24u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") BytePointer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u24u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") ByteBuffer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u24u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") byte[] pTable, int nBitSize);

/**
 * One channel 8-bit unsigned bit range restricted 32-bit palette look-up-table color conversion with 32-bit destination output per pixel.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step (4 bytes per pixel).
 * @param oSizeROI \ref roi_specification.
 * @param pTable Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
 * @param nBitSize Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_8u32u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32u*") IntPointer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u32u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32u*") IntBuffer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u32u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32u*") int[] pTable, int nBitSize);

/**
 * Three channel 8-bit unsigned bit range restricted palette look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") @ByPtrPtr BytePointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") @ByPtrPtr ByteBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") @ByPtrPtr byte[] pTables, int nBitSize);

/**
 * Four channel 8-bit unsigned bit range restricted palette look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") @ByPtrPtr BytePointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") @ByPtrPtr ByteBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp8u**") @ByPtrPtr byte[] pTables, int nBitSize);

/**
 * Four channel 8-bit unsigned bit range restricted palette look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u**") @ByPtrPtr BytePointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u**") @ByPtrPtr ByteBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u**") @ByPtrPtr byte[] pTables, int nBitSize);

/**
 * One channel 16-bit unsigned bit range restricted palette look-up-table color conversion.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTable Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u*") ShortPointer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u*") ShortBuffer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u*") short[] pTable, int nBitSize);

/**
 * One channel 16-bit unsigned bit range restricted 8-bit unsigned palette look-up-table color conversion with 8-bit unsigned destination output per pixel.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step (1 unsigned byte per pixel).
 * @param oSizeROI \ref roi_specification.
 * @param pTable Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_16u8u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") BytePointer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u8u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") ByteBuffer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u8u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") byte[] pTable, int nBitSize);

/**
 * One channel 16-bit unsigned bit range restricted 24-bit unsigned palette look-up-table color conversion with 24-bit unsigned destination output per pixel.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step (3 unsigned bytes per pixel).
 * @param oSizeROI \ref roi_specification.
 * @param pTable Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_16u24u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp8u*") BytePointer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u24u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp8u*") ByteBuffer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u24u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp8u*") byte[] pTable, int nBitSize);

/**
 * One channel 16-bit unsigned bit range restricted 32-bit palette look-up-table color conversion with 32-bit unsigned destination output per pixel.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step (4 bytes per pixel).
 * @param oSizeROI \ref roi_specification.
 * @param pTable Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_16u32u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp32u*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32u*") IntPointer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u32u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp32u*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32u*") IntBuffer pTable, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u32u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp32u*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32u*") int[] pTable, int nBitSize);

/**
 * Three channel 16-bit unsigned bit range restricted palette look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") @ByPtrPtr ShortPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") @ByPtrPtr ShortBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") @ByPtrPtr short[] pTables, int nBitSize);

/**
 * Four channel 16-bit unsigned bit range restricted palette look-up-table color conversion.
 * 
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") @ByPtrPtr ShortPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") @ByPtrPtr ShortBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp16u**") @ByPtrPtr short[] pTables, int nBitSize);

/**
 * Four channel 16-bit unsigned bit range restricted palette look-up-table color conversion, not affecting Alpha.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 * Alpha channel is the last channel and is not processed.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPalette_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp16u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp16u**") @ByPtrPtr ShortPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp16u**") @ByPtrPtr ShortBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPalette_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp16u**") @ByPtrPtr short[] pTables, int nBitSize);

/**
 * Three channel 8-bit unsigned source bit range restricted palette look-up-table color conversion to four channel 8-bit unsigned destination output with alpha.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 * This function also reverses the source pixel channel order in the destination so the Alpha channel is the first channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step (3 bytes per pixel).
 * @param nAlphaValue Signed alpha value that will be used to initialize the pixel alpha channel position in all modified destination pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step (4 bytes per pixel with alpha).
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * Alpha values < 0 or > 255 will cause destination pixel alpha channel values to be unmodified.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.
 */
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_8u_C3A0C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp8u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_8u_C3A0C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp8u**") @ByPtrPtr BytePointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_8u_C3A0C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp8u**") @ByPtrPtr ByteBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_8u_C3A0C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp8u**") @ByPtrPtr byte[] pTables, int nBitSize);

/**
 * Three channel 16-bit unsigned source bit range restricted palette look-up-table color conversion to four channel 16-bit unsigned destination output with alpha.
 *
 * The LUT is derived from a set of user defined mapping points in a palette and 
 * source pixels are then processed using a restricted bit range when looking up palette values.
 * This function also reverses the source pixel channel order in the destination so the Alpha channel is the first channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step (3 unsigned short integers per pixel).
 * @param nAlphaValue Signed alpha value that will be used to initialize the pixel alpha channel position in all modified destination pixels.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step (4 unsigned short integers per pixel with alpha).
 * @param oSizeROI \ref roi_specification.
 * @param pTables Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
 * Alpha values < 0 or > 65535 will cause destination pixel alpha channel values to be unmodified.
 * @param nBitSize Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 *        - ::NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.
 */
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_16u_C3A0C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp16u**") PointerPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_16u_C3A0C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp16u**") @ByPtrPtr ShortPointer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_16u_C3A0C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp16u**") @ByPtrPtr ShortBuffer pTables, int nBitSize);
public static native @Cast("NppStatus") int nppiLUTPaletteSwap_16u_C3A0C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, int nAlphaValue, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp16u**") @ByPtrPtr short[] pTables, int nBitSize);

/** \} */

/** \} image_color_processing */ 

/** \} image_color_conversion */ 

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_COLOR_CONVERSION_H */


// Parsed from <nppi_threshold_and_compare_operations.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_THRESHOLD_AND_COMPARE_OPERATIONS_H
// #define NV_NPPI_THRESHOLD_AND_COMPARE_OPERATIONS_H
 
/**
 * \file nppi_threshold_and_compare_operations.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif


/** \defgroup image_threshold_and_compare_operations Threshold and Compare Operations
 *  \ingroup nppi
 *
 * Methods for pixel-wise threshold and compare operations.
 *
 * \{
 *
 */

/** 
 * \defgroup image_threshold_operations Threshold Operations
 *
 * Threshold image pixels.
 *
 * \{
 *
 */

/** 
 * 1 channel 8-bit unsigned char threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                     @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                               @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp8u") byte nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                     @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                               @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp8u") byte nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                     @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                               @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp8u") byte nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u") byte nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u") byte nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u") byte nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit unsigned short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16u") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16u") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16u") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit signed short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                      @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16s") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                      @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16s") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                      @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16s") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit signed short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s") short nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 32-bit floating point threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f") float nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f") float nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f") float nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 32-bit floating point in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f") float nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f") float nThreshold, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f") float nThreshold, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 8-bit unsigned char threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                     @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") BytePointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                     @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                     @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") byte[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") BytePointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") byte[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit unsigned short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16u*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit signed short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                      @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                      @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                      @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp16s*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit signed short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 32-bit floating point threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") float[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 32-bit floating point in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") float[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation); 


/** 
 * 4 channel 8-bit unsigned char image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                      @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") BytePointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                      @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                      @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp8u*") byte[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 8-bit unsigned char in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp8u*") BytePointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp8u*") byte[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                       @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                       @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                       @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16u*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp16u*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                       @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                       @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                       @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp16s*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp16s*") short[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit floating point image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                       @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                 @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") float[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit floating point in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] rThresholds, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u") byte nThreshold); 

/** 
 * 1 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold); 

/** 
 * 1 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u") short nThreshold); 

/** 
 * 1 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold); 

/** 
 * 1 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s") short nThreshold); 

/** 
 * 1 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold); 

/** 
 * 1 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                         @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f") float nThreshold); 

/** 
 * 1 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold); 

/** 
 * 3 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u*") byte[] rThresholds); 

/** 
 * 3 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") byte[] rThresholds); 

/** 
 * 3 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u*") short[] rThresholds); 

/** 
 * 3 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") short[] rThresholds); 

/** 
 * 3 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s*") short[] rThresholds); 

/** 
 * 3 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") short[] rThresholds); 

/** 
 * 3 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                         @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") float[] rThresholds); 

/** 
 * 3 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") float[] rThresholds); 


/** 
 * 4 channel 8-bit unsigned char image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") byte[] rThresholds);

/** 
 * 4 channel 8-bit unsigned char in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") byte[] rThresholds);

/** 
 * 4 channel 16-bit unsigned short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") short[] rThresholds);

/** 
 * 4 channel 16-bit unsigned short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") short[] rThresholds);

/** 
 * 4 channel 16-bit signed short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") short[] rThresholds);

/** 
 * 4 channel 16-bit signed short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") short[] rThresholds);

/** 
 * 4 channel 32-bit floating point image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") float[] rThresholds);

/** 
 * 4 channel 32-bit floating point in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_GT_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") float[] rThresholds);


/** 
 * 1 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u") byte nThreshold); 

/** 
 * 1 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold); 

/** 
 * 1 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u") short nThreshold); 

/** 
 * 1 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold); 

/** 
 * 1 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s") short nThreshold); 

/** 
 * 1 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold); 

/** 
 * 1 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                         @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f") float nThreshold); 

/** 
 * 1 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold); 

/** 
 * 3 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                  @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp8u*") byte[] rThresholds); 

/** 
 * 3 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") byte[] rThresholds); 

/** 
 * 3 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16u*") short[] rThresholds); 

/** 
 * 3 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") short[] rThresholds); 

/** 
 * 3 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                         @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp16s*") short[] rThresholds); 

/** 
 * 3 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") short[] rThresholds); 

/** 
 * 3 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                         @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") float[] rThresholds); 

/** 
 * 3 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") float[] rThresholds); 


/** 
 * 4 channel 8-bit unsigned char image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") byte[] rThresholds);

/** 
 * 4 channel 8-bit unsigned char in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") BytePointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") ByteBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") byte[] rThresholds);

/** 
 * 4 channel 16-bit unsigned short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") short[] rThresholds);

/** 
 * 4 channel 16-bit unsigned short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") short[] rThresholds);

/** 
 * 4 channel 16-bit signed short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") short[] rThresholds);

/** 
 * 4 channel 16-bit signed short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") short[] rThresholds);

/** 
 * 4 channel 32-bit floating point image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") float[] rThresholds);

/** 
 * 4 channel 32-bit floating point in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * value is set to nThreshold, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatPointer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatBuffer rThresholds);
public static native @Cast("NppStatus") int nppiThreshold_LT_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") float[] rThresholds);


/** 
 * 1 channel 8-bit unsigned char threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit unsigned short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit signed short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 16-bit signed short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue, @Cast("NppCmpOp") int eComparisonOperation); 
                                     
/** 
 * 1 channel 32-bit floating point threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 1 channel 32-bit floating point in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 8-bit unsigned char threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                   @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit unsigned short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit signed short threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                          @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 16-bit signed short in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 32-bit floating point threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 

/** 
 * 3 channel 32-bit floating point in place threshold.
 * If for a comparison operations OP the predicate (sourcePixel OP nThreshold) is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues, @Cast("NppCmpOp") int eComparisonOperation); 


/** 
 * 4 channel 8-bit unsigned char image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                    @ByVal NppiSize oSizeROI, 
                                    @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 8-bit unsigned char in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                           @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                           @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                           @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                           @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                           @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                           @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit floating point image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                           @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit floating point in place image threshold, not affecting Alpha.
 * If for a comparison operations OP the predicate (sourcePixel.channel OP nThreshold) is true, the channel
 * value is set to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @param eComparisonOperation The type of comparison operation to be used. The only valid
 *      values are: NPP_CMP_LESS and NPP_CMP_GREATER.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_SUPPORTED_MODE_ERROR if an invalid
 * comparison operation type is specified.
 */
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiThreshold_Val_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                           @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue); 

/** 
 * 1 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue); 

/** 
 * 1 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue); 

/** 
 * 1 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue); 

/** 
 * 1 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue); 

/** 
 * 1 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue); 

/** 
 * 1 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue); 

/** 
 * 1 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is greater than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement values.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue); 

/** 
 * 3 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                           @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues); 

/** 
 * 3 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues); 

/** 
 * 3 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues); 

/** 
 * 3 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues); 
                                       
/** 
 * 3 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues); 

/** 
 * 3 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues); 

/** 
 * 3 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues); 

/** 
 * 3 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues); 

/** 
 * 4 channel 8-bit unsigned char image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues);

/** 
 * 4 channel 8-bit unsigned char in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues);

/** 
 * 4 channel 16-bit unsigned short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                             @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                             @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                             @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues);

/** 
 * 4 channel 16-bit unsigned short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues);

/** 
 * 4 channel 16-bit signed short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                             @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                             @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                             @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues);

/** 
 * 4 channel 16-bit signed short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues);

/** 
 * 4 channel 32-bit floating point image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues);

/** 
 * 4 channel 32-bit floating point in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is greater than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_GTVal_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues);


/** 
 * 1 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                           @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue); 

/** 
 * 1 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u") byte nThreshold, @Cast("const Npp8u") byte nValue); 

/** 
 * 1 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue); 

/** 
 * 1 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u") short nThreshold, @Cast("const Npp16u") short nValue); 

/** 
 * 1 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue); 

/** 
 * 1 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s") short nThreshold, @Cast("const Npp16s") short nValue); 

/** 
 * 1 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue); 

/** 
 * 1 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is less than nThreshold is true, the pixel is set
 * to nValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThreshold The threshold value.
 * @param nValue The threshold replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f") float nThreshold, @Cast("const Npp32f") float nValue); 

/** 
 * 3 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                           @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                           @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                     @ByVal NppiSize oSizeROI, 
                                     @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues); 

/** 
 * 3 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues); 

/** 
 * 3 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues); 

/** 
 * 3 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues); 

/** 
 * 3 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                            @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                            @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues); 

/** 
 * 3 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues); 

/** 
 * 3 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues); 

/** 
 * 3 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues); 

/** 
 * 4 channel 8-bit unsigned char image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                      @ByVal NppiSize oSizeROI, 
                                      @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues);

/** 
 * 4 channel 8-bit unsigned char in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp8u*") BytePointer rThresholds, @Cast("const Npp8u*") BytePointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp8u*") ByteBuffer rThresholds, @Cast("const Npp8u*") ByteBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp8u*") byte[] rThresholds, @Cast("const Npp8u*") byte[] rValues);

/** 
 * 4 channel 16-bit unsigned short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                             @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                             @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                             @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues);

/** 
 * 4 channel 16-bit unsigned short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16u*") ShortPointer rThresholds, @Cast("const Npp16u*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16u*") ShortBuffer rThresholds, @Cast("const Npp16u*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16u*") short[] rThresholds, @Cast("const Npp16u*") short[] rValues);

/** 
 * 4 channel 16-bit signed short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                             @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                             @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                             @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues);

/** 
 * 4 channel 16-bit signed short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16s*") ShortPointer rThresholds, @Cast("const Npp16s*") ShortPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16s*") ShortBuffer rThresholds, @Cast("const Npp16s*") ShortBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp16s*") short[] rThresholds, @Cast("const Npp16s*") short[] rValues);

/** 
 * 4 channel 32-bit floating point image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                       @ByVal NppiSize oSizeROI, 
                                       @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues);

/** 
 * 4 channel 32-bit floating point in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThreshold is true, the pixel is set
 * value is set to rValue, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholds The threshold values, one per color channel.
 * @param rValues The threshold replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp32f*") FloatPointer rThresholds, @Cast("const Npp32f*") FloatPointer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp32f*") FloatBuffer rThresholds, @Cast("const Npp32f*") FloatBuffer rValues);
public static native @Cast("NppStatus") int nppiThreshold_LTVal_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                        @ByVal NppiSize oSizeROI, 
                                        @Cast("const Npp32f*") float[] rThresholds, @Cast("const Npp32f*") float[] rValues);

/** 
 * 1 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                          @ByVal NppiSize oSizeROI, 
                                          @Cast("const Npp8u") byte nThresholdLT, @Cast("const Npp8u") byte nValueLT, @Cast("const Npp8u") byte nThresholdGT, @Cast("const Npp8u") byte nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                          @ByVal NppiSize oSizeROI, 
                                          @Cast("const Npp8u") byte nThresholdLT, @Cast("const Npp8u") byte nValueLT, @Cast("const Npp8u") byte nThresholdGT, @Cast("const Npp8u") byte nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                                @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                          @ByVal NppiSize oSizeROI, 
                                          @Cast("const Npp8u") byte nThresholdLT, @Cast("const Npp8u") byte nValueLT, @Cast("const Npp8u") byte nThresholdGT, @Cast("const Npp8u") byte nValueGT); 

/** 
 * 1 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u") byte nThresholdLT, @Cast("const Npp8u") byte nValueLT, @Cast("const Npp8u") byte nThresholdGT, @Cast("const Npp8u") byte nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u") byte nThresholdLT, @Cast("const Npp8u") byte nValueLT, @Cast("const Npp8u") byte nThresholdGT, @Cast("const Npp8u") byte nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u") byte nThresholdLT, @Cast("const Npp8u") byte nValueLT, @Cast("const Npp8u") byte nThresholdGT, @Cast("const Npp8u") byte nValueGT); 

/** 
 * 1 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16u") short nThresholdLT, @Cast("const Npp16u") short nValueLT, @Cast("const Npp16u") short nThresholdGT, @Cast("const Npp16u") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16u") short nThresholdLT, @Cast("const Npp16u") short nValueLT, @Cast("const Npp16u") short nThresholdGT, @Cast("const Npp16u") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                                 @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16u") short nThresholdLT, @Cast("const Npp16u") short nValueLT, @Cast("const Npp16u") short nThresholdGT, @Cast("const Npp16u") short nValueGT); 

/** 
 * 1 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u") short nThresholdLT, @Cast("const Npp16u") short nValueLT, @Cast("const Npp16u") short nThresholdGT, @Cast("const Npp16u") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u") short nThresholdLT, @Cast("const Npp16u") short nValueLT, @Cast("const Npp16u") short nThresholdGT, @Cast("const Npp16u") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u") short nThresholdLT, @Cast("const Npp16u") short nValueLT, @Cast("const Npp16u") short nThresholdGT, @Cast("const Npp16u") short nValueGT); 

/** 
 * 1 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                                 @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16s") short nThresholdLT, @Cast("const Npp16s") short nValueLT, @Cast("const Npp16s") short nThresholdGT, @Cast("const Npp16s") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                                 @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16s") short nThresholdLT, @Cast("const Npp16s") short nValueLT, @Cast("const Npp16s") short nThresholdGT, @Cast("const Npp16s") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                                 @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16s") short nThresholdLT, @Cast("const Npp16s") short nValueLT, @Cast("const Npp16s") short nThresholdGT, @Cast("const Npp16s") short nValueGT); 

/** 
 * 1 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s") short nThresholdLT, @Cast("const Npp16s") short nValueLT, @Cast("const Npp16s") short nThresholdGT, @Cast("const Npp16s") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s") short nThresholdLT, @Cast("const Npp16s") short nValueLT, @Cast("const Npp16s") short nThresholdGT, @Cast("const Npp16s") short nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s") short nThresholdLT, @Cast("const Npp16s") short nValueLT, @Cast("const Npp16s") short nThresholdGT, @Cast("const Npp16s") short nValueGT); 

/** 
 * 1 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp32f") float nThresholdLT, @Cast("const Npp32f") float nValueLT, @Cast("const Npp32f") float nThresholdGT, @Cast("const Npp32f") float nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp32f") float nThresholdLT, @Cast("const Npp32f") float nValueLT, @Cast("const Npp32f") float nThresholdGT, @Cast("const Npp32f") float nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                                 @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp32f") float nThresholdLT, @Cast("const Npp32f") float nValueLT, @Cast("const Npp32f") float nThresholdGT, @Cast("const Npp32f") float nValueGT); 

/** 
 * 1 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is less than nThresholdLT is true, the pixel is set
 * to nValueLT, else if sourcePixel is greater than nThresholdGT the pixel is set to nValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nThresholdLT The thresholdLT value.
 * @param nValueLT The thresholdLT replacement value.
 * @param nThresholdGT The thresholdGT value.
 * @param nValueGT The thresholdGT replacement value.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f") float nThresholdLT, @Cast("const Npp32f") float nValueLT, @Cast("const Npp32f") float nThresholdGT, @Cast("const Npp32f") float nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f") float nThresholdLT, @Cast("const Npp32f") float nValueLT, @Cast("const Npp32f") float nThresholdGT, @Cast("const Npp32f") float nValueGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f") float nThresholdLT, @Cast("const Npp32f") float nValueLT, @Cast("const Npp32f") float nThresholdGT, @Cast("const Npp32f") float nValueGT); 

/** 
 * 3 channel 8-bit unsigned char threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                          @ByVal NppiSize oSizeROI, 
                                          @Cast("const Npp8u*") BytePointer rThresholdsLT, @Cast("const Npp8u*") BytePointer rValuesLT, @Cast("const Npp8u*") BytePointer rThresholdsGT, @Cast("const Npp8u*") BytePointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                          @ByVal NppiSize oSizeROI, 
                                          @Cast("const Npp8u*") ByteBuffer rThresholdsLT, @Cast("const Npp8u*") ByteBuffer rValuesLT, @Cast("const Npp8u*") ByteBuffer rThresholdsGT, @Cast("const Npp8u*") ByteBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                                @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                          @ByVal NppiSize oSizeROI, 
                                          @Cast("const Npp8u*") byte[] rThresholdsLT, @Cast("const Npp8u*") byte[] rValuesLT, @Cast("const Npp8u*") byte[] rThresholdsGT, @Cast("const Npp8u*") byte[] rValuesGT); 

/** 
 * 3 channel 8-bit unsigned char in place threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref destination_image_pointer.
 * @param nSrcDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u*") BytePointer rThresholdsLT, @Cast("const Npp8u*") BytePointer rValuesLT, @Cast("const Npp8u*") BytePointer rThresholdsGT, @Cast("const Npp8u*") BytePointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u*") ByteBuffer rThresholdsLT, @Cast("const Npp8u*") ByteBuffer rValuesLT, @Cast("const Npp8u*") ByteBuffer rThresholdsGT, @Cast("const Npp8u*") ByteBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u*") byte[] rThresholdsLT, @Cast("const Npp8u*") byte[] rValuesLT, @Cast("const Npp8u*") byte[] rThresholdsGT, @Cast("const Npp8u*") byte[] rValuesGT); 

/** 
 * 3 channel 16-bit unsigned short threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16u*") ShortPointer rThresholdsLT, @Cast("const Npp16u*") ShortPointer rValuesLT, @Cast("const Npp16u*") ShortPointer rThresholdsGT, @Cast("const Npp16u*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16u*") ShortBuffer rThresholdsLT, @Cast("const Npp16u*") ShortBuffer rValuesLT, @Cast("const Npp16u*") ShortBuffer rThresholdsGT, @Cast("const Npp16u*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                                 @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16u*") short[] rThresholdsLT, @Cast("const Npp16u*") short[] rValuesLT, @Cast("const Npp16u*") short[] rThresholdsGT, @Cast("const Npp16u*") short[] rValuesGT); 

/** 
 * 3 channel 16-bit unsigned short in place threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u*") ShortPointer rThresholdsLT, @Cast("const Npp16u*") ShortPointer rValuesLT, @Cast("const Npp16u*") ShortPointer rThresholdsGT, @Cast("const Npp16u*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u*") ShortBuffer rThresholdsLT, @Cast("const Npp16u*") ShortBuffer rValuesLT, @Cast("const Npp16u*") ShortBuffer rThresholdsGT, @Cast("const Npp16u*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u*") short[] rThresholdsLT, @Cast("const Npp16u*") short[] rValuesLT, @Cast("const Npp16u*") short[] rThresholdsGT, @Cast("const Npp16u*") short[] rValuesGT); 

/** 
 * 3 channel 16-bit signed short threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                                 @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16s*") ShortPointer rThresholdsLT, @Cast("const Npp16s*") ShortPointer rValuesLT, @Cast("const Npp16s*") ShortPointer rThresholdsGT, @Cast("const Npp16s*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                                 @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16s*") ShortBuffer rThresholdsLT, @Cast("const Npp16s*") ShortBuffer rValuesLT, @Cast("const Npp16s*") ShortBuffer rThresholdsGT, @Cast("const Npp16s*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                                 @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp16s*") short[] rThresholdsLT, @Cast("const Npp16s*") short[] rValuesLT, @Cast("const Npp16s*") short[] rThresholdsGT, @Cast("const Npp16s*") short[] rValuesGT); 

/** 
 * 3 channel 16-bit signed short in place threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s*") ShortPointer rThresholdsLT, @Cast("const Npp16s*") ShortPointer rValuesLT, @Cast("const Npp16s*") ShortPointer rThresholdsGT, @Cast("const Npp16s*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s*") ShortBuffer rThresholdsLT, @Cast("const Npp16s*") ShortBuffer rValuesLT, @Cast("const Npp16s*") ShortBuffer rThresholdsGT, @Cast("const Npp16s*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s*") short[] rThresholdsLT, @Cast("const Npp16s*") short[] rValuesLT, @Cast("const Npp16s*") short[] rThresholdsGT, @Cast("const Npp16s*") short[] rValuesGT); 

/** 
 * 3 channel 32-bit floating point threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp32f*") FloatPointer rThresholdsLT, @Cast("const Npp32f*") FloatPointer rValuesLT, @Cast("const Npp32f*") FloatPointer rThresholdsGT, @Cast("const Npp32f*") FloatPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp32f*") FloatBuffer rThresholdsLT, @Cast("const Npp32f*") FloatBuffer rValuesLT, @Cast("const Npp32f*") FloatBuffer rThresholdsGT, @Cast("const Npp32f*") FloatBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                                 @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp32f*") float[] rThresholdsLT, @Cast("const Npp32f*") float[] rValuesLT, @Cast("const Npp32f*") float[] rThresholdsGT, @Cast("const Npp32f*") float[] rValuesGT); 

/** 
 * 3 channel 32-bit floating point in place threshold.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f*") FloatPointer rThresholdsLT, @Cast("const Npp32f*") FloatPointer rValuesLT, @Cast("const Npp32f*") FloatPointer rThresholdsGT, @Cast("const Npp32f*") FloatPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f*") FloatBuffer rThresholdsLT, @Cast("const Npp32f*") FloatBuffer rValuesLT, @Cast("const Npp32f*") FloatBuffer rThresholdsGT, @Cast("const Npp32f*") FloatBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f*") float[] rThresholdsLT, @Cast("const Npp32f*") float[] rValuesLT, @Cast("const Npp32f*") float[] rThresholdsGT, @Cast("const Npp32f*") float[] rValuesGT); 

/** 
 * 4 channel 8-bit unsigned char image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u*") BytePointer rThresholdsLT, @Cast("const Npp8u*") BytePointer rValuesLT, @Cast("const Npp8u*") BytePointer rThresholdsGT, @Cast("const Npp8u*") BytePointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u*") ByteBuffer rThresholdsLT, @Cast("const Npp8u*") ByteBuffer rValuesLT, @Cast("const Npp8u*") ByteBuffer rThresholdsGT, @Cast("const Npp8u*") ByteBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                           @ByVal NppiSize oSizeROI, 
                                           @Cast("const Npp8u*") byte[] rThresholdsLT, @Cast("const Npp8u*") byte[] rValuesLT, @Cast("const Npp8u*") byte[] rThresholdsGT, @Cast("const Npp8u*") byte[] rValuesGT);

/** 
 * 4 channel 8-bit unsigned char in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp8u*") BytePointer rThresholdsLT, @Cast("const Npp8u*") BytePointer rValuesLT, @Cast("const Npp8u*") BytePointer rThresholdsGT, @Cast("const Npp8u*") BytePointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp8u*") ByteBuffer rThresholdsLT, @Cast("const Npp8u*") ByteBuffer rValuesLT, @Cast("const Npp8u*") ByteBuffer rThresholdsGT, @Cast("const Npp8u*") ByteBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp8u*") byte[] rThresholdsLT, @Cast("const Npp8u*") byte[] rValuesLT, @Cast("const Npp8u*") byte[] rThresholdsGT, @Cast("const Npp8u*") byte[] rValuesGT);

/** 
 * 4 channel 16-bit unsigned short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u*") ShortPointer rThresholdsLT, @Cast("const Npp16u*") ShortPointer rValuesLT, @Cast("const Npp16u*") ShortPointer rThresholdsGT, @Cast("const Npp16u*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u*") ShortBuffer rThresholdsLT, @Cast("const Npp16u*") ShortBuffer rValuesLT, @Cast("const Npp16u*") ShortBuffer rThresholdsGT, @Cast("const Npp16u*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                                  @Cast("Npp16u*") short[] pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16u*") short[] rThresholdsLT, @Cast("const Npp16u*") short[] rValuesLT, @Cast("const Npp16u*") short[] rThresholdsGT, @Cast("const Npp16u*") short[] rValuesGT);

/** 
 * 4 channel 16-bit unsigned short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp16u*") ShortPointer rThresholdsLT, @Cast("const Npp16u*") ShortPointer rValuesLT, @Cast("const Npp16u*") ShortPointer rThresholdsGT, @Cast("const Npp16u*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp16u*") ShortBuffer rThresholdsLT, @Cast("const Npp16u*") ShortBuffer rValuesLT, @Cast("const Npp16u*") ShortBuffer rThresholdsGT, @Cast("const Npp16u*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp16u*") short[] rThresholdsLT, @Cast("const Npp16u*") short[] rValuesLT, @Cast("const Npp16u*") short[] rThresholdsGT, @Cast("const Npp16u*") short[] rValuesGT);

/** 
 * 4 channel 16-bit signed short image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                                  @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s*") ShortPointer rThresholdsLT, @Cast("const Npp16s*") ShortPointer rValuesLT, @Cast("const Npp16s*") ShortPointer rThresholdsGT, @Cast("const Npp16s*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                                  @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s*") ShortBuffer rThresholdsLT, @Cast("const Npp16s*") ShortBuffer rValuesLT, @Cast("const Npp16s*") ShortBuffer rThresholdsGT, @Cast("const Npp16s*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                                  @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp16s*") short[] rThresholdsLT, @Cast("const Npp16s*") short[] rValuesLT, @Cast("const Npp16s*") short[] rThresholdsGT, @Cast("const Npp16s*") short[] rValuesGT);

/** 
 * 4 channel 16-bit signed short in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp16s*") ShortPointer rThresholdsLT, @Cast("const Npp16s*") ShortPointer rValuesLT, @Cast("const Npp16s*") ShortPointer rThresholdsGT, @Cast("const Npp16s*") ShortPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp16s*") ShortBuffer rThresholdsLT, @Cast("const Npp16s*") ShortBuffer rValuesLT, @Cast("const Npp16s*") ShortBuffer rThresholdsGT, @Cast("const Npp16s*") ShortBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp16s*") short[] rThresholdsLT, @Cast("const Npp16s*") short[] rValuesLT, @Cast("const Npp16s*") short[] rThresholdsGT, @Cast("const Npp16s*") short[] rValuesGT);

/** 
 * 4 channel 32-bit floating point image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f*") FloatPointer rThresholdsLT, @Cast("const Npp32f*") FloatPointer rValuesLT, @Cast("const Npp32f*") FloatPointer rThresholdsGT, @Cast("const Npp32f*") FloatPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f*") FloatBuffer rThresholdsLT, @Cast("const Npp32f*") FloatBuffer rValuesLT, @Cast("const Npp32f*") FloatBuffer rThresholdsGT, @Cast("const Npp32f*") FloatBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                                  @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                            @ByVal NppiSize oSizeROI, 
                                            @Cast("const Npp32f*") float[] rThresholdsLT, @Cast("const Npp32f*") float[] rValuesLT, @Cast("const Npp32f*") float[] rThresholdsGT, @Cast("const Npp32f*") float[] rValuesGT);

/** 
 * 4 channel 32-bit floating point in place image threshold, not affecting Alpha.
 * If for a comparison operations sourcePixel is less than rThresholdLT is true, the pixel is set
 * value is set to rValueLT, else if sourcePixel is greater than rThresholdGT the pixel is set to rValueGT, otherwise it is set to sourcePixel.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param rThresholdsLT The thresholdLT values, one per color channel.
 * @param rValuesLT The thresholdLT replacement values, one per color channel.
 * @param rThresholdsGT The thresholdGT values, one per channel.
 * @param rValuesGT The thresholdGT replacement values, one per color channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp32f*") FloatPointer rThresholdsLT, @Cast("const Npp32f*") FloatPointer rValuesLT, @Cast("const Npp32f*") FloatPointer rThresholdsGT, @Cast("const Npp32f*") FloatPointer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp32f*") FloatBuffer rThresholdsLT, @Cast("const Npp32f*") FloatBuffer rValuesLT, @Cast("const Npp32f*") FloatBuffer rThresholdsGT, @Cast("const Npp32f*") FloatBuffer rValuesGT);
public static native @Cast("NppStatus") int nppiThreshold_LTValGTVal_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                                             @ByVal NppiSize oSizeROI, 
                                             @Cast("const Npp32f*") float[] rThresholdsLT, @Cast("const Npp32f*") float[] rValuesLT, @Cast("const Npp32f*") float[] rThresholdsGT, @Cast("const Npp32f*") float[] rValuesGT);

/** \} image_threshold_operations */

/** \defgroup image_compare_operations Compare Operations
 * Compare the pixels of two images and create a binary result image. In case of multi-channel
 * image types, the condition must be fulfilled for all channels, otherwise the comparison
 * is considered false.
 * The "binary" result image is of type 8u_C1. False is represented by 0, true by NPP_MAX_8U.
 *
 * \{
 *
 */

/** 
 * 1 channel 8-bit unsigned char image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 8-bit unsigned char image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 8-bit unsigned char image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step,
                             @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step,
                                   @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                             @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 8-bit unsigned char image compare, not affecting Alpha.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step,
                              @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step,
                              @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 16-bit unsigned short image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 16-bit unsigned short image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step,
                              @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short image compare, not affecting Alpha.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step,
                               @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step,
                               @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step,
                               @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 16-bit signed short image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 16-bit signed short image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step,
                              @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short image compare, not affecting Alpha.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step,
                               @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step,
                               @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step,
                               @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 32-bit floating point image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 32-bit floating point image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit floating point image compare.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                              @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit signed floating point compare, not affecting Alpha.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompare_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                               @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                               @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompare_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                               @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 8-bit unsigned char image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param nConstant constant value.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                              @Cast("const Npp8u") byte nConstant,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                              @Cast("const Npp8u") byte nConstant,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                              @Cast("const Npp8u") byte nConstant,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 8-bit unsigned char image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constant values, one per color channel..
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                              @Cast("const Npp8u*") BytePointer pConstants,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                              @Cast("const Npp8u*") ByteBuffer pConstants,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                              @Cast("const Npp8u*") byte[] pConstants,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 8-bit unsigned char image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                              @Cast("const Npp8u*") BytePointer pConstants,
                                    @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                              @Cast("const Npp8u*") ByteBuffer pConstants,
                                    @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                              @Cast("const Npp8u*") byte[] pConstants,
                                    @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                              @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 8-bit unsigned char image compare, not affecting Alpha.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep,
                               @Cast("const Npp8u*") BytePointer pConstants,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep,
                               @Cast("const Npp8u*") ByteBuffer pConstants,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep,
                               @Cast("const Npp8u*") byte[] pConstants,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 16-bit unsigned short image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param nConstant constant value
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                               @Cast("const Npp16u") short nConstant,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                               @Cast("const Npp16u") short nConstant,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                               @Cast("const Npp16u") short nConstant,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 16-bit unsigned short image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                               @Cast("const Npp16u*") ShortPointer pConstants,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                               @Cast("const Npp16u*") ShortBuffer pConstants,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                               @Cast("const Npp16u*") short[] pConstants,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                               @Cast("const Npp16u*") ShortPointer pConstants,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                               @Cast("const Npp16u*") ShortBuffer pConstants,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                               @Cast("const Npp16u*") short[] pConstants,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit unsigned short image compare, not affecting Alpha.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep,
                                @Cast("const Npp16u*") ShortPointer pConstants,
                                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep,
                                @Cast("const Npp16u*") ShortBuffer pConstants,
                                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep,
                                @Cast("const Npp16u*") short[] pConstants,
                                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 16-bit signed short image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param nConstant constant value.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                               @Cast("const Npp16s") short nConstant,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                               @Cast("const Npp16s") short nConstant,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                               @Cast("const Npp16s") short nConstant,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 16-bit signed short image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                               @Cast("const Npp16s*") ShortPointer pConstants,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                               @Cast("const Npp16s*") ShortBuffer pConstants,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                               @Cast("const Npp16s*") short[] pConstants,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                               @Cast("const Npp16s*") ShortPointer pConstants,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                               @Cast("const Npp16s*") ShortBuffer pConstants,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                               @Cast("const Npp16s*") short[] pConstants,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 16-bit signed short image compare, not affecting Alpha.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep,
                                @Cast("const Npp16s*") ShortPointer pConstants,
                                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep,
                                @Cast("const Npp16s*") ShortBuffer pConstants,
                                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep,
                                @Cast("const Npp16s*") short[] pConstants,
                                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 1 channel 32-bit floating point image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param nConstant constant value
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                               @Cast("const Npp32f") float nConstant,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                               @Cast("const Npp32f") float nConstant,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                               @Cast("const Npp32f") float nConstant,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 3 channel 32-bit floating point image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                               @Cast("const Npp32f*") FloatPointer pConstants,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                               @Cast("const Npp32f*") FloatBuffer pConstants,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                               @Cast("const Npp32f*") float[] pConstants,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit floating point image compare with constant value.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                               @Cast("const Npp32f*") FloatPointer pConstants,
                                     @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                               @Cast("const Npp32f*") FloatBuffer pConstants,
                                     @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                               @Cast("const Npp32f*") float[] pConstants,
                                     @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                               @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);

/** 
 * 4 channel 32-bit signed floating point compare, not affecting Alpha.
 * Compare pSrc's pixels with constant value. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eComparisonOperation Specifies the comparison operation to be used in the pixel comparison.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareC_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                @Cast("const Npp32f*") FloatPointer pConstants,
                                      @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                @Cast("const Npp32f*") FloatBuffer pConstants,
                                      @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);
public static native @Cast("NppStatus") int nppiCompareC_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                @Cast("const Npp32f*") float[] pConstants,
                                      @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                                @ByVal NppiSize oSizeROI, @Cast("NppCmpOp") int eComparisonOperation);


/** 
 * 1 channel 32-bit floating point image compare whether two images are equal within epsilon.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2 to determine whether they are equal with a difference of epsilon. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") BytePointer pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") byte[] pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);

/** 
 * 3 channel 32-bit floating point image compare whether two images are equal within epsilon.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2 to determine whether they are equal with a difference of epsilon. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to per color channel pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") BytePointer pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") byte[] pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);

/** 
 * 4 channel 32-bit floating point image compare whether two images are equal within epsilon.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2 to determine whether they are equal with a difference of epsilon. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to per color channel pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") BytePointer pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                                      @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                            @Cast("Npp8u*") byte[] pDst,   int nDstStep,
                                      @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);

/** 
 * 4 channel 32-bit signed floating point compare whether two images are equal within epsilon, not affecting Alpha.
 * Compare pSrc1's pixels with corresponding pixels in pSrc2 to determine whether they are equal with a difference of epsilon. 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to per color channel pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step,
                                       @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step,
                                             @Cast("Npp8u*") BytePointer pDst,   int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step,
                                       @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step,
                                             @Cast("Npp8u*") ByteBuffer pDst,   int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEps_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step,
                                       @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step,
                                             @Cast("Npp8u*") byte[] pDst,   int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);

/** 
 * 1 channel 32-bit floating point image compare whether image and constant are equal within epsilon.
 * Compare pSrc's pixels with constant value to determine whether they are equal within a difference of epsilon. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param nConstant constant value
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                       @Cast("const Npp32f") float nConstant,
                                             @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                       @Cast("const Npp32f") float nConstant,
                                             @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                       @Cast("const Npp32f") float nConstant,
                                             @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);

/** 
 * 3 channel 32-bit floating point image compare whether image and constant are equal within epsilon.
 * Compare pSrc's pixels with constant value to determine whether they are equal within a difference of epsilon. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to per color channel pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                       @Cast("const Npp32f*") FloatPointer pConstants,
                                             @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                       @Cast("const Npp32f*") FloatBuffer pConstants,
                                             @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                       @Cast("const Npp32f*") float[] pConstants,
                                             @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);

/** 
 * 4 channel 32-bit floating point image compare whether image and constant are equal within epsilon.
 * Compare pSrc's pixels with constant value to determine whether they are equal within a difference of epsilon. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to per color channel pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                       @Cast("const Npp32f*") FloatPointer pConstants,
                                             @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                       @Cast("const Npp32f*") FloatBuffer pConstants,
                                             @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                       @Cast("const Npp32f*") float[] pConstants,
                                             @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                                       @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);

/** 
 * 4 channel 32-bit signed floating point compare whether image and constant are equal within epsilon, not affecting Alpha.
 * Compare pSrc's pixels with constant value to determine whether they are equal within a difference of epsilon. 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pConstants pointer to a list of constants, one per color channel.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nEpsilon epsilon tolerance value to compare to per color channel pixel absolute differences
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep,
                                        @Cast("const Npp32f*") FloatPointer pConstants,
                                              @Cast("Npp8u*") BytePointer pDst,  int nDstStep,
                                        @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep,
                                        @Cast("const Npp32f*") FloatBuffer pConstants,
                                              @Cast("Npp8u*") ByteBuffer pDst,  int nDstStep,
                                        @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);
public static native @Cast("NppStatus") int nppiCompareEqualEpsC_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep,
                                        @Cast("const Npp32f*") float[] pConstants,
                                              @Cast("Npp8u*") byte[] pDst,  int nDstStep,
                                        @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nEpsilon);


/** \} image_compare_operations */

/** \} image_threshold_and_compare_operations */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_THRESHOLD_AND_COMPARE_OPERATIONS_H */


// Parsed from <nppi_morphological_operations.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_MORPHOLOGICAL_OPERATIONS_H
// #define NV_NPPI_MORPHOLOGICAL_OPERATIONS_H
 
/**
 * \file nppi_morphological_operations.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_morphological_operations Morphological Operations
 *  \ingroup nppi
 *
 * Morphological image operations. 
 *
 * Morphological operations are classified as \ref neighborhood_operations. 
 *
 * \{
 *
 */

/** \defgroup image_dilate Dilation
 *
 * Dilation computes the output pixel as the maximum pixel value of the pixels
 * under the mask. Pixels who's corresponding mask values are zero do not 
 * participate in the maximum search.
 *
 * It is the user's responsibility to avoid \ref sampling_beyond_image_boundaries.
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three-channel 8-bit unsigned integer dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 8-bit unsigned integer dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 8-bit unsigned integer dilation, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);


/**
 * Single-channel 16-bit unsigned integer dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three-channel 16-bit unsigned integer dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 16-bit unsigned integer dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 16-bit unsigned integer dilation, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);


/**
 * Single-channel 32-bit floating-point dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three-channel 32-bit floating-point dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 32-bit floating-point dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 32-bit floating-point dilation, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiDilate_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);


/** \} image_dilate */

/** \defgroup image_dilate_border Dilation with border control
 *
 * Dilation computes the output pixel as the maximum pixel value of the pixels
 * under the mask. Pixels who's corresponding mask values are zero do not 
 * participate in the maximum search.
 *
 * If any portion of the mask overlaps the source image boundary the requested border type 
 * operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 8-bit unsigned integer dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer dilation with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 16-bit unsigned integer dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 16-bit unsigned integer dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer dilation with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 32-bit floating-point dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 32-bit floating-point dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point dilation with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilateBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilateBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/** \} image_dilate_border */

/** \defgroup image_dilate_3x3 Dilate3x3
 *
 * Dilation using a 3x3 mask with the anchor at its center pixel.
 *
 * It is the user's responsibility to avoid \ref sampling_beyond_image_boundaries.
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 8-bit unsigned integer 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned integer 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned integer 3x3 dilation, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/**
 * Single-channel 16-bit unsigned integer 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 16-bit unsigned integer 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned integer 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned integer 3x3 dilation, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/**
 * Single-channel 32-bit floating-point 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 32-bit floating-point 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating-point 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating-point 3x3 dilation, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single-channel 64-bit floating-point 3x3 dilation.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoublePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoubleBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDilate3x3_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") double[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} image_dilate_3x3 */

/** \defgroup image_dilate_3x3_border Dilate3x3Border
 *
 * Dilation using a 3x3 mask with the anchor at its center pixel with border control.
 *
 * If any portion of the mask overlaps the source image boundary the requested border type 
 * operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 8-bit unsigned integer 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer 3x3 dilation with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 16-bit unsigned integer 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 16-bit unsigned integer 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer 3x3 dilation with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 32-bit floating-point 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 32-bit floating-point 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point 3x3 dilation with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point 3x3 dilation with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiDilate3x3Border_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} image_dilate_3x3_border */

/** \defgroup image_erode Erode
 *
 * Erosion computes the output pixel as the minimum pixel value of the pixels
 * under the mask. Pixels who's corresponding mask values are zero do not 
 * participate in the maximum search.
 *
 * It is the user's responsibility to avoid \ref sampling_beyond_image_boundaries.
 *
 * \{
 *
 */


/**
 * Single-channel 8-bit unsigned integer erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three-channel 8-bit unsigned integer erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 8-bit unsigned integer erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                  @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 8-bit unsigned integer erosion, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);


/**
 * Single-channel 16-bit unsigned integer erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three-channel 16-bit unsigned integer erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 16-bit unsigned integer erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 16-bit unsigned integer erosion, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);


/**
 * Single-channel 32-bit floating-point erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three-channel 32-bit floating-point erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 32-bit floating-point erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                   @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four-channel 32-bit floating-point erosion, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiErode_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                    @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);


/** \} image_erode */

/** \defgroup image_erode_border Erosion with border control
 *
 * Erosion computes the output pixel as the minimum pixel value of the pixels
 * under the mask. Pixels who's corresponding mask values are zero do not 
 * participate in the minimum search.
 *
 * If any portion of the mask overlaps the source image boundary the requested border type 
 * operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 8-bit unsigned integer erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer erosion with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 16-bit unsigned integer erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 16-bit unsigned integer erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer erosion with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 32-bit floating-point erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 32-bit floating-point erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point erosion with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMask Pointer to the start address of the mask array
 * @param oMaskSize Width and Height mask array.
 * @param oAnchor X and Y offsets of the mask origin frame of reference
 *        w.r.t the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErodeBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") BytePointer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") ByteBuffer pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErodeBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("const Npp8u*") byte[] pMask, @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/** \} image_erode_border */

/** \defgroup image_erode_3x3 Erode3x3
 *
 * Erosion using a 3x3 mask with the anchor at its center pixel.
 *
 * It is the user's responsibility to avoid \ref sampling_beyond_image_boundaries.
 *
 * \{
 *
 */


/**
 * Single-channel 8-bit unsigned integer 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 8-bit unsigned integer 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned integer 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned integer 3x3 erosion, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/**
 * Single-channel 16-bit unsigned integer 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 16-bit unsigned integer 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned integer 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned integer 3x3 erosion, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);


/**
 * Single-channel 32-bit floating-point 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 32-bit floating-point 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating-point 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating-point 3x3 erosion, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single-channel 64-bit floating-point 3x3 erosion.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoublePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoubleBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiErode3x3_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") double[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} image_erode */

/** \defgroup image_erode_3x3_border Erode3x3Border
 *
 * Erosion using a 3x3 mask with the anchor at its center pixel with border control.
 *
 * If any portion of the mask overlaps the source image boundary the requested border type 
 * operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 8-bit unsigned integer 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 8-bit unsigned integer 3x3 erosion with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 16-bit unsigned integer 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 16-bit unsigned integer 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 16-bit unsigned integer 3x3 erosion with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);


/**
 * Single-channel 32-bit floating-point 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three-channel 32-bit floating-point 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point 3x3 erosion with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four-channel 32-bit floating-point 3x3 erosion with border control, ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset Source image starting point relative to pSrc. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiErode3x3Border_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} image_erode_3x3_border */

/** \} image_morphological_operations */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_MORPHOLOGICAL_OPERATIONS_H */


// Parsed from <nppi_filtering_functions.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and                                                          
  * international Copyright laws.                                                                                              
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_FILTERING_FUNCTIONS_H
// #define NV_NPPI_FILTERING_FUNCTIONS_H
 
/**
 * \file nppi_filtering_functions.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_filtering_functions Filtering Functions
 *  \ingroup nppi
 *
 * Linear and non-linear image filtering functions.
 *
 * Filtering functions are classified as \ref neighborhood_operations. It is the user's 
 * responsibility to avoid \ref sampling_beyond_image_boundaries. 
 *
 * \{
 *
 */

/** \defgroup image_1D_linear_filter 1D Linear Filter
 *
 * \{
 *
 */

/** \name FilterColumn
 * Apply convolution filter with user specified 1D column of weights.  
 * Result pixel is equal to the sum of the products between the kernel
 * coefficients (pKernel array) and corresponding neighboring column pixel
 * values in the source image defined by nKernelDim and nAnchorY, divided by
 * nDivisor. 
 * 
 * \{
 *
 */

/**
 * 8-bit unsigned single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 8-bit unsigned three-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 8-bit unsigned four-channel 1D column convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 8-bit unsigned four-channel 1D column convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned three-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned four-channel 1D column convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned four-channel 1D column convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit three-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit four-channel 1D column convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit four-channel 1D column convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterColumn_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 32-bit float single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 32-bit float three-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 32-bit float four-channel 1D column convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 32-bit float four-channel 1D column convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 64-bit float single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoublePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp64f*") DoublePointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoubleBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp64f*") DoubleBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") double[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp64f*") double[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);


/** \} FilterColumn */

/** \name FilterColumnBorder
 * General purpose 1D convolution column filter with border control.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed. Before writing the result pixel the sum is scaled
 * back via division by nDivisor. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 8-bit unsigned 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 8-bit unsigned 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned convolution 1D column filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned convolution 1D column filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 16-bit unsigned 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 16-bit 1D column unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D column convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 16-bit 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 16-bit 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit 1D column convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
 
/**
 * Single channel 32-bit float 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit float 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit float 1D column convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit float 1D column convolution filter with border control, ignoring alpha channel.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterColumnBorder */

/** \name FilterColumn32f
 * 
 * FilterColumn using floating-point weights.
 * 
 * \{
 *
 */

/**
 * 8-bit unsigned single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 8-bit unsigned three-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 8-bit unsigned four-channel 1D column convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                           @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 8-bit unsigned four-channel 1D column convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned three-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned four-channel 1D column convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned four-channel 1D column convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                             @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                             @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                             @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit single-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit three-channel 1D column convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit four-channel 1D column convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit four-channel 1D column convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                             @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                             @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterColumn32f_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                             @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/** \} FilterColumn32f */

/** \name FilterColumnBorder32f
 * General purpose 1D column convolution filter using floating-point weights with border control.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed.  If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */


/**
 * Single channel 8-bit unsigned 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Three channel 8-bit unsigned 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Four channel 8-bit unsigned 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Four channel 8-bit unsigned 1D column convolution filter with border control, ignorint alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D column convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit 1D column convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                  @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit 1D column convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterColumnBorder32f_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                   @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterColumnBorder32f */

/** \name FilterRow
 * Apply convolution filter with user specified 1D row of weights.  
 * Result pixel is equal to the sum of the products between the kernel
 * coefficients (pKernel array) and corresponding neighboring row pixel
 * values in the source image defined by nKernelDim and nAnchorX, divided by
 * nDivisor. 
 * 
 * \{
 *
 */

/**
 * 8-bit unsigned single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 8-bit unsigned three-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 8-bit unsigned four-channel 1D row convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                     @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 8-bit unsigned four-channel 1D row convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned three-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned four-channel 1D row convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit unsigned four-channel 1D row convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit three-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit four-channel 1D row convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);

/**
 * 16-bit four-channel 1D row convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *                 operation should be divided.  If equal to the sum of
 *                 coefficients, this will keep the maximum result value within
 *                 full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilterRow_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor);


/**
 * 32-bit float single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 32-bit float three-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 32-bit float four-channel 1D row convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 32-bit float four-channel 1D row convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                       @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 64-bit float single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoublePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp64f*") DoublePointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoubleBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp64f*") DoubleBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") double[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                      @Cast("const Npp64f*") double[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);


/** \} FilterRow */

/** \name FilterRowBorder
 * General purpose 1D convolution row filter with border control.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed. Before writing the result pixel the sum is scaled
 * back via division by nDivisor. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 8-bit unsigned 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 8-bit unsigned 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned convolution 1D row filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned convolution 1D row filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 16-bit unsigned 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 16-bit 1D row unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D row convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 16-bit 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 16-bit 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit 1D row convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32s*") IntPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32s*") IntBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32s*") int[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
 
/**
 * Single channel 32-bit float 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit float 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit float 1D row convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit float 1D row convolution filter with border control, ignoring alpha channel.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterRowBorder */

/** \name FilterRow32f
 * 
 * FilterRow using floating-point weights.
 * 
 * \{
 *
 */

/**
 * 8-bit unsigned single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 8-bit unsigned three-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 8-bit unsigned four-channel 1D row convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                        @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 8-bit unsigned four-channel 1D row convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned three-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned four-channel 1D row convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit unsigned four-channel 1D row convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit single-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit three-channel 1D row convolution.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit four-channel 1D row convolution.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                         @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * 16-bit four-channel 1D row convolution ignoring alpha-channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *                Coefficients are expected to be stored in reverse order.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *                 source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiFilterRow32f_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                          @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/** \} FilterRow32f */

/** \name FilterRowBorder32f
 * General purpose 1D row convolution filter using floating-point weights with border control.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed.  If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */


/**
 * Single channel 8-bit unsigned 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Three channel 8-bit unsigned 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Four channel 8-bit unsigned 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Four channel 8-bit unsigned 1D row convolution filter with border control, ignorint alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D row convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit 1D row convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit 1D row convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param nMaskSize Width of the kernel.
 * @param nAnchor X offset of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatPointer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRowBorder32f_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                                @Cast("const Npp32f*") float[] pKernel, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterRowBorder32f */

/** \defgroup image_1D_window_sum 1D Window Sum
 *
 * \{
 *
 */

/** \name 1D Window Sum
 *  1D mask Window Sum for 8 and 16 bit images.
 *
 * \{
 *
 */

/**
 * One channel 8-bit unsigned 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 8 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);


/**
 * Three channel 8-bit unsigned 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 3-channel 8 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);


/**
 * Four channel 8-bit unsigned 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 4-channel 8 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                              @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                        @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * One channel 16-bit unsigned 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Three channel 16-bit unsigned 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 3-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Four channel 16-bit unsigned 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 4-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * One channel 16-bit signed 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Three channel 16-bit signed 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Four channel 16-bit signed 1D (column) sum to 32f.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 4-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowColumn_16s32f_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                               @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                         @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * One channel 8-bit unsigned 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 1-channel 8-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Three channel 8-bit unsigned 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 3-channel 8-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Four channel 8-bit unsigned 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 4-channel 8-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                 @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                           @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * One channel 16-bit unsigned 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 1-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Three channel 16-bit unsigned 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 3-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Four channel 16-bit unsigned 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 4-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * One channel 16-bit signed 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 1-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
/**
 * Three channel 16-bit signed 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 3-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);

/**
 * Four channel 16-bit signed 1D (row) sum to 32f.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 4-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
public static native @Cast("NppStatus") int nppiSumWindowRow_16s32f_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, 
                                  @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                            @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor);
/** \} */

/** \} image_1D_window_sum */

/** \defgroup image_1D_window_sum_border 1D Window Sum with Border Control
 *
 * \{
 *
 */

/** \name 1D Window Sum Border
 * 1D mask Window Sum for 8 and 16 bit images with border control. 
 * If any portion of the mask overlaps the source image boundary the requested border type operation 
 * is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * One channel 8-bit unsigned 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 8 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Three channel 8-bit unsigned 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 3-channel 8 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Four channel 8-bit unsigned 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 4-channel 8 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                    @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                    @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * One channel 16-bit unsigned 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 3-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 4-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * One channel 16-bit signed 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 1-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed 1D (column) sum to 32f with border control.
 *
 * Apply Column Window Summation filter over a 1D mask region around each
 * source pixel for 4-channel 16 bit/pixel input images with 32-bit floating point
 * output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring column pixel values in a mask region of the source image defined by
 * nMaskSize and nAnchor. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor Y offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowColumnBorder_16s32f_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                                     @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oROI, 
                                                     @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * One channel 8-bit unsigned 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 1-channel 8-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 3-channel 8-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 4-channel 8-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                       @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                       @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * One channel 16-bit unsigned 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 1-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 3-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 4-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * One channel 16-bit signed 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 1-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
/**
 * Three channel 16-bit signed 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 3-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed 1D (row) sum to 32f with border control.
 *
 * Apply Row Window Summation filter over a 1D mask region around each source
 * pixel for 4-channel 16-bit pixel input images with 32-bit floating point output.  
 * Result 32-bit floating point pixel is equal to the sum of the corresponding and
 * neighboring row pixel values in a mask region of the source image defined
 * by iKernelDim and iAnchorX. 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nMaskSize Length of the linear kernel array.
 * @param nAnchor X offset of the kernel origin frame of reference relative to the
 *        source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiSumWindowRowBorder_16s32f_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, 
                                        @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, 
                                        @ByVal NppiSize oROI, @Cast("Npp32s") int nMaskSize, @Cast("Npp32s") int nAnchor, @Cast("NppiBorderType") int eBorderType);
/** \} */

/** \} image_1D_window_sum_border */

/** \defgroup image_convolution Convolution
 *
 * \{
 *
 */

/** \name Filter
 * General purpose 2D convolution filter.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed. Before writing the result pixel the sum is scaled
 * back via division by nDivisor.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
  
/**
 * Three channel 8-bit unsigned convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
                 
/**
 * Four channel channel 8-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                  @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);

/**
 * Four channel 8-bit unsigned convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);

/**
 * Single channel 16-bit unsigned convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
  
/**
 * Three channel 16-bit unsigned convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
                 
/**
 * Four channel channel 16-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);

/**
 * Four channel 16-bit unsigned convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);

/**
 * Single channel 16-bit convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
  
/**
 * Three channel 16-bit convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
                 
/**
 * Four channel channel 16-bit convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);

/**
 * Four channel 16-bit convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                    @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                    @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
public static native @Cast("NppStatus") int nppiFilter_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                    @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor);
 
/**
 * Single channel 32-bit float convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Two channel 32-bit float convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_32f_C2R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C2R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C2R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 32-bit float convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit float convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit float convolution filter, ignoring alpha channel.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                    @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                    @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                    @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 64-bit float convolution filter.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoublePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp64f*") DoublePointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoubleBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp64f*") DoubleBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") double[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                   @Cast("const Npp64f*") double[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);


/** \} Filter */

/** \name Filter32f
 * General purpose 2D convolution filter using floating-point weights.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed. 
 *
 * \{
 *
 */


/**
 * Single channel 8-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
        
/**
 * Two channel 8-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
        
/**
 * Three channel 8-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
        
/**
 * Four channel 8-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
        
/**
 * Four channel 8-bit unsigned convolution filter, ignorint alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 8-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Two channel 8-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C2R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 8-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                     @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit signed convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);


/**
 * Single channel 32-bit convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 32-bit convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                      @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                       @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);


/**
 * Single channel 8-bit unsigned to 16-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 8-bit unsigned to 16-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned to 16-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned to 16-bit signed convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8u16s_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 8-bit to 16-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 8-bit to 16-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit to 16-bit signed convolution filter.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit to 16-bit signed convolution filter, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilter32f_8s16s_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor);


/** \} Filter32f */

/** \name FilterBorder
 * General purpose 2D convolution filter with border control.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed. Before writing the result pixel the sum is scaled
 * back via division by nDivisor. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 8-bit unsigned convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 8-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                        @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 16-bit unsigned convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 16-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
  
/**
 * Three channel 16-bit convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
                 
/**
 * Four channel channel 16-bit convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param nDivisor The factor by which the convolved summation from the Filter
 *        operation should be divided.  If equal to the sum of coefficients,
 *        this will keep the maximum result value within full scale.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32s*") IntPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32s*") IntBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32s*") int[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("Npp32s") int nDivisor, @Cast("NppiBorderType") int eBorderType);
 
/**
 * Single channel 32-bit float convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Two channel 32-bit float convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C2R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C2R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C2R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit float convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit float convolution filter with border control.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                         @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit float convolution filter with border control, ignoring alpha channel.
 * 
 *
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                          @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterBorder */

/** \name FilterBorder32f
 * General purpose 2D convolution filter using floating-point weights with border control.
 *
 * Pixels under the mask are multiplied by the respective weights in the mask
 * and the results are summed. Before writing the result pixel the sum is scaled
 * back via division by nDivisor. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */


/**
 * Single channel 8-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Two channel 8-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C2R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Three channel 8-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Four channel 8-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
        
/**
 * Four channel 8-bit unsigned convolution filter with border control, ignorint alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Two channel 8-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C2R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                           @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit signed convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") BytePointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8s*") byte[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Single channel 32-bit convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                            @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/**
 * Single channel 8-bit unsigned to 16-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned to 16-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned to 16-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                             @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned to 16-bit signed convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8u16s_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit to 16-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit to 16-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit to 16-bit signed convolution filter with border control.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                              @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit to 16-bit signed convolution filter with border control, ignoring alpha channel.
 * 
 * @param pSrc  \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pKernel Pointer to the start address of the kernel coefficient array.
 *        Coeffcients are expected to be stored in reverse order.
 * @param oKernelSize Width and Height of the rectangular kernel.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatPointer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") FloatBuffer pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBorder32f_8s16s_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, 
                               @Cast("const Npp32f*") float[] pKernel, @ByVal NppiSize oKernelSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);


/** \} FilterBorder32f */

/** \} image_convolution */

/** \defgroup image_2D_fixed_linear_filters 2D Fixed Linear Filters
 *
 * \{
 *
 */

/** \name FilterBox
 *
 * Computes the average pixel values of the pixels under a rectangular mask.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 8-bit unsigned box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned box filter, ignorting alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit unsigned box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit unsigned box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned box filter, ignorting alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit box filter, ignorting alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 32-bit floating-point box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 32-bit floating-point box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit floating-point box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit floating-point box filter, ignorting alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 64-bit floating-point box filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBox_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoublePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") DoubleBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterBox_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp64f*") double[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/** \} FilterBox */

/** \name FilterBoxBorder
 *
 * Computes the average pixel values of the pixels under a rectangular mask with border control.
 * If any portion of the mask overlaps the source image boundary the requested 
 * border type operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported. *
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned box filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned box filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit box filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point box filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point box filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Avg operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference relative to
 *        the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterBoxBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterBoxBorder */

/** \} image_2D_fixed_linear_filters */

/** \defgroup image_rank_filters Rank Filters
 *
 * \{
 *
 */

/** \name ImageMax Filter
 *
 * Result pixel value is the maximum of pixel values under the rectangular
 * mask region.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 8-bit unsigned maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned maximum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit unsigned maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit unsigned maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned maximum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit signed maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit signed maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit signed maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit signed maximum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 32-bit floating-point maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 32-bit floating-point maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit floating-point maximum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit floating-point maximum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMax_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMax_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/** \} FilterMax */

/** \name ImageMaxBorder Filter
 *
 * Result pixel value is the maximum of pixel values under the rectangular
 * mask region. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned maximum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned maximum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed maximum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point maximum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point maximum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMaxBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterMaxBorder */

/** \name ImageMin Filter
 *
 * Result pixel value is the minimum of pixel values under the rectangular
 * mask region.
 *
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 8-bit unsigned minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 8-bit unsigned minimum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit unsigned minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit unsigned minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit unsigned minimum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Single channel 16-bit signed minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 16-bit signed minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit signed minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 16-bit signed minimum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);


/**
 * Single channel 32-bit floating-point minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Three channel 32-bit floating-point minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit floating-point minimum filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/**
 * Four channel 32-bit floating-point minimum filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Max operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMin_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);
public static native @Cast("NppStatus") int nppiFilterMin_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor);

/** \} FilterMin */

/** \name ImageMinBorder Filter
 *
 * Result pixel value is the minimum of pixel values under the rectangular
 * mask region. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                           @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned minimum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned minimum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed minimum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point minimum filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                            @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point minimum filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Min operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterMinBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                             @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("NppiBorderType") int eBorderType);

/** \} FilterMinBorder */

/** \name ImageMedian Filter
 *
 * Result pixel value is the median of pixel values under the rectangular
 * mask region.
 *
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three channel 8-bit unsigned median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 8-bit unsigned median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                     @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 8-bit unsigned median filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Single channel 16-bit unsigned median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three channel 16-bit unsigned median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 16-bit unsigned median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 16-bit unsigned median filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Single channel 16-bit signed median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three channel 16-bit signed median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 16-bit signed median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 16-bit signed median filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);


/**
 * Single channel 32-bit floating-point median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three channel 32-bit floating-point median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 32-bit floating-point median filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                      @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four channel 32-bit floating-point median filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local
 *        Median operation.
 * @param oAnchor X and Y offsets of the kernel origin frame of reference
 *        relative to the source pixel.
 * @param pBuffer Pointer to the user-allocated scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedian_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiFilterMedian_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, 
                       @ByVal NppiSize oMaskSize, @ByVal NppiPoint oAnchor, @Cast("Npp8u*") byte[] pBuffer);
                       






/**
 * Single channel 8-bit unsigned median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Three channel 8-bit unsigned median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 8-bit unsigned median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 8-bit unsigned median filter, ignoring alpha channel.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Single channel 16-bit unsigned median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Three channel 16-bit unsigned median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 16-bit unsigned median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 16-bit unsigned median filter, ignoring alpha channel.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Single channel 16-bit signed median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Three channel 16-bit signed median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 16-bit signed median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 16-bit signed median filter, ignoring alpha channel.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);


/**
 * Single channel 32-bit floating-point median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C1R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Three channel 32-bit floating-point median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C3R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 32-bit floating-point median filter scratch memory size.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_C4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);

/**
 * Four channel 32-bit floating-point median filter, ignoring alpha channel.
 * @param oSizeROI \ref roi_specification.
 * @param oMaskSize Width and Height of the neighborhood region for the local Median operation.
 * @param nBufferSize Pointer to the size of the scratch buffer required for the Median operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntPointer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") IntBuffer nBufferSize);
public static native @Cast("NppStatus") int nppiFilterMedianGetBufferSize_32f_AC4R(@ByVal NppiSize oSizeROI, @ByVal NppiSize oMaskSize, @Cast("Npp32u*") int[] nBufferSize);


/** \} FilterMedian */



/** \} image_rank_filters */

/** \defgroup fixed_filters Fixed Filters
 *
 * Fixed filters perform linear filtering operations (i.e. convolutions) with predefined kernels
 * of fixed sizes.
 * 
 * Some of the fixed filters have versions with border control.   For these functions, if any portion 
 * of the mask overlaps the source image boundary the requested border type operation is applied to 
 * all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported for these functions.
 *
 * \{
 *
 */

/** \name FilterPrewittHoriz 
 *
 * Filters the image using a horizontal Prewitt filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    1 &  1 &  1 \\
 *    0 &  0 &  0 \\
 *   -1 & -1 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 8-bit unsigned horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned horizontal Prewitt filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit signed horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit signed horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed horizontal Prewitt filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 32-bit floating-point horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point horizontal Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point horizontal Prewitt filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittHoriz_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} FilterPrewittHoriz */

/** \name FilterPrewittHorizBorder 
 *
 * Filters the image using a horizontal Prewitt filter kernel with border control. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    1 &  1 &  1 \\
 *    0 &  0 &  0 \\
 *   -1 & -1 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned horizontal Prewitt filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed horizontal Prewitt filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point horizontal Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point horizontal Prewitt filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittHorizBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} FilterPrewittHorizBorder */

/** \name FilterPrewittVert 
 *
 * Filters the image using a vertical Prewitt filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   -1 & 0 & 1 \\
 *   -1 & 0 & 1 \\
 *   -1 & 0 & 1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 8-bit unsigned vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned vertical Prewitt filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit signed vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit signed vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed vertical Prewitt filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 32-bit floating-point vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point vertical Prewitt filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point vertical Prewitt filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterPrewittVert_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} FilterPrewittVert */

/** \name FilterPrewittVertBorder 
 *
 * Filters the image using a vertical Prewitt filter kernel with border control. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   -1 & 0 & 1 \\
 *   -1 & 0 & 1 \\
 *   -1 & 0 & 1 \\
 *  \end{array} \right);
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned vertical Prewitt filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed vertical Prewitt filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point vertical Prewitt filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point vertical Prewitt filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterPrewittVertBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} FilterPrewittVertBorder */


/** \name FilterScharrHoriz 
 *
 * Filters the image using a horizontal Scharr filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    3 &  10 &  3 \\
 *    0 &   0 &  0 \\
 *   -3 & -10 & -3 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed horizontal Scharr filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 8-bit signed to 16-bit signed horizontal Scharr filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point horizontal Scharr filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrHoriz_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} FilterScharrHoriz */

/** \name FilterScharrVert 
 *
 * Filters the image using a vertical Scharr filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *     3 &   0 &  -3 \\
 *    10 &   0 & -10 \\
 *     3 &   0 &  -3 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed vertical Scharr filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrVert_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrVert_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrVert_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 8-bit signed to 16-bit signed vertical Scharr filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrVert_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrVert_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrVert_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point vertical Scharr filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrVert_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrVert_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterScharrVert_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} FilterScharrVert */

/** \name FilterScharrHorizBorder 
 *
 * Filters the image using a horizontal Scharr filter kernel with border control:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    3 &  10 &  3 \\
 *    0 &   0 &  0 \\
 *   -3 & -10 & -3 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed horizontal Scharr filter kernel with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed horizontal Scharr filter kernel with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point horizontal Scharr filter kernel with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrHorizBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} FilterScharrHorizBorder */

/** \name FilterScharrVertBorder 
 *
 * Filters the image using a vertical Scharr filter kernel kernel with border control:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *     3 &   0 &  -3 \\
 *    10 &   0 & -10 \\
 *     3 &   0 &  -3 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed vertical Scharr filter kernel with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed vertical Scharr filter kernel with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point vertical Scharr filter kernel with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterScharrVertBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} FilterScharrVertBorder */


/** \name FilterSobelHoriz 
 *              
 * Filters the image using a horizontal Sobel filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    1 &  2 &  1 \\
 *    0 &  0 &  0 \\
 *   -1 & -2 & -1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *    1  &  4 &   6 &  4 &  1 \\
 *    2  &  8 &  12 &  8 &  2 \\
 *    0  &  0 &   0 &  0 &  0 \\
 *    -2 & -8 & -12 & -8 & -2 \\
 *    -1 & -4 &  -6 & -4 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 8-bit unsigned horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed horizontal Sobel filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit signed horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit signed horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned horizontal Sobel filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 32-bit floating-point horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point horizontal Sobel filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 8-bit unsigned to 16-bit signed horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 8-bit signed to 16-bit signed horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHoriz_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 32-bit floating-point horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizMask_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizMask_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizMask_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize);


/** \} FilterSobelHoriz */

/** \name FilterSobelVert 
 *
 * Filters the image using a vertical Sobel filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    -1 & 0 & 1 \\
 *    -2 & 0 & 2 \\
 *    -1 & 0 & 1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *    -1 &  -2 & 0 &  2 & 1 \\
 *    -4 &  -8 & 0 &  8 & 4 \\
 *    -6 & -12 & 0 & 12 & 6 \\
 *    -4 &  -8 & 0 &  8 & 4 \\
 *    -1 &  -2 & 0 &  2 & 1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 8-bit unsigned vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed vertical Sobel filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit signed vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit signed vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned vertical Sobel filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 32-bit floating-point vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point vertical Sobel filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSobelVert_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 8-bit unsigned to 16-bit signed vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 8-bit signed to 16-bit signed vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVert_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVert_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 32-bit floating-point vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertMask_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertMask_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertMask_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize);


/** \} FilterSobelVert */

/** \name FilterSobelHorizSecond
 *
 * Filters the image using a second derivative, horizontal Sobel filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *     1 &   2 &   1 \\
 *    -2 &  -4 &  -2 \\
 *     1 &   2 &   1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *     1  &  4 &   6 &  4 &  1 \\
 *     0  &  0 &   0 &  0 &  0 \\
 *    -2  & -8 & -12 & -8 & -2 \\
 *     0  &  0 &   0 &  0 &  0 \\
 *     1  &  4 &   6 &  4 &  1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed second derivative, horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 8-bit signed to 16-bit signed second derivative, horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize);
/**
 * Single channel 32-bit floating-point second derivative, horizontal Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                   @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                   @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecond_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                   @Cast("NppiMaskSize") int eMaskSize);

/** \} FilterSobelVertSecond */

/** \} FilterSobelVert */

/** \name FilterSobelVertSecond
 *
 * Filters the image using a second derivative, vertical Sobel filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
     *    1 & -2 & 1 \\
     *    2 & -4 & 2 \\
     *    1 & -2 & 1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *     1 & 0 &  -2 & 0 & 1 \\
 *     4 & 0 &  -8 & 0 & 4 \\
 *     6 & 0 & -12 & 0 & 6 \\
 *     4 & 0 &  -8 & 0 & 4 \\
 *     1 & 0 &  -2 & 0 & 1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed second derivative, vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 8-bit signed to 16-bit signed second derivative, vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
/**
 * Single channel 32-bit floating-point second derivative, vertical Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecond_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize);

/** \} FilterSobelVertSecond */

/** \name FilterSobelCross
 *
 * Filters the image using a second cross derivative Sobel filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    -1 & 0 &  1 \\
 *     0 & 0 &  0 \\
 *     1 & 0 & -1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *    -1 & -2 & 0 &  2 &  1 \\
 *    -2 & -4 & 0 &  4 &  2 \\
 *     0 &  0 & 0 &  0 &  0 \\
 *     2 &  4 & 0 & -4 & -2 \\
 *     1 &  2 & 0 & -2 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed second cross derivative Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelCross_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelCross_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelCross_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 8-bit signed to 16-bit signed second cross derivative Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelCross_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelCross_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelCross_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize);
/**
 * Single channel 32-bit floating-point second cross derivative Sobel filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelCross_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelCross_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterSobelCross_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize);

/** \} FilterSobelCross */


/** \name FilterSobelHorizBorder 
 *
 * Filters the image using a horizontal Sobel filter kernel with border control:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    1 &  2 &  1 \\
 *    0 &  0 &  0 \\
 *   -1 & -2 & -1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *    1  &  4 &   6 &  4 &  1 \\
 *    2  &  8 &  12 &  8 &  2 \\
 *    0  &  0 &   0 &  0 &  0 \\
 *    -2 & -8 & -12 & -8 & -2 \\
 *    -1 & -4 &  -6 & -4 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed horizontal Sobel filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned horizontal Sobel filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point horizontal Sobel filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit unsigned to 16-bit signed horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizMaskBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizMaskBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizMaskBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);


/** \} FilterSobelHorizBorder */

/** \name FilterSobelVertBorder 
 *
 * Filters the image using a vertical Sobel filter kernel with border control:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    -1 & 0 & 1 \\
 *    -2 & 0 & 2 \\
 *    -1 & 0 & 1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *    -1 &  -2 & 0 &  2 & 1 \\
 *    -4 &  -8 & 0 &  8 & 4 \\
 *    -6 & -12 & 0 & 12 & 6 \\
 *    -4 &  -8 & 0 &  8 & 4 \\
 *    -1 &  -2 & 0 &  2 & 1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed vertical Sobel filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned vertical Sobel filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point vertical Sobel filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit unsigned to 16-bit signed vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                    @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertMaskBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertMaskBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertMaskBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);


/** \} FilterSobelVertBorder */

/** \name FilterSobelHorizSecondBorder
 *
 * Filters the image using a second derivative, horizontal Sobel filter kernel with border control:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *     1 &   2 &   1 \\
 *    -2 &  -4 &  -2 \\
 *     1 &   2 &   1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *     1  &  4 &   6 &  4 &  1 \\
 *     0  &  0 &   0 &  0 &  0 \\
 *    -2  & -8 & -12 & -8 & -2 \\
 *     0  &  0 &   0 &  0 &  0 \\
 *     1  &  4 &   6 &  4 &  1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed second derivative, horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                           @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                           @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                           @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed second derivative, horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                           @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                           @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                           @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
/**
 * Single channel 32-bit floating-point second derivative, horizontal Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                         @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                         @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelHorizSecondBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                         @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/** \} FilterSobelVertSecondBorder */

/** \} FilterSobelVertBorder */

/** \name FilterSobelVertSecondBorder
 *
 * Filters the image using a second derivative, vertical Sobel filter kernel with border control:
 *
 * \f[
 *  \left( \begin{array}{rrr}
     *    1 & -2 & 1 \\
     *    2 & -4 & 2 \\
     *    1 & -2 & 1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *     1 & 0 &  -2 & 0 & 1 \\
 *     4 & 0 &  -8 & 0 & 4 \\
 *     6 & 0 & -12 & 0 & 6 \\
 *     4 & 0 &  -8 & 0 & 4 \\
 *     1 & 0 &  -2 & 0 & 1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed second derivative, vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                          @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                          @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                          @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed second derivative, vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                          @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                          @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                          @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
/**
 * Single channel 32-bit floating-point second derivative, vertical Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                        @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                        @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelVertSecondBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                        @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/** \} FilterSobelVertSecondBorder */

/** \name FilterSobelCrossBorder
 *
 * Filters the image using a second cross derivative Sobel filter kernel with border control:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *    -1 & 0 &  1 \\
 *     0 & 0 &  0 \\
 *     1 & 0 & -1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *    -1 & -2 & 0 &  2 &  1 \\
 *    -2 & -4 & 0 &  4 &  2 \\
 *     0 &  0 & 0 &  0 &  0 \\
 *     2 &  4 & 0 & -4 & -2 \\
 *     1 &  2 & 0 & -2 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned to 16-bit signed second cross derivative Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed second cross derivative Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
/**
 * Single channel 32-bit floating-point second cross derivative Sobel filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                   @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                   @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSobelCrossBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                   @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/** \} FilterSobelCrossBorder */

/** \name FilterRobertsDown
 *
 * Filters the image using a horizontal Roberts filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   0 & 0 &  0 \\
 *   0 & 1 &  0 \\
 *   0 & 0 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 8-bit unsigned horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned horizontal Roberts filter, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit signed horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit signed horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed horizontal Roberts filter, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 32-bit floating-point horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point horizontal Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point horizontal Roberts filter, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsDown_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} FilterRobertsDown */

/** \name FilterRobertsDownBorder
 *
 * Filters the image using a horizontal Roberts filter kernel with border control.  If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   0 & 0 &  0 \\
 *   0 & 1 &  0 \\
 *   0 & 0 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned horizontal Roberts filter with border control, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed horizontal Roberts filter with border control, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point horizontal Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point horizontal Roberts filter with border control, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsDownBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} FilterRobertsDownBorder */

/** \name FilterRobertsUp
 *
 * Filters the image using a vertical Roberts filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   0 & 0 &  0 \\
 *   0 & 1 &  0 \\
 *  -1 & 0 &  0 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 8-bit unsigned vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned vertical Roberts filter, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit signed vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit signed vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed vertical Roberts filter, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 32-bit floating-point vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point vertical Roberts filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point vertical Roberts filter, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterRobertsUp_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} FilterRobertsUp */

/** \name FilterRobertsUpBorder
 *
 * Filters the image using a vertical Roberts filter kernel with border control.  If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   0 & 0 &  0 \\
 *   0 & 1 &  0 \\
 *  -1 & 0 &  0 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned vertical Roberts filter with border control, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed vertical Roberts filter with border control, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point vertical Roberts filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point vertical Roberts filter with border control, ignoring alpha-channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterRobertsUpBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} FilterRobertsUpBorder */


/** \name FilterLaplace
 *
 * Filters the image using a Laplacian filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   -1 & -1 & -1 \\
 *   -1 &  8 & -1 \\
 *   -1 & -1 & -1 \\
 *  \end{array} \right)
  *  \left( \begin{array}{rrrrr}
 *   -1 & -3 & -4 & -3 & -1 \\
 *   -3 &  0 &  6 &  0 & -3 \\
 *   -4 &  6 & 20 &  6 & -4 \\
 *   -3 &  0 &  6 &  0 & -3 \\
 *   -1 & -3 & -4 & -3 & -1 \\
 *  \end{array} \right)
 <p>
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 8-bit unsigned Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned Laplace filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 16-bit signed Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 16-bit signed Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed Laplace filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 32-bit floating-point Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 32-bit floating-point Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point Laplace filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 8-bit unsigned to 16-bit signed Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 8-bit signed to 16-bit signed Laplace filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplace_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLaplace_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);

/** \} FilterLaplace */

/** \name FilterLaplaceBorder
 *
 * Filters the image using a Laplacian filter kernel with border control. If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *   -1 & -1 & -1 \\
 *   -1 &  8 & -1 \\
 *   -1 & -1 & -1 \\
 *  \end{array} \right)
  *  \left( \begin{array}{rrrrr}
 *   -1 & -3 & -4 & -3 & -1 \\
 *   -3 &  0 &  6 &  0 & -3 \\
 *   -4 &  6 & 20 &  6 & -4 \\
 *   -3 &  0 &  6 &  0 & -3 \\
 *   -1 & -3 & -4 & -3 & -1 \\
 *  \end{array} \right)
 <p>
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned Laplace filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed Laplace filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point Laplace filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit unsigned to 16-bit signed Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 8-bit signed to 16-bit signed Laplace filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8s16s_C1R(@Cast("const Npp8s*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8s16s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLaplaceBorder_8s16s_C1R(@Cast("const Npp8s*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/** \} FilterLaplaceBorder */

/** \name FilterGauss
 *
 * Filters the image using a Gaussian filter kernel:
 *
 * Note that all FilterGauss functions currently support mask sizes up to 15x15.
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      1/16  & 2/16  & 1/16 \\
 *      2/16  & 4/16  & 2/16 \\
 *      1/16  & 2/16  & 1/16 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *       2/571 &  7/571 &  12/571 &  7/571 &  2/571 \\
 *       7/571 & 31/571 &  52/571 & 31/571 &  7/571 \\
 *      12/571 & 52/571 & 127/571 & 52/571 & 12/571 \\
 *       7/571 & 31/571 &  52/571 & 31/571 &  7/571 \\
 *       2/571 &  7/571 &  12/571 &  7/571 &  2/571 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 8-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                       @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 16-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 16-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit unsigned Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 16-bit signed Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 16-bit signed Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 32-bit floating-point Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 32-bit floating-point Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                        @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGauss_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterGauss_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/** \} FilterGauss */

/** \name FilterGaussAdvanced
 *
 * Filters the image using a separable Gaussian filter kernel with user supplied floating point coefficients:
 *
 * \{
 *
 */                                                  

/**
 * Single channel 8-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Three channel 8-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 8-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 8-bit unsigned Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Single channel 16-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Three channel 16-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 16-bit unsigned Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 16-bit unsigned Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Single channel 16-bit signed Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Three channel 16-bit signed Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 16-bit signed Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 16-bit signed Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Single channel 32-bit floating-point Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Three channel 32-bit floating-point Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 32-bit floating-point Gauss filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/**
 * Four channel 32-bit floating-point Gauss filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel);
public static native @Cast("NppStatus") int nppiFilterGaussAdvanced_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 int nFilterTaps, @Cast("const Npp32f*") float[] pKernel);

/** \} FilterGaussAdvanced */

/** \name FilterGaussBorder
 *
 * If any portion of the mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * Note that all FilterGaussBorder functions currently support mask sizes up to 15x15.
 *
 * Filters the image using a Gaussian filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      1/16  & 2/16  & 1/16 \\
 *      2/16  & 4/16  & 2/16 \\
 *      1/16  & 2/16  & 1/16 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *       2/571 &  7/571 &  12/571 &  7/571 &  2/571 \\
 *       7/571 & 31/571 &  52/571 & 31/571 &  7/571 \\
 *      12/571 & 52/571 & 127/571 & 52/571 & 12/571 \\
 *       7/571 & 31/571 &  52/571 & 31/571 &  7/571 \\
 *       2/571 &  7/571 &  12/571 &  7/571 &  2/571 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                             @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                              @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                               @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/** \} FilterGaussBorder */

/** \name FilterGaussAdvancedBorder
 *
 * Filters the image using a separable Gaussian filter kernel with user supplied floating point coefficients with border control:
 * If any portion of the mask overlaps the source image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                     int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point Gauss filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                      int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point Gauss filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nFilterTaps The number of filter taps where nFilterTaps =  2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
 * @param pKernel Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F. 
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") FloatPointer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") FloatBuffer pKernel, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterGaussAdvancedBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                       int nFilterTaps, @Cast("const Npp32f*") float[] pKernel, @Cast("NppiBorderType") int eBorderType);

/** \} FilterGaussAdvancedBorder */

/** \name FilterHighPass
 *
 * Filters the image using a high-pass filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      -1 & -1 & -1 \\
 *      -1 &  8 & -1 \\
 *      -1 & -1 & -1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *      -1 & -1 & -1 & -1 & -1 \\
 *      -1 & -1 & -1 & -1 & -1 \\
 *      -1 & -1 & 24 & -1 & -1 \\
 *      -1 & -1 & -1 & -1 & -1 \\
 *      -1 & -1 & -1 & -1 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit unsigned high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterHighPass_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                            @Cast("NppiMaskSize") int eMaskSize);

/** \} FilterHighPass */

/** \name FilterHighPassBorder
 *
 * Filters the image using a high-pass filter kernel with border control.
 * If any portion of the mask overlaps the source image boundary the requested 
 * border type operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported. 
 *
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      -1 & -1 & -1 \\
 *      -1 &  8 & -1 \\
 *      -1 & -1 & -1 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *      -1 & -1 & -1 & -1 & -1 \\
 *      -1 & -1 & -1 & -1 & -1 \\
 *      -1 & -1 & 24 & -1 & -1 \\
 *      -1 & -1 & -1 & -1 & -1 \\
 *      -1 & -1 & -1 & -1 & -1 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterHighPassBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/** \} FilterHighPassBorder */

/** \name FilterLowPass
 *
 * Filters the image using a low-pass filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      1/9 & 1/9 & 1/9 \\
 *      1/9 & 1/9 & 1/9 \\
 *      1/9 & 1/9 & 1/9 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 8-bit unsigned low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                         @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 8-bit unsigned low-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 16-bit unsigned low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 16-bit unsigned low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit unsigned low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit unsigned low-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 16-bit signed low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 16-bit signed low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 16-bit signed low-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/**
 * Single channel 32-bit floating-point low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Three channel 32-bit floating-point low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point low-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                          @Cast("NppiMaskSize") int eMaskSize);

/**
 * Four channel 32-bit floating-point high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);
public static native @Cast("NppStatus") int nppiFilterLowPass_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                           @Cast("NppiMaskSize") int eMaskSize);

/** \} FilterLowPass */

/** \name FilterLowPassBorder
 *
 * Filters the image using a low-pass filter kernel with border control.
 * If any portion of the mask overlaps the source image boundary the requested 
 * border type operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported. 
 *
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      1/9 & 1/9 & 1/9 \\
 *      1/9 & 1/9 & 1/9 \\
 *      1/9 & 1/9 & 1/9 \\
 *  \end{array} \right)
 *  \left( \begin{array}{rrrrr}
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *      1/25 & 1/25 & 1/25 & 1/25 & 1/25 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point high-pass filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                 @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point high-pass filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eMaskSize Enumeration value specifying the mask size.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterLowPassBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI,
                                  @Cast("NppiMaskSize") int eMaskSize, @Cast("NppiBorderType") int eBorderType);

/** \} FilterLowPassBorder */

/** \name FilterSharpen
 *
 * Filters the image using a sharpening filter kernel:
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      -1/8 & -1/8 & -1/8 \\
 *      -1/8 & 16/8 & -1/8 \\
 *      -1/8 & -1/8 & -1/8 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 8-bit unsigned sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 8-bit unsigned sharpening filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit unsigned sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit unsigned sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit unsigned sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit unsigned sharpening filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 16-bit signed sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 16-bit signed sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 16-bit signed sharpening filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Single channel 32-bit floating-point sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three channel 32-bit floating-point sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point sharpening filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four channel 32-bit floating-point sharpening filter, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiFilterSharpen_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI);

/** \} FilterSharpen */

/** \name FilterSharpenBorder
 *
 * Filters the image using a sharpening filter kernel with border control. If any portion of the 3x3 mask overlaps the source
 * image boundary the requested border type operation is applied to all mask pixels
 * which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \f[
 *  \left( \begin{array}{rrr}
 *      -1/8 & -1/8 & -1/8 \\
 *      -1/8 & 16/8 & -1/8 \\
 *      -1/8 & -1/8 & -1/8 \\
 *  \end{array} \right)
 * \f]
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 8-bit unsigned sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 8-bit unsigned sharpening filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit unsigned sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit unsigned sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit unsigned sharpening filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 16-bit signed sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 16-bit signed sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 16-bit signed sharpening filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Single channel 32-bit floating-point sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Three channel 32-bit floating-point sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point sharpening filter with border control.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/**
 * Four channel 32-bit floating-point sharpening filter with border control, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Source image width and height in pixels relative to pSrc.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);
public static native @Cast("NppStatus") int nppiFilterSharpenBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiSize oSrcSize, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("NppiBorderType") int eBorderType);

/** \} FilterSharpenBorder */

/** \name FilterUnsharpBorder
 *
 * Filters the image using a unsharp-mask sharpening filter kernel with border control.
 *
 * The algorithm involves the following steps:
 * Smooth the original image with a Gaussian filter, with the width controlled by the nRadius.
 * Subtract the smoothed image from the original to create a high-pass filtered image.
 * Apply any clipping needed on the high-pass image, as controlled by the nThreshold.
 * Add a certain percentage of the high-pass filtered image to the original image, 
 * with the percentage controlled by the nWeight.
 * In pseudocode this algorithm can be written as:
 * HighPass = Image - Gaussian(Image)
 * Result = Image + nWeight * HighPass * ( |HighPass| >= nThreshold ) 
 * where nWeight is the amount, nThreshold is the threshold, and >= indicates a Boolean operation, 1 if true, or 0 otherwise.
 *
 * If any portion of the mask overlaps the source image boundary, the requested border type 
 * operation is applied to all mask pixels which fall outside of the source image.
 *
 * Currently only the NPP_BORDER_REPLICATE border type operation is supported.
 *
 * \{
 *
 */

/**
 * Single channel 8-bit unsigned unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three channel 8-bit unsigned unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 8-bit unsigned unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 8-bit unsigned unsharp filter (alpha channel is not processed).
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Single channel 16-bit unsigned unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three channel 16-bit unsigned unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 16-bit unsigned unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 16-bit unsigned unsharp filter (alpha channel is not processed).
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16u*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Single channel 16-bit signed unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three channel 16-bit signed unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 16-bit signed unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 16-bit signed unsharp filter (alpha channel is not processed).
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Single channel 32-bit floating point unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three channel 32-bit floating point unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 32-bit floating point unsharp filter.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four channel 32-bit floating point unsharp filter (alpha channel is not processed).
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcOffset The pixel offset that pSrc points to relative to the origin of the source image. 
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param nWeight The percentage of the difference between the original and the high pass image that is added back into the original.
 * @param nThreshold The threshold neede to apply the difference amount.
 * @param eBorderType The border type operation to be applied at source image border boundaries.
 * @param pDeviceBuffer Pointer to the user-allocated device scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiFilterUnsharpBorder_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @Cast("Npp32s") int nSrcStep, @ByVal NppiPoint oSrcOffset, @Cast("Npp32f*") float[] pDst, @Cast("Npp32s") int nDstStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f") float nRadius, @Cast("Npp32f") float nSigma, @Cast("Npp32f") float nWeight, @Cast("Npp32f") float nThreshold, @Cast("NppiBorderType") int eBorderType, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Single channel 8-bit unsigned unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Three channel 8-bit unsigned unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 8-bit unsigned unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 8-bit unsigned unsharp filter scratch memory size (alpha channel is not processed).
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_8u_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Single channel 16-bit unsigned unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Three channel 16-bit unsigned unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 16-bit unsigned unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 16-bit unsigned unsharp filter scratch memory size (alpha channel is not processed).
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16u_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Single channel 16-bit signed unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Three channel 16-bit signed unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 16-bit signed unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 16-bit signed unsharp filter scratch memory size (alpha channel is not processed).
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_16s_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Single channel 32-bit floating point unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C1R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Three channel 32-bit floating point unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C3R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 32-bit floating point unsharp filter scratch memory size.
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_C4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/**
 * Four channel 32-bit floating point unsharp filter scratch memory size (alpha channel is not processed).
 * @param nRadius The radius of the Gaussian filter, in pixles, not counting the center pixel.
 * @param nSigma The standard deviation of the Gaussian filter, in pixel.
 * @param hpBufferSize Pointer to the size of the scratch buffer required for the unsharp operation.
 * @return \ref image_data_error_codes
 */
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFilterUnsharpGetBufferSize_32f_AC4R(@Cast("const Npp32f") float nRadius, @Cast("const Npp32f") float nSigma, int[] hpBufferSize);

/** \} FilterUnsharp */

/** \} fixed_filters */


/** \} image_filtering_functions */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_FILTERING_FUNCTIONS_H */


// Parsed from <nppi_statistics_functions.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_STATISTICS_FUNCTIONS_H
// #define NV_NPPI_STATISTICS_FUNCTIONS_H
 
/**
 * \file nppi_statistics_functions.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_statistics_functions Statistical Operations
 *  \ingroup nppi
 *
 * Primitives for computing the statistical properties of an image.
 * Some statistical primitives also require scratch buffer during the computation. For details, please 
 * refer to \ref general_scratch_buffer.
 * \{
 *
 */

/** \defgroup image_sum Sum
 * Primitives for computing the sum of all the pixel values in an image.
 * \{
 */

/** \name Sum
 * \{
 * Given an image \f$pSrc\f$ with width \f$W\f$ and height \f$H\f$, the sum
 * will be computed as
 * \f[Sum = \sum_{j=0}^{H-1}\sum_{i=0}^{W-1}pSrc(j,i)\f]
 * All the results are stored in a 64-bit double precision format, 
 * except for two primitives \ref nppiSum_8u64s_C1R and \ref nppiSum_8u64s_C4R.
 * The sum functions require additional scratch buffer for computations.
 */

/**
 * One-channel 8-bit unsigned image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_8u_C1R to determine the minium number of bytes required.
 * @param pSum Pointer to the computed sum.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pSum);
public static native @Cast("NppStatus") int nppiSum_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pSum);
public static native @Cast("NppStatus") int nppiSum_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pSum);

/**
 * One-channel 8-bit unsigned image sum. The result is 64-bit long long integer.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_8u64s_C1R to determine the minium number of bytes required.
 * @param pSum Pointer to the computed sum.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_8u64s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64s*") LongPointer pSum);
public static native @Cast("NppStatus") int nppiSum_8u64s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64s*") LongBuffer pSum);
public static native @Cast("NppStatus") int nppiSum_8u64s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64s*") long[] pSum);

/**
 * One-channel 16-bit unsigned image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_16u_C1R to determine the minium number of bytes required.
 * @param pSum Pointer to the computed sum.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pSum);
public static native @Cast("NppStatus") int nppiSum_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pSum);
public static native @Cast("NppStatus") int nppiSum_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pSum);

/**
 * One-channel 16-bit signed image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_16s_C1R to determine the minium number of bytes required.
 * @param pSum Pointer to the computed sum.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pSum);
public static native @Cast("NppStatus") int nppiSum_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pSum);
public static native @Cast("NppStatus") int nppiSum_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pSum);

/**
 * One-channel 32-bit floating point image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiSumGetBufferHostSize_32f_C1R to determine the minium number of bytes required.
 * @param pSum Pointer to the computed sum.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pSum);
public static native @Cast("NppStatus") int nppiSum_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pSum);
public static native @Cast("NppStatus") int nppiSum_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pSum);

/**
 * Three-channel 8-bit unsigned image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_8u_C3R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Three-channel 16-bit unsigned image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_16u_C3R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Three-channel 16-bit signed image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_16s_C3R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Three-channel 32-bit floating point image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_32f_C3R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 8-bit unsigned image sum ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_8u_AC4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel (alpha channel is not computed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 16-bit unsigned image sum ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_16u_AC4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel (alpha channel is not computed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 16-bit signed image sum ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiSumGetBufferHostSize_16s_AC4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel (alpha channel is not computed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 32-bit floating point image sum ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiSumGetBufferHostSize_32f_AC4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel (alpha channel is not computed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 8-bit unsigned image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiSumGetBufferHostSize_8u_C4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 8-bit unsigned image sum. The result is 64-bit long long integer.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiSumGetBufferHostSize_8u64s_C4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_8u64s_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64s*") LongPointer aSum);
public static native @Cast("NppStatus") int nppiSum_8u64s_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64s*") LongBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_8u64s_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64s*") long[] aSum);

/**
 * Four-channel 16-bit unsigned image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiSumGetBufferHostSize_16u_C4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 16-bit signed image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiSumGetBufferHostSize_16s_C4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/**
 * Four-channel 32-bit floating point image sum.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiSumGetBufferHostSize_32f_C4R to determine the minium number of bytes required.
 * @param aSum Array that contains computed sum for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSum_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aSum);
public static native @Cast("NppStatus") int nppiSum_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aSum);
public static native @Cast("NppStatus") int nppiSum_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aSum);

/** \} Sum */

/** \name SumGetBufferHostSize 
 * Companion primitives for computing the device buffer size (in bytes) required by the sum primitives.
 * \{
 */

/**
 * Buffer size for \ref nppiSum_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/**
 * Buffer size for \ref nppiSum_8u64s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u64s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u64s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u64s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_8u64s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u64s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u64s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u64s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiSum_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSumGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
 
/** \} SumGetBufferHostSize */
/** \} image_sum */

/** \defgroup image_min Min
 * Primitives for computing the minimal pixel value of an image.
 * \{
 */

/** \name Min
 * The scratch buffer is required by the min functions.
 * \{
 */

/**
 * One-channel 8-bit unsigned image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_8u_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed minimum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer pMin);
public static native @Cast("NppStatus") int nppiMin_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer pMin);
public static native @Cast("NppStatus") int nppiMin_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] pMin);

/**
 * One-channel 16-bit unsigned image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16u_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed minimum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer pMin);
public static native @Cast("NppStatus") int nppiMin_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer pMin);
public static native @Cast("NppStatus") int nppiMin_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] pMin);

/**
 * One-channel 16-bit signed image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16s_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed minimum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer pMin);
public static native @Cast("NppStatus") int nppiMin_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer pMin);
public static native @Cast("NppStatus") int nppiMin_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] pMin);

/**
 * One-channel 32-bit floating point image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_32f_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed minimum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer pMin);
public static native @Cast("NppStatus") int nppiMin_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer pMin);
public static native @Cast("NppStatus") int nppiMin_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] pMin);

/**
 * Three-channel 8-bit unsigned image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_8u_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMin);
public static native @Cast("NppStatus") int nppiMin_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMin);

/**
 * Three-channel 16-bit unsigned image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16u_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMin);
public static native @Cast("NppStatus") int nppiMin_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMin);

/**
 * Three-channel 16-bit signed image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16s_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMin);
public static native @Cast("NppStatus") int nppiMin_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMin);

/**
 * Three-channel 32-bit floating point image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_32f_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMin);
public static native @Cast("NppStatus") int nppiMin_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMin);

/**
 * Four-channel 8-bit unsigned image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_8u_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMin);
public static native @Cast("NppStatus") int nppiMin_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMin);

/**
 * Four-channel 16-bit unsigned image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16u_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiMin_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMin);
public static native @Cast("NppStatus") int nppiMin_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMin);

/**
 * Four-channel 16-bit signed image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16s_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiMin_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMin);
public static native @Cast("NppStatus") int nppiMin_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMin);

/**
 * Four-channel 32-bit floating point image min. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_32f_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiMin_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMin);
public static native @Cast("NppStatus") int nppiMin_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMin);

/**
 * Four-channel 8-bit unsigned image min ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_8u_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMin);
public static native @Cast("NppStatus") int nppiMin_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMin);

/**
 * Four-channel 16-bit unsigned image min ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16u_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMin);
public static native @Cast("NppStatus") int nppiMin_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMin);

/**
 * Four-channel 16-bit signed image min ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_16s_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMin);
public static native @Cast("NppStatus") int nppiMin_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMin);

/**
 * Four-channel 32-bit floating point image min ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinGetBufferHostSize_32f_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the computed minimum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMin_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMin);
public static native @Cast("NppStatus") int nppiMin_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMin);
public static native @Cast("NppStatus") int nppiMin_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMin);

/** \} Min */

/** \name MinGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the min primitives.
 * \{
 */

/**
 * Buffer size for \ref nppiMin_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMin_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** \} MinGetBufferHostSize */
/** \} image_min */

/** \defgroup image_min_index MinIndx
 * Primitives for computing the minimal value and its indices (X and Y coordinates) of an image.
 * \{
 */
/** \name MinIndx
 * If there are several minima in the selected ROI, the function returns one on the top leftmost position.
 * The scratch buffer is required by the functions.
 * \{
 */
/**
 * One-channel 8-bit unsigned image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_8u_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed min result.
 * @param pIndexX Pointer to the X coordinate of the image min value.
 * @param pIndexY Ppointer to the Y coordinate of the image min value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer pMin, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer pMin, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] pMin, int[] pIndexX, int[] pIndexY);

/**
 * One-channel 16-bit unsigned image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16u_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed min result.
 * @param pIndexX Pointer to the X coordinate of the image min value.
 * @param pIndexY Pointer to the Y coordinate of the image min value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer pMin, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer pMin, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] pMin, int[] pIndexX, int[] pIndexY);

/**
 * One-channel 16-bit signed image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16s_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed min result.
 * @param pIndexX Pointer to the X coordinate of the image min value.
 * @param pIndexY Pointer to the Y coordinate of the image min value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer pMin, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer pMin, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] pMin, int[] pIndexX, int[] pIndexY);

/**
 * One-channel 32-bit floating point image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_32f_C1R to determine the minium number of bytes required.
 * @param pMin Pointer to the computed min result.
 * @param pIndexX Pointer to the X coordinate of the image min value.
 * @param pIndexY Pointer to the Y coordinate of the image min value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer pMin, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer pMin, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] pMin, int[] pIndexX, int[] pIndexY);

/**
 * Three-channel 8-bit unsigned image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_8u_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Three-channel 16-bit unsigned image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16u_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Three-channel 16-bit signed image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16s_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Three-channel 32-bit floating point image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_32f_C3R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 8-bit unsigned image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_8u_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit unsigned image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16u_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit signed image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16s_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 32-bit floating point image MinIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_32f_C4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 8-bit unsigned image MinIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_8u_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit unsigned image MinIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16u_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit signed image MinIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_16s_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMin, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 32-bit floating point image MinIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMinIndxGetBufferHostSize_32f_AC4R to determine the minium number of bytes required.
 * @param aMin Array that contains the min values.
 * @param aIndexX Array that contains the X coordinates of the image min values.
 * @param aIndexY Array that contains the Y coordinates of the image min values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinIndx_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMin, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMin, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMinIndx_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMin, int[] aIndexX, int[] aIndexY);

/** \} Min */

/** \name MinIndxGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the MinIndx primitives.
 * \{
 */
/**
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMinIndx_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinIndxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** \} MinIndxGetBufferHostSize */
/** \} image_min_index */

/** \defgroup image_max Max
 * Primitives for computing the maximal pixel value of an image.
 * \{
 */

/** \name Max
 *  The scratch buffer is required by the functions.
 * \{
 */

/**
 * One-channel 8-bit unsigned image Max.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_8u_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed maximum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer pMax);
public static native @Cast("NppStatus") int nppiMax_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer pMax);
public static native @Cast("NppStatus") int nppiMax_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] pMax);

/**
 * One-channel 16-bit unsigned image Max.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16u_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed maximum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer pMax);
public static native @Cast("NppStatus") int nppiMax_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer pMax);
public static native @Cast("NppStatus") int nppiMax_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] pMax);

/**
 * One-channel 16-bit signed image Max.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16s_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed maximum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer pMax);
public static native @Cast("NppStatus") int nppiMax_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer pMax);
public static native @Cast("NppStatus") int nppiMax_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] pMax);

/**
 * One-channel 32-bit floating point image Max.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_32f_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed maximum result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer pMax);
public static native @Cast("NppStatus") int nppiMax_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer pMax);
public static native @Cast("NppStatus") int nppiMax_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] pMax);

/**
 * Three-channel 8-bit unsigned image Max.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_8u_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMax);
public static native @Cast("NppStatus") int nppiMax_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMax);

/**
 * Three-channel 16-bit unsigned image Max.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16u_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMax);
public static native @Cast("NppStatus") int nppiMax_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMax);

/**
 * Three-channel 16-bit signed image Max.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16s_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMax);
public static native @Cast("NppStatus") int nppiMax_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMax);

/**
 * Three-channel 32-bit floating point image Max. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_32f_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMax);
public static native @Cast("NppStatus") int nppiMax_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMax);

/**
 * Four-channel 8-bit unsigned image Max. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_8u_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMax);
public static native @Cast("NppStatus") int nppiMax_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMax);

/**
 * Four-channel 16-bit unsigned image Max. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16u_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiMax_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMax);
public static native @Cast("NppStatus") int nppiMax_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMax);

/**
 * Four-channel 16-bit signed image Max. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16s_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiMax_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMax);
public static native @Cast("NppStatus") int nppiMax_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMax);

/**
 * Four-channel 32-bit floating point image Max. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_32f_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel.
 * @return \ref image_data_error_codes, \ref roi_error_codes
*/
public static native @Cast("NppStatus") int nppiMax_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMax);
public static native @Cast("NppStatus") int nppiMax_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMax);

/**
 * Four-channel 8-bit unsigned image Max ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_8u_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMax);
public static native @Cast("NppStatus") int nppiMax_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMax);

/**
 * Four-channel 16-bit unsigned image Max ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16u_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMax);
public static native @Cast("NppStatus") int nppiMax_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMax);

/**
 * Four-channel 16-bit signed image Max ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_16s_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMax);
public static native @Cast("NppStatus") int nppiMax_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMax);

/**
 * Four-channel 32-bit floating point image Max ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxGetBufferHostSize_32f_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the computed maximum results for each channel (alpha channel is not processed).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMax_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMax);
public static native @Cast("NppStatus") int nppiMax_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMax);
public static native @Cast("NppStatus") int nppiMax_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMax);
/** \} */

/** \name MaxGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the Max primitives.
 * \{
 */
/**
 * Buffer size for \ref nppiMax_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMax_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} MaxGetBufferHostSize */
/** \} image_max */

/** \defgroup image_max_index MaxIndx
 * Primitives for computing the maximal value and its indices (X and Y coordinates) of an image.
 * \{
 */
/** \name MaxIndx
 * If there are several maxima in the selected region of interest, the function returns one on the top leftmost position. 
 * The scratch buffer is required by the functions.
 * \{
 *
 */

/**
 * One-channel 8-bit unsigned image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_8u_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed max result.
 * @param pIndexX Pointer to the X coordinate of the image max value.
 * @param pIndexY Ppointer to the Y coordinate of the image max value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer pMax, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer pMax, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] pMax, int[] pIndexX, int[] pIndexY);

/**
 * One-channel 16-bit unsigned image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16u_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed max result.
 * @param pIndexX Pointer to the X coordinate of the image max value.
 * @param pIndexY Pointer to the Y coordinate of the image max value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer pMax, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer pMax, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] pMax, int[] pIndexX, int[] pIndexY);

/**
 * One-channel 16-bit signed image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16s_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed max result.
 * @param pIndexX Pointer to the X coordinate of the image max value.
 * @param pIndexY Pointer to the Y coordinate of the image max value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer pMax, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer pMax, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] pMax, int[] pIndexX, int[] pIndexY);

/**
 * One-channel 32-bit floating point image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_32f_C1R to determaxe the maxium number of bytes required.
 * @param pMax Pointer to the computed max result.
 * @param pIndexX Pointer to the X coordinate of the image max value.
 * @param pIndexY Pointer to the Y coordinate of the image max value.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer pMax, IntPointer pIndexX, IntPointer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer pMax, IntBuffer pIndexX, IntBuffer pIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] pMax, int[] pIndexX, int[] pIndexY);

/**
 * Three-channel 8-bit unsigned image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_8u_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Three-channel 16-bit unsigned image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16u_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Three-channel 16-bit signed image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16s_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Three-channel 32-bit floating point image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_32f_C3R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 8-bit unsigned image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_8u_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit unsigned image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16u_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit signed image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16s_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 32-bit floating point image MaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_32f_C4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 8-bit unsigned image MaxIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_8u_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp8u*") BytePointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp8u*") ByteBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp8u*") byte[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit unsigned image MaxIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16u_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16u*") ShortPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16u*") ShortBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16u*") short[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 16-bit signed image MaxIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_16s_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp16s*") ShortPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp16s*") ShortBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp16s*") short[] aMax, int[] aIndexX, int[] aIndexY);

/**
 * Four-channel 32-bit floating point image MaxIndx ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMaxIndxGetBufferHostSize_32f_AC4R to determaxe the maxium number of bytes required.
 * @param aMax Array that contains the max values.
 * @param aIndexX Array that contains the X coordinates of the image max values.
 * @param aIndexY Array that contains the Y coordinates of the image max values.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMaxIndx_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp32f*") FloatPointer aMax, IntPointer aIndexX, IntPointer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp32f*") FloatBuffer aMax, IntBuffer aIndexX, IntBuffer aIndexY);
public static native @Cast("NppStatus") int nppiMaxIndx_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp32f*") float[] aMax, int[] aIndexX, int[] aIndexY);

/** \} */

/** \name MaxIndxGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the MaxIndx primitives.
 * \{
 */

/**
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the dvice scratch buffer size (in bytes) for nppiMaxIndx_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaxIndxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_max_index */

/** \defgroup image_min_max MinMax
 * Primitives for computing both the minimal and the maximal values of an image.
 * \{
 */

/** \name MinMax
 * The functions require the device scratch buffer.
 * \{
 */
/**
 * One-channel 8-bit unsigned image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMin Pointer to the computed minimal result.
 * @param pMax Pointer to the computed maximal result.
 * @param pDeviceBuffer Buffer to a scratch memory. 
 *        Use \ref nppiMinMaxGetBufferHostSize_8u_C1R to determine the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pMin, @Cast("Npp8u*") BytePointer pMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pMin, @Cast("Npp8u*") ByteBuffer pMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pMin, @Cast("Npp8u*") byte[] pMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMin Pointer to the computed minimal result.
 * @param pMax Pointer to the computed maximal result.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16u_C1R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortPointer pMin, @Cast("Npp16u*") ShortPointer pMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortBuffer pMin, @Cast("Npp16u*") ShortBuffer pMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") short[] pMin, @Cast("Npp16u*") short[] pMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMin Pointer to the computed minimal result.
 * @param pMax Pointer to the computed maximal result.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16s_C1R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortPointer pMin, @Cast("Npp16s*") ShortPointer pMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortBuffer pMin, @Cast("Npp16s*") ShortBuffer pMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") short[] pMin, @Cast("Npp16s*") short[] pMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMin Pointer to the computed minimal result.
 * @param pMax Pointer to the computed maximal result.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_32f_C1R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatPointer pMin, @Cast("Npp32f*") FloatPointer pMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatBuffer pMin, @Cast("Npp32f*") FloatBuffer pMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") float[] pMin, @Cast("Npp32f*") float[] pMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_8u_C3R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer aMin, @Cast("Npp8u*") BytePointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer aMin, @Cast("Npp8u*") ByteBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] aMin, @Cast("Npp8u*") byte[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16u_C3R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortPointer aMin, @Cast("Npp16u*") ShortPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortBuffer aMin, @Cast("Npp16u*") ShortBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") short[] aMin, @Cast("Npp16u*") short[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16s_C3R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortPointer aMin, @Cast("Npp16s*") ShortPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortBuffer aMin, @Cast("Npp16s*") ShortBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") short[] aMin, @Cast("Npp16s*") short[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_32f_C3R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatPointer aMin, @Cast("Npp32f*") FloatPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatBuffer aMin, @Cast("Npp32f*") FloatBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") float[] aMin, @Cast("Npp32f*") float[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image MinMax ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_8u_AC4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer aMin, @Cast("Npp8u*") BytePointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer aMin, @Cast("Npp8u*") ByteBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] aMin, @Cast("Npp8u*") byte[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image MinMax ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16u_AC4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortPointer aMin, @Cast("Npp16u*") ShortPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortBuffer aMin, @Cast("Npp16u*") ShortBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") short[] aMin, @Cast("Npp16u*") short[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image MinMax ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16s_AC4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortPointer aMin, @Cast("Npp16s*") ShortPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortBuffer aMin, @Cast("Npp16s*") ShortBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") short[] aMin, @Cast("Npp16s*") short[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image MinMax ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_32f_AC4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatPointer aMin, @Cast("Npp32f*") FloatPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatBuffer aMin, @Cast("Npp32f*") FloatBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") float[] aMin, @Cast("Npp32f*") float[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_8u_C4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer aMin, @Cast("Npp8u*") BytePointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer aMin, @Cast("Npp8u*") ByteBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] aMin, @Cast("Npp8u*") byte[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16u_C4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortPointer aMin, @Cast("Npp16u*") ShortPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortBuffer aMin, @Cast("Npp16u*") ShortBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") short[] aMin, @Cast("Npp16u*") short[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_16s_C4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortPointer aMin, @Cast("Npp16s*") ShortPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") ShortBuffer aMin, @Cast("Npp16s*") ShortBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16s*") short[] aMin, @Cast("Npp16s*") short[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image MinMax.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aMin Array that contains the minima.
 * @param aMax Array that contains the maxima.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxGetBufferHostSize_32f_C4R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMinMax_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatPointer aMin, @Cast("Npp32f*") FloatPointer aMax, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatBuffer aMin, @Cast("Npp32f*") FloatBuffer aMax, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMax_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") float[] aMin, @Cast("Npp32f*") float[] aMax, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name MinMaxGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the MinMax primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiMinMax_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMax_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_min_max */

/** \defgroup image_min_max_index MinMaxIndx
 * Primitives for computing the minimal and the maximal values with their indices (X and Y coordinates) of an image.
 * \{
 */

/** \name MinMaxIndx
 * If there are several minima and maxima in the selected region of interest, the function returns ones on the top leftmost position.
 * The scratch buffer is required by the functions.
 * \{
 */

/**
 * Computes the minimal and the maximal pixel values with their X and Y coordinates of 1-channel 8-bit unsigned char image. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8u_C1R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes. 
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pMinValue, @Cast("Npp8u*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pMinValue, @Cast("Npp8u*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pMinValue, @Cast("Npp8u*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Computes the minimal and the maximal pixel values with their X and Y coordinates of 1-channel 8-bit signed char image. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8s_C1R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes. 
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8s*") BytePointer pMinValue, @Cast("Npp8s*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8s*") ByteBuffer pMinValue, @Cast("Npp8s*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8s*") byte[] pMinValue, @Cast("Npp8s*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Computes the minimal and the maximal pixel values with their X and Y coordinates of 1-channel 16-bit unsigned short image. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_16u_C1R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes. 
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortPointer pMinValue, @Cast("Npp16u*") ShortPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortBuffer pMinValue, @Cast("Npp16u*") ShortBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") short[] pMinValue, @Cast("Npp16u*") short[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Computes the minimal and the maximal pixel values with their X and Y coordinates of 1-channel 32-bit floating point image. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_32f_C1R to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatPointer pMinValue, @Cast("Npp32f*") FloatPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatBuffer pMinValue, @Cast("Npp32f*") FloatBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") float[] pMinValue, @Cast("Npp32f*") float[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked MinMaxIndx
 * See \ref masked_operation.
 * \{
 */

/**
 * Masked one-channel 8-bit unsigned image MinMaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8u_C1MR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes. 
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pMinValue, @Cast("Npp8u*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pMinValue, @Cast("Npp8u*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pMinValue, @Cast("Npp8u*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image MinMaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8s_C1MR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes. 
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8s*") BytePointer pMinValue, @Cast("Npp8s*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8s*") ByteBuffer pMinValue, @Cast("Npp8s*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8s*") byte[] pMinValue, @Cast("Npp8s*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image MinMaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_16u_C1MR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes. 
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortPointer pMinValue, @Cast("Npp16u*") ShortPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") ShortBuffer pMinValue, @Cast("Npp16u*") ShortBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C1MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp16u*") short[] pMinValue, @Cast("Npp16u*") short[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image MinMaxIndx.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_32f_C1MR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified.
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatPointer pMinValue, @Cast("Npp32f*") FloatPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") FloatBuffer pMinValue, @Cast("Npp32f*") FloatBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C1MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp32f*") float[] pMinValue, @Cast("Npp32f*") float[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Channel MinMaxIndx
 * See \ref channel_of_interest.
 * \{
 */

/**
 * Three-channel 8-bit unsigned image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8u_C3CR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C3CR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pMinValue, @Cast("Npp8u*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C3CR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pMinValue, @Cast("Npp8u*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C3CR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pMinValue, @Cast("Npp8u*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8s_C3CR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C3CR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8s*") BytePointer pMinValue, @Cast("Npp8s*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C3CR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8s*") ByteBuffer pMinValue, @Cast("Npp8s*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C3CR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8s*") byte[] pMinValue, @Cast("Npp8s*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_16u_C3CR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C3CR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp16u*") ShortPointer pMinValue, @Cast("Npp16u*") ShortPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C3CR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp16u*") ShortBuffer pMinValue, @Cast("Npp16u*") ShortBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C3CR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp16u*") short[] pMinValue, @Cast("Npp16u*") short[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_32f_C3CR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C3CR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp32f*") FloatPointer pMinValue, @Cast("Npp32f*") FloatPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C3CR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp32f*") FloatBuffer pMinValue, @Cast("Npp32f*") FloatBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C3CR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp32f*") float[] pMinValue, @Cast("Npp32f*") float[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Channel MinMaxIndx
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */

/**
 * Masked three-channel 8-bit unsigned image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8u_C3CMR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pMinValue, @Cast("Npp8u*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pMinValue, @Cast("Npp8u*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pMinValue, @Cast("Npp8u*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_8s_C3CMR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8s*") BytePointer pMinValue, @Cast("Npp8s*") BytePointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8s*") ByteBuffer pMinValue, @Cast("Npp8s*") ByteBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8s*") byte[] pMinValue, @Cast("Npp8s*") byte[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_16u_C3CMR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp16u*") ShortPointer pMinValue, @Cast("Npp16u*") ShortPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp16u*") ShortBuffer pMinValue, @Cast("Npp16u*") ShortBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp16u*") short[] pMinValue, @Cast("Npp16u*") short[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image MinMaxIndx affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pMinValue Pointer to the minimum value.
 * @param pMaxValue Pointer to the maximum value.
 * @param pMinIndex Pointer to the indicies (X and Y coordinates) of the minimum value.
 * @param pMaxIndex Pointer to the indicies (X and Y coordinates) of the maximum value.
 * @param pDeviceBuffer Buffer to a scratch memory. Use \ref nppiMinMaxIndxGetBufferHostSize_32f_C3CMR to determine
 *          the minium number of bytes required.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified, or NPP_COI_ERROR if an invalid channel of interest is specified.
 * If the mask is filled with zeros, then all the returned values are zeros, i.e., pMinIndex = {0, 0}, pMaxIndex = {0, 0},
 * pMinValue = 0, pMaxValue = 0.
 * If any of pMinValue, pMaxValue, pMinIndex, or pMaxIndex is not needed, zero pointer must be passed correspondingly.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp32f*") FloatPointer pMinValue, @Cast("Npp32f*") FloatPointer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp32f*") FloatBuffer pMinValue, @Cast("Npp32f*") FloatBuffer pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMinMaxIndx_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp32f*") float[] pMinValue, @Cast("Npp32f*") float[] pMaxValue, NppiPoint pMinIndex, NppiPoint pMaxIndex, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name MinMaxIndxGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the MinMaxIndx primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiMinMaxIndx_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_8s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_8u_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_8s_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_16u_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_32f_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMinMaxIndx_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMinMaxIndxGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_min_max_index */

/** \defgroup image_mean Mean
 * Primitives for computing the arithmetic mean of all the pixel values in an image.
 * \{
 */

/** \name Mean
 * Given an image \f$pSrc\f$ with width \f$W\f$ and height \f$H\f$, the arithmetic mean
 * will be computed as
 * \f[Mean = \frac{1}{W\cdot H}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}pSrc(j,i)\f]
 * The mean functions require additional scratch buffer for computations.
 * \{
 */
/**
 * One-channel 8-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8u_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * One-channel 16-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16u_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * One-channel 16-bit signed image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16s_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * One-channel 32-bit floating point image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_32f_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified.
 */
public static native @Cast("NppStatus") int nppiMean_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * Three-channel 8-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8u_C3R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Three-channel 16-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16u_C3R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Three-channel 16-bit signed image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16s_C3R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Three-channel 32-bit floating point image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_32f_C3R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified.
 */
public static native @Cast("NppStatus") int nppiMean_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 8-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8u_C4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 16-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16u_C4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 16-bit signed image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16s_C4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 32-bit floating point image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_32f_C4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified.
 */
public static native @Cast("NppStatus") int nppiMean_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 8-bit unsigned image Mean ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8u_AC4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 16-bit unsigned image Mean ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16u_AC4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 16-bit signed image Mean ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16s_AC4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/**
 * Four-channel 32-bit floating point image Mean ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_32f_AC4R to determine the minium number of bytes required.
 * @param aMean Array that contains the computed mean results.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified.
 */
public static native @Cast("NppStatus") int nppiMean_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer aMean);
public static native @Cast("NppStatus") int nppiMean_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer aMean);
public static native @Cast("NppStatus") int nppiMean_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] aMean);

/** \} */

/** \name Masked Mean
 * See \ref masked_operation.
 * \{
 */
/**
 * Masked one-channel 8-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8u_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMean_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * Masked one-channel 8-bit signed image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8s_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMean_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * Masked one-channel 16-bit unsigned image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16u_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMean_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_16u_C1MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * Masked one-channel 32-bit floating point image Mean.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_32f_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified.
 */
public static native @Cast("NppStatus") int nppiMean_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_32f_C1MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);
/** \} */

/** \name Masked Channel Mean
 * See \ref channel_of_interest and \ref masked_operation.
 * \{
 */
/**
 * Masked three-channel 8-bit unsigned image Mean affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8u_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * Masked three-channel 8-bit signed image Mean affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_8s_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * Masked three-channel 16-bit unsigned image Mean affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_16u_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);

/**
 * Masked three-channel 32-bit floating point image Mean affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanGetBufferHostSize_32f_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean result.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean);
public static native @Cast("NppStatus") int nppiMean_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean);
public static native @Cast("NppStatus") int nppiMean_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean);
/** \} */

/** \name MeanGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the Mean primitives.
 * \{
 */
/**
 * Buffer size for \ref nppiMean_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/**
 * Buffer size for \ref nppiMean_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/**
 * Buffer size for \ref nppiMean_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
 
/** 
 * Buffer size for \ref nppiMean_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_mean */

/** \defgroup image_mean_stddev Mean_StdDev
 * Primitives for computing both the arithmetic mean and the standard deviation of an image.
 * \{
 */

/** \name Mean_StdDev
 * Given an image \f$pSrc\f$ with width \f$W\f$ and height \f$H\f$, the mean and the standard deviation
 * will be computed as
 * \f[Mean = \frac{1}{W\cdot H}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}pSrc(j,i)\f]
 * \f[StdDev = \sqrt{\frac{1}{W\cdot H}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}(pSrc(j,i)-Mean)^2}\f]
 * The Mean_StdDev primitives require additional scratch buffer for computations.
 * \{
 */

/**
 * One-channel 8-bit unsigned image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8u_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * One-channel 8-bit signed image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8s_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * One-channel 16-bit unsigned image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_16u_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * One-channel 32-bit floating point image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_32f_C1R to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );
/** \} */

/** \name Masked Mean_StdDev
 * See \ref masked_operation.
 * \{
 */

/**
 * Masked one-channel 8-bit unsigned image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8u_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Masked one-channel 8-bit signed image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8s_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Masked one-channel 16-bit unsigned image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_16u_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C1MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Masked one-channel 32-bit floating point image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_32f_C1MR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C1MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );
/** \} */

 /** \name Channel Mean_StdDev
 * See \ref channel_of_interest.
 * \{
 */
 
/**
 * Three-channel 8-bit unsigned image Mean_StdDev affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8u_C3CR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C3CR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C3CR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C3CR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Three-channel 8-bit signed image Mean_StdDev affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8s_C3CR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C3CR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C3CR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C3CR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Three-channel 16-bit unsigned image Mean_StdDev affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_16u_C3CR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C3CR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C3CR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C3CR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Three-channel 32-bit floating point image Mean_StdDev affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_32f_C3CR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C3CR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C3CR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C3CR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );
 /** \} */
 
 /** \name Masked Channel Mean_StdDev
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */

/**
 * Masked three-channel 8-bit unsigned image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8u_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Masked three-channel 8-bit signed image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_8s_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Masked three-channel 16-bit unsigned image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_16u_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );

/**
 * Masked three-channel 32-bit floating point image Mean_StdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer
 *        Use \ref nppiMeanStdDevGetBufferHostSize_32f_C3CMR to determine the minium number of bytes required.
 * @param pMean Pointer to the computed mean.
 * @param pStdDev Pointer to the computed standard deviation.
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") BytePointer pDeviceBuffer, @Cast("Npp64f*") DoublePointer pMean, @Cast("Npp64f*") DoublePointer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") ByteBuffer pDeviceBuffer, @Cast("Npp64f*") DoubleBuffer pMean, @Cast("Npp64f*") DoubleBuffer pStdDev );
public static native @Cast("NppStatus") int nppiMean_StdDev_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp8u*") byte[] pDeviceBuffer, @Cast("Npp64f*") double[] pMean, @Cast("Npp64f*") double[] pStdDev );
/** \} */

/** \name MeanStdDevGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the Mean_StdDev primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiMean_StdDev_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_8s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_8u_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_8s_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_16u_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_32f_C3CR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C3CR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C3CR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C3CR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMean_StdDev_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMeanStdDevGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_mean_stddev */

/** \defgroup image_norm Image Norms
 *
 * Primitives for computing the norms of an image, the norms of difference, and the relative errors of two images.
 * Given an image \f$pSrc\f$ with width \f$W\f$ and height \f$H\f$, 
 * -# The infinity norm (Norm_Inf) is defined as the largest absolute pixel value of the image.
 * -# The L1 norm (Norm_L1) is defined as the sum of the absolute pixel value of the image, i.e., \f[Norm\_L1 = \sum_{j=0}^{H-1}\sum_{i=0}^{W-1}\left| pSrc(j,i)\right|\f].
 * -# The L2 norm (Norm_L2) is defined as the square root of the sum of the squared absolute pixel value of the image, i.e.,\f[Norm\_L2 = \sqrt{\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}\left| pSrc(j,i)\right| ^2}\f].
 * 
 * Given two images \f$pSrc1\f$ and \f$pSrc2\f$ both with width \f$W\f$ and height \f$H\f$, 
 * -# The infinity norm of differece (NormDiff_Inf) is defined as the largest absolute difference between pixels of two images.
 * -# The L1 norm of differece (NormDiff_L1) is defined as the sum of the absolute difference between pixels of two images, i.e., \f[NormDiff\_L1 = \sum_{j=0}^{H-1}\sum_{i=0}^{W-1}\left| pSrc1(j,i)-pSrc2(j,i)\right|\f].
 * -# The L2 norm of differece (NormDiff_L2) is defined as the squared root of the sum of the squared absolute difference between pixels of two images, i.e.,\f[NormDiff\_L2 = \sqrt{\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}\left| pSrc1(j,i)-pSrc2(j,i)\right| ^2}\f].
 * 
 * Given two images \f$pSrc1\f$ and \f$pSrc2\f$ both with width \f$W\f$ and height \f$H\f$, 
 * -# The relative error for the infinity norm of differece (NormRel_Inf) is defined as NormDiff_Inf divided by the infinity norm of the second image, i.e., \f[NormRel\_Inf = \frac{NormDiff\_Inf}{Norm\_Inf_{src2}}\f]
 * -# The relative error for the L1 norm of differece (NormRel_L1) is defined as NormDiff_L1 divided by the L1 norm of the second image, i.e., \f[NormRel\_L1 = \frac{NormDiff\_L1}{Norm\_L1_{src2}}\f]
 * -# The relative error for the L2 norm of differece (NormRel_L2) is defined as NormDiff_L2 divided by the L2 norm of the second image, i.e., \f[NormRel\_L2 = \frac{NormDiff\_L2}{Norm\_L2_{src2}}\f]
 * 
 * The norm functions require the addition device scratch buffer for the computations.
 * 
 * \{
 *
 */ 

/** \defgroup image_inf_norm Norm_Inf
 * Primitives for computing the infinity norm of an image. 
 * \{
 */

/** \name Basic Norm_Inf
 * \{
 */

/**
 * One-channel 8-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_32s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Norm_Inf ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Norm_Inf ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Norm_Inf ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Norm_Inf ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Norm_Inf
 * See \ref masked_operation.
 * \{
 */

/**
 * Masked one-channel 8-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C1MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image Norm_Inf.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C1MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Channel Norm_Inf
 * See \ref channel_of_interest and \ref masked_operation.
 * \{
 */

/**
 * Masked three-channel 8-bit unsigned image Norm_Inf affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image Norm_Inf affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image Norm_Inf affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image Norm_Inf affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormInfGetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an invalid 
 * floating-point image is specified, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_Inf_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name NormInfGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the Norm_Inf primitives.
 * \{
 */

/** Buffer size for \ref nppiNorm_Inf_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_32s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_Inf_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_inf_norm */


/** \defgroup image_L1_norm Norm_L1
 * Primitives for computing the L1 norm of an image. 
 * \{
 */
/** \name Basic Norm_L1
 * \{
 */ 
/**
 * One-channel 8-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Norm_L1 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Norm_L1 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Norm_L1 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Norm_L1 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Norm_L1
 * See \ref masked_operation.
 * \{
 */
/**
 * Masked one-channel 8-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C1MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image Norm_L1.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C1MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Channel Norm_L1
 * See \ref channel_of_interest and \ref masked_operation.
 * \{
 */
/**
 * Masked three-channel 8-bit unsigned image Norm_L1 affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image Norm_L1 affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image Norm_L1 affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image Norm_L1 affecting only single channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL1GetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if the step of 
 * the source image cannot be divided by 4, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L1_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
 /** \} */
 
 /** \name NormL1GetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the Norm_L1 primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiNorm_L1_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L1_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \}  */
/** \} image_L1_norm */

/** \defgroup image_L2_norm Norm_L2
 * Primitives for computing the L2 norm of an image. 
 * \{
 */
/** \name Basic Norm_L2
 * Computes the L2 norm of an image. 
 * \{
 */
/**
 * One-channel 8-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Norm_L2 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Norm_L2 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Norm_L2 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Norm_L2 ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Three-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNorm Array that contains the norm values of Four-channels.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiNormL2GetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Norm_L2
 * See \ref masked_operation.
 * \{
 */
 
/**
 * Masked one-channel 8-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C1MR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if the step 
 * of the source image cannot be divided by 4. 
 */
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C1MR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Channel Norm_L2
 * See \ref channel_of_interest and \ref masked_operation.
 * \{
 */
 /**
 * Masked three-channel 8-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiNormL2GetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiNormL2GetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 *        Use \ref nppiNormL2GetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image Norm_L2.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNorm Pointer to the norm value.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormL2GetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if the step 
 * of the source image cannot be divided by 4, or NPP_COI_ERROR if an invalid channel of interest is specified.
 */
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp8u*") BytePointer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNorm, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNorm, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNorm_L2_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp8u*") byte[] pMask, int nMaskStep, @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNorm, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name NormL2GetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the Norm_L2 primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiNorm_L2_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNorm_L2_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_L2_norm */

/** \defgroup image_inf_normdiff NormDiff_Inf
 * Primitives for computing the infinity norm of difference of pixels between two images.
 * \{
 */

/** \name Basic NormDiff_Inf
 * \{
 */
/**
 * One-channel 8-bit unsigned image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormDiff_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormDiff_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormDiff_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormDiff_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name Masked NormDiff_Inf
 * See \ref masked_operation.
 * \{
 */
/**
 * Masked one-channel 8-bit unsigned images NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed images NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned images NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C1MR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point images NormDiff_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C1MR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */
 
/** \name Masked Channel Mean
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */
/**
 * Masked three-channel 8-bit unsigned image NormDiff_Inf affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image NormDiff_Inf affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image NormDiff_Inf affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                     @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                     @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                     @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                     @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                     @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                     @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                     @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                     @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                     @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image NormDiff_Inf affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffInfGetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel 
 * of interest is specified, or NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                     @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                     @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                     @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                     @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                     @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                     @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_Inf_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                     @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                     @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                     @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */
 
/** \name NormDiffInfGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormDiff_Inf primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiNormDiff_Inf_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiNormDiff_Inf_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_inf_normdiff */

/** \defgroup image_L1_normdiff NormDiff_L1
 * Primitives for computing the L1 norm of difference of pixels between two images.
 * \{
 */

/** \name Basic NormDiff_L1
 * \{
 */
/**
 * One-channel 8-bit unsigned image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormDiff_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormDiff_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormDiff_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormDiff_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked NormDiff_L1
 * See \ref masked_operation.
 * \{
 */
/**
 * Masked one-channel 8-bit unsigned image NormDiff_L1.
 * 
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C1MR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image NormDiff_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C1MR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);
 /** \} */
 
 /** \name Masked Channel NormDiff_L1
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */

/**
 * Masked three-channel 8-bit unsigned image NormDiff_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image NormDiff_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image NormDiff_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image NormDiff_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL1GetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel 
 * of interest is specified, or NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L1_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);
 /** \} */
 
 /** \name NormDiffL1GetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormDiff_L1 primitives.
 * \{
 */
/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L1_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_L1_normdiff */

/** \defgroup image_L2_normdiff NormDiff_L2
 * Primitives for computing the L2 norm of difference of pixels between two images.
 * \{
 */
/** \name Basic NormDiff_L2
 * \{
 */
/**
 * One-channel 8-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormDiff_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormDiff_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormDiff_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormDiff_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormDiff Array that contains computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name Masked NormDiff_L2
 * See \ref masked_operation.
 * \{
 */
/**
 * Masked one-channel 8-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C1MR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image NormDiff_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C1MR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */
 
/** \name Masked Channel NormDiff_L2
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */
/**
 * Masked three-channel 8-bit unsigned image NormDiff_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image NormDiff_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image NormDiff_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel of interest is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image NormDiff_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormDiff Pointer to the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormDiffL2GetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel 
 * of interest is specified, or NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormDiff, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormDiff, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormDiff_L2_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormDiff, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name NormDiffL2GetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormDiff_L2 primitives.
 * \{
 */
/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormDiff_L2_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormDiffL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize); 
/** \} */
/** \} image_L2_normdiff */

/** \defgroup image_inf_normrel NormRel_Inf
 * Primitives for computing the relative error of infinity norm between two images.
 * \{
 */
/** \name Basic NormRel_Inf
 * \{
 */
/**
 * One-channel 8-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormRel_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormRel_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormRel_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormRel_Inf ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name Masked NormRel_Inf
 * See \ref masked_operation.
 * \{
 */
/**
 * Masked one-channel 8-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C1MR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image NormRel_Inf.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C1MR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);
 
/** \} */

/** \name Masked Channel NormRel_Inf
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */
/**
 * Masked three-channel 8-bit unsigned image NormRel_Inf affecting only signle channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_COI_ERROR if an 
 * invalid channel of interest is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image NormRel_Inf affecting only signle channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_COI_ERROR if an invalid 
 * channel of interest is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image NormRel_Inf affecting only signle channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_COI_ERROR if an invalid 
 * channel of interest is specified, or NPP_DIVISOR_ERROR if the infinity
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image NormRel_Inf affecting only signle channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the infinity norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelInfGetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_COI_ERROR if an invalid channel 
 * of interest is specified, or NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point 
 * image is specified, or NPP_DIVISOR_ERROR if the infinity norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_Inf_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name NormRelInfGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormRel_Inf primitives.
 * \{
 */
/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_32s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */


/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_Inf_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelInfGetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */

/** \} image_inf_normrel */

/** \defgroup image_L1_normrel NormRel_L1
 * Primitives for computing the relative error of L1 norm between two images.
 * \{
 */

/** \name Basic NormRel_L1
 * \{
 */
/**
 * One-channel 8-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image NormRel_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormRel_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormRel_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormRel_L1 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name Masked NormRel_L1
 * See \ref masked_operation.
 * \{
 */
/**
 * One-channel 8-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                 @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                 @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C1MR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image NormRel_L1.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L1
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C1MR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name Masked Channel NormRel_L1
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */
/**
 * Masked three-channel 8-bit unsigned image NormRel_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid 
 * channel of interest is specified, or NPP_DIVISOR_ERROR if the L1 norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image NormRel_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid 
 * channel of interest is specified, or NPP_DIVISOR_ERROR if the L1 norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image NormRel_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid 
 * channel of interest is specified, or NPP_DIVISOR_ERROR if the L1 norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image NormRel_L1 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L1 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL1GetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid channel 
 * of interest is specified, NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified, 
 * or NPP_DIVISOR_ERROR if the L1 norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L1_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name NormRelL1GetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormRel_L1 primitives.
 * \{
 */
/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L1_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL1GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */

/** \} image_L1_normrel */

/** \defgroup image_L2_normrel NormRel_L2
 * Primitives for computing the relative error of L2 norm between two images.
 * \{
 */

/** \name Basic NormRel_L2
 * \{
 */
/**
 * One-channel 8-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormRel_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormRel_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormRel_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16s_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormRel_L2 ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aNormRel Array that contains the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name Masked NormRel_L2
 * See \ref masked_operation.
 * \{
 */
/**
 * Masked one-channel 8-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C1MR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C1MR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C1MR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 8-bit signed image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8s_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8s_C1MR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8s_C1MR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8s_C1MR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 16-bit unsigned image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16u_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C1MR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C1MR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C1MR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked one-channel 32-bit floating point image NormRel_L2.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_32f_C1MR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_NOT_EVEN_STEP_ERROR if 
 * an invalid floating-point image is specified, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C1MR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C1MR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C1MR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer); 
 
 /** \} */

 /** \name Masked Channel NormRel_L2
 * See \ref masked_operation and \ref channel_of_interest.
 * \{
 */
/**
 * Masked three-channel 8-bit unsigned image NormRel_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid 
 * channel of interest is specified, or NPP_DIVISOR_ERROR if the L2 norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C3CMR(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C3CMR(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8u_C3CMR(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 8-bit signed image NormRel_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_8s_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_COI_ERROR if an invalid 
 * channel of interest is specified, or NPP_DIVISOR_ERROR if the L2 norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_8s_C3CMR(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8s_C3CMR(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_8s_C3CMR(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 16-bit unsigned image NormRel_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_16u_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_COI_ERROR if an 
 * invalid channel of interest is specified, or NPP_DIVISOR_ERROR if the L2
 * norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C3CMR(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C3CMR(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_16u_C3CMR(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                    @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                    @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                    @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Masked three-channel 32-bit floating point image NormRel_L2 affecting only single channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param pMask \ref mask_image_pointer.
 * @param nMaskStep \ref mask_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param nCOI \ref channel_of_interest_number.
 * @param pNormRel Pointer to the computed relative error for the L2 norm of two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiNormRelL2GetBufferHostSize_32f_C3CMR to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, NPP_COI_ERROR if an invalid channel 
 * of interest is specified, or NPP_NOT_EVEN_STEP_ERROR if an invalid floating-point image is specified, 
 * or NPP_DIVISOR_ERROR if the L2 norm of the second image is zero.
*/
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C3CMR(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") BytePointer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoublePointer pNormRel, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C3CMR(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") ByteBuffer pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") DoubleBuffer pNormRel, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiNormRel_L2_32f_C3CMR(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @Cast("const Npp8u*") byte[] pMask, int nMaskStep,
                                   @ByVal NppiSize oSizeROI, int nCOI, @Cast("Npp64f*") double[] pNormRel, @Cast("Npp8u*") byte[] pDeviceBuffer);

 /** \} */

/** \name NormRelL2GetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormRel_L2 primitives.
 * \{
 */
/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8s_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8s_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16u_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_32f_C1MR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C1MR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16s_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_8s_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_8s_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_16u_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_16u_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Computes the device scratch buffer size (in bytes) for nppiNormRel_L2_32f_C3CMR.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiNormRelL2GetBufferHostSize_32f_C3CMR(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_L2_normrel */
/** \} image_norm */

/** \defgroup image_dot_prod DotProd
 * Primitives for computing the dot product of two images.
 * \{
 *
 */

/** \name DotProd
 * Given two images \f$pSrc1\f$ and \f$pSrc2\f$ both with width \f$W\f$ and height \f$H\f$, 
 * the dot product will be computed as
 * \f[DotProd = \sum_{j=0}^{H-1}\sum_{i=0}^{W-1}[pSrc1(j,i)\cdot pSrc2(j,i)]\f]
 * The functions require additional scratch buffer for computations.
 * \{
 */
/**
 * One-channel 8-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDp Pointer to the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8u64f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDp Pointer to the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8s64f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDp Pointer to the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16u64f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDp Pointer to the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16s64f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDp Pointer to the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32u64f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C1R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C1R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C1R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDp Pointer to the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32s64f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pDp Pointer to the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32f64f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8u64f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8s64f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C3R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C3R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16u64f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16s64f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32u64f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C3R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C3R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C3R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32s64f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32f64f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8u64f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8s64f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_C4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16u64f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16s64f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit unsigned image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32u64f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C4R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C4R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_C4R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32s64f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image DotProd.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32f64f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image DotProd ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8u64f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8u64f_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8u64f_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image DotProd ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_8s64f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_8s64f_AC4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_8s64f_AC4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image DotProd ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed Inf-norm of differences. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16u64f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16u64f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16u64f_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image DotProd ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_16s64f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_16s64f_AC4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_16s64f_AC4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit unsigned image DotProd ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32u64f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32u64f_AC4R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_AC4R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32u64f_AC4R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                 @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                 @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed image DotProd ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32s64f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32s64f_AC4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_AC4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32s64f_AC4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image DotProd ignoring alpha channel.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aDp Array that contains the computed dot product of the two images. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiDotProdGetBufferHostSize_32f64f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiDotProd_32f64f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer aDp, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer aDp, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiDotProd_32f64f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] aDp, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name DotProdGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the Mean_StdDev primitives.
 * \{
 */ 
/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8u64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8s64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16u64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16s64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32u64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32s64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32f64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8u64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8s64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16u64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16s64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32u64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32s64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32f64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8u64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8s64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16u64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16s64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32u64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32s64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32f64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8u64f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8u64f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_8s64f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_8s64f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16u64f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16u64f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_16s64f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_16s64f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32u64f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32u64f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32s64f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32s64f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiDotProd_32f64f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiDotProdGetBufferHostSize_32f64f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_dot_prod */

/** \defgroup image_count_in_range CountInRange.
 * Primitives for computing the amount of pixels that fall into the specified intensity range.
 * \{
 *
 */

/** \name CountInRange
 * The lower bound and the upper bound are inclusive. The functions require additional
 * scratch buffer for computations. 
 * \{
 *
 */

/**
 * One-channel 8-bit unsigned image CountInRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pCounts Pointer to the number of pixels that fall into the specified range.
 * @param nLowerBound Lower bound of the specified range.
 * @param nUpperBound Upper bound of the specified range.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiCountInRangeGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_RANGE_ERROR if the lower bound
 * is larger than the upper bound.
*/
public static native @Cast("NppStatus") int nppiCountInRange_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                  IntPointer pCounts, @Cast("Npp8u") byte nLowerBound, @Cast("Npp8u") byte nUpperBound, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                  IntBuffer pCounts, @Cast("Npp8u") byte nLowerBound, @Cast("Npp8u") byte nUpperBound, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                  int[] pCounts, @Cast("Npp8u") byte nLowerBound, @Cast("Npp8u") byte nUpperBound, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image CountInRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pCounts Pointer to the number of pixels that fall into the specified range.
 * @param nLowerBound Lower bound of the specified range.
 * @param nUpperBound Upper bound of the specified range.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiCountInRangeGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_RANGE_ERROR if the lower bound
 * is larger than the upper bound.
*/
public static native @Cast("NppStatus") int nppiCountInRange_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   IntPointer pCounts, @Cast("Npp32f") float nLowerBound, @Cast("Npp32f") float nUpperBound, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   IntBuffer pCounts, @Cast("Npp32f") float nLowerBound, @Cast("Npp32f") float nUpperBound, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   int[] pCounts, @Cast("Npp32f") float nLowerBound, @Cast("Npp32f") float nUpperBound, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image CountInRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCounts Array that contains the number of pixels that fall into the specified range for Three-channels.
 * @param aLowerBound Fixed size array of the lower bound of the specified range, one per channel.
 * @param aUpperBound Fixed size array of the upper bound of the specified range, one per channel.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiCountInRangeGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_RANGE_ERROR if the lower bound
 * is larger than the upper bound.
*/
public static native @Cast("NppStatus") int nppiCountInRange_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                  IntPointer aCounts, @Cast("Npp8u*") BytePointer aLowerBound, @Cast("Npp8u*") BytePointer aUpperBound, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                  IntBuffer aCounts, @Cast("Npp8u*") ByteBuffer aLowerBound, @Cast("Npp8u*") ByteBuffer aUpperBound, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                  int[] aCounts, @Cast("Npp8u*") byte[] aLowerBound, @Cast("Npp8u*") byte[] aUpperBound, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image CountInRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCounts Array that contains the number of pixels that fall into the specified range for Three-channels.
 * @param aLowerBound Fixed size array of the lower bound of the specified range, one per channel.
 * @param aUpperBound Fixed size array of the upper bound of the specified range, one per channel.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiCountInRangeGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_RANGE_ERROR if the lower bound
 * is larger than the upper bound.
*/
public static native @Cast("NppStatus") int nppiCountInRange_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   IntPointer aCounts, @Cast("Npp32f*") FloatPointer aLowerBound, @Cast("Npp32f*") FloatPointer aUpperBound, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   IntBuffer aCounts, @Cast("Npp32f*") FloatBuffer aLowerBound, @Cast("Npp32f*") FloatBuffer aUpperBound, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   int[] aCounts, @Cast("Npp32f*") float[] aLowerBound, @Cast("Npp32f*") float[] aUpperBound, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CountInRange ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCounts Array that contains the number of pixels that fall into the specified range for Three-channels.
 * @param aLowerBound Fixed size array of the lower bound of the specified range, one per channel.
 * @param aUpperBound Fixed size array of the upper bound of the specified range, one per channel.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiCountInRangeGetBufferHostSize_8u_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_RANGE_ERROR if the lower bound
 * is larger than the upper bound.
*/
public static native @Cast("NppStatus") int nppiCountInRange_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   IntPointer aCounts, @Cast("Npp8u*") BytePointer aLowerBound, @Cast("Npp8u*") BytePointer aUpperBound, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   IntBuffer aCounts, @Cast("Npp8u*") ByteBuffer aLowerBound, @Cast("Npp8u*") ByteBuffer aUpperBound, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                   int[] aCounts, @Cast("Npp8u*") byte[] aLowerBound, @Cast("Npp8u*") byte[] aUpperBound, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image CountInRange ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param aCounts Array that contains the number of pixels that fall into the specified range for Three-channels.
 * @param aLowerBound Fixed size array of the lower bound of the specified range, one per channel.
 * @param aUpperBound Fixed size array of the upper bound of the specified range, one per channel.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiCountInRangeGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_RANGE_ERROR if the lower bound
 * is larger than the upper bound.
*/
public static native @Cast("NppStatus") int nppiCountInRange_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                    IntPointer aCounts, @Cast("Npp32f*") FloatPointer aLowerBound, @Cast("Npp32f*") FloatPointer aUpperBound, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                    IntBuffer aCounts, @Cast("Npp32f*") FloatBuffer aLowerBound, @Cast("Npp32f*") FloatBuffer aUpperBound, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCountInRange_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                    int[] aCounts, @Cast("Npp32f*") float[] aLowerBound, @Cast("Npp32f*") float[] aUpperBound, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */
 
 /** \name CountInRangeGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the CountInRange primitives.
 * \{
 */

/** 
 * Device scratch buffer size (in bytes) for nppiCountInRange_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiCountInRange_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiCountInRange_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiCountInRange_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiCountInRange_8u_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Device scratch buffer size (in bytes) for nppiCountInRange_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiCountInRangeGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} image_count_in_range */

/** \defgroup image_maxevery MaxEvery
 * Primitives for computing the maximal value of the pixel pair from two images.
 * \{
 *
 */

/** \name MaxEvery
 * The maximum is stored into the second image.
 * \{
 *
 */
/**
 * One-channel 8-bit unsigned image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C1IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C1IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * One-channel 16-bit unsigned image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C1IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C1IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * One-channel 16-bit signed image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C1IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C1IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C1IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * One-channel 32-bit floating point image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C1IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 8-bit unsigned image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C3IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C3IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C3IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 16-bit unsigned image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C3IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C3IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C3IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 16-bit signed image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C3IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C3IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C3IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 32-bit floating point image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C3IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C3IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C3IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C4IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C4IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_C4IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C4IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C4IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_C4IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit signed image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C4IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C4IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_C4IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating point image MaxEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C4IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C4IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_C4IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned image MaxEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_8u_AC4IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_8u_AC4IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned image MaxEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16u_AC4IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16u_AC4IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit signed image MaxEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_16s_AC4IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_AC4IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_16s_AC4IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating point image MaxEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaxEvery_32f_AC4IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMaxEvery_32f_AC4IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
/** \} */
/** \} image_maxevery*/

/** \defgroup image_minevery MinEvery
 * Primitives for computing the minimal value of the pixel pair from two images.
 * \{
 *
 */

/** \name MinEvery
 * The minimum is stored into the second image.
 * \{
 *
 */
/**
 * One-channel 8-bit unsigned image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_8u_C1IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_C1IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_C1IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * One-channel 16-bit unsigned image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16u_C1IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_C1IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_C1IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * One-channel 16-bit signed image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16s_C1IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_C1IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_C1IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * One-channel 32-bit floating point image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_32f_C1IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_C1IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_C1IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 8-bit unsigned image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_8u_C3IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_C3IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_C3IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 16-bit unsigned image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16u_C3IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_C3IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_C3IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 16-bit signed image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16s_C3IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_C3IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_C3IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Three-channel 32-bit floating point image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_32f_C3IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_C3IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_C3IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_8u_C4IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_C4IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_C4IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16u_C4IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_C4IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_C4IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit signed image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16s_C4IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_C4IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_C4IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating point image MinEvery.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_32f_C4IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_C4IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_C4IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 8-bit unsigned image MinEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_8u_AC4IR(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_AC4IR(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_8u_AC4IR(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit unsigned image MinEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16u_AC4IR(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_AC4IR(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16u_AC4IR(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 16-bit signed image MinEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_16s_AC4IR(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_AC4IR(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_16s_AC4IR(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);

/**
 * Four-channel 32-bit floating point image MinEvery ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMinEvery_32f_AC4IR(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_AC4IR(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMinEvery_32f_AC4IR(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, @ByVal NppiSize oSizeROI);
/** \} */
/** \} image_minevery */

/** \defgroup image_integral Integral
 * Primitives for computing the integral image of a given image.
 * \{
 *
 */
                                  
/** \name Integral
 * Given an input image \f$pSrc\f$ and the specified value \f$nVal\f$, 
 * the pixel value of the integral image \f$pDst\f$ at coordinate 
 * (i, j) will be computed as
 * \f[pDst(j,i) = nVal + \sum_{l=0}^{j-1}\sum_{k=0}^{i-1}pSrc(l,k)\f]
 * If the size of the input image is \f$W \times H\f$, the size of 
 * the integral image will be \f$(W+1) \times (H+1)\f$.
 */

/**
 * One-channel 8-bit unsigned image Integral with 32-bit signed output.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nVal The value to add to pDst image pixels
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiIntegral_8u32s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                             @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                             @ByVal NppiSize oROI, @Cast("Npp32s") int nVal);
public static native @Cast("NppStatus") int nppiIntegral_8u32s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                             @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                             @ByVal NppiSize oROI, @Cast("Npp32s") int nVal);
public static native @Cast("NppStatus") int nppiIntegral_8u32s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                             @Cast("Npp32s*") int[] pDst, int nDstStep, 
                             @ByVal NppiSize oROI, @Cast("Npp32s") int nVal);

/**
 * One-channel 8-bit unsigned image Integral with 32-bit floating point output.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param nVal The value to add to pDst image pixels
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiIntegral_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                             @ByVal NppiSize oROI, @Cast("Npp32f") float nVal);
public static native @Cast("NppStatus") int nppiIntegral_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                             @ByVal NppiSize oROI, @Cast("Npp32f") float nVal);
public static native @Cast("NppStatus") int nppiIntegral_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                             @Cast("Npp32f*") float[] pDst, int nDstStep, 
                             @ByVal NppiSize oROI, @Cast("Npp32f") float nVal);

/** \} */
/** \} Integral */

/** \defgroup image_sqrintegral SqrIntegral
 * Primitives for computing both the integral and the squared integral images of a given image.
 * \{
 *
 */

/** \name SqrIntegral
 *
 * Given an input image \f$pSrc\f$ and the specified value \f$nVal\f$, 
 * the pixel value of the integral image \f$pDst\f$ at coordinate 
 * (i, j) will be computed as
 * \f[pDst(j,i) = nVal + \sum_{l=0}^{j-1}\sum_{k=0}^{i-1}pSrc(l,k)\f]
 * Given an input image \f$pSrc\f$ and the specified value \f$nValSqr\f$, 
 * the pixel value of the squared integral image \f$pSqr\f$ at coordinate 
 * (i, j) will be computed as
 * \f[pSqr(j,i) = nValSqr + \sum_{l=0}^{j-1}\sum_{k=0}^{i-1}{pSrc(l,k)}^2\f]
 * If the size of the input image is \f$W \times H\f$, the size of 
 * the squared integral image will be \f$(W+1) \times (H+1)\f$.
 */

 /**
 * One-channel 8-bit unsigned image SqrIntegral. 
 * Destination integral image and square integral image are 32-bit signed int.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pSqr \ref destination_image_pointer.
 * @param nSqrStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 * @param nVal The value to add to pDst image pixels
 * @param nValSqr The value to add to pSqr image pixels
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                                @Cast("Npp32s*") IntPointer pSqr, int nSqrStep,
                                @ByVal NppiSize oSrcROI, @Cast("Npp32s") int nVal, @Cast("Npp32s") int nValSqr);
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                                @Cast("Npp32s*") IntBuffer pSqr, int nSqrStep,
                                @ByVal NppiSize oSrcROI, @Cast("Npp32s") int nVal, @Cast("Npp32s") int nValSqr);
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                @Cast("Npp32s*") int[] pDst, int nDstStep, 
                                @Cast("Npp32s*") int[] pSqr, int nSqrStep,
                                @ByVal NppiSize oSrcROI, @Cast("Npp32s") int nVal, @Cast("Npp32s") int nValSqr);

/**
 * One-channel 8-bit unsigned image SqrIntegral. 
 * Destination integral image is 32-bit signed int. 
 * Destination square integral image is 64-bit double floating point.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pSqr \ref destination_image_pointer.
 * @param nSqrStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 * @param nVal The value to add to pDst image pixels
 * @param nValSqr The value to add to pSqr image pixels
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32s64f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                   @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                                   @Cast("Npp64f*") DoublePointer pSqr, int nSqrStep,
                                   @ByVal NppiSize oSrcROI, @Cast("Npp32s") int nVal, @Cast("Npp64f") double nValSqr);
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32s64f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                   @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                                   @Cast("Npp64f*") DoubleBuffer pSqr, int nSqrStep,
                                   @ByVal NppiSize oSrcROI, @Cast("Npp32s") int nVal, @Cast("Npp64f") double nValSqr);
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32s64f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                   @Cast("Npp32s*") int[] pDst, int nDstStep, 
                                   @Cast("Npp64f*") double[] pSqr, int nSqrStep,
                                   @ByVal NppiSize oSrcROI, @Cast("Npp32s") int nVal, @Cast("Npp64f") double nValSqr);

/**
 * One-channel 8-bit unsigned image SqrIntegral. 
 * Destination integral image is 32-bit floating point.
 * Destination square integral image is 64-bit double floating point.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pSqr \ref destination_image_pointer.
 * @param nSqrStep \ref destination_image_line_step.
 * @param oSrcROI \ref roi_specification.
 * @param nVal The value to add to pDst image pixels
 * @param nValSqr The value to add to pSqr image pixels
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32f64f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                   @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                                   @Cast("Npp64f*") DoublePointer pSqr, int nSqrStep,
                                   @ByVal NppiSize oSrcROI, @Cast("Npp32f") float nVal, @Cast("Npp64f") double nValSqr);
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32f64f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                   @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                                   @Cast("Npp64f*") DoubleBuffer pSqr, int nSqrStep,
                                   @ByVal NppiSize oSrcROI, @Cast("Npp32f") float nVal, @Cast("Npp64f") double nValSqr);
public static native @Cast("NppStatus") int nppiSqrIntegral_8u32f64f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                   @Cast("Npp32f*") float[] pDst, int nDstStep, 
                                   @Cast("Npp64f*") double[] pSqr, int nSqrStep,
                                   @ByVal NppiSize oSrcROI, @Cast("Npp32f") float nVal, @Cast("Npp64f") double nValSqr);
/** \}  */
/** \} image_sqrintegral */

/** \defgroup image_rectstddev RectStdDev
 * Primitives for computing the standard deviation of the integral images.
 * The function computes the standard deviation of the pixel in the rectangular window with the 
 * integral image \f$pSrc\f$ and the squared integral image \f$pSqr\f$, which can be obtained by calling
 * \ref image_integral and \ref image_sqrintegral.
 * 
 * The standard deviation of the pixel \f$(j, i)\f$ can be computed using the formula:
 * \f[pDst(j, i) = \sqrt{max(0, \frac{\sum(SqrIntegral)\cdot N - (\sum(Integral))^2}{N^2})}\f]
 * where \f$\sum(SqrIntegral) = pSqr[j+oRect.y+oRect.height, i+oRect.x+oRect.width] - pSqr[j+oRect.y,i+oRect.x+oRect.width]
 * - pSqr[j+oRect.y+oRect.height, i+oRect.x] + pSqr[j+oRect.y, i+oRect.x]\f$,
 * \f$\sum(Integral) = pSrc[j+oRect.y+oRect.height, i+oRect.x+oRect.width] - pSrc[j+oRect.y,i+oRect.x+oRect.width]
 * - pSrc[j+oRect.y+oRect.height, i+oRect.x] + pSrc[j+oRect.y, i+oRect.x]\f$,
 * \f$N = oRect.width \cdot oRect.height\f$.
 *
 * The size of the \f$pSrc\f$ and \f$pSqr\f$ should be \f$(oSizeROI.width + oRect.x + oRect.width, 
 * oSizeROI.height + oRect.y + oRect.height).\f$
 * \{
 *
 */
/** \name RectStdDev
 * \{
 */

/**
 * One-channel 32-bit floating point image RectStdDev.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSqr \ref destination_image_pointer.
 * @param nSqrStep \ref destination_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oRect rectangular window
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRectStdDev_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @Cast("const Npp64f*") DoublePointer pSqr, int nSqrStep, 
                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect);
public static native @Cast("NppStatus") int nppiRectStdDev_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @Cast("const Npp64f*") DoubleBuffer pSqr, int nSqrStep, 
                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect);
public static native @Cast("NppStatus") int nppiRectStdDev_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @Cast("const Npp64f*") double[] pSqr, int nSqrStep, 
                             @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect);

/**
 * One-channel 32-bit signed image RectStdDev, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSqr \ref destination_image_pointer.
 * @param nSqrStep \ref destination_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oRect rectangular window
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRectStdDev_32s_C1RSfs(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("const Npp32s*") IntPointer pSqr, int nSqrStep, 
                                @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect, int nScaleFactor);
public static native @Cast("NppStatus") int nppiRectStdDev_32s_C1RSfs(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("const Npp32s*") IntBuffer pSqr, int nSqrStep, 
                                @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect, int nScaleFactor);
public static native @Cast("NppStatus") int nppiRectStdDev_32s_C1RSfs(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("const Npp32s*") int[] pSqr, int nSqrStep, 
                                @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect, int nScaleFactor);

 /**
 * One-channel 32-bit signed image RectStdDev. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pSqr \ref destination_image_pointer.
 * @param nSqrStep \ref destination_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param oRect rectangular window
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiRectStdDev_32s32f_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, @Cast("const Npp64f*") DoublePointer pSqr, int nSqrStep, 
                                @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect);
public static native @Cast("NppStatus") int nppiRectStdDev_32s32f_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, @Cast("const Npp64f*") DoubleBuffer pSqr, int nSqrStep, 
                                @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect);
public static native @Cast("NppStatus") int nppiRectStdDev_32s32f_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, @Cast("const Npp64f*") double[] pSqr, int nSqrStep, 
                                @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oSizeROI, @ByVal NppiRect oRect);
/** \}  */
/** \} image_rectstddev */


/** \defgroup image_histogrameven HistogramEven
 * Primitives for computing the histogram of an image with evenly distributed bins.
 * \{
 *
 */

/** \name HistogramEven
 * The \f$nLowerLevel\f$ (inclusive) and \f$nUpperLevel\f$ (exclusive) define the boundaries of the range, 
 * which are evenly segmented into \f$nLevel - 1\f$ bins. The computed histogram is stored in \f$pHist\f$. 
 * The levels are calculated by another primitive \ref nppiEvenLevelsHost_32s and are stored 
 * in a host pointer \f$hpLevels\f$. The number of levels is also \f$nLevel - 1\f$.
 * The histogram \f$pHist[k]\f$ is defined as the total number of pixels that fall into the range:
 * \f$hpLevels[k] <= pSrc(j, i) < hpLevels[k+1]\f$.
 * The functions require additional scratch buffer for computations.
 * \{
 */

/**
 * Compute levels with even distribution.
 *
 * @param hpLevels A host pointer to array which receives the levels being
 *        computed. The array needs to be of size nLevels. 
 * @param nLevels The number of levels being computed. nLevels must be at least 2.
 * @param nLowerLevel Lower boundary value of the lowest level.
 * @param nUpperLevel Upper boundary value of the greatest level.
 * @return image_data_error_codes, or NPP_HISTO_NUMBER_OF_LEVELS_ERROR if an invalid nLevels is specified.
*/
public static native @Cast("NppStatus") int nppiEvenLevelsHost_32s(@Cast("Npp32s*") IntPointer hpLevels, int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel);
public static native @Cast("NppStatus") int nppiEvenLevelsHost_32s(@Cast("Npp32s*") IntBuffer hpLevels, int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel);
public static native @Cast("NppStatus") int nppiEvenLevelsHost_32s(@Cast("Npp32s*") int[] hpLevels, int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel);

/**
 * One-channel 8-bit unsigned HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Pointer to array that receives the computed histogram. 
 *      The array must be of size nLevels-1. 
 * @param nLevels Number of levels.
 * @param nLowerLevel Lower boundary of lowest level bin.
 * @param nUpperLevel Upper boundary of highest level bin.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_8u_C1R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntPointer pHist, 
                         int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntBuffer pHist, 
                         int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") int[] pHist, 
                         int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three-channel 8-bit unsigned HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_8u_C3R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                         IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                         IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                         IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                         int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 8-bit unsigned HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_8u_C4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                               @Cast("Npp32s**") PointerPointer pHist, 
                         IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                               @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                         IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                               @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                         IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                               @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                         int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 8-bit unsigned HistogramEven ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_8u_AC4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") PointerPointer pHist, 
                          IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                          IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                          IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                          int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * One-channel 16-bit unsigned HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Pointer to array that receives the computed histogram. 
 *      The array must be of size nLevels-1. 
 * @param nLevels Number of levels.
 * @param nLowerLevel Lower boundary of lowest level bin.
 * @param nUpperLevel Upper boundary of highest level bin.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16u_C1R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntPointer pHist, 
                          int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntBuffer pHist, 
                          int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") int[] pHist, 
                          int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three-channel 16-bit unsigned HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16u_C3R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") PointerPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit unsigned HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16u_C4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") PointerPointer pHist, 
                          IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                          IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                          IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                          int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit unsigned HistogramEven ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16u_AC4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") PointerPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * One-channel 16-bit signed HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Pointer to array that receives the computed histogram. 
 *      The array must be of size nLevels-1. 
 * @param nLevels Number of levels.
 * @param nLowerLevel Lower boundary of lowest level bin.
 * @param nUpperLevel Upper boundary of highest level bin.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16s_C1R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntPointer pHist, 
                         int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntBuffer pHist, 
                         int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") int[] pHist, 
                         int nLevels, @Cast("Npp32s") int nLowerLevel, @Cast("Npp32s") int nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three-channel 16-bit signed HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16s_C3R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") PointerPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit signed HistogramEven.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16s_C4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") PointerPointer pHist, 
                          IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                          IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                          IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                          int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit signed HistogramEven ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving computed histograms per color channel. 
 *      Array pointed by pHist[i] be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param nLowerLevel Array containing lower-level of lowest bin per color channel.
 * @param nUpperLevel Array containing upper-level of highest bin per color channel.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramEvenGetBufferSize_16s_AC4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramEven_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") PointerPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           IntPointer nLevels, @Cast("Npp32s*") IntPointer nLowerLevel, @Cast("Npp32s*") IntPointer nUpperLevel, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           IntBuffer nLevels, @Cast("Npp32s*") IntBuffer nLowerLevel, @Cast("Npp32s*") IntBuffer nUpperLevel, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramEven_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           int[] nLevels, @Cast("Npp32s*") int[] nLowerLevel, @Cast("Npp32s*") int[] nUpperLevel, @Cast("Npp8u*") byte[] pBuffer);
/** \} */
 
/** \name HistogramEvenGetBufferSize
 * Companion primitives for computing the device buffer size (in bytes) required by the HistogramEven primitives.
 * \{
 */

/**
 * Buffer size for \ref nppiHistogramEven_8u_C1R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, int nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_8u_C3R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_8u_C4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_8u_AC4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16u_C1R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, int nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16u_C3R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16u_C4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16u_AC4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16s_C1R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, int nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16s_C3R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16s_C4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Buffer size for \ref nppiHistogramEven_16s_AC4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramEvenGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);
/** \} */

/** \} image_histogrameven */


/** \defgroup image_histogramrange HistogramRange
 * Primitives for computing the histogram of an image within specified ranges.
 * \{
 *
 */

/** \name HistogramEven
 * The histogram is computed according to the ranges provided in \f$pLevels\f$. 
 * The histogram \f$pHist[k]\f$ is defined as the total number of pixels that fall into the range:
 * \f$pLevels[k] <= pSrc(j, i) < pLevels[k+1]\f$. The number of the histogram bins is \f$nLevel - 1\f$.
 * The functions require additional scratch buffer for computations.
 * \{
 */
/**
 * One-channel 8-bit unsigned HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Pointer to array that receives the computed histogram. 
 *      The array must be of size nLevels-1. 
 * @param pLevels Pointer to array containing the level sizes of the bins.
        The array must be of size nLevels.
 * @param nLevels Number of levels in histogram.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_8u_C1R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntPointer pHist, 
                          @Cast("const Npp32s*") IntPointer pLevels, int nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntBuffer pHist, 
                          @Cast("const Npp32s*") IntBuffer pLevels, int nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") int[] pHist, 
                          @Cast("const Npp32s*") int[] pLevels, int nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three-channel 8-bit unsigned HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_8u_C3R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                           @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 8-bit unsigned HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_8u_C4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                          @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                          @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                          @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                          @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 8-bit unsigned HistogramRange ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_8u_AC4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                           @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * One-channel 16-bit unsigned HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Pointer to array that receives the computed histogram. 
 *      The array must be of size nLevels-1. 
 * @param pLevels Pointer to array containing the level sizes of the bins.
        The array must be of size nLevels.
 * @param nLevels Number of levels in histogram.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16u_C1R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntPointer pHist, 
                           @Cast("const Npp32s*") IntPointer pLevels, int nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntBuffer pHist, 
                           @Cast("const Npp32s*") IntBuffer pLevels, int nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") int[] pHist, 
                           @Cast("const Npp32s*") int[] pLevels, int nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three-channel 16-bit unsigned HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16u_C3R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                            @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit unsigned HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16u_C4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                           @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit unsigned HistogramRange ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16u_AC4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                            @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * One-channel 16-bit signed HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Pointer to array that receives the computed histogram. 
 *      The array must be of size nLevels-1. 
 * @param pLevels Pointer to array containing the level sizes of the bins.
        The array must be of size nLevels.
 * @param nLevels Number of levels in histogram.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16s_C1R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntPointer pHist, 
                           @Cast("const Npp32s*") IntPointer pLevels, int nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntBuffer pHist, 
                           @Cast("const Npp32s*") IntBuffer pLevels, int nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") int[] pHist, 
                           @Cast("const Npp32s*") int[] pLevels, int nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three-channel 16-bit signed HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16s_C3R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                            @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit signed HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16s_C4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                           @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 16-bit signed HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_16s_AC4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                            @Cast("const Npp32s**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr IntBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                            @Cast("const Npp32s**") @ByPtrPtr int[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * One-channel 32-bit floating point HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Pointer to array that receives the computed histogram. 
 *      The array must be of size nLevels-1. 
 * @param pLevels Pointer to array containing the level sizes of the bins.
        The array must be of size nLevels.
 * @param nLevels Number of levels in histogram.
 * @param pBuffer Pointer to appropriately sized (\ref nppiHistogramRangeGetBufferSize_32f_C1R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntPointer pHist, 
                           @Cast("const Npp32f*") FloatPointer pLevels, int nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") IntBuffer pHist, 
                           @Cast("const Npp32f*") FloatBuffer pLevels, int nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s*") int[] pHist, 
                           @Cast("const Npp32f*") float[] pLevels, int nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Three-channel 32-bit floating point HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (nppiHistogramRangeGetBufferSize_32f_C3R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                            @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                            @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                            @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                            @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);


/**
 * Four-channel 32-bit floating point HistogramRange.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (nppiHistogramRangeGetBufferSize_32f_C4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                           @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                           @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                           @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                           @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);

/**
 * Four-channel 32-bit floating point HistogramRange ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pHist Array of pointers which are receiving the computed histograms per color channel. 
 *      Array pointed by pHist[i] must be of size nLevels[i]-1.
 * @param nLevels Array containing number of levels per color channel. 
 * @param pLevels Array containing pointers to level-arrays per color channel.
        Array pointed by pLevel[i] must be of size nLevels[i].
 * @param pBuffer Pointer to appropriately sized (nppiHistogramRangeGetBufferSize_32f_AC4R) 
 *      scratch buffer.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiHistogramRange_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") PointerPointer pHist, 
                            @Cast("const Npp32f**") PointerPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntPointer pHist, 
                            @Cast("const Npp32f**") @ByPtrPtr FloatPointer pLevels, IntPointer nLevels, @Cast("Npp8u*") BytePointer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr IntBuffer pHist, 
                            @Cast("const Npp32f**") @ByPtrPtr FloatBuffer pLevels, IntBuffer nLevels, @Cast("Npp8u*") ByteBuffer pBuffer);
public static native @Cast("NppStatus") int nppiHistogramRange_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSizeROI, @Cast("Npp32s**") @ByPtrPtr int[] pHist, 
                            @Cast("const Npp32f**") @ByPtrPtr float[] pLevels, int[] nLevels, @Cast("Npp8u*") byte[] pBuffer);
/** \} */

/** \name HistogramRangeGetBufferSize
 * Companion primitives for computing the device buffer size (in bytes) required by the HistogramRange primitives.
 * \{
 */
 
/**
 * Scratch-buffer size for nppiHistogramRange_8u_C1R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C1R(@ByVal NppiSize oSizeROI, int nLevels,int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_8u_C3R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_8u_C4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_8u_AC4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_8u_AC4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16u_C1R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, int nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C1R(@ByVal NppiSize oSizeROI, int nLevels,int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16u_C3R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16u_C4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16u_AC4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16u_AC4R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16s_C1R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, int nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, int nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C1R(@ByVal NppiSize oSizeROI, int nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16s_C3R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16s_C4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer nLevels,IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels,IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] nLevels,int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_16s_AC4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_16s_AC4R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_32f_C1R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Number of levels in the histogram.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C1R(@ByVal NppiSize oSizeROI, int nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C1R(@ByVal NppiSize oSizeROI, int nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C1R(@ByVal NppiSize oSizeROI, int nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_32f_C3R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_32f_C4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);

/**
 * Scratch-buffer size for nppiHistogramRange_32f_AC4R.
 * 
 * @param oSizeROI \ref roi_specification.
 * @param nLevels Array containing number of levels per color channel.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes..
 */
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer nLevels, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer nLevels, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiHistogramRangeGetBufferSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] nLevels, int[] hpBufferSize);
/** \} */
/** \} image_histogramrange */

/** \defgroup image_proximity Image Proximity
 * Primitives for computing the proximity measure between a source image and a template image.
 *
 * \section general_introduction General Introduction
 * There are basically two approaches to compute the proximity measure for template matching, 
 * Euclidean distance and the cross correlation.
 * -# Euclidean distance computes the sum of the squared distance (SSD) between the corresponding 
 * pixels of the source image and the template image. The smaller the distance is, the more 
 * similar the source image and the template image is around the pixel. The anchor of the template  
 * image is used during the computations, which always lies in the gemotric center of the image. 
 * Given a source image \f$pSrc\f$ (\f$W_s \times H_s\f$) and a template image \f$pTpl\f$ (\f$W_t \times H_t\f$), 
 * the Euclidean distance \f$D_{st}(c,r)\f$ between two images at pixel in row \f$r\f$ and column 
 * \f$c\f$ is computed as (\f$s\f$ stands for source image and \f$t\f$ for template image for short):
 * \f[D_{st}(c,r)=\sum_{j=0}^{H_t-1}\sum_{i=0}^{W_t-1}[pTpl(j,i)-pSrc(j+c-\frac{H_t}{2}, i+r-\frac{W_t}{2})]^2 \f]
 * -# Cross correlation computes the sum of the product between the corresponding pixels of the source 
 * image and the template image. The cross correlation \f$R_{st}(c,r)\f$ is calculated as:
 * \f[R_{st}(c,r)=\sum_{j=0}^{H_t-1}\sum_{i=0}^{W_t-1}[pTpl(j,i)\cdot pSrc(j+c-\frac{H_t}{2}, i+r-\frac{W_t}{2})] \f]
 * The larger the cross correlation value is, the more similar the source image and the template image is around the pixel. 
 * -# The cross correlation \f$R_{st}(c,r)\f$ is affected by the brightness of the images which may vary due to the lighting 
 * and exposure conditions. Therefore, NPP computes the cross correlation coefficient to circumvent this dependence. 
 * This is typically done at every step by subtracting the mean from every pixel value, i.e.,
 * \f[\tilde{R}_{st}(c,r)=\sum_{j=0}^{H_t-1}\sum_{i=0}^{W_t-1}[pTpl(j,i)-Mean_t]\cdot [pSrc(j+c-\frac{H_t}{2}, i+r-\frac{W_t}{2})-Mean_s] \f]
 * 
 * NPP computes the normalized values of Euclidean distance, cross correlation and the cross correlation coefficient.
 * -# The normalized Euclidean distance \f$\sigma_{st}(c,r)\f$ is defined as:
 * \f[\sigma_{st}(c,r) = \frac{D_{st}(c,r)}{\sqrt{R_{ss}(c,r)\cdot R_{tt}(\frac{H_t}{2},\frac{W_t}{2})}} \f]
 * -# The normalized cross correlation \f$\rho_{st}(c,r)\f$ is defined as:
 * \f[\rho_{st}(c,r) = \frac{R_{st}(c,r)}{\sqrt{R_{ss}(c,r)\cdot R_{tt}(\frac{H_t}{2},\frac{W_t}{2})}} \f]
 * The \f$R_{ss}(c,r)\f$ and \f$R_{tt}(\frac{H_t}{2}, \frac{W_t}{2}\f$ denote the auto correlation of the source
 * image and the template image individually. They are defined as:
 * \f[R_{ss}(c,r)=\sum_{j=c-\frac{H_t}{2}}^{c+\frac{H_t}{2}}\sum_{i=r-\frac{W_t}{2}}^{r+\frac{W_t}{2}}pSrc(j, i) \f]
 * \f[R_{tt}(\frac{H_t}{2},\frac{W_t}{2})=\sum_{j=0}^{H_t-1}\sum_{i=0}^{W_t-1}pTpl(j,i) \f]
 * -# Similarly, the normalized cross correlation coefficient \f$\gamma_{st}(c,r)\f$ is calculated as:
 * \f[\gamma_{st}(c,r) = \frac{\tilde{R}_{st}(c,r)}{\sqrt{\tilde{R}_{ss}(c,r)\cdot \tilde{R}_{tt}(\frac{H_t}{2},\frac{W_t}{2})}} \f]
 * The \f$\tilde{R}_{ss}(c,r)\f$ and \f$\tilde{R}_{tt}(\frac{H_t}{2}, \frac{W_t}{2}\f$ are defined as:
 * \f[\tilde{R}_{ss}(c,r)=\sum_{j=c-\frac{H_t}{2}}^{c+\frac{H_t}{2}}\sum_{i=r-\frac{W_t}{2}}^{r+\frac{W_t}{2}}[pSrc(j, i)-Mean_s] \f]
 * \f[\tilde{R}_{tt}(\frac{H_t}{2},\frac{W_t}{2})=\sum_{j=0}^{H_t-1}\sum_{i=0}^{W_t-1}[pTpl(j,i)-Mean_t] \f]
 *
 * \section category Categorizations
 * The Euclidean distance and the cross correlation are categorized into three types, full, same, and valid. 
 * -# Full mode indicates that the anchor of the template image starts from the outside of the source image, 
 * assuming the out-of-boundary pixels are zeor-padded. The size of the destination
 * image is \f$(W_s + W_t - 1) \times (H_s + H_t - 1)\f$.
 * -# Same mode means that the anchor of the template image starts from the top left pixel
 * of the source image. All the out-of-boundary pixels are also zero-padded.
 * The size of the destination image is the same as the source one, i.e., \f$W_s \times H_s\f$.
 * -# Valid mode indicates that there are no out-of-boudnary readings from the source image.
 * The anchor of the template image starts from the inside of the source image. The 
 * size of the destination image is \f$(W_s - W_t + 1) \times (H_s - H_t + 1)\f$.
 * 
 * \{
 */

/** \defgroup sqrdistancefullnorm SqrDistanceFull_Norm 
 * Primitives for computing the normalized Euclidean distance between two images with full mode.
 * \{
 */
/**
 * \name SqrDistanceFull_Norm
 * The functions compute the \f$\sigma_{st}(c,r)\f$ in \ref general_introduction
 * with full mode (see \ref category).
 * \{
 */
 /**
 * One-channel 8-bit unsigned image SqrDistanceFull_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Three-channel 8-bit unsigned image SqrDistanceFull_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image SqrDistanceFull_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image SqrDistanceFull_Norm ignoring alpha channel, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * One-channel 32-bit floating point image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 32-bit floating point image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image SqrDistanceFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit unsigned image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit unsigned image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image SqrDistanceFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit signed image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit signed image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image SqrDistanceFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 16-bit unsigned image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 16-bit unsigned image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image SqrDistanceFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image SqrDistanceFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceFull_Norm_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);
/** \} */
/** \} SqrDistanceFull_Norm */

/**
 * \defgroup sqrdistancesamenorm SqrDistanceSame_Norm
 * Primitives for computing the normalized Euclidean distance between two images with same mode.
 * \{
 */
/**
 * \name SqrDistanceSame_Norm
 * The functions compute the \f$\sigma_{st}(c,r)\f$ in \ref general_introduction 
 * with same mode (see \ref category).
 * \{
 */
/**
 * One-channel 8-bit unsigned image SqrDistanceSame_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Three-channel 8-bit unsigned image SqrDistanceSame_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image SqrDistanceSame_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image SqrDistanceSame_Norm ignoring alpha channel, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * One-channel 32-bit floating point image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 32-bit floating point image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image SqrDistanceSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit unsigned image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit unsigned image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image SqrDistanceSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit signed image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit signed image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image SqrDistanceSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 16-bit unsigned image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 16-bit unsigned image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image SqrDistanceSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image SqrDistanceSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceSame_Norm_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);
/** \} */
/** \} SqrDistanceFull_Norm */

/**
 * \defgroup sqrdistancevalidnorm SqrDistanceValid_Norm
 * Primitives for computing the normalized Euclidean distance between two images with valid mode.
 * \{
 */
/**
 * \name SqrDistanceValid_Norm
 * The functions compute the \f$\sigma_{st}(c,r)\f$ in \ref general_introduction 
 * with valid mode (see \ref category).
 * \{
 */
/**
 * One-channel 8-bit unsigned image SqrDistanceValid_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Three-channel 8-bit unsigned image SqrDistanceValid_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image SqrDistanceValid_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image SqrDistanceValid_Norm ignoring alpha channel, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * One-channel 32-bit floating point image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 32-bit floating point image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image SqrDistanceValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit unsigned image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit unsigned image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */ 
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image SqrDistanceValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit signed image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit signed image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image SqrDistanceValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 16-bit unsigned image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 16-bit unsigned image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image SqrDistanceValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image SqrDistanceValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiSqrDistanceValid_Norm_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep);
/** \} */
/** \} SqrDistanceValid_Norm*/

/**
 * \defgroup crosscorrfullnorm CrossCorrFull_Norm
 * Primitives for computing the normalized cross correlation between two images with full mode.
 *
 * \{
 */
/**
 * \name CrossCorrFull_Norm
 * The functions compute the \f$\rho_{st}(c,r)\f$ in \ref general_introduction 
 * with full mode (see \ref category).
 * \{
 */
/**
 * One-channel 8-bit unsigned image CrossCorrFull_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Three-channel 8-bit unsigned image CrossCorrFull_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_Norm ignoring alpha channel, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * One-channel 32-bit floating point image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 32-bit floating point image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image CrossCorrFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit unsigned image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit unsigned image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit signed image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit signed image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image CrossCorrFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 16-bit unsigned image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 16-bit unsigned image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image CrossCorrFull_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image CrossCorrFull_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrFull_Norm_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);
/** \} */
/** \} CrossCorrFull_Norm */

/**
 * \defgroup crosscorrsamenorm CrossCorrSame_Norm
 * Primitives for computing the normalized cross correlation between two images with same mode.
 *
 * \{
 */
/**
 * \name CrossCorrSame_Norm
 * The functions compute the \f$\rho_{st}(c,r)\f$ in \ref general_introduction 
 * with same mode (see \ref category).
 * \{
 */
/**
 * One-channel 8-bit unsigned image CrossCorrSame_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Three-channel 8-bit unsigned image CrossCorrSame_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_Norm ignoring alpha channel, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * One-channel 32-bit floating point image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 32-bit floating point image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image CrossCorrSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit unsigned image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit unsigned image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit signed image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit signed image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image CrossCorrSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 16-bit unsigned image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 16-bit unsigned image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image CrossCorrSame_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image CrossCorrSame_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrSame_Norm_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);
/** \} */
/** \} CrossCorrSame_Norm*/

/**
 * \defgroup crosscorrvalidnorm CrossCorrValid_Norm
 * Primitives for computing the normalized cross correlation between two images with valid mode.
 *
 * \{
 */
/**
 * \name CrossCorrValid_Norm
 * The functions compute the \f$\rho_{st}(c,r)\f$ in \ref general_introduction 
 * with valid mode (see \ref category).
 * \{
 */
/**
 * One-channel 8-bit unsigned image CrossCorrValid_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Three-channel 8-bit unsigned image CrossCorrValid_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_Norm, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_Norm ignoring alpha channel, scaled by \f$2^(-nScaleFactor)\f$. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor);

/**
 * One-channel 32-bit floating point image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 32-bit floating point image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                 @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 32-bit floating point image CrossCorrValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                  @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                        @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit unsigned image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit unsigned image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 8-bit signed image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 8-bit signed image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                   @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                         @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 8-bit signed image CrossCorrValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * One-channel 16-bit unsigned image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Three-channel 16-bit unsigned image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image CrossCorrValid_Norm. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep);

/**
 * Four-channel 16-bit unsigned image CrossCorrValid_Norm ignoring alpha channel. 
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_Norm_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep);
/** \} */
/** \} CrossCorrValid_Norm*/

/**
 * \defgroup crosscorrvalid CrossCorrValid
 * Primitives for computing the cross correlation between two images with valid mode.
 *
 * \{
 */
/**
 * \name CrossCorrValid
 * The functions compute the \f$R_{st}(c,r)\f$ in \ref general_introduction 
 * with valid mode (see \ref category).
 * \{
 */
/**
 * One-channel 32-bit floating point images CrossCorrValid.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                           @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                           @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                           @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep);
                                        
/**
 * One-channel 8-bit unsigned images CrossCorrValid.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                             @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                   @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                             @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                   @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                             @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                   @Cast("Npp32f*") float[] pDst, int nDstStep);
                                          
/**
 * One-channel 8-bit signed images CrossCorrValid.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                             @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                   @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                             @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                   @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                             @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                   @Cast("Npp32f*") float[] pDst, int nDstStep);
                                          
/**
 * One-channel 16-bit unsigned images CrossCorrValid.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                              @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                    @Cast("Npp32f*") FloatPointer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                              @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                    @Cast("Npp32f*") FloatBuffer pDst, int nDstStep);
public static native @Cast("NppStatus") int nppiCrossCorrValid_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                              @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                    @Cast("Npp32f*") float[] pDst, int nDstStep);                                          
/** \} */
/** \} CrossCorrValid*/

/**
 * \defgroup crosscorrfullnormlevel CrossCorrFull_NormLevel
 * Primitives for computing the normalized cross correlation coefficient between two images with full mode.
 *
 * \{
 */
/**
 * \name CrossCorrFull_NormLevel
 * The functions compute the \f$\gamma_{st}(c,r)\f$ in \ref general_introduction 
 * with full mode (see \ref category). The functions require additional scratch buffer for computations.
 * \{
 */
/**
 * One-channel 8-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u_C1RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u_C3RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u_C4RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u_AC4RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image CrossCorrFull_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrFull_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8s32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8s32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8s32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image CrossCorrFull_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_8s32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_16u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_16u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image CrossCorrFull_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_16u32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image CrossCorrFull_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiFullNormLevelGetBufferHostSize_16u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrFull_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name FullNormLevelGetBufferHostSize 
 * Companion primitives for computing the device buffer size (in bytes) required by the CrossCorrFull_NormLevel primitives.
 * \{
 */
/** 
 * Buffer size (in bytes) for nppiCrossCorrFull_NormLevel_8u_C1RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8u_C3RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8u_C4RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8u_AC4RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8u32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8s32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8s32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8s32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_8s32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_16u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_16u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_16u32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrFull_NormLevel_16u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiFullNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} CrossCorrFull_NormLevel*/

/**
 * \defgroup crosscorrsamenormlevel CrossCorrSame_NormLevel
 * Primitives for computing the normalized cross correlation coefficient between two images with same mode.
 *
 * \{
 */
/**
 * \name CrossCorrSame_NormLevel
 * The functions compute the \f$\gamma_{st}(c,r)\f$ in \ref general_introduction 
 * with same mode (see \ref category). The functions require additional scratch buffer for computations.
 * \{
 */
/**
 * One-channel 8-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u_C1RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u_C3RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u_C4RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u_AC4RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image CrossCorrSame_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrSame_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8s32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8s32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8s32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image CrossCorrSame_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_8s32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_16u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_16u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image CrossCorrSame_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_16u32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image CrossCorrSame_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiSameNormLevelGetBufferHostSize_16u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrSame_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name SameNormLevelGetBufferHostSize 
 * Companion primitives for computing the device buffer size (in bytes) required by the CrossCorrSame_NormLevel primitives.
 * \{
 */
/** 
 * Buffer size (in bytes) for nppiCrossCorrSame_NormLevel_8u_C1RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8u_C3RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8u_C4RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8u_AC4RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8u32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8s32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8s32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8s32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_8s32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_16u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_16u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_16u32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrSame_NormLevel_16u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiSameNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */
/** \} CrossCorrSame_NormLevel*/

/**
 * \defgroup crosscorrvalidnormlevel CrossCorrValid_NormLevel
 * Primitives for computing the normalized cross correlation coefficient between two images with valid mode.
 *
 * \{
 */
/**
 * \name CrossCorrValid_NormLevel
 * The functions compute the \f$\gamma_{st}(c,r)\f$ in \ref general_introduction 
 * with valid mode (see \ref category). The functions require additional scratch buffer for computations.
 * \{
 */
/**
 * One-channel 8-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u_C1RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C1RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u_C3RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C3RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u_C4RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_C4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param nScaleFactor \ref integer_result_scaling.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u_AC4RSfs to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") BytePointer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u_AC4RSfs(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp8u*") byte[] pDst, int nDstStep, int nScaleFactor, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                    @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                          @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image CrossCorrValid_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") FloatPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") FloatBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                     @Cast("const Npp32f*") float[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                           @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image CrossCorrValid_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8u*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8s32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C1R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C1R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C1R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8s32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C3R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C3R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C3R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8s32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_C4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                      @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                            @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image CrossCorrValid_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_8s32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") BytePointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") BytePointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") ByteBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") ByteBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_8s32f_AC4R(@Cast("const Npp8s*") byte[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp8s*") byte[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_16u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_16u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image CrossCorrValid_NormLevel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_16u32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                       @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                             @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image CrossCorrValid_NormLevel ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcRoiSize \ref roi_specification.
 * @param pTpl Pointer to the template image.
 * @param nTplStep Number of bytes between successive rows in the template image.
 * @param oTplRoiSize \ref roi_specification.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiValidNormLevelGetBufferHostSize_16u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") ShortPointer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") ShortBuffer pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiCrossCorrValid_NormLevel_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, @ByVal NppiSize oSrcRoiSize, 
                                        @Cast("const Npp16u*") short[] pTpl, int nTplStep, @ByVal NppiSize oTplRoiSize, 
                                              @Cast("Npp32f*") float[] pDst, int nDstStep, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name ValidNormLevelGetBufferHostSize 
 * Companion primitives for computing the device buffer size (in bytes) required by the CrossCorrValid_NormLevel primitives.
 * \{
 */
/** 
 * Buffer size (in bytes) for nppiCrossCorrValid_NormLevel_8u_C1RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C1RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8u_C3RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C3RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8u_C4RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_C4RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8u_AC4RSfs.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u_AC4RSfs(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8u32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8s32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8s32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8s32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_8s32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_8s32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_16u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_16u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_16u32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiCrossCorrValid_NormLevel_16u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiValidNormLevelGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** \} */
/** \} CrossCorrValid_NormLevel*/
/** \} image_proximity */

/** \defgroup image_quality_index Image Quality Index
 * Primitives for computing the image quality index of two images.
 * \{
 */
/**
 * \name QualityIndex
  * Given two images \f$M\f$ and \f$N\f$ (both \f$W \times H\f$), the
 * mathematical formula to calculate the image quality index \f$Q\f$ between them is expressed as:
 * \f[Q = \frac{4\sigma_{MN}\tilde{M}\tilde{N}}{[(\tilde{M}^2)+(\tilde{N}^2)][(\sigma_M)^2+(\sigma_N)^2]} \f]
 * where
 * \f[\tilde{M} = \frac{1}{W\cdot H}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}M(j,i)\f]
 * \f[\tilde{N} = \frac{1}{W\cdot H}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}N(j,i)\f]
 * \f[\sigma_{M} = \sqrt{\frac{1}{W\cdot H-1}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}[M(j,i)-\tilde{M}]^2}\f]
 * \f[\sigma_{N} = \sqrt{\frac{1}{W\cdot H-1}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}[N(j,i)-\tilde{N}]^2}\f]
 * \f[\sigma_{MN} = \frac{1}{W\cdot H-1}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}[M(j,i)-\tilde{M}][N(j,i)-\tilde{N}]\f]
 * The functions require additional scratch buffer for computations.
 * \{
 */
/**
 * One-channel 8-bit unsigned image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_8u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                           @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                           @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                           @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                           @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                           @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                           @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_16u32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                            @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                            @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                            @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                         @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                         @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                         @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                         @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                         @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                         @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_8u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                           @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                           @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                           @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                           @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                           @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                           @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_16u32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                            @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                            @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                            @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                         @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                         @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                         @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                         @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                         @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                         @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_8u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_AC4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                            @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                            @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_8u32f_AC4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                            @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                            @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_16u32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_AC4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                             @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                             @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                             @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                             @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_16u32f_AC4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                             @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                             @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image QualityIndex.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oRoiSize \ref roi_specification.
 * @param pDst Pointer to the quality index.
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiQualityIndexGetBufferHostSize_32f_AC4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_QUALITY_INDEX_ERROR if pixels of 
 * either image are constant numberse.
 */
public static native @Cast("NppStatus") int nppiQualityIndex_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                          @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatPointer pDst, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                          @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                          @ByVal NppiSize oRoiSize, @Cast("Npp32f*") FloatBuffer pDst, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiQualityIndex_32f_AC4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                          @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                          @ByVal NppiSize oRoiSize, @Cast("Npp32f*") float[] pDst, @Cast("Npp8u*") byte[] pDeviceBuffer);
/** \} */

/** \name QualityIndexGetBufferHostSize 
 * Companion primitives for computing the device buffer size (in bytes) required by the QualityIndex primitives.
 * \{
 */
/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_8u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_16u32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_8u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_16u32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_8u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_8u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_16u32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_16u32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size (in bytes) for \ref nppiQualityIndex_32f_AC4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiQualityIndexGetBufferHostSize_32f_AC4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \}  */
/** \} image_quality_index */

/** \defgroup image_maximum_error MaximumError
 * Primitives for computing the maximum error between two images.
 * Given two images \f$pSrc1\f$ and \f$pSrc2\f$ both with width \f$W\f$ and height \f$H\f$, 
 * the maximum error is defined as the largest absolute difference between pixels of two images.
 * If the image is in complex format, the absolute value of the complex number is provided.
 * 
 * \{
 */
/**
 * One-channel 8-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32u_C1R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C1R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C1R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 64-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C1R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C2R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C2R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16u_C2R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C2R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C2R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16s_C2R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C2R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C2R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32u_C2R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C2R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C2R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32s_C2R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C2R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C2R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32f_C2R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C2R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C2R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 64-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_64f_C2R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C2R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C2R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C3R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32u_C3R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C3R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C3R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 64-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_64f_C3R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C3R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C3R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_8s_C4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit unsigned image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32u_C4R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C4R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32u_C4R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point complex image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 64-bit floating point image Maximum_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumError_64f_C4R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C4R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumError_64f_C4R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name NormDiffInfGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormDiff_Inf primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiMaximumError_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_8s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32fc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_8u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_8s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32fc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_64f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_8s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32fc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_8s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_16sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_32fc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumError_64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */

/** \defgroup image_average_error AverageError
 * Primitives for computing the average error between two images.
 * Given two images \f$pSrc1\f$ and \f$pSrc2\f$ both with width \f$W\f$ and height \f$H\f$, 
 * the average error is defined as:
 * \f[Average Error = \frac{1}{W\cdot H\cdot N}\sum_{n=0}^{N-1}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}\left|pSrc1(j,i) - pSrc2(j,i)\right|\f]
 * where N stands for the number of channels. If the image is in complex format, the absolute value is used for computation.
 * \{
 */
/**
 * One-channel 8-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32u_C1R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C1R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C1R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 64-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C1R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C2R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C2R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16u_C2R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C2R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C2R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16s_C2R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C2R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C2R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32u_C2R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C2R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C2R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32s_C2R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C2R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C2R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32f_C2R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C2R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C2R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 64-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_64f_C2R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C2R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C2R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C3R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32u_C3R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C3R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C3R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 64-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_64f_C3R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C3R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C3R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_8s_C4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit unsigned image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32u_C4R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C4R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32u_C4R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point complex image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 64-bit floating point image Average_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageError_64f_C4R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C4R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageError_64f_C4R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name NormDiffInfGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormDiff_Inf primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiAverageError_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_8s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32fc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_8u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_8s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32fc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_64f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_8s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32fc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_8s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_16sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_32fc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageError_64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */

/** \defgroup image_maximum_relative_error MaximumRelativeError
 * Primitives for computing the maximum relative error between two images.
 * Given two images \f$pSrc1\f$ and \f$pSrc2\f$ both with width \f$W\f$ and height \f$H\f$, 
 * the maximum relative error is defined as:
 * \f[MaximumRelativeError = max{\frac{\left|pSrc1(j,i) - pSrc2(j,i)\right|}{max(\left|pSrc1(j,i)\right|, \left|pSrc2(j,i)\right|)}}\f]
 * If the image is in complex format, the absolute value is used for computation.
 * For multiple channles, the maximum relative error of all the channles is returned.
 * \{
 */
/**
 * One-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C1R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C1R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C1R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C1R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C2R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C2R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C2R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C2R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C2R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C2R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C2R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C2R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C2R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C2R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C2R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C2R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C2R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C2R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C2R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C2R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C2R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C2R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C2R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C2R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C3R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C3R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C3R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C3R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C3R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C3R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C3R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_8s_C4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C4R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C4R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32u_C4R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiMaximumRelativeErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C4R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C4R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiMaximumRelativeError_64f_C4R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name NormDiffInfGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormDiff_Inf primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiMaximumRelativeError_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_8s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32fc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_8u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_8s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32fc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_64f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_8s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32fc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_8s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_16sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_32fc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiMaximumRelativeError_64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiMaximumRelativeErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */

/** \defgroup image_average_relative_error AverageRelativeError
 * Primitives for computing the average relative error between two images.
 * Given two images \f$pSrc1\f$ and \f$pSrc2\f$ both with width \f$W\f$ and height \f$H\f$, 
 * the maximum relative error is defined as:
 * \f[AverageRelativeError = \frac{1}{W\cdot H\cdot N}\sum_{n=0}^{N-1}\sum_{j=0}^{H-1}\sum_{i=0}^{W-1}\frac{\left|pSrc1(j,i) - pSrc2(j,i)\right|}{max(\left|pSrc1(j,i)\right|, \left|pSrc2(j,i)\right|)}\f]
 * where N is the number of channels.
 * If the image is in complex format, the absolute value is used for computation.
 * \{
 */
/**
 * One-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C1R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C1R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C1R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C1R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C1R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C1R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C1R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C1R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C1R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C1R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C1R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C1R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C1R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C1R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * One-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C1R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C1R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C2R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C2R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C2R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C2R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C2R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C2R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C2R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C2R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C2R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C2R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C2R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C2R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C2R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C2R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C2R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C2R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C2R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C2R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C2R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C2R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C2R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C2R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C2R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C2R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Two-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C2R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C2R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C2R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C2R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C3R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C3R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C3R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C3R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C3R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C3R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C3R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C3R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C3R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C3R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C3R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C3R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C3R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C3R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Three-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C3R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C3R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C3R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C3R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8u_C4R(@Cast("const Npp8u*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8u*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 8-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_8u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C4R(@Cast("const Npp8s*") BytePointer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") BytePointer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C4R(@Cast("const Npp8s*") ByteBuffer pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") ByteBuffer pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_8s_C4R(@Cast("const Npp8s*") byte[] pSrc1, int nSrc1Step, 
                                  @Cast("const Npp8s*") byte[] pSrc2, int nSrc2Step, 
                                  @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16u_C4R(@Cast("const Npp16u*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16u*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") ShortBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16s_C4R(@Cast("const Npp16s*") short[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp16s*") short[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 16-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_16sc_C4R(@Const Npp16sc pSrc1, int nSrc1Step, 
                                    @Const Npp16sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit unsigned image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16u_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C4R(@Cast("const Npp32u*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C4R(@Cast("const Npp32u*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32u_C4R(@Cast("const Npp32u*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32u*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") IntBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32s_C4R(@Cast("const Npp32s*") int[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32s*") int[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit signed complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_16s_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32sc_C4R(@Const Npp32sc pSrc1, int nSrc1Step, 
                                    @Const Npp32sc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatPointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") FloatBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32f_C4R(@Cast("const Npp32f*") float[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp32f*") float[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 32-bit floating point complex image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error (absolute value). 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_32fc_C4R(@Const Npp32fc pSrc1, int nSrc1Step, 
                                    @Const Npp32fc pSrc2, int nSrc2Step, 
                                    @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/**
 * Four-channel 64-bit floating point image MaximumRelative_Error.
 *
 * @param pSrc1 \ref source_image_pointer.
 * @param nSrc1Step \ref source_image_line_step.
 * @param pSrc2 \ref source_image_pointer.
 * @param nSrc2Step \ref source_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @param pError Pointer to the computed error. 
 * @param pDeviceBuffer Pointer to the required device memory allocation, \ref general_scratch_buffer. 
 * Use \ref nppiAverageRelativeErrorGetBufferHostSize_32f_C4R to compute the required size (in bytes).
 * @return \ref image_data_error_codes, \ref roi_error_codes, or NPP_NOT_EVEN_STEP_ERROR if an 
 * invalid floating-point image is specified.
*/
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C4R(@Cast("const Npp64f*") DoublePointer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoublePointer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoublePointer pError, @Cast("Npp8u*") BytePointer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C4R(@Cast("const Npp64f*") DoubleBuffer pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") DoubleBuffer pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") DoubleBuffer pError, @Cast("Npp8u*") ByteBuffer pDeviceBuffer);
public static native @Cast("NppStatus") int nppiAverageRelativeError_64f_C4R(@Cast("const Npp64f*") double[] pSrc1, int nSrc1Step, 
                                   @Cast("const Npp64f*") double[] pSrc2, int nSrc2Step, 
                                   @ByVal NppiSize oSizeROI, @Cast("Npp64f*") double[] pError, @Cast("Npp8u*") byte[] pDeviceBuffer);

/** \} */

/** \name NormDiffInfGetBufferHostSize
 * Companion primitives for computing the device buffer size (in bytes) required by the NormDiff_Inf primitives.
 * \{
 */
/** 
 * Buffer size for \ref nppiAverageRelativeError_8u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_8s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32u_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32s_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32sc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32fc_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_64f_C1R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C1R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_8u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_8s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32u_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32s_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32sc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32fc_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_64f_C2R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C2R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_8u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_8s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32u_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32s_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32sc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32fc_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_64f_C3R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C3R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_8u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_8s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_8s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_16sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_16sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32u_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32u_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32s_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32s_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32sc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32sc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_32fc_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_32fc_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);

/** 
 * Buffer size for \ref nppiAverageRelativeError_64f_C4R.
 * @param oSizeROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntPointer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, IntBuffer hpBufferSize);
public static native @Cast("NppStatus") int nppiAverageRelativeErrorGetBufferHostSize_64f_C4R(@ByVal NppiSize oSizeROI, int[] hpBufferSize);
/** \} */

/** \} image_statistics_functions */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_STATISTICS_FUNCTIONS_H */


// Parsed from <nppi_linear_transforms.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_LINEAR_TRANSFORMS_H
// #define NV_NPPI_LINEAR_TRANSFORMS_H
 
/**
 * \file nppi_linear_transforms.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_linear_transforms Linear Transforms
 *  \ingroup nppi
 *
 * Linear image transformations.
 *
 * \{
 *
 */

/** \defgroup image_fourier_transforms Fourier Transforms
 *
 * \{
 *
 */

/**
 * 32-bit floating point complex to 32-bit floating point magnitude.
 * 
 * Converts complex-number pixel image to single channel image computing
 * the result pixels as the magnitude of the complex values.
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMagnitude_32fc32f_C1R(@Const Npp32fc pSrc, int nSrcStep,
                                @Cast("Npp32f*") FloatPointer pDst, int nDstStep,
                          @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMagnitude_32fc32f_C1R(@Const Npp32fc pSrc, int nSrcStep,
                                @Cast("Npp32f*") FloatBuffer pDst, int nDstStep,
                          @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMagnitude_32fc32f_C1R(@Const Npp32fc pSrc, int nSrcStep,
                                @Cast("Npp32f*") float[] pDst, int nDstStep,
                          @ByVal NppiSize oSizeROI);
                                          
/**
 * 32-bit floating point complex to 32-bit floating point squared magnitude.
 * 
 * Converts complex-number pixel image to single channel image computing
 * the result pixels as the squared magnitude of the complex values.
 * 
 * The squared magnitude is an itermediate result of magnitude computation and
 * can thus be computed faster than actual magnitude. If magnitudes are required
 * for sorting/comparing only, using this function instead of nppiMagnitude_32fc32f_C1R
 * can be a worthwhile performance optimization.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oSizeROI \ref roi_specification.
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiMagnitudeSqr_32fc32f_C1R(@Const Npp32fc pSrc, int nSrcStep,
                                   @Cast("Npp32f*") FloatPointer pDst, int nDstStep,
                             @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMagnitudeSqr_32fc32f_C1R(@Const Npp32fc pSrc, int nSrcStep,
                                   @Cast("Npp32f*") FloatBuffer pDst, int nDstStep,
                             @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiMagnitudeSqr_32fc32f_C1R(@Const Npp32fc pSrc, int nSrcStep,
                                   @Cast("Npp32f*") float[] pDst, int nDstStep,
                             @ByVal NppiSize oSizeROI);
                                          
/** \} image_fourier_transforms */

/** \} image_linear_transforms */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_LINEAR_TRANSFORMS_H */


// Parsed from <nppi_geometry_transforms.h>


 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_GEOMETRY_TRANSFORMS_H
// #define NV_NPPI_GEOMETRY_TRANSFORMS_H
 
/**
 * \file nppi_geometry_transforms.h
 * Image Geometry Transform Primitives.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_geometry_transforms Geometry Transforms
 *  \ingroup nppi
 *
 * Routines manipulating an image's geometry.
 *
 * \section geometric_transform_api Geometric Transform API Specifics
 *
 * This section covers some of the unique API features common to the
 * geometric transform primitives.
 *
 * \subsection geometric_transform_roi Geometric Transforms and ROIs
 *
 * Geometric transforms operate on source and destination ROIs. The way
 * these ROIs affect the processing of pixels differs from other (non
 * geometric) image-processing primitives: Only pixels in the intersection
 * of the destination ROI and the transformed source ROI are being
 * processed.
 *
 * The typical processing proceedes as follows:
 * -# Transform the rectangular source ROI (given in source image coordinates)
 *		into the destination image space. This yields a quadrilateral.
 * -# Write only pixels in the intersection of the transformed source ROI and
 *		the destination ROI.
 *
 * \subsection geometric_transforms_interpolation Pixel Interpolation
 *
 * The majority of image geometry transform operation need to perform a 
 * resampling of the source image as source and destination pixels are not
 * coincident.
 *
 * NPP supports the following pixel inerpolation modes (in order from fastest to 
 * slowest and lowest to highest quality):
 * - nearest neighbor
 * - linear interpolation
 * - cubic convolution
 * - supersampling
 * - interpolation using Lanczos window function
 *
 * \{
 *
 */

/** \defgroup image_resize_square_pixel ResizeSqrPixel
 *
 * ResizeSqrPixel supports the following interpolation modes:
 *
 * <pre>{@code
 *   NPPI_INTER_NN
 *   NPPI_INTER_LINEAR
 *   NPPI_INTER_CUBIC
 *   NPPI_INTER_CUBIC2P_BSPLINE
 *   NPPI_INTER_CUBIC2P_CATMULLROM
 *   NPPI_INTER_CUBIC2P_B05C03
 *   NPPI_INTER_SUPER
 *   NPPI_INTER_LANCZOS
 * }</pre>
 *
 * ResizeSqrPixel attempts to choose source pixels that would approximately represent the center of the destination pixels.
 * It does so by using the following scaling formula to select source pixels for interpolation:
 *
 * <pre>{@code
 *   nAdjustedXFactor = 1.0 / nXFactor;
 *   nAdjustedYFactor = 1.0 / nYFactor;
 *   nAdjustedXShift = nXShift * nAdjustedXFactor + ((1.0 - nAdjustedXFactor) * 0.5);
 *   nAdjustedYShift = nYShift * nAdjustedYFactor + ((1.0 - nAdjustedYFactor) * 0.5);
 *   nSrcX = nAdjustedXFactor * nDstX - nAdjustedXShift;
 *   nSrcY = nAdjustedYFactor * nDstY - nAdjustedYShift;
 * }</pre>
 *
 * In the ResizeSqrPixel functions below source image clip checking is handled as follows:
 *
 * If the source pixel fractional x and y coordinates are greater than or equal to oSizeROI.x and less than oSizeROI.x + oSizeROI.width and
 * greater than or equal to oSizeROI.y and less than oSizeROI.y + oSizeROI.height then the source pixel is considered to be within
 * the source image clip rectangle and the source image is sampled.  Otherwise the source image is not sampled and a destination pixel is not
 * written to the destination image. 
 *
 * \section resize_error_codes Error Codes
 * The resize primitives return the following error codes:
 *
 *         - ::NPP_WRONG_INTERSECTION_ROI_ERROR indicates an error condition if
 *           srcROIRect has no intersection with the source image.
 *         - ::NPP_RESIZE_NO_OPERATION_ERROR if either destination ROI width or
 *           height is less than 1 pixel.
 *         - ::NPP_RESIZE_FACTOR_ERROR Indicates an error condition if either nXFactor or
 *           nYFactor is less than or equal to zero.
 *         - ::NPP_INTERPOLATION_ERROR if eInterpolation has an illegal value.
 *         - ::NPP_SIZE_ERROR if source size width or height is less than 2 pixels.
 *
 * \{
 *
 */

/** \name GetResizeRect
 * Returns NppiRect which represents the offset and size of the destination rectangle that would be generated by
 * resizing the source NppiRect by the requested scale factors and shifts.
 *                                    
 * \{
 *
 */

/**
 * @param oSrcROI Region of interest in the source image.
 * @param pDstRect User supplied host memory pointer to an NppiRect structure that will be filled in by this function with the region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiGetResizeRect(@ByVal NppiRect oSrcROI, NppiRect pDstRect, 
                  double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/** \} */

/** \name ResizeSqrPixel
 * Resizes images.
 *                                    
 * \{
 *
 */

/**
 * 1 channel 8-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 8-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 8-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 8-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P4R(@Cast("const Npp8u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 1 channel 16-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 16-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 16-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P3R(@Cast("const Npp16u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 16-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P4R(@Cast("const Npp16u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 1 channel 16-bit signed image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 16-bit signed image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 16-bit signed image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 16-bit signed image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 16-bit signed planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P3R(@Cast("const Npp16s*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 16-bit signed planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P4R(@Cast("const Npp16s*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P4R(@Cast("const Npp16s*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P4R(@Cast("const Npp16s*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_16s_P4R(@Cast("const Npp16s*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16s**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 1 channel 32-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 32-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 32-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 32-bit floating point image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 32-bit floating point planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P3R(@Cast("const Npp32f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 32-bit floating point planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P4R(@Cast("const Npp32f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 1 channel 64-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                          double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 64-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C3R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C3R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C3R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 64-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C4R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C4R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_C4R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 64-bit floating point image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_AC4R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_AC4R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_AC4R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                            double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 3 channel 64-bit floating point planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P3R(@Cast("const Npp64f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P3R(@Cast("const Npp64f*const*") @ByPtrPtr DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") @ByPtrPtr DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P3R(@Cast("const Npp64f*const*") @ByPtrPtr DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") @ByPtrPtr DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P3R(@Cast("const Npp64f*const*") @ByPtrPtr double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") @ByPtrPtr double[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * 4 channel 64-bit floating point planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param nXShift Source pixel shift in x-direction.
 * @param nYShift Source pixel shift in y-direction.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P4R(@Cast("const Npp64f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P4R(@Cast("const Npp64f*const*") @ByPtrPtr DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") @ByPtrPtr DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P4R(@Cast("const Npp64f*const*") @ByPtrPtr DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") @ByPtrPtr DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_64f_P4R(@Cast("const Npp64f*const*") @ByPtrPtr double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp64f**") @ByPtrPtr double[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                           double nXFactor, double nYFactor, double nXShift, double nYShift, int eInterpolation);

/**
 * Buffer size for \ref nppiResizeSqrPixel_8u_C1R_Advanced.
 * @param oSrcROI \ref roi_specification.
 * @param oDstROI \ref roi_specification.
 * @param hpBufferSize Required buffer size. Important: hpBufferSize is a 
 *        <em>host pointer.</em> \ref general_scratch_buffer.
 * @param eInterpolationMode The type of eInterpolation to perform resampling. Currently only supports NPPI_INTER_LANCZOS3_Advanced.
 * @return NPP_NULL_POINTER_ERROR if hpBufferSize is 0 (NULL),  \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiResizeAdvancedGetBufferHostSize_8u_C1R(@ByVal NppiSize oSrcROI, @ByVal NppiSize oDstROI, IntPointer hpBufferSize, int eInterpolationMode);
public static native @Cast("NppStatus") int nppiResizeAdvancedGetBufferHostSize_8u_C1R(@ByVal NppiSize oSrcROI, @ByVal NppiSize oDstROI, IntBuffer hpBufferSize, int eInterpolationMode);
public static native @Cast("NppStatus") int nppiResizeAdvancedGetBufferHostSize_8u_C1R(@ByVal NppiSize oSrcROI, @ByVal NppiSize oDstROI, int[] hpBufferSize, int eInterpolationMode);

/**
 * 1 channel 8-bit unsigned image resize. This primitive matches the behavior of GraphicsMagick++.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param pBuffer Device buffer that is used during calculations.
 * @param eInterpolationMode The type of eInterpolation to perform resampling. Currently only supports NPPI_INTER_LANCZOS3_Advanced.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C1R_Advanced(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                                  double nXFactor, double nYFactor, @Cast("Npp8u*") BytePointer pBuffer, int eInterpolationMode);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C1R_Advanced(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                                  double nXFactor, double nYFactor, @Cast("Npp8u*") ByteBuffer pBuffer, int eInterpolationMode);
public static native @Cast("NppStatus") int nppiResizeSqrPixel_8u_C1R_Advanced(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                                  double nXFactor, double nYFactor, @Cast("Npp8u*") byte[] pBuffer, int eInterpolationMode);
/** \} */

/** \} image_resize_square_pixel */

/** \defgroup image_resize Resize
 *
 * This function has been deprecated.  ResizeSqrPixel provides the same functionality and more.
 *
 * Resize supports the following interpolation modes:
 *
 * <pre>{@code
 *   NPPI_INTER_NN
 *   NPPI_INTER_LINEAR
 *   NPPI_INTER_CUBIC
 *   NPPI_INTER_SUPER
 *   NPPI_INTER_LANCZOS
 * }</pre>
 *
 * Resize uses the following scaling formula to select source pixels for interpolation:
 *
 * <pre>{@code
 *   scaledSrcSize.width = nXFactor * srcRectROI.width;
 *   scaledSrcSize.height = nYFactor * srcRectROI.height;
 *   nAdjustedXFactor = (srcRectROI.width - 1) / (scaledSrcSize.width - 1);
 *   nAdjustedYFactor = (srcRectROI.height - 1) / (scaledSrcSize.height - 1);
 *   nSrcX = nAdjustedXFactor * nDstX;
 *   nSrcY = nAdjustedYFactor * nDstY;
 * }</pre>
 *
 * In the Resize functions below source image clip checking is handled as follows:
 *
 * If the source pixel fractional x and y coordinates are greater than or equal to oSizeROI.x and less than oSizeROI.x + oSizeROI.width and
 * greater than or equal to oSizeROI.y and less than oSizeROI.y + oSizeROI.height then the source pixel is considered to be within
 * the source image clip rectangle and the source image is sampled.  Otherwise the source image is not sampled and a destination pixel is not
 * written to the destination image. 
 *
 * \section resize_error_codes Error Codes
 * The resize primitives return the following error codes:
 *
 *         - ::NPP_WRONG_INTERSECTION_ROI_ERROR indicates an error condition if
 *           srcROIRect has no intersection with the source image.
 *         - ::NPP_RESIZE_NO_OPERATION_ERROR if either destination ROI width or
 *           height is less than 1 pixel.
 *         - ::NPP_RESIZE_FACTOR_ERROR Indicates an error condition if either nXFactor or
 *           nYFactor is less than or equal to zero.
 *         - ::NPP_INTERPOLATION_ERROR if eInterpolation has an illegal value.
 *         - ::NPP_SIZE_ERROR if source size width or height is less than 2 pixels.
 *
 * \{
 *
 */

/** \name Resize
 * Resizes images.
 *                                    
 * \{
 *
 */

/**
 * 1 channel 8-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);

/**
 * 3 channel 8-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 3 channel 8-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 8-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_8u_P4R(@Cast("const Npp8u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);

/**
 * 1 channel 16-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);

/**
 * 3 channel 16-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed.
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                    double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                    double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                    double nXFactor, double nYFactor, int eInterpolation);

/**
 * 3 channel 16-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_16u_P3R(@Cast("const Npp16u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 16-bit unsigned planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_16u_P4R(@Cast("const Npp16u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 1 channel 32-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                  double nXFactor, double nYFactor, int eInterpolation);

/**
 * 3 channel 32-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 32-bit floating point image resize.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 32-bit floating point image resize not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                    double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                    double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                    double nXFactor, double nYFactor, int eInterpolation);

/**
 * 3 channel 32-bit floating point planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_32f_P3R(@Cast("const Npp32f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/**
 * 4 channel 32-bit floating point planar image resize.
 *
 * @param pSrc \ref source_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_planar_image_pointer_array (host memory array containing device memory image plane pointers).
 * @param nDstStep \ref destination_image_line_step.
 * @param dstROISize Size in pixels of the destination image.
 * @param nXFactor Factor by which x dimension is changed. 
 * @param nYFactor Factor by which y dimension is changed. 
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref resize_error_codes
 */
public static native @Cast("NppStatus") int nppiResize_32f_P4R(@Cast("const Npp32f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);
public static native @Cast("NppStatus") int nppiResize_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiSize dstROISize,
                   double nXFactor, double nYFactor, int eInterpolation);

/** \} */

/** \} image_resize */

/** \defgroup image_remap Remap
 *
 * Remap supports the following interpolation modes:
 *
 *   NPPI_INTER_NN
 *   NPPI_INTER_LINEAR
 *   NPPI_INTER_CUBIC
 *   NPPI_INTER_CUBIC2P_BSPLINE
 *   NPPI_INTER_CUBIC2P_CATMULLROM
 *   NPPI_INTER_CUBIC2P_B05C03
 *   NPPI_INTER_LANCZOS
 *
 * Remap chooses source pixels using pixel coordinates explicitely supplied in two 2D device memory image arrays pointed to by the pXMap and pYMap pointers.
 * The pXMap array contains the X coordinated and the pYMap array contains the Y coordinate of the corresponding source image pixel to
 * use as input.   These coordinates are in floating point format so fraction pixel positions can be used. The coordinates of the source
 * pixel to sample are determined as follows:
 *
 *   nSrcX = pxMap[nDstX, nDstY]
 *   nSrcY = pyMap[nDstX, nDstY]
 *
 * In the Remap functions below source image clip checking is handled as follows:
 *
 * If the source pixel fractional x and y coordinates are greater than or equal to oSizeROI.x and less than oSizeROI.x + oSizeROI.width and
 * greater than or equal to oSizeROI.y and less than oSizeROI.y + oSizeROI.height then the source pixel is considered to be within
 * the source image clip rectangle and the source image is sampled.  Otherwise the source image is not sampled and a destination pixel is not
 * written to the destination image. 
 *
 * \section remap_error_codes Error Codes
 * The remap primitives return the following error codes:
 *
 *         - ::NPP_WRONG_INTERSECTION_ROI_ERROR indicates an error condition if
 *           srcROIRect has no intersection with the source image.
 *         - ::NPP_INTERPOLATION_ERROR if eInterpolation has an illegal value.
 *
 * \{
 *
 */

/** \name Remap
 * Remaps images.
 *                                    
 * \{
 *
 */

/**
 * 1 channel 8-bit unsigned image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 8-bit unsigned image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image remap not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 8-bit unsigned planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_8u_P3R(@Cast("const Npp8u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                        @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                        @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                        @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_P3R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                        @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 8-bit unsigned planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_8u_P4R(@Cast("const Npp8u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                        @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                        @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                        @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_8u_P4R(@Cast("const Npp8u*const*") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                  @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                        @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 1 channel 16-bit unsigned image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 16-bit unsigned image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image remap not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of interpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                          @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 16-bit unsigned planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16u_P3R(@Cast("const Npp16u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_P3R(@Cast("const Npp16u*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 16-bit unsigned planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16u_P4R(@Cast("const Npp16u*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16u_P4R(@Cast("const Npp16u*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 1 channel 16-bit signed image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_C1R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 16-bit signed image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_C3R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 16-bit signed image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_C4R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 16-bit signed image remap not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                          @Cast("Npp16s*") short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 16-bit signed planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16s_P3R(@Cast("const Npp16s*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16s**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16s**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16s**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_P3R(@Cast("const Npp16s*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16s**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 16-bit signed planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_16s_P4R(@Cast("const Npp16s*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16s**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_P4R(@Cast("const Npp16s*const*") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp16s**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_P4R(@Cast("const Npp16s*const*") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp16s**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_16s_P4R(@Cast("const Npp16s*const*") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp16s**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 1 channel 32-bit floating point image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 32-bit floating point image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 32-bit floating point image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 32-bit floating point image remap not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                          @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 32-bit floating point planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_32f_P3R(@Cast("const Npp32f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_P3R(@Cast("const Npp32f*const*") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 32-bit floating point planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_32f_P4R(@Cast("const Npp32f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatPointer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatPointer pYMap, int nYMapStep,
                         @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") FloatBuffer pXMap, int nXMapStep, @Cast("const Npp32f*") FloatBuffer pYMap, int nYMapStep,
                         @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_32f_P4R(@Cast("const Npp32f*const*") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp32f*") float[] pXMap, int nXMapStep, @Cast("const Npp32f*") float[] pYMap, int nYMapStep,
                         @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 1 channel 64-bit floating point image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                         @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoubleBuffer pXMap, int nXMapStep, @Cast("const Npp64f*") DoubleBuffer pYMap, int nYMapStep,
                         @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") double[] pXMap, int nXMapStep, @Cast("const Npp64f*") double[] pYMap, int nYMapStep,
                         @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 64-bit floating point image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_64f_C3R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                         @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_C3R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoubleBuffer pXMap, int nXMapStep, @Cast("const Npp64f*") DoubleBuffer pYMap, int nYMapStep,
                         @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_C3R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") double[] pXMap, int nXMapStep, @Cast("const Npp64f*") double[] pYMap, int nYMapStep,
                         @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 64-bit floating point image remap.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_64f_C4R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                         @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_C4R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoubleBuffer pXMap, int nXMapStep, @Cast("const Npp64f*") DoubleBuffer pYMap, int nYMapStep,
                         @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_C4R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") double[] pXMap, int nXMapStep, @Cast("const Npp64f*") double[] pYMap, int nYMapStep,
                         @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 64-bit floating point image remap not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_64f_AC4R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                          @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_AC4R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp64f*") DoubleBuffer pXMap, int nXMapStep, @Cast("const Npp64f*") DoubleBuffer pYMap, int nYMapStep,
                          @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_AC4R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                    @Cast("const Npp64f*") double[] pXMap, int nXMapStep, @Cast("const Npp64f*") double[] pYMap, int nYMapStep,
                          @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 3 channel 64-bit floating point planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_64f_P3R(@Cast("const Npp64f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                         @Cast("Npp64f**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_P3R(@Cast("const Npp64f*const*") @ByPtrPtr DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                         @Cast("Npp64f**") @ByPtrPtr DoublePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_P3R(@Cast("const Npp64f*const*") @ByPtrPtr DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoubleBuffer pXMap, int nXMapStep, @Cast("const Npp64f*") DoubleBuffer pYMap, int nYMapStep,
                         @Cast("Npp64f**") @ByPtrPtr DoubleBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_P3R(@Cast("const Npp64f*const*") @ByPtrPtr double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") double[] pXMap, int nXMapStep, @Cast("const Npp64f*") double[] pYMap, int nYMapStep,
                         @Cast("Npp64f**") @ByPtrPtr double[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/**
 * 4 channel 64-bit floating point planar image remap.
 *
 * @param pSrc \ref source_planar_image_pointer_array.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image.
 * @param oSrcROI Region of interest in the source image.
 * @param pXMap Device memory pointer to 2D image array of X coordinate values to be used when sampling source image. 
 * @param nXMapStep pXMap image array line step in bytes.
 * @param pYMap Device memory pointer to 2D image array of Y coordinate values to be used when sampling source image. 
 * @param nYMapStep pYMap image array line step in bytes.
 * @param pDst \ref destination_planar_image_pointer_array.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstSizeROI Region of interest size in the destination image.
 * @param eInterpolation The type of eInterpolation to perform resampling.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref remap_error_codes
 */
public static native @Cast("NppStatus") int nppiRemap_64f_P4R(@Cast("const Npp64f*const*") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                         @Cast("Npp64f**") PointerPointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_P4R(@Cast("const Npp64f*const*") @ByPtrPtr DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoublePointer pXMap, int nXMapStep, @Cast("const Npp64f*") DoublePointer pYMap, int nYMapStep,
                         @Cast("Npp64f**") @ByPtrPtr DoublePointer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_P4R(@Cast("const Npp64f*const*") @ByPtrPtr DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") DoubleBuffer pXMap, int nXMapStep, @Cast("const Npp64f*") DoubleBuffer pYMap, int nYMapStep,
                         @Cast("Npp64f**") @ByPtrPtr DoubleBuffer pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);
public static native @Cast("NppStatus") int nppiRemap_64f_P4R(@Cast("const Npp64f*const*") @ByPtrPtr double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                   @Cast("const Npp64f*") double[] pXMap, int nXMapStep, @Cast("const Npp64f*") double[] pYMap, int nYMapStep,
                         @Cast("Npp64f**") @ByPtrPtr double[] pDst, int nDstStep, @ByVal NppiSize oDstSizeROI, int eInterpolation);

/** \} */

/** \} image_remap */

/** \defgroup image_rotate Rotate
 *
 *  Rotates an image around the origin (0,0) and then shifts it.
 *
 * \section rotate_error_codes Rotate Error Codes
 * - ::NPP_INTERPOLATION_ERROR if eInterpolation has an illegal value.
 * - ::NPP_RECTANGLE_ERROR Indicates an error condition if width or height of
 *   the intersection of the oSrcROI and source image is less than or
 *   equal to 1.
 * - ::NPP_WRONG_INTERSECTION_ROI_ERROR indicates an error condition if
 *   srcROIRect has no intersection with the source image.
 * - ::NPP_WRONG_INTERSECTION_QUAD_WARNING indicates a warning that no
 *   operation is performed if the transformed source ROI does not
 *   intersect the destination ROI.
 *
 * \{
 *
 */

/** \name Utility Functions
 *
 * \{
 *
 */

/**
 * Compute shape of rotated image.
 * 
 * @param oSrcROI Region-of-interest of the source image.
 * @param aQuad Array of 2D points. These points are the locations of the corners
 *      of the rotated ROI. 
 * @param nAngle The rotation nAngle.
 * @param nShiftX Post-rotation shift in x-direction
 * @param nShiftY Post-rotation shift in y-direction
 * @return \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiGetRotateQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") DoublePointer aQuad, double nAngle, double nShiftX, double nShiftY);
public static native @Cast("NppStatus") int nppiGetRotateQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") DoubleBuffer aQuad, double nAngle, double nShiftX, double nShiftY);
public static native @Cast("NppStatus") int nppiGetRotateQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") double[] aQuad, double nAngle, double nShiftX, double nShiftY);

/**
 * Compute bounding-box of rotated image.
 * @param oSrcROI Region-of-interest of the source image.
 * @param aBoundingBox Two 2D points representing the bounding-box of the rotated image. All four points
 *      from nppiGetRotateQuad are contained inside the axis-aligned rectangle spanned by the the two
 *      points of this bounding box.
 * @param nAngle The rotation angle.
 * @param nShiftX Post-rotation shift in x-direction.
 * @param nShiftY Post-rotation shift in y-direction.
 *
 * @return \ref roi_error_codes.
 */
public static native @Cast("NppStatus") int nppiGetRotateBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") DoublePointer aBoundingBox, double nAngle, double nShiftX, double nShiftY);
public static native @Cast("NppStatus") int nppiGetRotateBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") DoubleBuffer aBoundingBox, double nAngle, double nShiftX, double nShiftY);
public static native @Cast("NppStatus") int nppiGetRotateBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") double[] aBoundingBox, double nAngle, double nShiftX, double nShiftY);

/** \} Utility Functions */

/** \name Rotate
 *
 * \{
 *
 */

/**
 * 8-bit unsigned image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 3 channel 8-bit unsigned image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                  double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 4 channel 8-bit unsigned image rotate ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 16-bit unsigned image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 3 channel 16-bit unsigned image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 4 channel 16-bit unsigned image rotate ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                    double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                    double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                    double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 32-bit float image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 3 channel 32-bit float image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 4 channel 32-bit float image rotate.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                   double nAngle, double nShiftX, double nShiftY, int eInterpolation);

/**
 * 4 channel 32-bit float image rotate ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcSize Size in pixels of the source image
 * @param oSrcROI Region of interest in the source image.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Region of interest in the destination image.
 * @param nAngle The angle of rotation in degrees.
 * @param nShiftX Shift along horizontal axis 
 * @param nShiftY Shift along vertical axis 
 * @param eInterpolation The type of interpolation to perform resampling
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref rotate_error_codes
 */
public static native @Cast("NppStatus") int nppiRotate_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                    double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,
                    double nAngle, double nShiftX, double nShiftY, int eInterpolation);
public static native @Cast("NppStatus") int nppiRotate_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                          @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI,
                    double nAngle, double nShiftX, double nShiftY, int eInterpolation);
/** \} */

/** \} image_rotate */

/** \defgroup image_mirror Mirror
 * \section mirror_error_codes Mirror Error Codes
 *         - ::NPP_MIRROR_FLIP_ERR if flip has an illegal value.
 *
 * \{
 *
 */

/** \name Mirror
 *  Mirrors images horizontally, vertically and diagonally.
 *
 * \{
 *
 */

/**
 * 1 channel 8-bit unsigned image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 1 channel 8-bit unsigned in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_C1IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C1IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C1IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
                              
/**
 * 3 channel 8-bit unsigned image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 8-bit unsigned in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_C3IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C3IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C3IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 8-bit unsigned image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                  @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 8-bit unsigned in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_C4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_C4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 8-bit unsigned image mirror not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                         @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                         @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                         @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 8-bit unsigned in place image mirror not affecting alpha.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_8u_AC4IR(@Cast("Npp8u*") BytePointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_AC4IR(@Cast("Npp8u*") ByteBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_8u_AC4IR(@Cast("Npp8u*") byte[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
/**
 * 1 channel 16-bit unsigned image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C1R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
                              
/**
 * 1 channel 16-bit unsigned in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_C1IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C1IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C1IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 16-bit unsigned image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C3R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 16-bit unsigned in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_C3IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C3IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C3IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit unsigned image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                         @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                         @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                         @Cast("Npp16u*") short[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit unsigned in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_C4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_C4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit unsigned image mirror not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, int nSrcStep, 
                          @Cast("Npp16u*") ShortPointer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, int nSrcStep, 
                          @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, int nSrcStep, 
                          @Cast("Npp16u*") short[] pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit unsigned in place image mirror not affecting alpha.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16u_AC4IR(@Cast("Npp16u*") ShortPointer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_AC4IR(@Cast("Npp16u*") ShortBuffer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16u_AC4IR(@Cast("Npp16u*") short[] pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 1 channel 16-bit signed image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                         @Cast("Npp16s*") short[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
                              
/**
 * 1 channel 16-bit signed in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_C1IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C1IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C1IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 16-bit signed image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_C3R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C3R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C3R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                         @Cast("Npp16s*") short[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 16-bit signed in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_C3IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C3IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C3IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit signed image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_C4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                         @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                         @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                         @Cast("Npp16s*") short[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit signed in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_C4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_C4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit signed image mirror not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_AC4R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_AC4R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_AC4R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                          @Cast("Npp16s*") short[] pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 16-bit signed in place image mirror not affecting alpha.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_16s_AC4IR(@Cast("Npp16s*") ShortPointer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_AC4IR(@Cast("Npp16s*") ShortBuffer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_16s_AC4IR(@Cast("Npp16s*") short[] pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 1 channel 32-bit image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, 
                         @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, 
                         @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C1R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, 
                         @Cast("Npp32s*") int[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
                              
/**
 * 1 channel 32-bit signed in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_C1IR(@Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C1IR(@Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C1IR(@Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 32-bit image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, 
                         @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, 
                         @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C3R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, 
                         @Cast("Npp32s*") int[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 32-bit signed in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_C3IR(@Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C3IR(@Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C3IR(@Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 32-bit image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, 
                         @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, 
                         @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, 
                         @Cast("Npp32s*") int[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 32-bit signed in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_C4IR(@Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C4IR(@Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_C4IR(@Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);


/**
 * 4 channel 32-bit image mirror not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, int nSrcStep, 
                          @Cast("Npp32s*") IntPointer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, int nSrcStep, 
                          @Cast("Npp32s*") IntBuffer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, int nSrcStep, 
                          @Cast("Npp32s*") int[] pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 32-bit signed in place image mirror not affecting alpha.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32s_AC4IR(@Cast("Npp32s*") IntPointer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_AC4IR(@Cast("Npp32s*") IntBuffer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32s_AC4IR(@Cast("Npp32s*") int[] pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);


/**
 * 1 channel 32-bit float image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C1R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
                              
/**
 * 1 channel 32-bit float in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_C1IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C1IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C1IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);


/**
 * 3 channel 32-bit float image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C3R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 3 channel 32-bit float in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_C3IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C3IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C3IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 32-bit float image mirror.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, 
                         @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, 
                         @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, 
                         @Cast("Npp32f*") float[] pDst, int nDstStep, 
                   @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 32-bit float in place image mirror.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_C4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_C4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 32-bit float image mirror not affecting alpha.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Distance in bytes between starts of consecutive lines of the
 *        destination image.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, int nSrcStep, 
                          @Cast("Npp32f*") FloatPointer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, int nSrcStep, 
                          @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, int nSrcStep, 
                          @Cast("Npp32f*") float[] pDst, int nDstStep, 
                    @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/**
 * 4 channel 32-bit float in place image mirror not affecting alpha.
 *
 * @param pSrcDst \ref in_place_image_pointer.
 * @param nSrcDstStep \ref in_place_image_line_step.
 * @param oROI \ref roi_specification.
 * @param flip Specifies the axis about which the image is to be mirrored.
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref mirror_error_codes
 */
public static native @Cast("NppStatus") int nppiMirror_32f_AC4IR(@Cast("Npp32f*") FloatPointer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_AC4IR(@Cast("Npp32f*") FloatBuffer pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);
public static native @Cast("NppStatus") int nppiMirror_32f_AC4IR(@Cast("Npp32f*") float[] pSrcDst, int nSrcDstStep, 
                     @ByVal NppiSize oROI, @Cast("NppiAxis") int flip);

/** \} */

/** \} image_mirror */

/** \defgroup image_affine_transform Affine Transforms
 *
 * \section affine_transform_error_codes Affine Transform Error Codes
 *
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_WRONG_INTERSECTION_ROI_ERROR Indicates an error condition if
 *           oSrcROI has no intersection with the source image
 *         - ::NPP_INTERPOLATION_ERROR Indicates an error condition if
 *           interpolation has an illegal value
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 *         - ::NPP_WRONG_INTERSECTION_QUAD_WARNING Indicates a warning that no
 *           operation is performed if the transformed source ROI has no
 *           intersection with the destination ROI
 *
 * \{
 *
 */

/** \name Utility Functions
 *
 * \{
 *
 */

/**
 * Computes affine transform coefficients based on source ROI and destination quadrilateral.
 *
 * The function computes the coefficients of an affine transformation that maps the
 * given source ROI (axis aligned rectangle with integer coordinates) to a quadrilateral
 * in the destination image.
 *
 * An affine transform in 2D is fully determined by the mapping of just three vertices.
 * This function's API allows for passing a complete quadrilateral effectively making the 
 * prolem overdetermined. What this means in practice is, that for certain quadrilaterals it is
 * not possible to find an affine transform that would map all four corners of the source
 * ROI to the four vertices of that quadrilateral.
 *
 * The function circumvents this problem by only looking at the first three vertices of
 * the destination image quadrilateral to determine the affine transformation's coefficients.
 * If the destination quadrilateral is indeed one that cannot be mapped using an affine
 * transformation the functions informs the user of this situation by returning a 
 * ::NPP_AFFINE_QUAD_INCORRECT_WARNING.
 *
 * @param oSrcROI The source ROI. This rectangle needs to be at least one pixel wide and
 *          high. If either width or hight are less than one an ::NPP_RECT_ERROR is returned.
 * @param aQuad The destination quadrilateral.
 * @param aCoeffs The resulting affine transform coefficients.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *           has zero or negative value
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 *         - ::NPP_AFFINE_QUAD_INCORRECT_WARNING Indicates a warning when quad
 *           does not conform to the transform properties. Fourth vertex is
 *           ignored, internally computed coordinates are used instead
 */
public static native @Cast("NppStatus") int nppiGetAffineTransform(@ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aQuad, @Cast("double(* /*[2]*/ )[3]") DoublePointer aCoeffs);
public static native @Cast("NppStatus") int nppiGetAffineTransform(@ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aQuad, @Cast("double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiGetAffineTransform(@ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aQuad, @Cast("double(* /*[2]*/ )[3]") double[] aCoeffs);


/**
 * Compute shape of transformed image.
 *
 * This method computes the quadrilateral in the destination image that 
 * the source ROI is transformed into by the affine transformation expressed
 * by the coefficients array (aCoeffs).
 *
 * @param oSrcROI The source ROI.
 * @param aQuad The resulting destination quadrangle.
 * @param aCoeffs The afine transform coefficients.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *           has zero or negative value
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 */
public static native @Cast("NppStatus") int nppiGetAffineQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") DoublePointer aQuad, @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs);
public static native @Cast("NppStatus") int nppiGetAffineQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") DoubleBuffer aQuad, @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiGetAffineQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") double[] aQuad, @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs);


/**
 * Compute bounding-box of transformed image.
 *
 * The method effectively computes the bounding box (axis aligned rectangle) of
 * the transformed source ROI (see nppiGetAffineQuad()). 
 *
 * @param oSrcROI The source ROI.
 * @param aBound The resulting bounding box.
 * @param aCoeffs The afine transform coefficients.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *           has zero or negative value
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 */
public static native @Cast("NppStatus") int nppiGetAffineBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") DoublePointer aBound, @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs);
public static native @Cast("NppStatus") int nppiGetAffineBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") DoubleBuffer aBound, @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiGetAffineBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") double[] aBound, @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs);

/** \} Utility Functions Section */

/** \name Affine Transform
 * Transforms (warps) an image based on an affine transform. The affine
 * transform is given as a \f$2\times 3\f$ matrix C. A pixel location \f$(x, y)\f$ in the
 * source image is mapped to the location \f$(x', y')\f$ in the destination image.
 * The destination image coorodinates are computed as follows:
 * \f[
 * x' = c_{00} * x + c_{01} * y + c_{02} \qquad
 * y' = c_{10} * x + c_{11} * y + c_{12} \qquad
 * C = \left[ \matrix{c_{00} & c_{01} & c_{02} \cr 
                      c_{10} & c_{11} & c_{12} } \right]
 * \f]
 * Affine transforms can be understood as a linear transformation (traditional
 * matrix multiplication) and a shift operation. The \f$2\times 2\f$ matrix 
 * \f[
 *    L = \left[ \matrix{c_{00} & c_{01} \cr 
 *                       c_{10} & c_{11} } \right]
 * \f]
 * represents the linear transform portion of the affine transformation. The
 * vector
 * \f[
 *      v = \left( \matrix{c_{02} \cr
                           c_{12} } \right)
 * \f]
 * represents the post-transform shift, i.e. after the pixel location is transformed
 * by \f$L\f$ it is translated by \f$v\f$.
 * 
 * \{
 *
 */


/**
 * Single-channel 8-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                            @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 8-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);


/**
 * Four-channel 8-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);


/**
 * Four-channel 8-bit unsigned affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);


/**
 * Three-channel planar 8-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P3R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 8-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P4R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                            @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                      @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 16-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 16-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 16-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 16-bit unsigned affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 16-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P3R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 16-bit unsigned affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P4R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit signed affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C1R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit signed affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C3R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_C4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit signed affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P3R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit signed affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P4R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P3R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P4R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);


/**
 * Single-channel 64-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C1R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C1R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C1R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 64-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C3R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C3R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C3R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 64-bit floating-point affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C4R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C4R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_C4R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                             @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 64-bit floating-point affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_64f_AC4R(@Cast("const Npp64f*") DoublePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp64f*") DoublePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_AC4R(@Cast("const Npp64f*") DoubleBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp64f*") DoubleBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_AC4R(@Cast("const Npp64f*") double[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                              @Cast("Npp64f*") double[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                        @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 64-bit floating-point affine warp.
 * 
 * @param aSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P3R(@Cast("const Npp64f**") PointerPointer aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") PointerPointer aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P3R(@Cast("const Npp64f**") @ByPtrPtr DoublePointer aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") @ByPtrPtr DoublePointer aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P3R(@Cast("const Npp64f**") @ByPtrPtr DoubleBuffer aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") @ByPtrPtr DoubleBuffer aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P3R(@Cast("const Npp64f**") @ByPtrPtr double[] aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") @ByPtrPtr double[] aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 64-bit floating-point affine warp.
 * 
 * @param aSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P4R(@Cast("const Npp64f**") PointerPointer aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") PointerPointer aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P4R(@Cast("const Npp64f**") @ByPtrPtr DoublePointer aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") @ByPtrPtr DoublePointer aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P4R(@Cast("const Npp64f**") @ByPtrPtr DoubleBuffer aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") @ByPtrPtr DoubleBuffer aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffine_64f_P4R(@Cast("const Npp64f**") @ByPtrPtr double[] aSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                             @Cast("Npp64f**") @ByPtrPtr double[] aDst, int nDstStep, @ByVal NppiRect oDstROI, 
                       @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);


/** \} Affine Transform Section */

/** \name Backwards Affine Transform
 * Transforms (warps) an image based on an affine transform. The affine
 * transform is given as a \f$2\times 3\f$ matrix C. A pixel location \f$(x, y)\f$ in the
 * source image is mapped to the location \f$(x', y')\f$ in the destination image.
 * The destination image coorodinates fullfil the following properties:
 * \f[
 * x = c_{00} * x' + c_{01} * y' + c_{02} \qquad
 * y = c_{10} * x' + c_{11} * y' + c_{12} \qquad
 * C = \left[ \matrix{c_{00} & c_{01} & c_{02} \cr 
                      c_{10} & c_{11} & c_{12} } \right]
 * \f]
 * In other words, given matrix \f$C\f$ the source image's shape is transfored to the destination image
 * using the inverse matrix \f$C^{-1}\f$:
 * \f[
 * M = C^{-1} = \left[ \matrix{m_{00} & m_{01} & m_{02} \cr 
                               m_{10} & m_{11} & m_{12} } \right]
 * x' = m_{00} * x + m_{01} * y + m_{02} \qquad
 * y' = m_{10} * x + m_{11} * y + m_{12} \qquad
 * \f]
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 8-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer backwards affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 8-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P3R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 8-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P4R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                          @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 16-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 16-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer backwards affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 16-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P3R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 16-bit unsigned integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P4R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit signed integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C1R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit signed integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C3R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_C4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed integer backwards affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit signed integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P3R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit signed integer backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P4R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit floating-point backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit floating-point backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point backwards affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit floating-point backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P3R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit floating-point backwards affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Affine transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P4R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineBack_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[2]*/ )[3]") double[] aCoeffs, int eInterpolation);


/** \} Backwards Affine Transform Section */

/** \name Quad-Based Affine Transform
 * Transforms (warps) an image based on an affine transform. The affine
 * transform is computed such that it maps a quadrilateral in source image space to a 
 * quadrilateral in destination image space. 
 *
 * An affine transform is fully determined by the mapping of 3 discrete points.
 * The following primitives compute an affine transformation matrix that maps 
 * the first three corners of the source quad are mapped to the first three 
 * vertices of the destination image quad. If the fourth vertices do not match
 * the transform, an ::NPP_AFFINE_QUAD_INCORRECT_WARNING is returned by the primitive.
 *
 *
 * \{
 *
 */

/**
 * Single-channel 32-bit floating-point quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                @Cast("Npp8u*") BytePointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                @Cast("Npp8u*") ByteBuffer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                @Cast("Npp8u*") byte[] pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                          int eInterpolation);


/**
 * Three-channel 8-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                @Cast("Npp8u*") BytePointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                @Cast("Npp8u*") ByteBuffer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                @Cast("Npp8u*") byte[] pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                          int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                @Cast("Npp8u*") BytePointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                @Cast("Npp8u*") ByteBuffer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                @Cast("Npp8u*") byte[] pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                          int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer quad-based affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp8u*") BytePointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp8u*") ByteBuffer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp8u*") byte[] pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Three-channel planar 8-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P3R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                @Cast("Npp8u**") PointerPointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                @Cast("Npp8u**") @ByPtrPtr BytePointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                @Cast("Npp8u**") @ByPtrPtr byte[] pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                          int eInterpolation);

/**
 * Four-channel planar 8-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P4R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                @Cast("Npp8u**") PointerPointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                @Cast("Npp8u**") @ByPtrPtr BytePointer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                          int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                @Cast("Npp8u**") @ByPtrPtr byte[] pDst,                    int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                          int eInterpolation);

/**
 * Single-channel 16-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI,                    @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,                    @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI,                    @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Three-channel 16-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer quad-based affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                            int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                            int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                            int eInterpolation);

/**
 * Three-channel planar 16-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P3R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel planar 16-bit unsigned integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P4R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Single-channel 32-bit signed integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C1R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Three-channel 32-bit signed integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C3R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel 32-bit signed integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_C4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel 32-bit signed integer quad-based affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                  @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                            int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                  @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                            int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                  @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                            int eInterpolation);

/**
 * Three-channel planar 32-bit signed integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P3R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel planar 32-bit signed integer quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P4R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Single-channel 32-bit floating-point quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Three-channel 32-bit floating-point quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel 32-bit floating-point quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad,
                                 @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad,
                                 @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad,
                                 @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel 32-bit floating-point quad-based affine warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                            int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                            int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                            int eInterpolation);

/**
 * Three-channel planar 32-bit floating-point quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P3R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);

/**
 * Four-channel planar 32-bit floating-point quad-based affine warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref affine_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P4R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                 @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, 
                           int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpAffineQuad_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                 @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, 
                           int eInterpolation);


/** \} Quad-Based Affine Transform Section */

/** \} image_affine_transforms */

/** \defgroup image_perspective_transforms Perspective Transform
 *
 * \section perspective_transform_error_codes Perspective Transform Error Codes
 *
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_WRONG_INTERSECTION_ROI_ERROR Indicates an error condition if
 *           oSrcROI has no intersection with the source image
 *         - ::NPP_INTERPOLATION_ERROR Indicates an error condition if
 *           interpolation has an illegal value
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 *         - ::NPP_WRONG_INTERSECTION_QUAD_WARNING Indicates a warning that no
 *           operation is performed if the transformed source ROI has no
 *           intersection with the destination ROI
 *
 * \{
 *
 */

/** \name Utility Functions
 *
 * \{
 *
 */

/**
 * Calculates perspective transform coefficients given source rectangular ROI
 * and its destination quadrangle projection
 *
 * @param oSrcROI Source ROI
 * @param quad Destination quadrangle
 * @param aCoeffs Perspective transform coefficients
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *           has zero or negative value
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 */
public static native @Cast("NppStatus") int nppiGetPerspectiveTransform(@ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer quad, @Cast("double(* /*[3]*/ )[3]") DoublePointer aCoeffs);
public static native @Cast("NppStatus") int nppiGetPerspectiveTransform(@ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer quad, @Cast("double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiGetPerspectiveTransform(@ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] quad, @Cast("double(* /*[3]*/ )[3]") double[] aCoeffs);


/**
 * Calculates perspective transform projection of given source rectangular
 * ROI
 *
 * @param oSrcROI Source ROI
 * @param quad Destination quadrangle
 * @param aCoeffs Perspective transform coefficients
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *           has zero or negative value
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 */
public static native @Cast("NppStatus") int nppiGetPerspectiveQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") DoublePointer quad, @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs);
public static native @Cast("NppStatus") int nppiGetPerspectiveQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") DoubleBuffer quad, @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiGetPerspectiveQuad(@ByVal NppiRect oSrcROI, @Cast("double(* /*[4]*/ )[2]") double[] quad, @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs);


/**
 * Calculates bounding box of the perspective transform projection of the
 * given source rectangular ROI
 *
 * @param oSrcROI Source ROI
 * @param bound Bounding box of the transformed source ROI
 * @param aCoeffs Perspective transform coefficients
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *           has zero or negative value
 *         - ::NPP_RECT_ERROR Indicates an error condition if width or height of
 *           the intersection of the oSrcROI and source image is less than or
 *           equal to 1
 *         - ::NPP_COEFF_ERROR Indicates an error condition if coefficient values
 *           are invalid
 */
public static native @Cast("NppStatus") int nppiGetPerspectiveBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") DoublePointer bound, @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs);
public static native @Cast("NppStatus") int nppiGetPerspectiveBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") DoubleBuffer bound, @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs);
public static native @Cast("NppStatus") int nppiGetPerspectiveBound(@ByVal NppiRect oSrcROI, @Cast("double(* /*[2]*/ )[2]") double[] bound, @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs);

/** \} Utility Functions Section */

/** \name Perspective Transform
 * Transforms (warps) an image based on a perspective transform. The perspective
 * transform is given as a \f$3\times 3\f$ matrix C. A pixel location \f$(x, y)\f$ in the
 * source image is mapped to the location \f$(x', y')\f$ in the destination image.
 * The destination image coorodinates are computed as follows:
 * \f[
 * x' = \frac{c_{00} * x + c_{01} * y + c_{02}}{c_{20} * x + c_{21} * y + c_{22}} \qquad
 * y' = \frac{c_{10} * x + c_{11} * y + c_{12}}{c_{20} * x + c_{21} * y + c_{22}}
 * \f]
 * \f[
 * C = \left[ \matrix{c_{00} & c_{01} & c_{02}   \cr 
                      c_{10} & c_{11} & c_{12}   \cr 
                      c_{20} & c_{21} & c_{22} } \right]
 * \f]
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 8-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer perspective warp, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 8-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P3R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 8-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P4R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                 @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                           @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 16-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 16-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs,int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs,int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs,int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer perspective warp, igoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 16-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P3R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 16-bit unsigned integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P4R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit signed integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C1R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit signed integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C3R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_C4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed integer perspective warp, igoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit signed integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P3R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit signed integer perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P4R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit floating-point perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit floating-point perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point perspective warp, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                   @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                             @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit floating-point perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P3R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit floating-point perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P4R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspective_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                  @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                            @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/** \} Perspective Transform Section */


/** \name Backwards Perspective Transform
 * Transforms (warps) an image based on a perspective transform. The perspective
 * transform is given as a \f$3\times 3\f$ matrix C. A pixel location \f$(x, y)\f$ in the
 * source image is mapped to the location \f$(x', y')\f$ in the destination image.
 * The destination image coorodinates fullfil the following properties:
 * \f[
 * x = \frac{c_{00} * x' + c_{01} * y' + c_{02}}{c_{20} * x' + c_{21} * y' + c_{22}} \qquad
 * y = \frac{c_{10} * x' + c_{11} * y' + c_{12}}{c_{20} * x' + c_{21} * y' + c_{22}}
 * \f]
 * \f[
 * C = \left[ \matrix{c_{00} & c_{01} & c_{02}   \cr 
                      c_{10} & c_{11} & c_{12}   \cr 
                      c_{20} & c_{21} & c_{22} } \right]
 * \f]
 * In other words, given matrix \f$C\f$ the source image's shape is transfored to the destination image
 * using the inverse matrix \f$C^{-1}\f$:
 * \f[
 * M = C^{-1} = \left[ \matrix{m_{00} & m_{01} & m_{02} \cr 
                               m_{10} & m_{11} & m_{12} \cr 
                               m_{20} & m_{21} & m_{22} } \right]
 * x' = \frac{c_{00} * x + c_{01} * y + c_{02}}{c_{20} * x + c_{21} * y + c_{22}} \qquad
 * y' = \frac{c_{10} * x + c_{11} * y + c_{12}}{c_{20} * x + c_{21} * y + c_{22}}
 * \f]
 *
 * \{
 *
 */


/**
 * Single-channel 8-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 8-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                                     @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                                     @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                                     @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer backwards perspective warp, igoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 8-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P3R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 8-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P4R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                     @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                               @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);


/**
 * Single-channel 16-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 16-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);
                                            
/**
 * Four-channel 16-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer backwards perspective warp, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 16-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P3R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 16-bit unsigned integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P4R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit signed integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C1R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit signed integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C3R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_C4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit signed integer backwards perspective warp, ignoring alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit signed integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P3R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit signed integer backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P4R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Single-channel 32-bit floating-point backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel 32-bit floating-point backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel 32-bit floating-point backwards perspective warp, ignorning alpha channel.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                 @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Three-channel planar 32-bit floating-point backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P3R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, 
                                      @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/**
 * Four-channel planar 32-bit floating-point backwards perspective warp.
 *
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aCoeffs Perspective transform coefficients
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P4R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                                      @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                                      @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoublePointer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                                      @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") DoubleBuffer aCoeffs, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveBack_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI,
                                      @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, 
                                @Cast("const double(* /*[3]*/ )[3]") double[] aCoeffs, int eInterpolation);

/** \} Backwards Perspective Transform Section */

/** \name Quad-Based Perspective Transform
 * Transforms (warps) an image based on an perspective transform. The perspective
 * transform is computed such that it maps a quadrilateral in source image space to a 
 * quadrilateral in destination image space. 
 *
 * \{
 *
 */

/**
 * Single-channel 8-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
 public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C1R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
 public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
 public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C1R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel 8-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C3R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                     @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI,  @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C3R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                     @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI,  @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C3R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                     @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI,  @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                     @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                     @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_C4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                     @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 8-bit unsigned integer quad-based perspective warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_AC4R(@Cast("const Npp8u*") BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp8u*") BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_AC4R(@Cast("const Npp8u*") ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_AC4R(@Cast("const Npp8u*") byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp8u*") byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel planar 8-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P3R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                     @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                     @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                     @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P3R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                     @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel planar 8-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P4R(@Cast("const Npp8u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                     @Cast("Npp8u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr BytePointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                     @Cast("Npp8u**") @ByPtrPtr BytePointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr ByteBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                     @Cast("Npp8u**") @ByPtrPtr ByteBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_8u_P4R(@Cast("const Npp8u**") @ByPtrPtr byte[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                     @Cast("Npp8u**") @ByPtrPtr byte[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Single-channel 16-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C1R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C1R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C1R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel 16-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C3R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C3R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C3R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_C4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 16-bit unsigned integer quad-based perspective warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_AC4R(@Cast("const Npp16u*") ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                       @Cast("Npp16u*") ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_AC4R(@Cast("const Npp16u*") ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                       @Cast("Npp16u*") ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_AC4R(@Cast("const Npp16u*") short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                       @Cast("Npp16u*") short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel planar 16-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P3R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P3R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel planar 16-bit unsigned integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P4R(@Cast("const Npp16u**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp16u**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr ShortBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp16u**") @ByPtrPtr ShortBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_16u_P4R(@Cast("const Npp16u**") @ByPtrPtr short[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp16u**") @ByPtrPtr short[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Single-channel 32-bit signed integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C1R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C1R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C1R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel 32-bit signed integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C3R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C3R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C3R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 32-bit signed integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_C4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 32-bit signed integer quad-based perspective warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_AC4R(@Cast("const Npp32s*") IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                       @Cast("Npp32s*") IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_AC4R(@Cast("const Npp32s*") IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                       @Cast("Npp32s*") IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_AC4R(@Cast("const Npp32s*") int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                       @Cast("Npp32s*") int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel planar 32-bit signed integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P3R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P3R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel planar 32-bit signed integer quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P4R(@Cast("const Npp32s**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32s**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32s**") @ByPtrPtr IntPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr IntBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32s**") @ByPtrPtr IntBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32s_P4R(@Cast("const Npp32s**") @ByPtrPtr int[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32s**") @ByPtrPtr int[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);
                                            
/**
 * Single-channel 32-bit floating-point quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C1R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C1R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C1R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel 32-bit floating-point quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C3R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C3R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C3R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 32-bit floating-point quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_C4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel 32-bit floating-point quad-based perspective warp, ignoring alpha channel.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_AC4R(@Cast("const Npp32f*") FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                       @Cast("Npp32f*") FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_AC4R(@Cast("const Npp32f*") FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                       @Cast("Npp32f*") FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_AC4R(@Cast("const Npp32f*") float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                       @Cast("Npp32f*") float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Three-channel planar 32-bit floating-point quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P3R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P3R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);

/**
 * Four-channel planar 32-bit floating-point quad-based perspective warp.
 * 
 * @param pSrc \ref source_image_pointer.
 * @param oSrcSize Size of source image in pixels
 * @param nSrcStep \ref source_image_line_step.
 * @param oSrcROI Source ROI
 * @param aSrcQuad Source quad.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param oDstROI Destination ROI
 * @param aDstQuad Destination quad.
 * @param eInterpolation Interpolation mode: can be NPPI_INTER_NN,
 *        NPPI_INTER_LINEAR or NPPI_INTER_CUBIC
 * @return \ref image_data_error_codes, \ref roi_error_codes, \ref perspective_transform_error_codes
 */
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P4R(@Cast("const Npp32f**") PointerPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32f**") PointerPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatPointer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aSrcQuad, 
                                      @Cast("Npp32f**") @ByPtrPtr FloatPointer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoublePointer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr FloatBuffer pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aSrcQuad, 
                                      @Cast("Npp32f**") @ByPtrPtr FloatBuffer pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") DoubleBuffer aDstQuad, int eInterpolation);
public static native @Cast("NppStatus") int nppiWarpPerspectiveQuad_32f_P4R(@Cast("const Npp32f**") @ByPtrPtr float[] pSrc, @ByVal NppiSize oSrcSize, int nSrcStep, @ByVal NppiRect oSrcROI, @Cast("const double(* /*[4]*/ )[2]") double[] aSrcQuad, 
                                      @Cast("Npp32f**") @ByPtrPtr float[] pDst, int nDstStep, @ByVal NppiRect oDstROI, @Cast("const double(* /*[4]*/ )[2]") double[] aDstQuad, int eInterpolation);



/** \} Quad-Based Perspective Transform Section */

/** \} image_perspective_transforms */

/** \} image_geometry_transforms */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_GEOMETRY_TRANSFORMS_H */


// Parsed from <nppi_compression_functions.h>

 /* Copyright 2009-2014 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_COMPRESSION_FUNCTIONS_H
// #define NV_NPPI_COMPRESSION_FUNCTIONS_H
 
/**
 * \file nppi_compression_functions.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"

// #ifdef __cplusplus
// #endif

/** \defgroup image_compression Compression
 *  \ingroup nppi
 *
 * Image compression primitives.
 *
 * The JPEG standard defines a flow of level shift, DCT and quantization for
 * forward JPEG transform and inverse level shift, IDCT and de-quantization
 * for inverse JPEG transform. This group has the functions for both forward
 * and inverse functions. 
 *
 * \{
 *
 */

/** \defgroup image_quantization Quantization Functions
 *
 * \{
 *
 */

/**
 * Apply quality factor to raw 8-bit quantization table.
 *
 * This is effectively and in-place method that modifies a given raw
 * quantization table based on a quality factor.
 * Note that this method is a host method and that the pointer to the
 * raw quantization table is a host pointer.
 *
 * @param hpQuantRawTable Raw quantization table.
 * @param nQualityFactor Quality factor for the table. Range is [1:100].
 * @return Error code:
 *      ::NPP_NULL_POINTER_ERROR is returned if hpQuantRawTable is 0.
 */
public static native @Cast("NppStatus") int nppiQuantFwdRawTableInit_JPEG_8u(@Cast("Npp8u*") BytePointer hpQuantRawTable, int nQualityFactor);
public static native @Cast("NppStatus") int nppiQuantFwdRawTableInit_JPEG_8u(@Cast("Npp8u*") ByteBuffer hpQuantRawTable, int nQualityFactor);
public static native @Cast("NppStatus") int nppiQuantFwdRawTableInit_JPEG_8u(@Cast("Npp8u*") byte[] hpQuantRawTable, int nQualityFactor);

/**
 * Initializes a quantization table for nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R().
 *    The method creates a 16-bit version of the raw table and converts the 
 * data order from zigzag layout to original row-order layout since raw
 * quantization tables are typically stored in zigzag format.
 *
 * This method is a host method. It consumes and produces host data. I.e. the pointers
 * passed to this function must be host pointers. The resulting table needs to be
 * transferred to device memory in order to be used with nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R()
 * function.
 *
 * @param hpQuantRawTable Host pointer to raw quantization table as returned by 
 *      nppiQuantFwdRawTableInit_JPEG_8u(). The raw quantization table is assumed to be in
 *      zigzag order.
 * @param hpQuantFwdRawTable Forward quantization table for use with nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R().
 * @return Error code:
 *      ::NPP_NULL_POINTER_ERROR pQuantRawTable is 0.
 */
public static native @Cast("NppStatus") int nppiQuantFwdTableInit_JPEG_8u16u(@Cast("const Npp8u*") BytePointer hpQuantRawTable, @Cast("Npp16u*") ShortPointer hpQuantFwdRawTable);
public static native @Cast("NppStatus") int nppiQuantFwdTableInit_JPEG_8u16u(@Cast("const Npp8u*") ByteBuffer hpQuantRawTable, @Cast("Npp16u*") ShortBuffer hpQuantFwdRawTable);
public static native @Cast("NppStatus") int nppiQuantFwdTableInit_JPEG_8u16u(@Cast("const Npp8u*") byte[] hpQuantRawTable, @Cast("Npp16u*") short[] hpQuantFwdRawTable);

/**
 * Initializes a quantization table for nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R().
 *      The nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R() method uses a quantization table
 * in a 16-bit format allowing for faster processing. In addition it converts the 
 * data order from zigzag layout to original row-order layout. Typically raw
 * quantization tables are stored in zigzag format.
 *
 * This method is a host method and consumes and produces host data. I.e. the pointers
 * passed to this function must be host pointers. The resulting table needs to be
 * transferred to device memory in order to be used with nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R()
 * function.
 *
 * @param hpQuantRawTable Raw quantization table.
 * @param hpQuantFwdRawTable Inverse quantization table.
 * @return ::NPP_NULL_POINTER_ERROR pQuantRawTable or pQuantFwdRawTable is0.
 */
public static native @Cast("NppStatus") int nppiQuantInvTableInit_JPEG_8u16u(@Cast("const Npp8u*") BytePointer hpQuantRawTable, @Cast("Npp16u*") ShortPointer hpQuantFwdRawTable);
public static native @Cast("NppStatus") int nppiQuantInvTableInit_JPEG_8u16u(@Cast("const Npp8u*") ByteBuffer hpQuantRawTable, @Cast("Npp16u*") ShortBuffer hpQuantFwdRawTable);
public static native @Cast("NppStatus") int nppiQuantInvTableInit_JPEG_8u16u(@Cast("const Npp8u*") byte[] hpQuantRawTable, @Cast("Npp16u*") short[] hpQuantFwdRawTable);


/**
 * Forward DCT, quantization and level shift part of the JPEG encoding.
 * Input is expected in 8x8 macro blocks and output is expected to be in 64x1
 * macro blocks.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pQuantFwdTable Forward quantization tables for JPEG encoding created
 *          using nppiQuantInvTableInit_JPEG_8u16u().
 * @param oSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 */
public static native @Cast("NppStatus") int nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                          @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                    @Cast("const Npp16u*") ShortPointer pQuantFwdTable, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                          @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                    @Cast("const Npp16u*") ShortBuffer pQuantFwdTable, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                          @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                    @Cast("const Npp16u*") short[] pQuantFwdTable, @ByVal NppiSize oSizeROI);

/**
 * Inverse DCT, de-quantization and level shift part of the JPEG decoding.
 * Input is expected in 64x1 macro blocks and output is expected to be in 8x8
 * macro blocks.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep Image width in pixels x 8 x sizeof(Npp16s).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Image width in pixels x 8 x sizeof(Npp16s).
 * @param pQuantInvTable Inverse quantization tables for JPEG decoding created
 *           using nppiQuantInvTableInit_JPEG_8u16u().
 * @param oSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 */
public static native @Cast("NppStatus") int nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                    @Cast("const Npp16u*") ShortPointer pQuantInvTable, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                    @Cast("const Npp16u*") ShortBuffer pQuantInvTable, @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                          @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                    @Cast("const Npp16u*") short[] pQuantInvTable, @ByVal NppiSize oSizeROI);
   


// #if defined (__cplusplus)
@Opaque public static class NppiDCTState extends Pointer {
    /** Empty constructor. Calls {@code super((Pointer)null)}. */
    public NppiDCTState() { super((Pointer)null); }
    /** Pointer cast constructor. Invokes {@link Pointer#Pointer(Pointer)}. */
    public NppiDCTState(Pointer p) { super(p); }
}
// #else
// #endif


/**
 * Initializes DCT state structure and allocates additional resources.
 *
 * @see nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R_NEW(), nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R_NEW.
 * 
 * @param ppState Pointer to pointer to DCT state structure. 
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pBufSize
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiDCTInitAlloc(@Cast("NppiDCTState**") PointerPointer ppState);
public static native @Cast("NppStatus") int nppiDCTInitAlloc(@ByPtrPtr NppiDCTState ppState);

/**
 * Frees the additional resources of the DCT state structure.
 *
 * @see nppiDCTInitAlloc
 * 
 * @param pState Pointer to DCT state structure. 
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pState
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiDCTFree(NppiDCTState pState);

/**
 * Forward DCT, quantization and level shift part of the JPEG encoding.
 * Input is expected in 8x8 macro blocks and output is expected to be in 64x1
 * macro blocks. The new version of the primitive takes the ROI in image pixel size and
 * works with DCT coefficients that are in zig-zag order.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep \ref source_image_line_step.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep Image width in pixels x 8 x sizeof(Npp16s).
 * @param pQuantizationTable Quantization Table in zig-zag order.
 * @param oSizeROI \ref roi_specification.
 * @param pState Pointer to DCT state structure. This structure must be
 *          initialized allocated and initialized using nppiDCTInitAlloc(). 
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 */
public static native @Cast("NppStatus") int nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R_NEW(@Cast("const Npp8u*") BytePointer pSrc, int nSrcStep, 
                                        @Cast("Npp16s*") ShortPointer pDst, int nDstStep, 
                                        @Cast("const Npp8u*") BytePointer pQuantizationTable, @ByVal NppiSize oSizeROI,
                                        NppiDCTState pState);
public static native @Cast("NppStatus") int nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R_NEW(@Cast("const Npp8u*") ByteBuffer pSrc, int nSrcStep, 
                                        @Cast("Npp16s*") ShortBuffer pDst, int nDstStep, 
                                        @Cast("const Npp8u*") ByteBuffer pQuantizationTable, @ByVal NppiSize oSizeROI,
                                        NppiDCTState pState);
public static native @Cast("NppStatus") int nppiDCTQuantFwd8x8LS_JPEG_8u16s_C1R_NEW(@Cast("const Npp8u*") byte[] pSrc, int nSrcStep, 
                                        @Cast("Npp16s*") short[] pDst, int nDstStep, 
                                        @Cast("const Npp8u*") byte[] pQuantizationTable, @ByVal NppiSize oSizeROI,
                                        NppiDCTState pState);



/**
 * Inverse DCT, de-quantization and level shift part of the JPEG decoding.
 * Input is expected in 64x1 macro blocks and output is expected to be in 8x8
 * macro blocks. The new version of the primitive takes the ROI in image pixel size and
 * works with DCT coefficients that are in zig-zag order.
 *
 * @param pSrc \ref source_image_pointer.
 * @param nSrcStep Image width in pixels x 8 x sizeof(Npp16s).
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pQuantizationTable Quantization Table in zig-zag order.
 * @param oSizeROI \ref roi_specification.
 * @param pState Pointer to DCT state structure. This structure must be
 *          initialized allocated and initialized using nppiDCTInitAlloc().  
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 */
public static native @Cast("NppStatus") int nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R_NEW(@Cast("const Npp16s*") ShortPointer pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") BytePointer pDst, int nDstStep, 
                                        @Cast("const Npp8u*") BytePointer pQuantizationTable, @ByVal NppiSize oSizeROI,
                                        NppiDCTState pState);
public static native @Cast("NppStatus") int nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R_NEW(@Cast("const Npp16s*") ShortBuffer pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") ByteBuffer pDst, int nDstStep, 
                                        @Cast("const Npp8u*") ByteBuffer pQuantizationTable, @ByVal NppiSize oSizeROI,
                                        NppiDCTState pState);
public static native @Cast("NppStatus") int nppiDCTQuantInv8x8LS_JPEG_16s8u_C1R_NEW(@Cast("const Npp16s*") short[] pSrc, int nSrcStep, 
                                        @Cast("Npp8u*") byte[] pDst, int nDstStep, 
                                        @Cast("const Npp8u*") byte[] pQuantizationTable, @ByVal NppiSize oSizeROI,
                                        NppiDCTState pState);
                                    

/** \} image_quantization */

// #if defined (__cplusplus)
@Opaque public static class NppiDecodeHuffmanSpec extends Pointer {
    /** Empty constructor. Calls {@code super((Pointer)null)}. */
    public NppiDecodeHuffmanSpec() { super((Pointer)null); }
    /** Pointer cast constructor. Invokes {@link Pointer#Pointer(Pointer)}. */
    public NppiDecodeHuffmanSpec(Pointer p) { super(p); }
}
// #else
// #endif

/**
 * Returns the length of the NppiDecodeHuffmanSpec structure.
 * @param pSize Pointer to a variable that will receive the length of the NppiDecodeHuffmanSpec structure.
 * @return Error codes:
 *         - ::NPP_NULL_POINTER_ERROR If one of the pointers is 0.
**/
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecGetBufSize_JPEG(IntPointer pSize);
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecGetBufSize_JPEG(IntBuffer pSize);
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecGetBufSize_JPEG(int[] pSize);

/**
 * Creates a Huffman table in a format that is suitable for the decoder on the host.
 * @param pRawHuffmanTable Huffman table formated as specified in the JPEG standard.
 * @param eTableType Enum specifying type of table (nppiDCTable or nppiACTable).
 * @param pHuffmanSpec Pointer to the Huffman table for the decoder
 * @return Error codes:
 *         - ::NPP_NULL_POINTER_ERROR If one of the pointers is 0.
**/
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecInitHost_JPEG(@Cast("const Npp8u*") BytePointer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, NppiDecodeHuffmanSpec pHuffmanSpec);
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecInitHost_JPEG(@Cast("const Npp8u*") ByteBuffer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, NppiDecodeHuffmanSpec pHuffmanSpec);
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecInitHost_JPEG(@Cast("const Npp8u*") byte[] pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, NppiDecodeHuffmanSpec pHuffmanSpec);

/**
 * Allocates memory and creates a Huffman table in a format that is suitable for the decoder on the host.
 * @param pRawHuffmanTable Huffman table formated as specified in the JPEG standard.
 * @param eTableType Enum specifying type of table (nppiDCTable or nppiACTable).
 * @param ppHuffmanSpec Pointer to returned pointer to the Huffman table for the decoder
 * @return Error codes:
 *         - ::NPP_NULL_POINTER_ERROR If one of the pointers is 0.
**/
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecInitAllocHost_JPEG(@Cast("const Npp8u*") BytePointer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @Cast("NppiDecodeHuffmanSpec**") PointerPointer ppHuffmanSpec);
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecInitAllocHost_JPEG(@Cast("const Npp8u*") BytePointer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @ByPtrPtr NppiDecodeHuffmanSpec ppHuffmanSpec);
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecInitAllocHost_JPEG(@Cast("const Npp8u*") ByteBuffer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @ByPtrPtr NppiDecodeHuffmanSpec ppHuffmanSpec);
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecInitAllocHost_JPEG(@Cast("const Npp8u*") byte[] pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @ByPtrPtr NppiDecodeHuffmanSpec ppHuffmanSpec);

/**
 * Frees the host memory allocated by nppiDecodeHuffmanSpecInitAllocHost_JPEG.
 * @param pHuffmanSpec Pointer to the Huffman table for the decoder
<p>
**/
public static native @Cast("NppStatus") int nppiDecodeHuffmanSpecFreeHost_JPEG(NppiDecodeHuffmanSpec pHuffmanSpec);

/**
 * Huffman Decoding of the JPEG decoding on the host.
 * Input is expected in byte stuffed huffman encoded JPEG scan and output is expected to be 64x1 macro blocks.
 *
 * @param pSrc Byte-stuffed huffman encoded JPEG scan.
 * @param nLength Byte length of the input.
 * @param restartInterval Restart Interval, see JPEG standard.
 * @param Ss Start Coefficient, see JPEG standard.
 * @param Se End Coefficient, see JPEG standard.
 * @param Ah Bit Approximation High, see JPEG standard.
 * @param Al Bit Approximation Low, see JPEG standard.
 * @param pDst \ref destination_image_pointer.
 * @param nDstStep \ref destination_image_line_step.
 * @param pHuffmanTableDC DC Huffman table.
 * @param pHuffmanTableAC AC Huffman table.
 * @param oSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 */
public static native @Cast("NppStatus") int nppiDecodeHuffmanScanHost_JPEG_8u16s_P1R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nLength,
                  @Cast("Npp32s") int restartInterval, @Cast("Npp32s") int Ss, @Cast("Npp32s") int Se, @Cast("Npp32s") int Ah, @Cast("Npp32s") int Al,
                    @Cast("Npp16s*") ShortPointer pDst, @Cast("Npp32s") int nDstStep,
                    NppiDecodeHuffmanSpec pHuffmanTableDC, 
                    NppiDecodeHuffmanSpec pHuffmanTableAC, 
                    @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDecodeHuffmanScanHost_JPEG_8u16s_P1R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nLength,
                  @Cast("Npp32s") int restartInterval, @Cast("Npp32s") int Ss, @Cast("Npp32s") int Se, @Cast("Npp32s") int Ah, @Cast("Npp32s") int Al,
                    @Cast("Npp16s*") ShortBuffer pDst, @Cast("Npp32s") int nDstStep,
                    NppiDecodeHuffmanSpec pHuffmanTableDC, 
                    NppiDecodeHuffmanSpec pHuffmanTableAC, 
                    @ByVal NppiSize oSizeROI);
public static native @Cast("NppStatus") int nppiDecodeHuffmanScanHost_JPEG_8u16s_P1R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nLength,
                  @Cast("Npp32s") int restartInterval, @Cast("Npp32s") int Ss, @Cast("Npp32s") int Se, @Cast("Npp32s") int Ah, @Cast("Npp32s") int Al,
                    @Cast("Npp16s*") short[] pDst, @Cast("Npp32s") int nDstStep,
                    NppiDecodeHuffmanSpec pHuffmanTableDC, 
                    NppiDecodeHuffmanSpec pHuffmanTableAC, 
                    @ByVal NppiSize oSizeROI); 


/**
 * Huffman Decoding of the JPEG decoding on the host.
 * Input is expected in byte stuffed huffman encoded JPEG scan and output is expected to be 64x1 macro blocks.
 *
 * @param pSrc Byte-stuffed huffman encoded JPEG scan.
 * @param nLength Byte length of the input.
 * @param nRestartInterval Restart Interval, see JPEG standard. 
 * @param nSs Start Coefficient, see JPEG standard.
 * @param nSe End Coefficient, see JPEG standard.
 * @param nAh Bit Approximation High, see JPEG standard.
 * @param nAl Bit Approximation Low, see JPEG standard.
 * @param apDst \ref destination_image_pointer.
 * @param aDstStep \ref destination_image_line_step.
 * @param apHuffmanDCTable DC Huffman tables.
 * @param apHuffmanACTable AC Huffman tables.
 * @param aSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 */
 public static native @Cast("NppStatus") int nppiDecodeHuffmanScanHost_JPEG_8u16s_P3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nLength,
                   @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp16s**") PointerPointer apDst, @Cast("Npp32s*") IntPointer aDstStep,
                     @Cast("NppiDecodeHuffmanSpec**") PointerPointer apHuffmanDCTable, 
                     @Cast("NppiDecodeHuffmanSpec**") PointerPointer apHuffmanACTable, 
                     NppiSize aSizeROI);
 public static native @Cast("NppStatus") int nppiDecodeHuffmanScanHost_JPEG_8u16s_P3R(@Cast("const Npp8u*") BytePointer pSrc, @Cast("Npp32s") int nLength,
                   @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp16s**") @ByPtrPtr ShortPointer apDst, @Cast("Npp32s*") IntPointer aDstStep,
                     @ByPtrPtr NppiDecodeHuffmanSpec apHuffmanDCTable, 
                     @ByPtrPtr NppiDecodeHuffmanSpec apHuffmanACTable, 
                     NppiSize aSizeROI);
 public static native @Cast("NppStatus") int nppiDecodeHuffmanScanHost_JPEG_8u16s_P3R(@Cast("const Npp8u*") ByteBuffer pSrc, @Cast("Npp32s") int nLength,
                   @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp16s**") @ByPtrPtr ShortBuffer apDst, @Cast("Npp32s*") IntBuffer aDstStep,
                     @ByPtrPtr NppiDecodeHuffmanSpec apHuffmanDCTable, 
                     @ByPtrPtr NppiDecodeHuffmanSpec apHuffmanACTable, 
                     NppiSize aSizeROI);
 public static native @Cast("NppStatus") int nppiDecodeHuffmanScanHost_JPEG_8u16s_P3R(@Cast("const Npp8u*") byte[] pSrc, @Cast("Npp32s") int nLength,
                   @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp16s**") @ByPtrPtr short[] apDst, @Cast("Npp32s*") int[] aDstStep,
                     @ByPtrPtr NppiDecodeHuffmanSpec apHuffmanDCTable, 
                     @ByPtrPtr NppiDecodeHuffmanSpec apHuffmanACTable, 
                     NppiSize aSizeROI);

/** \} image_compression */

// #if defined (__cplusplus)
@Opaque public static class NppiEncodeHuffmanSpec extends Pointer {
    /** Empty constructor. Calls {@code super((Pointer)null)}. */
    public NppiEncodeHuffmanSpec() { super((Pointer)null); }
    /** Pointer cast constructor. Invokes {@link Pointer#Pointer(Pointer)}. */
    public NppiEncodeHuffmanSpec(Pointer p) { super(p); }
}
// #else
// #endif


/**
 * Returns the length of the NppiEncodeHuffmanSpec structure.
 * @param pSize Pointer to a variable that will receive the length of the NppiEncodeHuffmanSpec structure.
 * @return Error codes:
 *         - ::NPP_NULL_POINTER_ERROR If one of the pointers is 0.
**/
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecGetBufSize_JPEG(IntPointer pSize);
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecGetBufSize_JPEG(IntBuffer pSize);
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecGetBufSize_JPEG(int[] pSize);

/**
 * Creates a Huffman table in a format that is suitable for the encoder.
 * @param pRawHuffmanTable Huffman table formated as specified in the JPEG standard.
 * @param eTableType Enum specifying type of table (nppiDCTable or nppiACTable).
 * @param pHuffmanSpec Pointer to the Huffman table for the decoder
 * @return Error codes:
 *         - ::NPP_NULL_POINTER_ERROR If one of the pointers is 0.
**/
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecInit_JPEG(@Cast("const Npp8u*") BytePointer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, NppiEncodeHuffmanSpec pHuffmanSpec);
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecInit_JPEG(@Cast("const Npp8u*") ByteBuffer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, NppiEncodeHuffmanSpec pHuffmanSpec);
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecInit_JPEG(@Cast("const Npp8u*") byte[] pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, NppiEncodeHuffmanSpec pHuffmanSpec);

/**
 * Allocates memory and creates a Huffman table in a format that is suitable for the encoder.
 * @param pRawHuffmanTable Huffman table formated as specified in the JPEG standard.
 * @param eTableType Enum specifying type of table (nppiDCTable or nppiACTable).
 * @param ppHuffmanSpec Pointer to returned pointer to the Huffman table for the encoder
 * @return Error codes:
 *         - ::NPP_NULL_POINTER_ERROR If one of the pointers is 0.
**/
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecInitAlloc_JPEG(@Cast("const Npp8u*") BytePointer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @Cast("NppiEncodeHuffmanSpec**") PointerPointer ppHuffmanSpec);
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecInitAlloc_JPEG(@Cast("const Npp8u*") BytePointer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @ByPtrPtr NppiEncodeHuffmanSpec ppHuffmanSpec);
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecInitAlloc_JPEG(@Cast("const Npp8u*") ByteBuffer pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @ByPtrPtr NppiEncodeHuffmanSpec ppHuffmanSpec);
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecInitAlloc_JPEG(@Cast("const Npp8u*") byte[] pRawHuffmanTable, @Cast("NppiHuffmanTableType") int eTableType, @ByPtrPtr NppiEncodeHuffmanSpec ppHuffmanSpec);

/**
 * Frees the memory allocated by nppiEncodeHuffmanSpecInitAlloc_JPEG.
 * @param pHuffmanSpec Pointer to the Huffman table for the encoder
<p>
**/
public static native @Cast("NppStatus") int nppiEncodeHuffmanSpecFree_JPEG(NppiEncodeHuffmanSpec pHuffmanSpec);

/**
 * Huffman Encoding of the JPEG Encoding.
 * Input is expected to be 64x1 macro blocks and output is expected as byte stuffed huffman encoded JPEG scan.
 *
 * @param pSrc \ref destination_image_pointer.
 * @param nSrcStep \ref destination_image_line_step.
 * @param nRestartInterval Restart Interval, see JPEG standard. Currently only values <=0 are supported.
 * @param nSs Start Coefficient, see JPEG standard.
 * @param nSe End Coefficient, see JPEG standard.
 * @param nAh Bit Approximation High, see JPEG standard.
 * @param nAl Bit Approximation Low, see JPEG standard.
 * @param pDst Byte-stuffed huffman encoded JPEG scan.
 * @param nLength Byte length of the huffman encoded JPEG scan.
 * @param pHuffmanTableDC DC Huffman table.
 * @param pHuffmanTableAC AC Huffman table.
 * @param oSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 *         - ::NPP_NOT_SUFFICIENT_COMPUTE_CAPABILITY If the device has compute capability < 2.0. 
 */
public static native @Cast("NppStatus") int nppiEncodeHuffmanScan_JPEG_8u16s_P1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep,
                    @Cast("Npp32s") int restartInterval, @Cast("Npp32s") int Ss, @Cast("Npp32s") int Se, @Cast("Npp32s") int Ah, @Cast("Npp32s") int Al,
                    @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s*") IntPointer nLength,
                    NppiEncodeHuffmanSpec pHuffmanTableDC, 
                    NppiEncodeHuffmanSpec pHuffmanTableAC, 
                    @ByVal NppiSize oSizeROI,
                    @Cast("Npp8u*") BytePointer pTempStorage);
public static native @Cast("NppStatus") int nppiEncodeHuffmanScan_JPEG_8u16s_P1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep,
                    @Cast("Npp32s") int restartInterval, @Cast("Npp32s") int Ss, @Cast("Npp32s") int Se, @Cast("Npp32s") int Ah, @Cast("Npp32s") int Al,
                    @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s*") IntBuffer nLength,
                    NppiEncodeHuffmanSpec pHuffmanTableDC, 
                    NppiEncodeHuffmanSpec pHuffmanTableAC, 
                    @ByVal NppiSize oSizeROI,
                    @Cast("Npp8u*") ByteBuffer pTempStorage);
public static native @Cast("NppStatus") int nppiEncodeHuffmanScan_JPEG_8u16s_P1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep,
                    @Cast("Npp32s") int restartInterval, @Cast("Npp32s") int Ss, @Cast("Npp32s") int Se, @Cast("Npp32s") int Ah, @Cast("Npp32s") int Al,
                    @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s*") int[] nLength,
                    NppiEncodeHuffmanSpec pHuffmanTableDC, 
                    NppiEncodeHuffmanSpec pHuffmanTableAC, 
                    @ByVal NppiSize oSizeROI,
                    @Cast("Npp8u*") byte[] pTempStorage); 


/**
 * Huffman Encoding of the JPEG Encoding.
 * Input is expected to be 64x1 macro blocks and output is expected as byte stuffed huffman encoded JPEG scan.
 *
 * @param apSrc \ref destination_image_pointer.
 * @param aSrcStep \ref destination_image_line_step.
 * @param nRestartInterval Restart Interval, see JPEG standard. Currently only values <=0 are supported.
 * @param nSs Start Coefficient, see JPEG standard.
 * @param nSe End Coefficient, see JPEG standard.
 * @param nAh Bit Approximation High, see JPEG standard.
 * @param nAl Bit Approximation Low, see JPEG standard.
 * @param pDst Byte-stuffed huffman encoded JPEG scan.
 * @param nLength Byte length of the huffman encoded JPEG scan.
 * @param apHuffmanTableDC DC Huffman tables.
 * @param apHuffmanTableAC AC Huffman tables.
 * @param aSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 *         - ::NPP_NOT_SUFFICIENT_COMPUTE_CAPABILITY If the device has compute capability < 2.0.
 */
 public static native @Cast("NppStatus") int nppiEncodeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") PointerPointer apSrc, @Cast("Npp32s*") IntPointer aSrcStep,
                     @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s*") IntPointer nLength,
                     @Cast("NppiEncodeHuffmanSpec**") PointerPointer apHuffmanDCTable, 
                     @Cast("NppiEncodeHuffmanSpec**") PointerPointer apHuffmanACTable, 
                     NppiSize aSizeROI,
                     @Cast("Npp8u*") BytePointer pTempStorage);
 public static native @Cast("NppStatus") int nppiEncodeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") @ByPtrPtr ShortPointer apSrc, @Cast("Npp32s*") IntPointer aSrcStep,
                     @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s*") IntPointer nLength,
                     @ByPtrPtr NppiEncodeHuffmanSpec apHuffmanDCTable, 
                     @ByPtrPtr NppiEncodeHuffmanSpec apHuffmanACTable, 
                     NppiSize aSizeROI,
                     @Cast("Npp8u*") BytePointer pTempStorage);
 public static native @Cast("NppStatus") int nppiEncodeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") @ByPtrPtr ShortBuffer apSrc, @Cast("Npp32s*") IntBuffer aSrcStep,
                     @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s*") IntBuffer nLength,
                     @ByPtrPtr NppiEncodeHuffmanSpec apHuffmanDCTable, 
                     @ByPtrPtr NppiEncodeHuffmanSpec apHuffmanACTable, 
                     NppiSize aSizeROI,
                     @Cast("Npp8u*") ByteBuffer pTempStorage);
 public static native @Cast("NppStatus") int nppiEncodeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") @ByPtrPtr short[] apSrc, @Cast("Npp32s*") int[] aSrcStep,
                     @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                     @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s*") int[] nLength,
                     @ByPtrPtr NppiEncodeHuffmanSpec apHuffmanDCTable, 
                     @ByPtrPtr NppiEncodeHuffmanSpec apHuffmanACTable, 
                     NppiSize aSizeROI,
                     @Cast("Npp8u*") byte[] pTempStorage);

/**
 * Optimize Huffman Encoding of the JPEG Encoding.
 * Input is expected to be 64x1 macro blocks and output is expected as byte stuffed huffman encoded JPEG scan.
 *
 * @param pSrc \ref destination_image_pointer.
 * @param nSrcStep \ref destination_image_line_step.
 * @param nRestartInterval Restart Interval, see JPEG standard. Currently only values <=0 are supported.
 * @param nSs Start Coefficient, see JPEG standard.
 * @param nSe End Coefficient, see JPEG standard.
 * @param nAh Bit Approximation High, see JPEG standard.
 * @param nAl Bit Approximation Low, see JPEG standard.
 * @param pDst Byte-stuffed huffman encoded JPEG scan.
 * @param pLength Pointer to the byte length of the huffman encoded JPEG scan.
 * @param hpCodesDC Host pointer to the code of the huffman tree for DC component.
 * @param hpTableDC Host pointer to the table of the huffman tree for DC component.
 * @param hpCodesAC Host pointer to the code of the huffman tree for AC component.
 * @param hpTableAC Host pointer to the table of the huffman tree for AC component.
* @param pHuffmanTableDC DC Huffman table.
 * @param pHuffmanTableAC AC Huffman table.
 * @param oSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 *         - ::NPP_NOT_SUFFICIENT_COMPUTE_CAPABILITY If the device has compute capability < 2.0. 
 */
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanScan_JPEG_8u16s_P1R(@Cast("const Npp16s*") ShortPointer pSrc, @Cast("Npp32s") int nSrcStep,
                                             @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, 
                                             @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                                             @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s*") IntPointer pLength,
                                             @Cast("Npp8u*") BytePointer hpCodesDC, @Cast("Npp8u*") BytePointer hpTableDC,
                                             @Cast("Npp8u*") BytePointer hpCodesAC, @Cast("Npp8u*") BytePointer hpTableAC,
                                             NppiEncodeHuffmanSpec aHuffmanDCTable, 
                                             NppiEncodeHuffmanSpec aHuffmanACTable, 
                                             @ByVal NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pTempStorage);
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanScan_JPEG_8u16s_P1R(@Cast("const Npp16s*") ShortBuffer pSrc, @Cast("Npp32s") int nSrcStep,
                                             @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, 
                                             @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                                             @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s*") IntBuffer pLength,
                                             @Cast("Npp8u*") ByteBuffer hpCodesDC, @Cast("Npp8u*") ByteBuffer hpTableDC,
                                             @Cast("Npp8u*") ByteBuffer hpCodesAC, @Cast("Npp8u*") ByteBuffer hpTableAC,
                                             NppiEncodeHuffmanSpec aHuffmanDCTable, 
                                             NppiEncodeHuffmanSpec aHuffmanACTable, 
                                             @ByVal NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pTempStorage);
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanScan_JPEG_8u16s_P1R(@Cast("const Npp16s*") short[] pSrc, @Cast("Npp32s") int nSrcStep,
                                             @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, 
                                             @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                                             @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s*") int[] pLength,
                                             @Cast("Npp8u*") byte[] hpCodesDC, @Cast("Npp8u*") byte[] hpTableDC,
                                             @Cast("Npp8u*") byte[] hpCodesAC, @Cast("Npp8u*") byte[] hpTableAC,
                                             NppiEncodeHuffmanSpec aHuffmanDCTable, 
                                             NppiEncodeHuffmanSpec aHuffmanACTable, 
                                             @ByVal NppiSize oSizeROI, @Cast("Npp8u*") byte[] pTempStorage);

/**
 * Optimize Huffman Encoding of the JPEG Encoding.
 * Input is expected to be 64x1 macro blocks and output is expected as byte stuffed huffman encoded JPEG scan.
 *
 * @param apSrc \ref destination_image_pointer.
 * @param aSrcStep \ref destination_image_line_step.
 * @param nRestartInterval Restart Interval, see JPEG standard. Currently only values <=0 are supported.
 * @param nSs Start Coefficient, see JPEG standard.
 * @param nSe End Coefficient, see JPEG standard.
 * @param nAh Bit Approximation High, see JPEG standard.
 * @param nAl Bit Approximation Low, see JPEG standard.
 * @param pDst Byte-stuffed huffman encoded JPEG scan.
 * @param pLength Pointer to the byte length of the huffman encoded JPEG scan.
 * @param hpCodesDC Host pointer to the code of the huffman tree for DC component.
 * @param hpTableDC Host pointer to the table of the huffman tree for DC component.
 * @param hpCodesAC Host pointer to the code of the huffman tree for AC component.
 * @param hpTableAC Host pointer to the table of the huffman tree for AC component.
 * @param apHuffmanTableDC DC Huffman tables.
 * @param apHuffmanTableAC AC Huffman tables.
 * @param aSizeROI \ref roi_specification.
 * @return Error codes:
 *         - ::NPP_SIZE_ERROR For negative input height/width or not a multiple of
 *           8 width/height.
 *         - ::NPP_STEP_ERROR If input image width is not multiple of 8 or does not
 *           match ROI.
 *         - ::NPP_NULL_POINTER_ERROR If the destination pointer is 0.
 *         - ::NPP_NOT_SUFFICIENT_COMPUTE_CAPABILITY If the device has compute capability < 2.0.
 */
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") PointerPointer pSrc, @Cast("Npp32s*") IntPointer aSrcStep,
                                             @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, 
                                             @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                                             @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s*") IntPointer pLength,
                                             @Cast("Npp8u**") PointerPointer hpCodesDC, @Cast("Npp8u**") PointerPointer hpTableDC,
                                             @Cast("Npp8u**") PointerPointer hpCodesAC, @Cast("Npp8u**") PointerPointer hpTableAC,
                                             @Cast("NppiEncodeHuffmanSpec**") PointerPointer aHuffmanDCTable, 
                                             @Cast("NppiEncodeHuffmanSpec**") PointerPointer aHuffmanACTable, 
                                             NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pTempStorage);
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") @ByPtrPtr ShortPointer pSrc, @Cast("Npp32s*") IntPointer aSrcStep,
                                             @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, 
                                             @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                                             @Cast("Npp8u*") BytePointer pDst, @Cast("Npp32s*") IntPointer pLength,
                                             @Cast("Npp8u**") @ByPtrPtr BytePointer hpCodesDC, @Cast("Npp8u**") @ByPtrPtr BytePointer hpTableDC,
                                             @Cast("Npp8u**") @ByPtrPtr BytePointer hpCodesAC, @Cast("Npp8u**") @ByPtrPtr BytePointer hpTableAC,
                                             @ByPtrPtr NppiEncodeHuffmanSpec aHuffmanDCTable, 
                                             @ByPtrPtr NppiEncodeHuffmanSpec aHuffmanACTable, 
                                             NppiSize oSizeROI, @Cast("Npp8u*") BytePointer pTempStorage);
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") @ByPtrPtr ShortBuffer pSrc, @Cast("Npp32s*") IntBuffer aSrcStep,
                                             @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, 
                                             @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                                             @Cast("Npp8u*") ByteBuffer pDst, @Cast("Npp32s*") IntBuffer pLength,
                                             @Cast("Npp8u**") @ByPtrPtr ByteBuffer hpCodesDC, @Cast("Npp8u**") @ByPtrPtr ByteBuffer hpTableDC,
                                             @Cast("Npp8u**") @ByPtrPtr ByteBuffer hpCodesAC, @Cast("Npp8u**") @ByPtrPtr ByteBuffer hpTableAC,
                                             @ByPtrPtr NppiEncodeHuffmanSpec aHuffmanDCTable, 
                                             @ByPtrPtr NppiEncodeHuffmanSpec aHuffmanACTable, 
                                             NppiSize oSizeROI, @Cast("Npp8u*") ByteBuffer pTempStorage);
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanScan_JPEG_8u16s_P3R(@Cast("Npp16s**") @ByPtrPtr short[] pSrc, @Cast("Npp32s*") int[] aSrcStep,
                                             @Cast("Npp32s") int nRestartInterval, @Cast("Npp32s") int nSs, 
                                             @Cast("Npp32s") int nSe, @Cast("Npp32s") int nAh, @Cast("Npp32s") int nAl,
                                             @Cast("Npp8u*") byte[] pDst, @Cast("Npp32s*") int[] pLength,
                                             @Cast("Npp8u**") @ByPtrPtr byte[] hpCodesDC, @Cast("Npp8u**") @ByPtrPtr byte[] hpTableDC,
                                             @Cast("Npp8u**") @ByPtrPtr byte[] hpCodesAC, @Cast("Npp8u**") @ByPtrPtr byte[] hpTableAC,
                                             @ByPtrPtr NppiEncodeHuffmanSpec aHuffmanDCTable, 
                                             @ByPtrPtr NppiEncodeHuffmanSpec aHuffmanACTable, 
                                             NppiSize oSizeROI, @Cast("Npp8u*") byte[] pTempStorage);

/**
 * Calculates the size of the temporary buffer for baseline Huffman encoding.
 *
 * @see nppiEncodeHuffmanScan_JPEG_8u16s_P1R(), nppiEncodeHuffmanScan_JPEG_8u16s_P3R().
 * 
 * @param oSize Image Dimension.
 * @param pBufSize Pointer to variable that returns the size of the
 *        temporary buffer. 
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pBufSize
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiEncodeHuffmanGetSize(@ByVal NppiSize oSize, int nChannels, IntPointer pBufSize);
public static native @Cast("NppStatus") int nppiEncodeHuffmanGetSize(@ByVal NppiSize oSize, int nChannels, IntBuffer pBufSize);
public static native @Cast("NppStatus") int nppiEncodeHuffmanGetSize(@ByVal NppiSize oSize, int nChannels, int[] pBufSize);

/**
 * Calculates the size of the temporary buffer for optimize Huffman coding.
 *
 * See \ref nppiGenerateOptimizeHuffmanTable_JPEG.
 * 
 * @param oSize Image Dimension.
 * @param nChannels Number of channels in the image.
 * @param pBufSize Pointer to variable that returns the size of the
 *        temporary buffer. 
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pBufSize
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanGetSize(@ByVal NppiSize oSize, int nChannels, IntPointer pBufSize);
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanGetSize(@ByVal NppiSize oSize, int nChannels, IntBuffer pBufSize);
public static native @Cast("NppStatus") int nppiEncodeOptimizeHuffmanGetSize(@ByVal NppiSize oSize, int nChannels, int[] pBufSize);

/** \} image_compression */


// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_COMPRESSION_FUNCTIONS_H */


// Parsed from <nppi_computer_vision.h>

 /* Copyright 2009-2015 NVIDIA Corporation.  All rights reserved. 
  * 
  * NOTICE TO LICENSEE: 
  * 
  * The source code and/or documentation ("Licensed Deliverables") are 
  * subject to NVIDIA intellectual property rights under U.S. and 
  * international Copyright laws. 
  * 
  * The Licensed Deliverables contained herein are PROPRIETARY and 
  * CONFIDENTIAL to NVIDIA and are being provided under the terms and 
  * conditions of a form of NVIDIA software license agreement by and 
  * between NVIDIA and Licensee ("License Agreement") or electronically 
  * accepted by Licensee.  Notwithstanding any terms or conditions to 
  * the contrary in the License Agreement, reproduction or disclosure 
  * of the Licensed Deliverables to any third party without the express 
  * written consent of NVIDIA is prohibited. 
  * 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, NVIDIA MAKES NO REPRESENTATION ABOUT THE 
  * SUITABILITY OF THESE LICENSED DELIVERABLES FOR ANY PURPOSE.  THEY ARE 
  * PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND. 
  * NVIDIA DISCLAIMS ALL WARRANTIES WITH REGARD TO THESE LICENSED 
  * DELIVERABLES, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, 
  * NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. 
  * NOTWITHSTANDING ANY TERMS OR CONDITIONS TO THE CONTRARY IN THE 
  * LICENSE AGREEMENT, IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY 
  * SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY 
  * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
  * OF THESE LICENSED DELIVERABLES. 
  * 
  * U.S. Government End Users.  These Licensed Deliverables are a 
  * "commercial item" as that term is defined at 48 C.F.R. 2.101 (OCT 
  * 1995), consisting of "commercial computer software" and "commercial 
  * computer software documentation" as such terms are used in 48 
  * C.F.R. 12.212 (SEPT 1995) and are provided to the U.S. Government 
  * only as a commercial end item.  Consistent with 48 C.F.R.12.212 and 
  * 48 C.F.R. 227.7202-1 through 227.7202-4 (JUNE 1995), all 
  * U.S. Government End Users acquire the Licensed Deliverables with 
  * only those rights set forth herein. 
  * 
  * Any use of the Licensed Deliverables in individual and commercial 
  * software must include, in the user documentation and internal 
  * comments to the code, the above Disclaimer and U.S. Government End 
  * Users Notice. 
  */ 
// #ifndef NV_NPPI_COMPUTER_VISION_H
// #define NV_NPPI_COMPUTER_VISION_H
 
/**
 * \file nppi_computer_vision.h
 * NPP Image Processing Functionality.
 */
 
// #include "nppdefs.h"


// #ifdef __cplusplus
// #endif

/** \defgroup image_labeling_and_segmentation Labeling and Segmentation
 *  \ingroup nppi
 *
 * Pixel labeling and image segementation operations.
 *
 * NOTE: All of these Graphcut functions will be deprecated in a future release.
 *
 * \{
 *
 */

// #if defined (__cplusplus)
@Opaque public static class NppiGraphcutState extends Pointer {
    /** Empty constructor. Calls {@code super((Pointer)null)}. */
    public NppiGraphcutState() { super((Pointer)null); }
    /** Pointer cast constructor. Invokes {@link Pointer#Pointer(Pointer)}. */
    public NppiGraphcutState(Pointer p) { super(p); }
}
// #else
// #endif

/** \defgroup image_graphcut GraphCut
 *
 * \{
 *
 */

/** \name Graphcut
 *
 * \{
 *
 */

/**
 * Calculates the size of the temporary buffer for graph-cut with 4 neighborhood labeling.
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcutInitAlloc(), nppiGraphcut_32s8u().
 * 
 * @param oSize Graph size.
 * @param pBufSize Pointer to variable that returns the size of the
 *        temporary buffer. 
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pBufSize
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiGraphcutGetSize(@ByVal NppiSize oSize, IntPointer pBufSize);
public static native @Cast("NppStatus") int nppiGraphcutGetSize(@ByVal NppiSize oSize, IntBuffer pBufSize);
public static native @Cast("NppStatus") int nppiGraphcutGetSize(@ByVal NppiSize oSize, int[] pBufSize);

/**
 * Calculates the size of the temporary buffer for graph-cut with 8 neighborhood labeling.
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcut8InitAlloc(), nppiGraphcut8_32s8u().
 * 
 * @param oSize Graph size.
 * @param pBufSize Pointer to variable that returns the size of the
 *        temporary buffer. 
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pBufSize
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiGraphcut8GetSize(@ByVal NppiSize oSize, IntPointer pBufSize);
public static native @Cast("NppStatus") int nppiGraphcut8GetSize(@ByVal NppiSize oSize, IntBuffer pBufSize);
public static native @Cast("NppStatus") int nppiGraphcut8GetSize(@ByVal NppiSize oSize, int[] pBufSize);

/**
 * Initializes graph-cut state structure and allocates additional resources for graph-cut with 8 neighborhood labeling.
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcut_32s8u(), nppiGraphcutGetSize().
 * 
 * @param oSize Graph size
 * @param ppState Pointer to pointer to graph-cut state structure. 
 * @param pDeviceMem pDeviceMem to the sufficient amount of device memory. The CUDA runtime or NPP memory allocators
 *      must be used to allocate this memory. The minimum amount of device memory required
 *      to run graph-cut on a for a specific image size is computed by nppiGraphcutGetSize().
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pBufSize
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiGraphcutInitAlloc(@ByVal NppiSize oSize, @Cast("NppiGraphcutState**") PointerPointer ppState, @Cast("Npp8u*") BytePointer pDeviceMem);
public static native @Cast("NppStatus") int nppiGraphcutInitAlloc(@ByVal NppiSize oSize, @ByPtrPtr NppiGraphcutState ppState, @Cast("Npp8u*") BytePointer pDeviceMem);
public static native @Cast("NppStatus") int nppiGraphcutInitAlloc(@ByVal NppiSize oSize, @ByPtrPtr NppiGraphcutState ppState, @Cast("Npp8u*") ByteBuffer pDeviceMem);
public static native @Cast("NppStatus") int nppiGraphcutInitAlloc(@ByVal NppiSize oSize, @ByPtrPtr NppiGraphcutState ppState, @Cast("Npp8u*") byte[] pDeviceMem);

/**
 * Allocates and initializes the graph-cut state structure and additional resources for graph-cut with 8 neighborhood labeling.
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcut8_32s8u(), nppiGraphcut8GetSize().
 * 
 * @param oSize Graph size
 * @param ppState Pointer to pointer to graph-cut state structure. 
 * @param pDeviceMem to the sufficient amount of device memory. The CUDA runtime or NPP memory allocators
 *      must be used to allocate this memory. The minimum amount of device memory required
 *      to run graph-cut on a for a specific image size is computed by nppiGraphcut8GetSize().
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pBufSize
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiGraphcut8InitAlloc(@ByVal NppiSize oSize, @Cast("NppiGraphcutState**") PointerPointer ppState, @Cast("Npp8u*") BytePointer pDeviceMem);
public static native @Cast("NppStatus") int nppiGraphcut8InitAlloc(@ByVal NppiSize oSize, @ByPtrPtr NppiGraphcutState ppState, @Cast("Npp8u*") BytePointer pDeviceMem);
public static native @Cast("NppStatus") int nppiGraphcut8InitAlloc(@ByVal NppiSize oSize, @ByPtrPtr NppiGraphcutState ppState, @Cast("Npp8u*") ByteBuffer pDeviceMem);
public static native @Cast("NppStatus") int nppiGraphcut8InitAlloc(@ByVal NppiSize oSize, @ByPtrPtr NppiGraphcutState ppState, @Cast("Npp8u*") byte[] pDeviceMem);

/**
 * Frees the additional resources of the graph-cut state structure.
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcutInitAlloc
 * @see nppiGraphcut8InitAlloc
 * 
 * @param pState Pointer to graph-cut state structure. 
 *
 * @return NPP_SUCCESS Indicates no error. Any other value indicates an error
 *         or a warning
 * @return NPP_SIZE_ERROR Indicates an error condition if any image dimension
 *         has zero or negative value
 * @return NPP_NULL_POINTER_ERROR Indicates an error condition if pState
 *         pointer is NULL
 */
public static native @Cast("NppStatus") int nppiGraphcutFree(NppiGraphcutState pState);

/**
 * Graphcut of a flow network (32bit signed integer edge capacities). The
 * function computes the minimal cut (graphcut) of a 2D regular 4-connected
 * graph. 
 * The inputs are the capacities of the horizontal (in transposed form),
 * vertical and terminal (source and sink) edges. The capacities to source and
 * sink 
 * are stored as capacity differences in the terminals array 
 * ( terminals(x) = source(x) - sink(x) ). The implementation assumes that the
 * edge capacities 
 * for boundary edges that would connect to nodes outside the specified domain
 * are set to 0 (for example left(0,*) == 0). If this is not fulfilled the
 * computed labeling may be wrong!
 * The computed binary labeling is encoded as unsigned 8bit values (0 and >0).
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcutInitAlloc(), nppiGraphcutFree(), nppiGraphcutGetSize().
 *
 * @param pTerminals Pointer to differences of terminal edge capacities
 *        (terminal(x) = source(x) - sink(x))
 * @param pLeftTransposed Pointer to transposed left edge capacities
 *        (left(0,*) must be 0)
 * @param pRightTransposed Pointer to transposed right edge capacities
 *        (right(width-1,*) must be 0)
 * @param pTop Pointer to top edge capacities (top(*,0) must be 0)
 * @param pBottom Pointer to bottom edge capacities (bottom(*,height-1)
 *        must be 0)
 * @param nStep Step in bytes between any pair of sequential rows of edge
 *        capacities
 * @param nTransposedStep Step in bytes between any pair of sequential
 *        rows of tranposed edge capacities
 * @param size Graph size
 * @param pLabel Pointer to destination label image 
 * @param nLabelStep Step in bytes between any pair of sequential rows of
 *        label image
 * @param pState Pointer to graph-cut state structure. This structure must be
 *          initialized allocated and initialized using nppiGraphcutInitAlloc().
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGraphcut_32s8u(@Cast("Npp32s*") IntPointer pTerminals, @Cast("Npp32s*") IntPointer pLeftTransposed, @Cast("Npp32s*") IntPointer pRightTransposed, @Cast("Npp32s*") IntPointer pTop, @Cast("Npp32s*") IntPointer pBottom, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") BytePointer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut_32s8u(@Cast("Npp32s*") IntBuffer pTerminals, @Cast("Npp32s*") IntBuffer pLeftTransposed, @Cast("Npp32s*") IntBuffer pRightTransposed, @Cast("Npp32s*") IntBuffer pTop, @Cast("Npp32s*") IntBuffer pBottom, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") ByteBuffer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut_32s8u(@Cast("Npp32s*") int[] pTerminals, @Cast("Npp32s*") int[] pLeftTransposed, @Cast("Npp32s*") int[] pRightTransposed, @Cast("Npp32s*") int[] pTop, @Cast("Npp32s*") int[] pBottom, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") byte[] pLabel, int nLabelStep, NppiGraphcutState pState);


/**
 * Graphcut of a flow network (32bit signed integer edge capacities). The
 * function computes the minimal cut (graphcut) of a 2D regular 8-connected
 * graph. 
 * The inputs are the capacities of the horizontal (in transposed form),
 * vertical and terminal (source and sink) edges. The capacities to source and
 * sink 
 * are stored as capacity differences in the terminals array 
 * ( terminals(x) = source(x) - sink(x) ). The implementation assumes that the
 * edge capacities 
 * for boundary edges that would connect to nodes outside the specified domain
 * are set to 0 (for example left(0,*) == 0). If this is not fulfilled the
 * computed labeling may be wrong!
 * The computed binary labeling is encoded as unsigned 8bit values (0 and >0).
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcut8InitAlloc(), nppiGraphcutFree(), nppiGraphcut8GetSize().
 *
 * @param pTerminals Pointer to differences of terminal edge capacities
 *        (terminal(x) = source(x) - sink(x))
 * @param pLeftTransposed Pointer to transposed left edge capacities
 *        (left(0,*) must be 0)
 * @param pRightTransposed Pointer to transposed right edge capacities
 *        (right(width-1,*) must be 0)
 * @param pTop Pointer to top edge capacities (top(*,0) must be 0)
 * @param pTopLeft Pointer to top left edge capacities (topleft(*,0) 
 *        & topleft(0,*) must be 0)
 * @param pTopRight Pointer to top right edge capacities (topright(*,0)
 *        & topright(width-1,*) must be 0)
 * @param pBottom Pointer to bottom edge capacities (bottom(*,height-1)
 *        must be 0)
 * @param pBottomLeft Pointer to bottom left edge capacities 
 *        (bottomleft(*,height-1) && bottomleft(0,*) must be 0)
 * @param pBottomRight Pointer to bottom right edge capacities 
 *        (bottomright(*,height-1) && bottomright(width-1,*) must be 0)
 * @param nStep Step in bytes between any pair of sequential rows of edge
 *        capacities
 * @param nTransposedStep Step in bytes between any pair of sequential
 *        rows of tranposed edge capacities
 * @param size Graph size
 * @param pLabel Pointer to destination label image 
 * @param nLabelStep Step in bytes between any pair of sequential rows of
 *        label image
 * @param pState Pointer to graph-cut state structure. This structure must be
 *          initialized allocated and initialized using nppiGraphcut8InitAlloc().
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGraphcut8_32s8u(@Cast("Npp32s*") IntPointer pTerminals, @Cast("Npp32s*") IntPointer pLeftTransposed, @Cast("Npp32s*") IntPointer pRightTransposed, @Cast("Npp32s*") IntPointer pTop, @Cast("Npp32s*") IntPointer pTopLeft, @Cast("Npp32s*") IntPointer pTopRight, @Cast("Npp32s*") IntPointer pBottom, @Cast("Npp32s*") IntPointer pBottomLeft, @Cast("Npp32s*") IntPointer pBottomRight, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") BytePointer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut8_32s8u(@Cast("Npp32s*") IntBuffer pTerminals, @Cast("Npp32s*") IntBuffer pLeftTransposed, @Cast("Npp32s*") IntBuffer pRightTransposed, @Cast("Npp32s*") IntBuffer pTop, @Cast("Npp32s*") IntBuffer pTopLeft, @Cast("Npp32s*") IntBuffer pTopRight, @Cast("Npp32s*") IntBuffer pBottom, @Cast("Npp32s*") IntBuffer pBottomLeft, @Cast("Npp32s*") IntBuffer pBottomRight, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") ByteBuffer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut8_32s8u(@Cast("Npp32s*") int[] pTerminals, @Cast("Npp32s*") int[] pLeftTransposed, @Cast("Npp32s*") int[] pRightTransposed, @Cast("Npp32s*") int[] pTop, @Cast("Npp32s*") int[] pTopLeft, @Cast("Npp32s*") int[] pTopRight, @Cast("Npp32s*") int[] pBottom, @Cast("Npp32s*") int[] pBottomLeft, @Cast("Npp32s*") int[] pBottomRight, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") byte[] pLabel, int nLabelStep, NppiGraphcutState pState);

/**
 * Graphcut of a flow network (32bit float edge capacities). The
 * function computes the minimal cut (graphcut) of a 2D regular 4-connected
 * graph. 
 * The inputs are the capacities of the horizontal (in transposed form),
 * vertical and terminal (source and sink) edges. The capacities to source and
 * sink 
 * are stored as capacity differences in the terminals array 
 * ( terminals(x) = source(x) - sink(x) ). The implementation assumes that the
 * edge capacities 
 * for boundary edges that would connect to nodes outside the specified domain
 * are set to 0 (for example left(0,*) == 0). If this is not fulfilled the
 * computed labeling may be wrong!
 * The computed binary labeling is encoded as unsigned 8bit values (0 and >0).
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcutInitAlloc(), nppiGraphcutFree(), nppiGraphcutGetSize().
 *
 * @param pTerminals Pointer to differences of terminal edge capacities
 *        (terminal(x) = source(x) - sink(x))
 * @param pLeftTransposed Pointer to transposed left edge capacities
 *        (left(0,*) must be 0)
 * @param pRightTransposed Pointer to transposed right edge capacities
 *        (right(width-1,*) must be 0)
 * @param pTop Pointer to top edge capacities (top(*,0) must be 0)
 * @param pBottom Pointer to bottom edge capacities (bottom(*,height-1)
 *        must be 0)
 * @param nStep Step in bytes between any pair of sequential rows of edge
 *        capacities
 * @param nTransposedStep Step in bytes between any pair of sequential
 *        rows of tranposed edge capacities
 * @param size Graph size
 * @param pLabel Pointer to destination label image 
 * @param nLabelStep Step in bytes between any pair of sequential rows of
 *        label image
 * @param pState Pointer to graph-cut state structure. This structure must be
 *          initialized allocated and initialized using nppiGraphcutInitAlloc().
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGraphcut_32f8u(@Cast("Npp32f*") FloatPointer pTerminals, @Cast("Npp32f*") FloatPointer pLeftTransposed, @Cast("Npp32f*") FloatPointer pRightTransposed, @Cast("Npp32f*") FloatPointer pTop, @Cast("Npp32f*") FloatPointer pBottom, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") BytePointer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut_32f8u(@Cast("Npp32f*") FloatBuffer pTerminals, @Cast("Npp32f*") FloatBuffer pLeftTransposed, @Cast("Npp32f*") FloatBuffer pRightTransposed, @Cast("Npp32f*") FloatBuffer pTop, @Cast("Npp32f*") FloatBuffer pBottom, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") ByteBuffer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut_32f8u(@Cast("Npp32f*") float[] pTerminals, @Cast("Npp32f*") float[] pLeftTransposed, @Cast("Npp32f*") float[] pRightTransposed, @Cast("Npp32f*") float[] pTop, @Cast("Npp32f*") float[] pBottom, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") byte[] pLabel, int nLabelStep, NppiGraphcutState pState);


/**
 * Graphcut of a flow network (32bit float edge capacities). The
 * function computes the minimal cut (graphcut) of a 2D regular 8-connected
 * graph. 
 * The inputs are the capacities of the horizontal (in transposed form),
 * vertical and terminal (source and sink) edges. The capacities to source and
 * sink 
 * are stored as capacity differences in the terminals array 
 * ( terminals(x) = source(x) - sink(x) ). The implementation assumes that the
 * edge capacities 
 * for boundary edges that would connect to nodes outside the specified domain
 * are set to 0 (for example left(0,*) == 0). If this is not fulfilled the
 * computed labeling may be wrong!
 * The computed binary labeling is encoded as unsigned 8bit values (0 and >0).
 *
 * NOTE: This Graphcut function will be deprecated in a future release.
 *
 * @see nppiGraphcut8InitAlloc(), nppiGraphcutFree(), nppiGraphcut8GetSize().
 *
 * @param pTerminals Pointer to differences of terminal edge capacities
 *        (terminal(x) = source(x) - sink(x))
 * @param pLeftTransposed Pointer to transposed left edge capacities
 *        (left(0,*) must be 0)
 * @param pRightTransposed Pointer to transposed right edge capacities
 *        (right(width-1,*) must be 0)
 * @param pTop Pointer to top edge capacities (top(*,0) must be 0)
 * @param pTopLeft Pointer to top left edge capacities (topleft(*,0) 
 *        & topleft(0,*) must be 0)
 * @param pTopRight Pointer to top right edge capacities (topright(*,0)
 *        & topright(width-1,*) must be 0)
 * @param pBottom Pointer to bottom edge capacities (bottom(*,height-1)
 *        must be 0)
 * @param pBottomLeft Pointer to bottom left edge capacities 
 *        (bottomleft(*,height-1) && bottomleft(0,*) must be 0)
 * @param pBottomRight Pointer to bottom right edge capacities 
 *        (bottomright(*,height-1) && bottomright(width-1,*) must be 0)
 * @param nStep Step in bytes between any pair of sequential rows of edge
 *        capacities
 * @param nTransposedStep Step in bytes between any pair of sequential
 *        rows of tranposed edge capacities
 * @param size Graph size
 * @param pLabel Pointer to destination label image 
 * @param nLabelStep Step in bytes between any pair of sequential rows of
 *        label image
 * @param pState Pointer to graph-cut state structure. This structure must be
 *          initialized allocated and initialized using nppiGraphcut8InitAlloc().
 * @return \ref image_data_error_codes, \ref roi_error_codes
 */
public static native @Cast("NppStatus") int nppiGraphcut8_32f8u(@Cast("Npp32f*") FloatPointer pTerminals, @Cast("Npp32f*") FloatPointer pLeftTransposed, @Cast("Npp32f*") FloatPointer pRightTransposed, @Cast("Npp32f*") FloatPointer pTop, @Cast("Npp32f*") FloatPointer pTopLeft, @Cast("Npp32f*") FloatPointer pTopRight, @Cast("Npp32f*") FloatPointer pBottom, @Cast("Npp32f*") FloatPointer pBottomLeft, @Cast("Npp32f*") FloatPointer pBottomRight, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") BytePointer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut8_32f8u(@Cast("Npp32f*") FloatBuffer pTerminals, @Cast("Npp32f*") FloatBuffer pLeftTransposed, @Cast("Npp32f*") FloatBuffer pRightTransposed, @Cast("Npp32f*") FloatBuffer pTop, @Cast("Npp32f*") FloatBuffer pTopLeft, @Cast("Npp32f*") FloatBuffer pTopRight, @Cast("Npp32f*") FloatBuffer pBottom, @Cast("Npp32f*") FloatBuffer pBottomLeft, @Cast("Npp32f*") FloatBuffer pBottomRight, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") ByteBuffer pLabel, int nLabelStep, NppiGraphcutState pState);
public static native @Cast("NppStatus") int nppiGraphcut8_32f8u(@Cast("Npp32f*") float[] pTerminals, @Cast("Npp32f*") float[] pLeftTransposed, @Cast("Npp32f*") float[] pRightTransposed, @Cast("Npp32f*") float[] pTop, @Cast("Npp32f*") float[] pTopLeft, @Cast("Npp32f*") float[] pTopRight, @Cast("Npp32f*") float[] pBottom, @Cast("Npp32f*") float[] pBottomLeft, @Cast("Npp32f*") float[] pBottomRight, int nStep, int nTransposedStep, @ByVal NppiSize size, @Cast("Npp8u*") byte[] pLabel, int nLabelStep, NppiGraphcutState pState);


/** \} end of Graphcut */

/** \} image_graphcut */

/** \} image_labeling_and_segmentation */

// #ifdef __cplusplus /* extern "C" */
// #endif

// #endif /* NV_NPPI_COMPUTER_VISION_H */


}
